// csCLRManager.cs

	// csDebger.cs の、mscoreee.dll 
	//  呼び出し部分

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。





//			https://csharpvbcomparer.blogspot.com/2013/05/cast-comparison-1.html
//					キャストの比較 #1 対比表
//						複雑だ。

//			! static_cast 
//			  reinterpret_cast
//				・・・というのは、c++/CLI 独特の文法らしい？
//			  const_cast
//			  dynamic_cast
//					・・・というのもC++にはあるらしい。




using BOOL = System.Int32;



namespace CliDbger {



namespace CLR {




internal class clsCLRManager_v4 : System.IDisposable {

	// 構造体、バイトレイアウト指定する方法：
	//[StructLayout(LayoutKind.Sequential)]
	//struct POINT {
	//public int x;
	//public int y;
	//}


	

	internal enum colonyRUNTIME_SELECTION_RULENO : uint
	{
		INSTALLED_MOST_NEW,
		UPNEAR_FROM_EXE, 
		USER_SELECT_V10, 
		USER_SELECT_V20, 
		USER_SELECT_V30, 
		USER_SELECT_V35, 
		USER_SELECT_V40, 
		USER_SELECT_V45
	}



	private struct stEnumRuntimeVerInfo {
		internal string						sVer;
		internal CLR.ICLRRuntimeInfo		objRuntime;
	}


	internal delegate int dlgt_GetThreadContext(
									uint dwThreadID,
									uint contextFlags,
									uint contextSize,
									[System.Runtime.InteropServices.Out]
									[System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.LPArray, ArraySubType=System.Runtime.InteropServices.UnmanagedType.U1,SizeParamIndex=2)]
									out byte [] pContext);


	private clsCleanUpDirManager			mobjCleanM;
	private clsDispDir						mobjClean_CurModule;

	// イチイチ丁寧に作ってたらキリねぇな。適当に使うとこだけ
	// 実装すっか・・・。
	private clsMySafeFreeLibraryHandle 		msfeHandleDllCorEE;

	private CLR.ICLRDebugging				mobjClrv4Debugging;

	private dlgt_GetThreadContext			mpGetThreadContext;


	internal clsCleanUpDirManager ParentCleanUpManager {
		set { this.mobjCleanM = value };
		get { return this.mobjCleanM; };
	}


	internal void Init() {
		clscsPub.Assert( this.mobjCleanM != null, "CleanUp manager unset . " );

		// イチイチディレクト指定が面倒なので変数として持っておく
		clscsPub.Assert( this.mobjCleanM != null, "CleanUp manager unset . " );

		clsDispDir		objDispDir_this;
		objDispDir_this = mobjCleanM.Root.GetChild_FromClassInstance( this );
		clscsPub.Assert( objDispDir_this != null, "CleanUp manager unset . " );

		this.mobjClean_CurModule = objDispDir_this;

	}	//	void Init()


	internal void Dispose()
	{
		// [CLEANUP:0005]

		// まぁ特にやる事ないんだけど・・・。
		// からっぽってのも行儀悪いし、適当になんかやっとくか。
		if ( this.msfeHandleDllCorEE != null ) {
			this.msfeHandleDllCorEE.Dispose();
			this.msfeHandleDllCorEE = null;
		}

		if ( this.mobjClrv4Debugging != null ) { 
			System.Runtime.InteropServices.Marshal.ReleaseComObject( this.mobjClrv4Debugging );
			this.mobjClrv4Debugging = null;
		}

		this.mobjClean_CurModule.SuccessEndCleanUp();
		this.mobjClean_CurModule = null;

		this.mpGetThreadContext = null;
	}



	#region clsCLRManager_v4:property / support mini function etc

		internal void SetNull_Clrv4Debugging() {
			this.mobjClrv4Debugging = null;
		}
		internal void SetNull_sfeHandleDllCorEE() {
			this.msfeHandleDllCorEE = null;
		}


	#endregion


	internal clsCLRRet CLRSetup()
	{
		clsCLRRet		objRet;
		
		// 以下は 8 を返していた。ビルト環境に合わせるようだ。
		//clscsPub.PErrMsg( "IntPtr.Size={0}", IntPtr.Size );


		/* CLR ver2.0 系の ICR com 系はまだコードに着手すら出来てない！ */

		objRet = this.v4DIFSetup(
							colonyRUNTIME_SELECTION_RULENO.INSTALLED_MOST_NEW
						);
		if ( objRet.Success() ) {
			objRet.SetSuccessCode(  );
		}

		return nRet;
	}
	
	/* 旧エラーコード : csCLRErrCode.cs に移動した。
	internal enum colonyRET_SETUPV4IF : uint
	{
		DLL_LOADLIBRARY_FAILED, 
		DLL_GETPROCADDRESS_FAILED,
		METAHOST_ENUMERATEINSTALLEDRUNTIMS_CALL_FAILED,
		METAHOST_S_IENUMUNKNOWN_NEXT_CALL_FAILED, 
		METAHOST_S_IENUMUNKNOWN_NEXT_CALL_RETURNS_ARG3_NOT_1_FAILED, 
		METAHOST_S_IENUMUNKNOWN_NEXT_CALL_RETURNS_NOT_SIZE1_ARRAY_FAILED, 
		ARRAY0_IUNKNOWN_QUERYINTRERFACE_FAILED, 
		PTRICLRRUNTIMEINFO_CAST_OBJICLRRUNTIMEINFO_FAILED,

		CURRENT_DISPDIR_IS_NOT_ATTACHEXE_CODE_PROGRAMING_ERROR,

		// つくんのめんどくせ。共通化ｗ
		CALL_CLRCREATEINSTANCE_SUCCEED, 
		CALL_SETUPV4IF_GETPMETAHOST_CALLCLRCREATEINSTANCE_RETURNS_UNKNOWN_CODE,
		CALL_SETUPV4IF_GETPMETAHOST_CAST_PTRMETAHOST_TO_CLRRMETAHOST_FAILED, 
		CALL_SETUPV4IF_GETPMETAHOST_CALLING_CLRCREATEINSTANCE_FAILED,
		CALL_SETUPV4IF_GETPMETAHOST_SUCCEED, 
		
		SUCESS_END_CLRDEBUGGING_IS_CREATED_NOW_DEMANDING_TARGET_PROCESSHANDLE,
	}
	*/

	internal colonyRET_SETUPV4IF v4DIFSetup( colonyRUNTIME_SELECTION_RULENO nRuntimeSelection )
	{
		colonyRET_SETUPV4IF		nRet;

		nRet = this.v4DIFSetup_CreateClrDebbuggingComObject( 
							colonyRUNTIME_SELECTION_RULENO.INSTALLED_MOST_NEW
						);
	
		if ( nRet != colonyRET_SETUPV4IF.SUCESS_END_CLRDEBUGGING_IS_CREATED_NOW_DEMANDING_TARGET_PROCESSHANDLE ) {
			return nRet;
		}
	}

	// Win32::DebugActiveProcess > WaitForDeabugObject > CreateProsess
	// で止まった後に、この関数により初期化を想定している。
	// ・・・ランタイムトラブル多そうだし、DebugActiveProcess 前に初期化した方が
	// 良いかもしんないね。
	// mscoreee.dll より metahost, iCorDebugging を初期化して受け取る。
	internal colonyRET_SETUPV4IF v4DIFSetup_CreateClrDebbuggingComObject( colonyRUNTIME_SELECTION_RULENO nRuntimeSelection )
	{

		#Error		引数から CleanUp マネージャ関連引数を削除しモジュール変数に移行させる！

		//clsMultiDisposer		objMultiDisposer = new clsMultiDisposer();
		clsDipDir				objCleanDir;

		objCleanDir = this.mobjCleanM.Current.CreateChild();
		objCleanDir.IsModule   = false;
		objCleanDir.IsFunc     = true;
		objCleanDir.FuncName   = "v4DIFSetup";


		CLR.ICLRMetaHost				objCLRMetaHost;
		colonyRET_SETUPV4IF				nRet;

		objCLRMetaHost = null;
		clscsPub.Assert( this.mobjCleanM.Current == objCleanDir, 
					" this.mobjCleanM.Current is not \"v4DIFSetup\" !. "  );

		nRet = this.v4DIFSetup_GetpMetaHost( out objCLRMetaHost );
		if ( nRet != colonyRET_SETUPV4IF.CALL_SETUPV4IF_GETPMETAHOST_SUCCEED ) {
			objCleanDir.ErrorCleanUp();
			return colonyRET_SETUPV4IF.DLL_GETPROCADDRESS_FAILED;
		}

		clscsPub.Assert( this.mobjCleanM.Current == objCleanDir, 
					" this.mobjCleanM.Current is not \"v4DIFSetup\" !. "  );

		// この段階で、objMultiDisposer には
		//  1: this.msfeHandleDllCorEE		（エラー時のみメモリ開放)
		// の１つだけが入ってるはず？？？

		clsComDisposer		objComDisposer_MetaHost
			= new clsComDisposer( objCLRMetaHost );
		// 上記は途中ですぐ開放するので、開放をキューする
		objCleanDir.Add_CleanupWhenAlways( objComDisposer_MetaHost );

		clsWin32.stHResult		stRet;

		/**************************************************/
		/* C# 化された interface ICLRMetaHost を使って      */
		/* ランタイム列挙をやってみる                        */
		/**************************************************/
		CLR.IEnumUnknown		runtimes;
		//clsIEnumUnknown		objRuntimes;
		//objRuntimes = null;
		
		//clscsPub.PErrMsg( "objCLRMetaHost.ToString() is nothing is...{0}", objCLRMetaHost.ToString() );

		objCleanDir.IsShowDisposeExection = true;

		runtimes = null;
		stRet = objCLRMetaHost.EnumerateInstalledRuntimes( out runtimes );
		if ( !stRet.success() ) {
			string		sErr;

			sErr = "EnumerateInstalledRuntimes call failed. ";
			clscsPub.PErrMsg( sErr );
			
			// FreeLibrary 等を実行
			objCleanDir.ErrorCleanUp();
			return colonyRET_SETUPV4IF.METAHOST_ENUMERATEINSTALLEDRUNTIMS_CALL_FAILED;
		}



		// metahost はもう使わないからココで開放しちゃっていいんだよね？？？
		objCleanDir.CleanUp_sucucessfully_Once();
		objCLRMetaHost = null;


		{		// 	clsComDisposer		objComDispoer_IEnumUnknown_Runtimes
		clsComDisposer		objComDispoer_IEnumUnknown_Runtimes = 
			new clsComDisposer( runtimes, 
						typeof( clsComDisposer ) );

		// 3 つ目のクリーンナップ登録
		objCleanDir.Add_CleanupWhenAlways( 
						objComDispoer_IEnumUnknown_Runtimes	);
		}		//	clsComDisposer		objComDispoer_IEnumUnknown_Runtimes
		
		//clscsPub.PErrMsg( "objRuntimes is null? {0} . ", 
		//				( runtimes == null ) );
		
		//clscsPub.PErrMsg( "objRuntimes is isComObject? {0} . ", 
		//		System.Runtime.InteropServices.Marshal.IsComObject( runtimes ) );


		// マルチクリーンナッパーをもう一つ入れる。
		// メインで使う物、１つ目のクリーンナッパーには、
		//  何も登録しない。
		// ２つ目のクリーンナッパーは、使う CLRRuntimeInfo を確定し、
		// ランタイムを生成した正常終了時のみ、全て開放するのに使う。

		
		
		clsDisposerArray		objMDisposerArray_ForRuntimes
			= new clsDisposerArray();

		objCleanDir.Add_CleanupWhenAlways( 
					objMDisposerArray_ForRuntimes );

		System.Collections.Generic.List< stEnumRuntimeVerInfo >
										lstRuntims;
		lstRuntims = new System.Collections.Generic.List< stEnumRuntimeVerInfo >();

		while ( true )
		{


			object[]		arEnumRuntimes = null;

			uint		uiSetted;
			uiSetted = 1;
			arEnumRuntimes = new object[ 1 ];

			// 3 つめ引数は値を直接セット出来ない！必ず変数=1にセットしないといけない！
			stRet = runtimes.Next(1, arEnumRuntimes, ref uiSetted );
			if ( !stRet.success() ) {

				//clscsPub.PErrMsg( "next returns not zero . " ); 

				// １つだけクリーンナップ実行して、
				//  IEnumUnknown runtimes を COM 開放する。
				// なんつぅややこしい事する必要があるんだ・・・。

				// ここではクリーンナップは実施しない。
				//objMultiDisposer.CleanUp_sucucessfully_Once();

				break;
			}

			if ( uiSetted == 0 ) {
				// 0 だと正常終了らしい？
				break;
			}
			if ( uiSetted != 1 ) {
				string		sErr;

				sErr = "IEnumUnknown->Next call uiSetted returns \"{0}\" ";
				clscsPub.PErrMsg( sErr, uiSetted );
				foreach ( object objComIndex in arEnumRuntimes ) {
					System.Runtime.InteropServices.Marshal.ReleaseComObject( objComIndex );
				}
				// FreeLibrary 等を実行
				objCleanDir.ErrorCleanUp();
				return colonyRET_SETUPV4IF.METAHOST_S_IENUMUNKNOWN_NEXT_CALL_RETURNS_ARG3_NOT_1_FAILED;
			}

			if ( arEnumRuntimes.Length != 1 ) {
				string		sErr;

				sErr = "IEnumUnknown->Next generates arEnumRuntimes.Count=\"{0}\" . "; 
				clscsPub.PErrMsg( sErr, arEnumRuntimes.Length );
				
				// FreeLibrary 等を実行
				foreach ( object objComIndex in arEnumRuntimes) {
					System.Runtime.InteropServices.Marshal.ReleaseComObject( objComIndex );
				}
				objCleanDir.ErrorCleanUp();
				return colonyRET_SETUPV4IF.METAHOST_S_IENUMUNKNOWN_NEXT_CALL_RETURNS_NOT_SIZE1_ARRAY_FAILED;
			}






			//ICLRRuntimeInfo runtimeInfo = null;
			// 以下はどっちも同じらしい。キャストして COM オブジェクトを
			// 取得する、という意味では、キャストも QueryInterface も意味が同じらしい。
			//runtimeInfo = (ICLRRuntimeInfo)arEnumRuntimes[ 0 ];
			
			//stRet = arEnumRuntimes[ 0 ].QueryInterface<ICLRRuntimeInfo>(&runtimeInfo);
			

			//		https://learn.microsoft.com/ja-jp/dotnet/api/system.runtime.interopservices.marshal.queryinterface?view=net-7.0
			//				Marshal.QueryInterface(IntPtr, Guid, IntPtr) メソッド
			//System.Guid		guidIID_ICLRRuntimeInfo;
			//guidIID_ICLRRuntimeInfo = new  System.Guid(
			//		"{BD39D1D2-BA2F-486a-89B0-B4B0CB466891}"
			//	);
			IntPtr			ptrarEnumRuntimes_0, ptrICLRRuntimeInfo;
			ptrarEnumRuntimes_0 = 
						System.Runtime.InteropServices.Marshal.GetIUnknownForObject(
									arEnumRuntimes[ 0 ]
								);




			stRet = System.Runtime.InteropServices.Marshal.QueryInterface(
						ptrarEnumRuntimes_0, 
						ref CLR.clsGuid.GUID_IID_ICLRRuntimeInfo, 
						out ptrICLRRuntimeInfo );

			if ( !stRet.success() ) {
				string		sErr;

				sErr = "arEnumRuntimes[ 0 ]/IUnknown->QueryIntaface failed. "; 
				clscsPub.PErrMsg( sErr, arEnumRuntimes.Length );

				// FreeLibrary 等を実行
				objCleanDir.ErrorCleanUp();
				return colonyRET_SETUPV4IF.ARRAY0_IUNKNOWN_QUERYINTRERFACE_FAILED;
			}

			CLR.ICLRRuntimeInfo objICLRRuntimeInfo;
			objICLRRuntimeInfo = (CLR.ICLRRuntimeInfo)
					System.Runtime.InteropServices.Marshal.GetObjectForIUnknown(
						ptrICLRRuntimeInfo
					);

			if ( objICLRRuntimeInfo == null ) {
				
				string		sErr;

				sErr = "arEnumRuntimes[ 0 ] to managed ICLRRuntimeInfo cast failed. "; 
				clscsPub.PErrMsg( sErr, arEnumRuntimes.Length );

				if ( ptrICLRRuntimeInfo != System.IntPtr.Zero ) {
					System.Runtime.InteropServices.Marshal.ReleaseComObject( ptrICLRRuntimeInfo );
					ptrICLRRuntimeInfo = System.IntPtr.Zero;
				}

				// FreeLibrary 等を実行
				objCleanDir.ErrorCleanUp();
				return colonyRET_SETUPV4IF.PTRICLRRUNTIMEINFO_CAST_OBJICLRRUNTIMEINFO_FAILED;
			}


			// 	列挙された objMDisposerArray_ForRuntimes 用クリーンナップ登録
			clsComDisposer		objComDisposer_ICLRRuntimeInfo
				= new clsComDisposer( objICLRRuntimeInfo, 
							typeof( CLR.ICLRRuntimeInfo ) );

			objMDisposerArray_ForRuntimes.Add_CleanupWhenAlways(
						objComDisposer_ICLRRuntimeInfo );

			//if (runtimeInfo != NULL)
			//{
				//runtimeInfo->GetVersionString(frameworkName, &bytes);
				//wprintf(L"[*] Supported Framework: %s\n", frameworkName);
			//}



			// 256バイト固定にしたのでその通りに…
			string sframeworkName;
			//sframeworkName = "AVCD";
			sframeworkName = null;
			//	= new string( ' ', 256 );
			uint		nBytes;
			nBytes = 256;

			//System.IntPtr	ptrVersionStr;
			//ptrVersionStr = System.Runtime.InteropServices.Marshal.AllocHGlobal( 256 );
			clscsPub.PErrMsg( "brefore GetVersionString . " );

			//objICLRRuntimeInfo.GetVersionString( out sframeworkName, ref nBytes );
			//objICLRRuntimeInfo.GetVersionString( ptrVersionStr, ref nBytes );
			CLR.clsRefString srefFrameworkname;
			// 256 バイト割り当て。WCHAR/unicode は１文字 16bit だから、
			// 128 文字分、256 バイトのバッファを要求している事になる。
			srefFrameworkname = new CLR.clsRefString( sframeworkName, 256 );
			objICLRRuntimeInfo.GetVersionString( srefFrameworkname.CreatePointer(), ref nBytes );

			//sframeworkName = System.Runtime.InteropServices.Marshal.PtrToStringUni( ptrVersionStr );

			//System.Runtime.InteropServices.Marshal.FreeHGlobal(ptrVersionStr);
			sframeworkName = srefFrameworkname.GetUnmangedString();
			srefFrameworkname.Dispose();
			srefFrameworkname = null;
			clscsPub.PErrMsg( "after GetVersionString {0} . ", sframeworkName );

			// 最後に登録したクリーンナップ、ICLRRuntimeInfo をメモリ開放
			// ・・・・とはせずに、
			// どのランタイムを使うかを確定、ランタイム生成後に 
			// objMDisposerArray_ForRuntimes で消す。
			//objMultiDispoer.CleanUp_sucucessfully_Once();

			stEnumRuntimeVerInfo	stAdd;
			stAdd = new stEnumRuntimeVerInfo();
			stAdd.sVer = sframeworkName;
			stAdd.objRuntime = objICLRRuntimeInfo;
			lstRuntims.Add( stAdd );


		}		// while (true)


		{ 		// 	nRuntimeIndex
		int nRuntimeIndex;

		nRuntimeIndex = this.v4DIFSetup_GetSelectruntimeIndex( 
								lstRuntims, 
								colonyRUNTIME_SELECTION_RULENO.INSTALLED_MOST_NEW
							);

		if ( nRuntimeIndex < 0 ) {
				string		sErr;

				sErr = "v4DIFSetup_GetSelectruntimeIndex returns < 0. "; 
				clscsPub.PErrMsg( sErr, nRuntimeIndex );

				// FreeLibrary 等を実行
				objCleanDir.ErrorCleanUp();
				return colonyRET_SETUPV4IF.PTRICLRRUNTIMEINFO_CAST_OBJICLRRUNTIMEINFO_FAILED;		}

		}		//	nRuntimeIndex


		/**************************************************/
		/**************************************************/
		/* debug version 4.0 でとりあえず動かしてみる。     */
		/**************************************************/
		/**************************************************/
		ICLRDebugging		objClrDebugging
										 = null;

		stRet = lstRuntims[ nRuntimeIndex ].
				GetInterface(
						ref CLR.clsGuid.GUID_CLSID_CLRDebugging, 
						ref CLR.clsGuid.GUID_IID_ICLRDebugging,
						ref objClrDebugging );

		if ( !stRet.success() ) {
			string		sErr;

			sErr = "runtime failed to create CLRDebugging com object . "; 
			clscsPub.PErrMsg( sErr, nRuntimeIndex );

			if ( objClrDebugging != null ) {
				System.Runtime.InteropServices.Marshal.ReleaseComObject( objClrDebugging );
			}
			// FreeLibrary 等を実行
			objCleanDir.ErrorCleanUp();
			return colonyRET_SETUPV4IF.PTRICLRRUNTIMEINFO_CAST_OBJICLRRUNTIMEINFO_FAILED;
		}


		// ランタイムのリストを全て開放する
		objCleanDir.List_CleanUp_sucucessfully_Once();
		lstRuntims.Clear();
		lstRuntims = null;

		//CLR.IEnumUnknown		runtimes;
		// ランタイムの一覧取得用 com オブジェクトを開放する
		objCleanDir.List_CleanUp_sucucessfully_Once();
		runtimes = null;

		// "v4DIFSetup" クリーンナップは空のはずだけど、
		// 上位側 chidren から "v4DIFSetup" クリーンナップを削除するために
		// クリーンナップを呼び出す
		objCleanDir.SuccessEndCleanUp();
		objCleanDir = null;


		clscsPub.Assert( this.mobjCleanM.Current.FuncName == "AttachExe", 
						" this.mobjCleanM.Current is not \"AttachExe\" !. "  );
		#ifdef __DEBUG__
			if ( this.mobjCleanM.Root.GetChild_FromFuncName( "AttachExe" ) != 
					this.mobjCleanM.Current	) {

					string sErr = "current DispDir is not current, program code mistake. "; 
					clscsPub.PErrMsg( sErr, nRuntimeIndex );

					return colonyRET_SETUPV4IF.CURRENT_DISPDIR_IS_NOT_ATTACHEXE_CODE_PROGRAMING_ERROR;
			}
		#endif


		this.mobjClrv4Debugging = objClrDebugging;

		{	//		clsComDisposer		objComDisposer_ICLRDebugging
			clsComDisposer		objComDisposer_ICLRDebugging
				= new clsComDisposer( objClrDebugging, 
							typeof( CLR.ICLRDebugging ) );

			// 上位クリーンナップファンクション "AttachExe" 内にて
			// エラーが発生したら Dispose()、
			// エラーが起きず正常終了したら、モジュール "clsCLRManager" インスタンス
			// 配下 Dipose() クリーンナップへと
			// 管理を指示する。
			
			// [CLEANUP:0009]
			this.mobjCleanM.Current.
					Add_CleanupForModuleVariable( 
						objComDisposer_ICLRDebugging,
						this.mobjCleanM.Current, 
						this.mobjClean_CurModule,
						this.SetNull_Clrv4Debugging
					);


		}	//	clsComDisposer		objComDisposer_ICLRDebugging







		clscsPub.PErrMsg( " : v4DIFSetup successly ended, lcrDebbung createed . " );


		// Function ぜんぶ成功時は以下クリーンナップをモジュールに登録
		return colonyRET_SETUPV4IF.
				SUCESS_END_CLRDEBUGGING_IS_CREATED_NOW_DEMANDING_TARGET_PROCESSHANDLE;
	}




	private int v4DIFSetup_GetSelectruntimeIndex( 
				System.Collections.Generic.List< stEnumRuntimeVerInfo >		lstRuntime, 
				colonyRUNTIME_SELECTION_RULENO								nRuntimeSelection
							)
	{
		if ( nRuntimeSelection == colonyRUNTIME_SELECTION_RULENO.INSTALLED_MOST_NEW ) {
			string sNewestVer;
			int		nMostHigh;

			if ( lstRuntime.Count == 0)
				return -1;

			nMostHigh = -1;
			sNewestVer = null;
			for( int nIndex = 0 ; nIndex < lstRuntime.Count; nIndex++ ) {
				stEnumRuntimeVerInfo	stCurrent;
				stCurrent = lstRuntime[ nIndex ];
				if ( nMostHigh == -1 ) {
					nMostHigh = nIndex;
					sNewestVer = stCurrent.sVer;
					continue;
				}

				int nNewerSta, nCurrentSta;
				nNewerSta = 0;
				nCurrentSta = 0;
				if ( sNewestVer[0] == 'v' )
					nNewerSta = 1;
				if ( (stCurrent.sVer)[0] == 'v' )
					nCurrentSta = 1;

				int nComp;

				nComp = String.Compare( 
								sNewestVer.Substring( nNewerSta ),
								stCurrent.sVer.Substring( nCurrentSta ),
								true // 大文字小文字の区別をしない
							);
				
				if ( nComp < 0 ) {
					nMostHigh = nIndex;
					sNewestVer = stCurrent.sVer;
				}
			}

			return nMostHigh;

		} else {
			clscsPub.Warn( "not code {0} . ", nRuntimeSelection.ToString() );
			return 0;		// 未コード
		}

	}
	
	private colonyRET_SETUPV4IF v4DIFSetup_GetpMetaHost( out CLR.ICLRMetaHost objRetmetaHost )
	{

		clsDipDir				objCleanCur;

		objCleanCur = this.mobjCleanM.Current.CreateChild();
		objCleanCur.IsModule   = false;
		objCleanCur.IsFunc     = true;
		objCleanCur.FuncName   = "v4DIFSetup_GetpMetaHost";


		System.IntPtr		hDllCorEE;

		// エラー時：メモリ開放
		// 成功時　：開放やらない
		hDllCorEE = clsWin32.LoadLibraryA( "MSCorEE.dll" );
		if ( hDllCorEE == IntPtr.Zero ) {
			clscsPub.PErrMsg( "LoadLibrary MSCorEE.dll Failed. " );
			// エラークリーンアップは空だが、
			// objCleanCur を上位chidlrenから削除するのに必要
			objCleanCur.ErrorCleanUp();
			return	colonyRET_SETUPV4IF.DLL_LOADLIBRARY_FAILED;
		}


		CLR.ICLRMetaHost metaHost;
		metaHost = null;

		// [CLEANUP:0008]
		this.msfeHandleDllCorEE = new clsMySafeFreeLibraryHandle( hDllCorEE );
		objCleanCur.Add_CleanupForModuleVariable( 
					this.msfeHandleDllCorEE, 
					this.mobjCleanM.RootFunc, 
					this.mobjCLean_CurModule,
					this.SetNull_sfeHandleDllCorEE );


		clsWin32.dgltCLRCreateInstance		dlgtCLRCreateInstance;

		{ bool		bSucess = false;
			this.msfeHandleDllCorEE.DangerousAddRef( ref bSucess );
		} //		bool bSucess

		{		// pFunctionAddress
		System.IntPtr pFunctionAddress = clsWin32.GetProcAddress( 
				msfeHandleDllCorEE.DangerousGetHandle(), "CLRCreateInstance" );
		this.msfeHandleDllCorEE.DangerousRelease();

		if( pFunctionAddress == System.IntPtr.Zero) {
			clscsPub.PErrMsg( 
				"GetProcAddress \"CLRCreateInstance\" failed." );
			
			objCleanCur.ErrorCleanUp();
			return colonyRET_SETUPV4IF.DLL_GETPROCADDRESS_FAILED;
		}




		/********************************************************************/
		/* 取得したポインタをデレゲート変数にキャスト                          */
		/********************************************************************/
		dlgtCLRCreateInstance = 
				(clsWin32.dgltCLRCreateInstance)
				System.Runtime.InteropServices.Marshal.GetDelegateForFunctionPointer(
										pFunctionAddress, 
										typeof (clsWin32.dgltCLRCreateInstance)
									);

		}	// pFunctionAddress


		System.IntPtr		ptrMetaHost;


		/********************************************************************/
		/* CLRCreateInstance 実際に呼び出し                                  */
		/*     CLRMetaHost クラスインスタンスを取得する                       */
		/********************************************************************/

		colonyRET_SETUPV4IF		nRet;
		nRet = this.Setupv4IF_GetpMetaHost_CallCLRCreateInstance( 
					dlgtCLRCreateInstance, out ptrMetaHost );
		if ( nRet != colonyRET_SETUPV4IF.CALL_SETUPV4IF_GETPMETAHOST_SUCCEED ) {
			objCleanCur.ErrorCleanUp();
			return colonyRET_SETUPV4IF.CALL_SETUPV4IF_GETPMETAHOST_CALLCLRCREATEINSTANCE_RETURNS_UNKNOWN_CODE;

		}


		/**************************************************/
		/* ptrMetaHost を、interface ICLRMetaHost         */
		/* インターフェイス変数に変換する                    */
		/**************************************************/
		//  pCLRCreateInstance で第３引数に
		//		[MarshalAs(UnmanagedType.Interface)]
		//		または
		//		[MarshalAs(UnmanagedType.IUnknown)]
		//  をつけてしまっても構わないが、ここでは一応、

		//		https://imihito.hatenablog.jp/entry/2020/05/08/210207
		//			.NET Core で Marshal.GetActiveObject を再現してみたときのメモ
		//
		//	を参考に、Marshal.GetObjectForIUnknown で object 型に
		//	に変換する方法でやってみる。

		//		https://learn.microsoft.com/ja-jp/dotnet/api/system.runtime.interopservices.marshal.getobjectforiunknown?view=netcore-3.1
		//			Marshal.GetObjectForIUnknown(IntPtr) メソッド



		metaHost = (CLR.ICLRMetaHost)( 
							System.Runtime.InteropServices.Marshal.GetObjectForIUnknown( ptrMetaHost )
		);
		if ( metaHost == null) {
			string		sErr;
			sErr = " : ICLRMetaHost metaHost cast failed. > ";
			clscsPub.PErrMsg( sErr );
			
			// いちおー削除を試みる
			if ( ptrMetaHost != System.IntPtr.Zero )
				System.Runtime.InteropServices.Marshal.ReleaseComObject( ptrMetaHost );

			// FreeLibrary 等を実行
			objCleanCur.ErrorCleanUp();

			return colonyRET_SETUPV4IF.CALL_SETUPV4IF_GETPMETAHOST_CAST_PTRMETAHOST_TO_CLRRMETAHOST_FAILED;
		}



		//clscsPub.Warn( "objDiposer_ptrMetaHost add type {0}", metaHost.GetType() );
		//clscsPub.Warn( "objDiposer_ptrMetaHost add type 2 {0}", typeof( CLR.ICLRMetaHost ).Name );


		// Add_CleanupForModuleVariable( 
		//			this.msfeHandleDllCorEE 
		// で特殊エラークリーンアップ登録した this.msfeHandleDllCorEE
		// Dispose() クリーンナップを上位側クリーンナップ "v4DIFSetup" につけかえる
		objCleanCur.SuccessEndCleanUp();
		objCleanCur = null;




		// 参照型クラスインスタンスに以下２つでは設定できんらしい。
		// 謎が多過ぎる。なんでだ。
		//objRetmetaHost = & metaHost;
		//objRetmetaHost = ref metaHost;
		objRetmetaHost = metaHost;


		return colonyRET_SETUPV4IF.CALL_SETUPV4IF_GETPMETAHOST_SUCCEED;
	}



	// コメントが長いんで関数分割
	private colonyRET_SETUPV4IF Setupv4IF_GetpMetaHost_CallCLRCreateInstance( 
					clsWin32.dgltCLRCreateInstance		dlgtCLRCreateInstance, 
				out System.IntPtr ptrMetaHost )
	{






		// https://learn.microsoft.com/ja-jp/dotnet/framework/interop/com-interop-sample-net-client-and-com-server
		// 		・・・によると、COM リターンコード、hresult の S_OK を見る時は
		//		c# bool 型で受け取って true/false を見て良いらしい。
		//		・・・ってなってるけど、これ、だめｗ
		//		S_OK は 0 なのに、これじゃ関数成功しても bool に 0 がセットされるじゃねーかｗ
		//		何考えてやがんだ、マイクロソフトｗ

		clsWin32.stHResult		stRet;
		//	ICLRMetaHost *metaHost = NULL;
		ptrMetaHost = System.IntPtr.Zero;


		stRet =  dlgtCLRCreateInstance( ref CLR.clsGuid.GUID_CLSID_CLRMetaHost, 
										ref CLR.clsGuid.GUID_IID_ICLRMetaHost, 
										out ptrMetaHost );



		if ( !stRet.success() ) {

			if ( ptrMetaHost != System.IntPtr.Zero )

				// これ多分開放できねぇなぁ・・・。まぁほっとくかぁ。
				System.Runtime.InteropServices.Marshal.ReleaseComObject( ptrMetaHost );

			ptrMetaHost = System.IntPtr.Zero;
			string 		sErr = 
					" deleagate variable \"pCLRCreateInstance\" function call failed. > ";

			clscsPub.PErrMsg( sErr );


			return colonyRET_SETUPV4IF.CALL_SETUPV4IF_GETPMETAHOST_CALLING_CLRCREATEINSTANCE_FAILED;
		}


		return colonyRET_SETUPV4IF.CALL_SETUPV4IF_GETPMETAHOST_SUCCEED;

	}	//		Setupv4IF_GetpMetaHost_CallCLRCreateInstance( )



	internal dlgt_GetThreadContext v4DIFSetup_Create_ICorDebugProcess_ComObject_SetFuncPointer_GetThreadContext
	{
		set { this.v4DIFSetup_Create_ICorDebugProcess_ComObject_SetFuncPointer_GetThreadContext = value; }
		get { return this.v4DIFSetup_Create_ICorDebugProcess_ComObject_SetFuncPointer_GetThreadContext; }
	}

	private dlgt_GetThreadContext v4DIFSetup_Create_ICorDebugProcess_ComObject_SetFuncPointer_GetThreadContext
	{
		set { this.mpGetThreadContext = value; }
		get { return this.mpGetThreadContext; }
	}



	internal enum colonyRET_CONNECTV4IF : uint
	{
		CODING_UNFINISHED

	}

	private colonyRET_CONNECTV4IF v4DIFSetup_Create_ICorDebugProcess_ComObject() {
		
		// 現在 PC 値から、	モジュール先頭アドレスを推定する。
		// 「モジュールごとに Map(というか x86 ページ?) が切られている」というのは推定として
		// 合ってるのだろうか？

		// clwWin32Manager 側から、現在のマップ先頭アドレスをもらう必要がある。



		// Win32 側 API 制御にてターゲットプロセスが run 後等に
		// 再度接続された時、再度 OpenVirtualProcess が呼ばれる必要がある。
		// (cordebug.idl   ICorDebugDataTarget  のコメント記述にそう書いてある )

		//  いやぁぁん、どういう構造にしようかしらん・・・。
		//  ブレーク時や接続直後に毎回 ConnectV4IF 呼べばいいんじゃないの？


		clsDipDir				objCleanCur;

		objCleanCur = this.mobjCleanM.Current.CreateChild();
		objCleanCur.IsModule   = false;
		objCleanCur.IsFunc     = true;
		objCleanCur.FuncName   = "Connectv4DIF";



		clsMyCorDebugDataTarget		objMyCoreDebugDataTarget;

		objMyCoreDebugDataTarget = new clsMyCorDebugDataTarget();
		objMyCoreDebugDataTarget.SetFuncPointer_GetThreadContext(
						this.mpGetThreadContext );


		clsWin32.stHResult		stRet;
		stRet = this.mobjClrv4Debugging.OpenVirtualProcess(
				null


				);
		if ( !stRet.success() ) {
		}

		return colonyRET_CONNECTV4IF.CODING_UNFINISHED;
	}




	#if __NOT_CODE_YET__
		// バッファ生成機能付きの ProcessReadMemory ラッパー
		internal bool ReadMemory( System.IntPtr hProcessHandle, clsNuint nuiAddr, clsNuint nuiSize, out byte[] arbytReadData )
		{
			
			clsMySafeHGlobalHandle		safeBuffer;
			int nRet;

			arbytReadData = null;
			if ( nuiAddr.Size != nuiSize.Size ) {
				Console.WriteLine( "\"{0}\".\"{1}\" nuint vars size different error nuiAddr=\"{2}\", nuiSize=\"{3}\". > ", 
								this.ToString(), 
								System.Reflection.MethodBase.GetCurrentMethod().Name,
								nuiAddr.ToString(), nuiSize.ToString() 
								);
				Console.ReadKey();
				return false;
			}

			if ( this.mblIsTarget_64 ) {
				if ( !nuiAddr.Is64bit || !nuiSize.Is64bit ) {
					Console.WriteLine( "\"{0}\".\"{1}\" nuint vars 32 vs this.mblIsTarget_64=true mismatach nuiAddr=\"{2}\", nuiSize=\"{3}\". > ", 
								this.ToString(), 
								System.Reflection.MethodBase.GetCurrentMethod().Name,
								nuiAddr.ToString(), nuiSize.ToString() 
									);
					Console.ReadKey();
					return false;
				}
			} else {
				if ( !nuiAddr.Is32bit || !nuiSize.Is32bit ) {
					Console.WriteLine( "\"{0}\".\"{1}\" nuint vars 64 vs this.mblIsTarget_32=true mismatach nuiAddr=\"{2}\", nuiSize=\"{3}\". > ", 
								this.ToString(), 
								System.Reflection.MethodBase.GetCurrentMethod().Name,
								nuiAddr.ToString(), nuiSize.ToString() 
									);
					Console.ReadKey();
					return false;
				}
			}

			arbytReadData = null;
			using ( safeBuffer = clsMySafeHGlobalHandle.AllocHGlobal( nuiSize.GetInt32Value() ) )
			{
				if ( this.mblIsTarget_64 ) {

					//		https://context.reverso.net/%E7%BF%BB%E8%A8%B3/%E6%97%A5%E6%9C%AC%E8%AA%9E-%E8%8B%B1%E8%AA%9E/%E8%AA%AD%E3%81%BF%E8%BE%BC%E3%81%BE%E3%82%8C%E3%81%9F
					//				「読み込まれた」を英語に翻訳する
					//					Readed ... に最初しようと思ったがやっぱ不自然だな。
					//					loaded だとちょっと意味が違うけど・・・。
					ulong		ulByteSizeLoaded;

					ulByteSizeLoaded = 0;
						
					nRet = clsWin32.ReadProcessMemory_64( 
						hProcessHandle,
						nuiAddr.Value64Internal, 
						safeBuffer.DangerousGetHandle(), 
						nuiSize.Value64Internal, 
						ref ulByteSizeLoaded );
					if ( nRet == 0 ) {
						return false;
					}
					if ( nuiSize != ulByteSizeLoaded )
						return false;

				} else {

					uint		uiByteSizeLoaded;

					uiByteSizeLoaded = 0;
						
					nRet = clsWin32.ReadProcessMemory_32( 
						hProcessHandle,
						nuiAddr.Value32Internal, 
						safeBuffer.DangerousGetHandle(), 
						nuiSize.Value32Internal, 
						ref uiByteSizeLoaded );
					if ( nRet == 0 ) {
						return false;
					}
					if ( nuiSize != uiByteSizeLoaded )
						return false;


				}		// if (this.mblIsTarget_64 ) {


				arbytReadData = new byte[ (int)nuiSize.Get64Value() ];
				System.Runtime.InteropServices.Marshal.Copy( 
							safeBuffer.DangerousGetHandle(), 
							arbytReadData, 0, arbytReadData.Length );

				/* あまり動かんかったら以下つかおっと。 */
				//unsafe {
				//	byte *pData;


				//	pData = (byte *)safeBuffer.DangerousAddRef;
				//	for ( nIndex = 0 ; nIndex < arbytReadData.Length; nIndex++ )
				//	{
				//		arbytReadData[ nIndex ] = *pData;
				//		pData++;
				//	}

				//}	// unsafe


			}	//			using		safeBuffer

			return true;

		}		//			bool ReadMemory()

	#endif


}		// class clsCLRManager


}		// namespace CLR


}		// namespace CliDbger


