// csCLRDebugInterface.cs

	// .Net framework msCorEE.dll から直接呼べる
	// API/com インターフェイス定義をまとめたファイル。
	// 
	//  ほんとは csDbger.cs : class clsCsDebugger
	//  の中に入れたかったけど長くなりそうなので、
	//  namespace CliDbger 名前空間の下に新たに 
	//  namespace CLR 名前空間を定義する。 

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;






using BOOL = System.Int32;



namespace CliDbger {

namespace CLR {



	internal class clsMyCorDebugDataTarget : ICorDebugDataTarget
	{
		internal delegate bool dlgtReadMemory( clsNuint nuiAddr, clsNuint nuiSize, out byte[] arbytReadData );

		internal delegate int dlgt_GetThreadContext(
									uint dwThreadID,
									uint contextFlags,
									uint contextSize,
									[System.Runtime.InteropServices.Out]
									[System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.LPArray, ArraySubType=System.Runtime.InteropServices.UnmanagedType.U1,SizeParamIndex=2)]
									out byte [] pContext);


		private bool							mblIsTarget_64;
		private dlgt_GetThreadContext			mpGetThreadContext;
		private dlgtReadMemory					mpReadMemory;

		internal void SetFuncAddr_ReadMemory ( dlgtReadMemory pFunc ) {
			this.mpReadMemory = pFunc;
		}

		internal clsMyCorDebugDataTarget( bool bIsTarget_64 ) {
			this.mblIsTarget_64 = bIsTarget_64;
			this.mpReadMemory = null;
		}

		internal void SetFuncPointer_GetThreadContext( dlgt_GetThreadContext pGetThreadContext )
		{
			this.mpGetThreadContext = pGetThreadContext;
		}
		

		//HRESULT GetPlatform([out] CorDebugPlatform * pTargetPlatform);
		public int GetPlatform( out colonyCorDebugPlatform pTargetPlatform) {
			if ( System.IntPtr.Size == 4 )
				pTargetPlatform = colonyCorDebugPlatform.CORDB_PLATFORM_WINDOWS_X86;
			else
				pTargetPlatform = colonyCorDebugPlatform.CORDB_PLATFORM_WINDOWS_AMD64;
			return 0;
		}

		//HRESULT ReadVirtual([in] CORDB_ADDRESS address,
		//					[out, size_is(bytesRequested), length_is(*pBytesRead)] BYTE * pBuffer,
		//					[in] ULONG32 bytesRequested,
		//					[out] ULONG32 * pBytesRead);
		public int ReadVirtual( ulong address,
							[System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.LPArray, ArraySubType=System.Runtime.InteropServices.UnmanagedType.IUnknown,SizeParamIndex=1)]
							[System.Runtime.InteropServices.Out]
							out	byte[] pBuffer,
							uint bytesRequested,
							out uint pBytesRead)
		{


			if (this.mpReadMemory == null ) {
				clscsPub.PErrMsg( "member mpReadMemory is not set . " );
				pBuffer = null;
				pBytesRead = 0;
				return -1;
			}

			clsNuint	nuAddr, nuDataLength;
			nuAddr = new clsNuint();
			nuDataLength = new clsNuint();
			if ( !this.mblIsTarget_64 ) {
				nuAddr.Size = 4;
				nuAddr.CastSet( address );
				nuDataLength.Size = 4;
				nuDataLength.Value32Internal = bytesRequested;
			} else {
				nuAddr.Size = 8;
				nuAddr.Value64Internal = address;
				nuDataLength.Size = 8;
				nuDataLength.CastSet( bytesRequested );

			}

			bool		bRet;
			byte[]		bytReaded;
			bRet = this.mpReadMemory( nuAddr, nuDataLength, out bytReaded );
			if ( !bRet ) {
				pBuffer = null;
				pBytesRead = 0;
				return -1;
			}

			pBuffer = bytReaded;
			pBytesRead = (uint)bytReaded.Length;
			return 0;

		}

		//HRESULT GetThreadContext([in] DWORD dwThreadID,
		//						[in] ULONG32 contextFlags,
		//						[in] ULONG32 contextSize,
		//						[out, size_is(contextSize)] BYTE * pContext);
		public int GetThreadContext(
								uint dwThreadID,
								uint contextFlags,
								uint contextSize,
								[System.Runtime.InteropServices.Out]
								[System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.LPArray, ArraySubType=System.Runtime.InteropServices.UnmanagedType.IUnknown,SizeParamIndex=2)]
								out byte [] pContext) {


			// まだからっぽ！
			#error   GetContext を実装せねば。
			int nRet;
			nRet = this.mpGetThreadContext( dwThreadID, contextFlags,
										contextSize,
										out pContext );
			return nRet;
		}




	}







}		// namespace CLR



}		// namespace CliDbger


