// csDbger.cs

	// https://learn.microsoft.com/ja-jp/windows/win32/debug/writing-the-debugger-s-main-loop
	//    デバッガーのメイン Loopの記述
	//  ・・・をまるまるコピー。

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;


// csharp におけるキャスト：
//			dotnet-csharp.pdf
//				1261 ページ	　「暗黙の変換」
//				2657 ページ 	「コンバージョン」
//			・(int)   とかのキャスト・・・いわゆる「明示的な変換」
//			・is, as 演算子の利用
//				is  		: csharp #1.0 
//								右辺が int/double などの型名に限り使用可能
//							: csharp #7.0 以降
//								is null, is int n などの記述が可能
//								Object 型の switch 文が型違っても出来る。羨ましいｗ
//							
//			・System.Convert ,  XXX.ToInt32 などの利用
//			・Interlope.Marshal.xxx によるキャスト？


namespace CliDbger {



internal partial class clsCsDebugger {
	//	VB 側からアクセスする、csharp クラスなので
	// プリフィックスを clsCs にしておく。

	// https://learn.microsoft.com/ja-jp/dotnet/csharp/programming-guide/classes-and-structs/partial-classes-and-methods
	//			部分クラスと部分メソッド
	// 				上記に従ってメソッド宣言と実装を分離してみる。
	//				宣言と実装を分離させると、
	//				・private かつ void
	//				・コントラスタでは使えない
	//				

	private MANAGEDAPI.clsWin32Manager		mobjWin32Manager;
	private CLR.clsCLRManager				mobjCLRManager;

	private clsCleanUpDirManager			mobjCleanUpManager;






	public clsCsDebugger() {
		// コントラスタ

		this.mobjCleanUpManager = new clsCleanUpDirManager();
		this.mobjCleanUpManager.SetRootClassInstance( this );
		this.mobjCleanUpManager.Current.FucName = "clsCsDebugger";
		this.mobjCleanUpManager.Current.ClassType = typeof( clsCsDebugger );

		this.mobjCleanUpManager.Current.Manager = this.mobjCleanUpManager;

		// [CLEANUP:007]
		this.mobjCleanUpManager.Current.Add_CleanupWhenAlways( this );


	
	}

	~clsCsDebugger() {
		this.Dispose();
	}

	internal void Dispose()
	{
		// 何書いたらいいかよく分からん・・・。
		mobjCleanUpManager.Dispose();
		mobjCleanUpManager = null;
	}


	
	#region clsWin32Manager:property / support mini function etc

		// プロパティの書き方はこうでいいのかな？？？
		// /MSDN_pdf/dotnet-csharp.pdf
		//			set アクセサー
		//			1353 ページ
		internal bool IsShowDebugRegister {
			get 
			{
				return this.dat.mbShowDebugRegs;
			}
			set
			{
				this.dat.mbShowDebugRegs = value;
			}
		}

		internal void SetNull_objWin32Manager() {
			this.mobjWin32Manager = null;
		}
		internal void SetNull_objCLRManager() {
			this.mobjCLRManager = null;
		}

	#endregion


	internal enum colonyRETAttachExe : uint
	{
		NOTFOUND_TARGET_PROCESS,
		FAILED_WIN32_DEBUG_ACTIVE_PROCESS,

		FAILED_TO_CREATE_CLRDEBUGGING,

		SUCCESS_TARGET_BREAK_NOW, 
		SUCCESS_BUT_TARGET_EXITED_BY_QUITCMD,
		SUCCESS_BUT_TARGET_EXITED
	}
	internal colonyRETAttachExe AttachExe() {
		/*****************************/
		/*   ターゲットexeに接続      */
		/*****************************/

		#if __DEBUG__
		clscsPub.Warn( " is comming > . " );
		#endif
		//	Console.WriteLine( "hex test : {0:x16}, {1:x16}, {2:x16}" , 
		//			0x1UL, 0x2UL, 0x3UL  );
		//	return true;

		if ( this.mobjCLRManager != null ) {
			this.mobjCLRManager.Dispose();
			this.mobjCleanUpManager.RemoveClassInstance
				( this.mobjCLRManager );

			this.mobjCLRManager = null;
		}

		if ( this.mobjWin32Manager != null ) {
			this.mobjWin32Manager.Dispose();
			this.mobjCleanUpManager.RemoveClassInstance
				( this.mobjWin32Manager );

			this.mobjWin32Manager = null;
		}



		// 今さらだけどクリーンナップ階層を作る
		clsDispDir		objCleanup_AtattchExe;
		objCleanup_AtattchExe = this.mobjCleanUpManager.Root.CreateChild();
		objCleanup_AtattchExe.FuncName = "AttachExe";
		objCleanup_AtattchExe.IsFunc = true;

		this.mobjCleanUpManager.RootFunc = objCleanup_AtattchExe;



		/**********************************************************/
		/*  clsCLRManager.Dispose() クリーンナップ                */
		/*   登録処理                                             */
		/**********************************************************/

		// デバッガ CLR 部分、再起動
		this.mobjCLRManager = new CLR.clsCLRManager();

		{	//			objModule_ClrManager
			
			clsDispDir			objModule_ClrManager;
			objModule_ClrManager = this.mobjCleanUpManager.
								Root.CreateChildModule(
												this.mobjCLRManager, 
												"clsCLRManager", 
												typeof( CLR.clsCLRManager )
										);

			// 関数処理成功時は、CleanUp() 実行で、
			//	objModule_ClrManager に移動するようにする。
			// [CLEANUP:0005]
			objCleanup_AtattchExe.
					Add_CleanupForModuleVariable( 
						this.mobjCLRManager, 
							objCleanup_AtattchExe, 
							objModule_ClrManager, 
							this.SetNull_objCLRManager
					);

		}	// 			objModule_ClrManager


		this.mobjCLRManager.ParentCleanUpManager = 
			this.mobjCleanUpManager;




		/**********************************************************/
		/*  clsWin32Manager.Dispose() クリーンナップ              */
		/*   登録処理                                             */
		/**********************************************************/

		this.mobjWin32Manager = new MANAGEDAPI.clsWin32Manager();


		{	// 	objModule_Win32Manager
			
			clsDipDir			objModule_Win32Manager;
			objModule_Win32Manager = this.mobjCleanUpManager.
								Root.CreateChildModule(
												this.mobjWin32Manager, 
												"clsWin32Manager", 
												typeof( MANAGEDAPI.clsWin32Manager )
										);


			// [CLEANUP:0006]
			objCleanup_AtattchExe.
				Add_CleanupForModuleVariable(
							this.mobjWin32Manager, 
							"", 
							objCleanup_AtattchExe, 
							objModule_Win32Manager, 
							this.SetNull_objWin32Manager );

			/* 上記は以下と同じ */
			/*

			stCleanUp		stpCleanUp = 
								= new stCleanup( stCleanup.colonyWHENDO.ONLYROLLBACK,  objDispoer, sListName  );
			stpCleanup.mbMoveToParent_WhenSuccess	= true;
			stpCleanup.mobjDir_WhenRootFuncSuceed	= objLastDir;
			stpCleanup.mobjDisposerDir_CurentExectingFunction_Root	=
						 objDisposerDir_CurentExectingFunction_Root;
			
			objCleanup_AtattchExe.MultiDisposer.Add_stCleanup( stpCleanup );
			*/


		}	// 	objModule_Win32Manager



		this.mobjWin32Manager.ParentCleanUpManager = 
			this.mobjCleanUpManager;




		this.mobjCleanUpManager.Current  = objCleanup_AtattchExe;
		this.mobjCleanUpManager.RootFunc = objCleanup_AtattchExe;


		/* リモートデバッグ環境だとこうじゃないけど、とりあえず */
		/* デバッグ環境==リモートじゃない、スタンドアロンという前提で。 */
		int n4or8ByteMode;

		if (System.IntPtr.Size == 8) {
			n4or8ByteMode = 8;
		} else {
			n4or8ByteMode = 4;
		}
		this.mobjWin32Manager.ParentCleanUpManager = 
			this.mobjCleanUpManager;
		this.mobjWin32Manager.Init( n4or8ByteMode );





		// プロセスIDを取得
		System.Diagnostics.Process[]	objAllProcess;

		objAllProcess = System.Diagnostics.Process.GetProcessesByName( 
					"mtCalc" );
		

		if ( objAllProcess == null || (objAllProcess.Length == 0 ) ) {
			Console.WriteLine( "mtCalc not found by GetProcessesByName()." );
			return colonyRETAttachExe.NOTFOUND_TARGET_PROCESS;
		}
		int nPid_managed = objAllProcess[ 0 ].Id;

		DWORD		dwPid;
		dwPid = (DWORD)nPid_managed;
		this.mobjWin32Manager.dat.mdwPidForDebugActiveProcess = dwPid;




		CLR.clsCLRManager.v4DIFSetup		nRetClr;


		// すてに Current は "AttachExe" になってるはずだけど、念のため。
		clsPub.Assert( this.mobjCleanUpManager.Current == objCleanup_AtattchExe, 
				"this.mobjCleanUpManager.Current is not  \"objCleanup_AtattchExe\" ! . " );
		this.mobjCleanUpManager.Current = objCleanup_AtattchExe;


		nRetClr = this.mobjCLRManager.CLRSetup();
		if ( nRetClr != CLR.clsCLRManager.v4DIFSetup.
			SUCESS_END_CLRDEBUGGING_IS_CREATED_NOW_DEMANDING_TARGET_PROCESSHANDLE 
			)
		{
			objCleanup_AtattchExe.ErrorCleanUp();

			return colonyRETAttachExe.FAILED_TO_CREATE_CLRDEBUGGING;

		}

		// デバッガをアタッチ
		int	nRet;

		nRet = clsWin32.DebugActiveProcess( dwPid );
		if ( nRet == 0 ) {
			objCleanup_AtattchExe.ErrorCleanUp();
			return colonyRETAttachExe.FAILED_WIN32_DEBUG_ACTIVE_PROCESS;
		}




		Console.WriteLine( "attach success!. ");
		//Console.ReadKey( false );


		#if PROCCESS_THREAD_USE_CODE
			// 旧テストコード
			System.Diagnostics.ProcessThread[]		arThreads;
			arThreads = System.Diagnostics.objAllProcess[ 0 ].Threads
			if ( arThreads == null || arThreads.Length == 0 ) {
				Console.WriteLine( "no thread found.");
				goto  finally_endsequence;
			}

			void*		hThread;
			hThread = arThreads[ 0 ].
		#endif


		#if MISTAKE_OPENTHREAD


			IntPtr		hThread;

			DWORD		dwThreadPermission;

			dwThreadPermission = (DWORD)(
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.DELETE | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.READ_CONTROL | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_GET_CONTEXT | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_QUERY_INFORMATION | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_QUERY_LIMITED_INFORMATION | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_CONTEXT | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_INFORMATION | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_LIMITED_INFORMATION | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_LIMITED_INFORMATION | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_THREAD_TOKEN | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SUSPEND_RESUME | 
				clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_TERMINATE 
				);
			//hThread = clsWin32.OpenThread( (DWORD)clsWin32.colonyTHREAD_ACCESS_PERMISSION.ALL   ,1 , dwPid );
			hThread = clsWin32.OpenThread( dwThreadPermission
			,1 , dwPid );
			if ( hThread == null || hThread == System.IntPtr.Zero ) { 
				Console.WriteLine( "no thread found.");
				goto  finally_endsequence;
			}

			// https://learn.microsoft.com/ja-jp/windows/win32/api/processthreadsapi/nf-processthreadsapi-suspendthread
			//    suspendThread
			DWORD		dwThreadCount;
			dwThreadCount = clsWin32.SuspendThread( hThread );
			if ( dwThreadCount <= 0 ){
				Console.WriteLine( "suspend failed.");
				goto  finally_endsequence_2;
			}
		#endif




		DWORD	dwContinueStatus;
		MANAGEDAPI.stDEBUG_EVENT		stpDebugEv;

		// この段階で、
		//	this.mobjCleanUpManager.Current は "AttachExe" のはず。

		dwContinueStatus = this.mobjWin32Manager.EnterDebugLoop( 
								ref stpDebugEv );



		if ( dwContinueStatus != 
			(DWORD)MANAGEDAPI.clsWin32Manager.colonyDW_MTDBG_CONTINUE_STATUS.TO_UIFLOW_WAITCOMMAND  )
		{
			colonyRETDettachExe ret;
			ret = this.DettachExe_NoCleanUp();
			objCleanup_AtattchExe.ErrorCleanUp();
			return colonyRETAttachExe.SUCCESS_BUT_TARGET_EXITED_BY_QUITCMD;
		}
		


		objCleanup_AtattchExe.SuccessEndCleanUp();
		return colonyRETAttachExe.SUCCESS_TARGET_BREAK_NOW;


	} // bool AttachExe






	internal enum colonyRETDettachExe : uint
	{
		NO_ATACCHED_TARGET,
		SUCCESS
	}

	internal colonyRETDettachExe DettachExe() {
		
	
		colonyRETDettachExe		nRet;

		nRet = this.DettachExe_NoCleanUp();
		if ( nRet != colonyRETDettachExe.SUCCESS ) {
			return nRet;
		}

		// clsWin32Datas を開放する
		clsDispDir	objDisposerDirManager;
		objDisposerDirManager = this.mobjCleanUpManager.Root.
							GetChild_FromFuncName(
										"clsCLRManager" );

		clscsPub.Assert( objDispoer != null, " cleanup Dir \"clsCLRManager\" not found under root children . " );
		if ( objDispoer != null )
			objDisposer.SuccessEndCleanUp();
		
		objDisposer = this.mobjCleanUpManager.Root.
							GetChild_FromFuncName(
										"clsWin32Manager" );

		clscsPub.Assert( objDispoer != null, " cleanup Dir \"clsWin32Manager\" not found under root children . " );
		if ( objDispoer != null )
			objDisposer.SuccessEndCleanUp();
		

		objDisposer = null;

		return colonyRETDettachExe.SUCCESS;

	}		//		colonyRETDettachExe DettachExe()



	internal colonyRETDettachExe DettachExe_NoCleanUp() {
		
		/*****************************/
		/*   ターゲットexe切断        */
		/*****************************/
		if (this.dat == null) {
			return colonyRETDettachExe.NO_ATACCHED_TARGET;
		}
		if ( this.mobjWin32Manager.dat.mdwPidForDebugActiveProcess ==
			(uint)clsDbgDatas.colonyDW_VALUE_STATE.UNSET )
			return colonyRETDettachExe.NO_ATACCHED_TARGET;

		int		nRet;

		nRet = clsWin32.DebugActiveProcessStop( 
					this.dat.mdwPidForDebugActiveProcess
		 					);
		if ( nRet == 0 ) {
			Console.WriteLine( "detach failed.");
		} else {
			Console.WriteLine( "detach sucess!");
		}

		return colonyRETDettachExe.SUCCESS;

	}		//		colonyRETDettachExe DettachExe()









	

	bool WaitKey() {

		// mtCalc : clsMtCalc_help.vb
		
		System.ConsoleKeyInfo		cki;
		cki = Console.ReadKey( true );
		if ( ( cki.Key == System.ConsoleKey.Q      )  ||
		 	 ( cki.Key == System.ConsoleKey.Escape ) ) {
			return true;
		}
		return false;

	}








	// バッファ生成機能付きの ProcessReadMemory ラッパー
	internal bool ReadMemory( clsNuint nuiAddr, clsNuint nuiSize, out byte[] arbytReadData )
	{
		
		clsMySafeHGlobalHandle		safeBuffer;
		int nRet;

		arbytReadData = null;
		if ( nuiAddr.Size != nuiSize.Size ) {
			Console.WriteLine( "\"{0}\".\"{1}\" nuint vars size different error nuiAddr=\"{2}\", nuiSize=\"{3}\". > ", 
							this.ToString(), 
							System.Reflection.MethodBase.GetCurrentMethod().Name,
							nuiAddr.ToString(), nuiSize.ToString() 
							 );
			Console.ReadKey();
			return false;
		}

		if ( this.mblIsTarget_64 ) {
			if ( !nuiAddr.Is64bit || !nuiSize.Is64bit ) {
				Console.WriteLine( "\"{0}\".\"{1}\" nuint vars 32 vs this.mblIsTarget_64=true mismatach nuiAddr=\"{2}\", nuiSize=\"{3}\". > ", 
							this.ToString(), 
							System.Reflection.MethodBase.GetCurrentMethod().Name,
							nuiAddr.ToString(), nuiSize.ToString() 
								);
				Console.ReadKey();
				return false;
			}
		} else {
			if ( !nuiAddr.Is32bit || !nuiSize.Is32bit ) {
				Console.WriteLine( "\"{0}\".\"{1}\" nuint vars 64 vs this.mblIsTarget_32=true mismatach nuiAddr=\"{2}\", nuiSize=\"{3}\". > ", 
							this.ToString(), 
							System.Reflection.MethodBase.GetCurrentMethod().Name,
							nuiAddr.ToString(), nuiSize.ToString() 
								);
				Console.ReadKey();
				return false;
			}
		}

		arbytReadData = null;
		using ( safeBuffer = clsMySafeHGlobalHandle.AllocHGlobal( nuiSize.GetInt32Value() ) )
		{
			if ( this.mblIsTarget_64 ) {

				//		https://context.reverso.net/%E7%BF%BB%E8%A8%B3/%E6%97%A5%E6%9C%AC%E8%AA%9E-%E8%8B%B1%E8%AA%9E/%E8%AA%AD%E3%81%BF%E8%BE%BC%E3%81%BE%E3%82%8C%E3%81%9F
				//				「読み込まれた」を英語に翻訳する
				//					Readed ... に最初しようと思ったがやっぱ不自然だな。
				//					loaded だとちょっと意味が違うけど・・・。
				ulong		ulByteSizeLoaded;

				ulByteSizeLoaded = 0;
					
				nRet = clsWin32.ReadProcessMemory_64( 
					this.mobjWin32Manager.dat.pi.mhProcess,
					nuiAddr.Value64Internal, 
					safeBuffer.DangerousGetHandle(), 
					nuiSize.Value64Internal, 
					ref ulByteSizeLoaded );
				if ( nRet == 0 ) {
					return false;
				}
				if ( nuiSize != ulByteSizeLoaded )
					return false;

			} else {

				uint		uiByteSizeLoaded;

				uiByteSizeLoaded = 0;
					
				nRet = clsWin32.ReadProcessMemory_32( 
					this.mobjWin32Manager.dat.pi.mhProcess,
					nuiAddr.Value32Internal, 
					safeBuffer.DangerousGetHandle(), 
					nuiSize.Value32Internal, 
					ref uiByteSizeLoaded );
				if ( nRet == 0 ) {
					return false;
				}
				if ( nuiSize != uiByteSizeLoaded )
					return false;


			}		// if (this.mblIsTarget_64 ) {


			arbytReadData = new byte[ (int)nuiSize.Get64Value() ];
			System.Runtime.InteropServices.Marshal.Copy( 
						safeBuffer.DangerousGetHandle(), 
						arbytReadData, 0, arbytReadData.Length );

			/* あまり動かんかったら以下つかおっと。 */
			//unsafe {
			//	byte *pData;


			//	pData = (byte *)safeBuffer.DangerousAddRef;
			//	for ( nIndex = 0 ; nIndex < arbytReadData.Length; nIndex++ )
			//	{
			//		arbytReadData[ nIndex ] = *pData;
			//		pData++;
			//	}

			//}	// unsafe


		}	//			using		safeBuffer

		return true;

	}		//			bool ReadMemory()


}		// clsCsDebugger




#if XSTATE_RESEARCH_BIGCOMMENT
	/******************************************/
	/* AVX/AVX2/AVX512 関連                   */
	/* win32Api :                             */
	/*    GetEnabledXStateFeatures ,          */
	/*    InitializeContext                   */
	/*	  GetXStateFeaturesMask               */
	/*	  LocateXStateFeature                 */
	/*	  SetXStateFeaturesMask               */
	/* で使用する XSTATE_xxx, XSTATE_xxx_MASK  */
	/* の値を確定させるために調べた資料         */
	/*                                        */
	/******************************************/
	//
	// 結論：FeatureID の番号と機能名は以下順に従うと推定される。
	//      ・x64 Extend CR0 レジスタ
	//      ・CPUID 命令、EAX=0DH,ECX=0 で指定されるリスト
	//
	// 理由：ntddk.h の表、上記、AVX関連API説明の３つと順序が一致する。
	// 以下、途中で調べた資料：

		// https://learn.microsoft.com/ja-jp/windows/win32/debug/working-with-xstate-context
		//		XState コンテキストの操作
		//			AVX レジスタの操作方法が一応書いてある。
		//			AVX( windows7 SP1以降)、AVX512 ・・・あとは何あるんだろ？？？
		//			*.lib とヘッダが無いから、LoadLibrary/GetProcAddress で各関数を呼べって
		//			書いてあるけど・・・。

		//		https://learn.microsoft.com/ja-jp/windows-hardware/drivers/ddi/ntddk/nf-ntddk-rtlgetenabledextendedfeatures
		//			RtlGetEnabledExtendedFeatures 関数 (ntddk.h)
		//
		//				XSTATE_xxxx の列挙がある。

		//		https://learn.microsoft.com/ja-JP/windows/win32/api/processthreadsapi/nf-processthreadsapi-isprocessorfeaturepresent
		//			IsProcessorFeaturePresent 関数 (processthreadsapi.h)
		//					CPU 個別にこういう機能有効だよ、と教えてくれる。
		//					これ以外だと CPUID 命令使うしかないんじゃないの？

		//		IntelCPUManual/253665-sdm-vol-1.pdf
		//			354 ページ
		//			Example 14-1. Detection of AVX Instruction
		//				AVX の有無を確認するサンプルコードがあるｗ
		//			
		//				OSXSAVE 命令の有効も見ている。
		//				つまり・・・CONTENT は OSXSAVE を足しただけ、
		//				っつぅ事になるな。
		//				and ecx, 018000000H
		//				
		//					1800	0000   D28,D27

		//				IPUID(EAX=1) => ECX の D27,28 =1 かどうか見ている


		// https://www.intel.com/content/www/us/en/developer/tools/isa-extensions/overview.html
		//			Intel 命令拡張/AVX/x64andIA32 マニュアルへのリンク
		//				こっからCPU 固有の情報を得れば良いのだな。
		//				将来的には AVX 対応した方が良いんだろうけど・・・なんかイマイチ言ってる事が意味分からんなぁ。。。
		//				xeon プロセッサにしか命令乗って無いみたいな説明なんだけど・・・。互換マクロで動かす感じなのかな。
		//				面倒臭いけど、後で実装するとなるとますます面倒くさくなるしな～～～、でも多分ほぼ確実に、
		//				将来的に AVX512 を使ったアプリ開発なんてやる見込み、無いしな～～～～～。

		//				パソコン初心者の女子高生です！AVX512 レジスタの使い方を教えて下さい。キャッ!
		//				・・・じゃねーよな・・・・。

		//	https://github.com/tpn/winsdk-10/blob/master/Include/10.0.16299.0/km/ntddk.h
		//			7540 行。 windows Device Drivers Kit (windk)のヘッダじゃないの？
		//			なんかのソースコード。
		//			//	*++ BUILD Version: 0184
		//			ntddk.h のバージョンによって値の定義がこれ全然違うって意味だよな・・・。



					//
					// Known extended CPU state feature BITs
					//
					// 0    x87
					// 1    SSE
					// 2    AVX
					// 3    BNDREGS (B0.LB-B3.LB B0.UB-B3.UB)
					// 4    BNDCSR  (BNDCFGU + BNDSTATUS)       Persistent
					// 5    KMASK   (KMASK [63:0][0-7])
					// 6    ZMM_H   (ZMM_H[511:256][0-15])
					// 7    ZMM     (ZMM[511:0][16-31])
					// 8    IPT                                 Supervisor
					//
					// 62   LWP                                 Persistent
					//
					// 63   RZ0                                 Reserved
					//
					//
					//#define XSTATE_LEGACY_FLOATING_POINT        (0)
					//#define XSTATE_LEGACY_SSE                   (1)
					//#define XSTATE_GSSE                         (2)
					//#define XSTATE_AVX                          (XSTATE_GSSE)
					//#define XSTATE_MPX_BNDREGS                  (3)
					//#define XSTATE_MPX_BNDCSR                   (4)
					//#define XSTATE_AVX512_KMASK                 (5)
					//#define XSTATE_AVX512_ZMM_H                 (6)
					//#define XSTATE_AVX512_ZMM                   (7)
					//#define XSTATE_IPT                          (8)
					//#define XSTATE_LWP                          (62)
					//#define MAXIMUM_XSTATE_FEATURES             (64)
					//
					////
					//// Known extended CPU state feature MASKs
					////
					//
					//#define XSTATE_MASK_LEGACY_FLOATING_POINT   (1ui64 << (XSTATE_LEGACY_FLOATING_POINT))
					//#define XSTATE_MASK_LEGACY_SSE              (1ui64 << (XSTATE_LEGACY_SSE))
					//#define XSTATE_MASK_LEGACY                  (XSTATE_MASK_LEGACY_FLOATING_POINT | \
					//															XSTATE_MASK_LEGACY_SSE)
					//
					//#define XSTATE_MASK_GSSE                    (1ui64 << (XSTATE_GSSE))
					//#define XSTATE_MASK_AVX                     (XSTATE_MASK_GSSE)
					//#define XSTATE_MASK_MPX                     ((1ui64 << (XSTATE_MPX_BNDREGS)) | \
					//                                             (1ui64 << (XSTATE_MPX_BNDCSR)))
					//
					//#define XSTATE_MASK_AVX512                  ((1ui64 << (XSTATE_AVX512_KMASK)) | \
					//                                             (1ui64 << (XSTATE_AVX512_ZMM_H)) | \
					//                                             (1ui64 << (XSTATE_AVX512_ZMM)))
					//
					//#define XSTATE_MASK_IPT                     (1ui64 << (XSTATE_IPT))
					//#define XSTATE_MASK_LWP                     (1ui64 << (XSTATE_LWP))
					//
					//#define XSTATE_MASK_ALLOWED                 (XSTATE_MASK_LEGACY | \
					//                                             XSTATE_MASK_AVX | \
					//                                             XSTATE_MASK_MPX | \
					//                                             XSTATE_MASK_AVX512 | \
					//                                             XSTATE_MASK_IPT | \
					//                                             XSTATE_MASK_LWP)
					//
					//#define XSTATE_MASK_PERSISTENT              ((1ui64 << (XSTATE_MPX_BNDCSR)) | \
					//                                             XSTATE_MASK_LWP)
					//
					////
					//// Flags associated with compaction mask
					////
					//
					//#define XSTATE_COMPACTION_ENABLE            (63)
					//#define XSTATE_COMPACTION_ENABLE_MASK       (1ui64 << (XSTATE_COMPACTION_ENABLE))
					//
					//#define XSTATE_ALIGN_BIT                    (1)
					//#define XSTATE_ALIGN_MASK                   (1ui64 << (XSTATE_ALIGN_BIT))
					//
					//#define XSTATE_CONTROLFLAG_XSAVEOPT_MASK    (1)
					//#define XSTATE_CONTROLFLAG_XSAVEC_MASK      (2)
					//#define XSTATE_CONTROLFLAG_VALID_MASK       (XSTATE_CONTROLFLAG_XSAVEOPT_MASK | \
					//                                             XSTATE_CONTROLFLAG_XSAVEC_MASK)
					//
					////
					//// Extended processor state configuration
					////
					//

		//		・・・という風に、一応は番号が書いてある。が、これは最新の CPU マニュアル
		//		( chapter 13.1 XSAVE-SUPPORTED FEATURES AND STATE-COMPONENT BITMAPS)
		//		より古い。
		//
		//			IntelCPUManual/253668-sdm-vol-3a.pdf
		//				83 ページ
		//					Extended XCR0 レジスタ
		//				上記の XSATE_xxx の順序は、EXCR0 レジスタの順序と
		//				だいたい同じ。


		//		https://lkml.iu.edu/hypermail/linux/kernel/1104.0/01372.html
		//			[RFC v3 7/8] x86, xsave: add kernel support for AMDs Lightweight Profiling (LWP)
		//			
		//			XSTATE_LWP はAMDの命令拡張、Lightweight Profiling (LWP)
		//			らしい。
		//				https://github.com/yse/easy_profiler
		//					yse/easy_profiler / Public
		//					GUI でプログラムのCPU使用率を簡単に見れるようにするための
		//					仕組み、らしい。
		//					スレッドとか、特定の関数単位のブロックでCPU使用率やメモリ使用率を
		//					を簡単にグラフ化出来る機能、らしい。

		//		IntelCPUManual/253666-sdm-vol-2a.pdf
		//			336 ページ
		//			CPUID 命令 EAX=0DH, ECX=0
		//			上記 ntddk.h : XSTATE_xxx と同じ順番のビット配列が EAX レジスタに入るらしい。
		//			同じファイル、337ページ
		//			CPUID 命令 EAX=0DH, ECX=n n > 1
		//				EAX にXSAVE時に使うバイト数、 EBX にXSAVE時に機能ごとのオフセット位置が入る。
		//				CONTENT 構造体は完全にデタラメな定義なので、使わない方がいいって事だね…。
		//
		//		っていうか、ユーザー空間上で XSAVE 命令の動作変更したら
		//		スタックがズレてOS吹っ飛ぶんじゃないのコレ？？？
		//		意味ねーじゃん・・・ｗ
		//		・・・と思ったけど、OS が各機能を有効/無効に自動設定してしまう。
		//		さらに、SetXStateFeaturesMask 関数の説明上では、
		//				https://learn.microsoft.com/ja-jp/windows/win32/api/winbase/nf-winbase-setxstatefeaturesmask
		//					SetXStateFeaturesMask 関数
		//						プロセッサで有効になっていない FeatureMask で
		//						指定された機能は、システムによって自動的に無視されます。
		//		とある。XCR0 レジスタに書き込んでも無効化されるはずだよん、と
		//		言いたいらしい。なんつぅデタラメな一言だ。
		//		念のため、無い/OSが有効化させてない機能は書き込まない方が良いｗ



		//		XSAVE/XRSTORE 命令自体の動きは変わらんはず？


		// IntelCPUManual/intel-avx512-fp16.pdf
		//		Intel®AVX512-FP16 Architecture Specification
		//			7 ページ
		//			コレの
		//
		//				PUID.(7.0).EDX[23] AVX512_FP16 FP16
		//		AVX512 は、64 bit マスク値のうち、D23 なんじゃないの？ｗ

		//	https://learn.microsoft.com/ja-jp/windows/win32/debug/working-with-xstate-context
		//			XState コンテキストの操作
		//
		//			によると、


		//#undef CONTEXT_XSTATE
		//
		//#if defined(_M_X64)
		//#define CONTEXT_XSTATE                      (0x00100040)
		//#else
		//#define CONTEXT_XSTATE                      (0x00010040)
		//#endif
		//
		//// Since the AVX API is not declared in the Windows 7 SDK headers and 
		//// since we don't have the proper libs to work with, we will declare 
		//// the API as function pointers and get them with GetProcAddress calls 
		//// from kernel32.dll.  We also need to set some #defines.
		//
		//#define XSTATE_AVX                          (XSTATE_GSSE)
		//#define XSTATE_MASK_AVX                     (XSTATE_MASK_GSSE)

		// 			・・・・みたいなコードがあるので。


		//			 _M_X64  ってナニ？
		//				https://learn.microsoft.com/ja-jp/cpp/preprocessor/predefined-macros?view=msvc-170
		//					定義済みマクロ
		//				によると
		//						_M_X64 x64 プロセッサまたは ARM64EC を対象とするコンパイルの整数リテラル値 100 として定義されます。
		//						 それ以外の場合は、定義されません。	
		//				とある。
		//
		//				つまり・・・。
		//				64 bit 版バイナリを作ろうとすると、_M_X64は定義される。
		//				32 bit 版バイナリを作ろうとすると、_M_X64は定義されない。
		//
		//				という事ではなく、単純に CONTEXT_XSTATE のビットが、windows7 SP1 以降と以前とで
		//				変更があって違うらしい。でもEnableXStateFutureMaskとかそこら辺ってwin7 SP1 以前って
		//				実装されてないのでは？？？
		//

		// https://learn.microsoft.com/ja-jp/windows-hardware/drivers/kernel/floating-point-support-for-64-bit-drivers
		//			カーネルドライバでの拡張レジスタの使い方
		//				ymm レジスタの保護/復旧方法が書いてある、らしい。
		//				で。
		//					RtlGetEnabledExtendedFeatures 関数を呼び出している。

		//	https://learn.microsoft.com/en-us/windows-hardware/drivers/ddi/wdm/nf-wdm-kesaveextendedprocessorstate
		//			KeSaveExtendedProcessorState function 関数

		//				A caller can set this parameter to the bitwise OR of one or more of the following XSTATE_MASK_XXX flag bits:

		//					Value										Meaning
		//					XSTATE_MASK_LEGACY_FLOATING_POINT			The floating-point extension (x87/MMX).
		//					XSTATE_MASK_LEGACY_SSE						The streaming SIMD extension (SSE).
		//					XSTATE_MASK_LEGACY							Both the x87/MMX and SSE extensions.
		//					XSTATE_MASK_GSSE							The Intel Sandy Bridge (formerly Gesher) SSE extension.
		//					XSTATE_MASK_AVX512							AVX-512 extension
		//					XSTATE_MASK_MPX								MPX extension
		//					XSTATE_MASK_AMX_TILE_CONFIG					AMX extension (configuration)
		//					XSTATE_MASK_AMX_TILE_DATA					AMX extension (data)

		//				この XSTATE_MASK_GSSE, XSTATE_MASK_AVX512 の値が何なのか
		//				分からんと設定しようがない。

		// https://microsoft.github.io/windows-docs-rs/doc/windows/Win32/System/SystemServices/constant.XSTATE_AVX512_KMASK.html
		//			pub const XSTATE_AVX512_KMASK: u32 = 5u32;
		//			でも違ってる気がする。これ Windows RT とかいう、別の体系用の windows の定数じゃねぇの？
		//			pub const XSTATE_GSSE: u32 = 2u32;


	// /IntelCPUManual/325462-sdm-vol-1-2abcd-3abcd.pdf
	//		319 ページ
	//		13.1 XSAVE-SUPPORTED FEATURES AND STATE-COMPONENT BITMAPS
	//			64bit  XSTATE の詳細書いてある
	//		319 ページ
	//		 CHAPTER 13MANAGING STATE USING THE XSAVE FEATURE SET
	//				IA32_XSS MSR ( index DA0H )		
	//				XSAVEOPT  .... ???
	//		13.3 ENABLING THE XSAVE FEATURE SET AND XSAVE-ENABLED FEATURE
	//		323 ページ
	//				XCR0 と IA32_XSS から決定されるビット？機能一覧？
	//
	//
	//		334 ページ
	//				lasrtbranch records
	//		335 ページ
	//				hardware P-states
	//		341 ページ
	//			13.10 OPERATION OF XSAVEC
	//				XSAVEC 命令は compact format らしい。
	//			
	//

#endif 		//		XSTATE_RESEARCH_BIGCOMMENT


#if RESEACH_IPT_TRACE_ENABLING_COMMENTS
	/************************************************************/
	/*                                                          */
	/*                                                          */
	/*	以下は、Trace 機能が使えないかどうかを調べた内容			*/
	/*                                                          */
	/*                                                          */
	/************************************************************/

	//			IntelCPUManual/326019-sdm-vol-3c.pdf
	//				229 ページ
	//				INTEL® PROCESSOR TRACE
	//				・・・なんかAPIでは実装ないみたい？？？
	//				ジャンプとか分岐のトレース出来るはずなのに？？？
	//				イベントは出来るのに？？？
	
	//			https://github.com/ionescu007/winipt
	//				ipt.sys は Windows 10 Spring Update (Version 1803 / Redstone 4), 
	//				くらいから、不完全な形で実装されたらしい。
	//				c:\windows\system32\drivers\ipt.sys  <--   一応ある。
	//				・・・けど、win10 以降サポートってんじゃちょっと無かった事にしたい
	//				って感じ？

	//			https://ionescu007.github.io/winipt/
	//				winipt の説明がちょっとだけある。


	//     	なんとか is32 ビット？を設定できないか？
	//				appDomain から動的にexeを作る方法調査：
	//			https://www.kurusugawa.jp/%E5%8B%95%E7%9A%84%E3%81%AB%E5%AE%9F%E8%A1%8C%E3%83%95%E3%82%A1%E3%82%A4%E3%83%AB%E3%82%92%E4%BD%9C%E3%82%8B/
	//				動的に実行ファイルを作る
	//
	//					・・・では、hello world exe を作る方法が一応書いてある。


	//			/IntelCPUManual/325462-sdm-vol-1-2abcd-3abcd.pdf
	//				
	//						e WRMSR instruction with ECX = DA0H writes 
	//						the 64-bit value in EDX:EAX to the IA32_XSS MSR (EAX is written to IA32_XSS[31:0] and EDX to 
	//						IA32_XSS[63:32]). The following items provide details regarding individual bits in the IA32_XSS MSR

	//				https://social.msdn.microsoft.com/Forums/ie/ja-JP/d802f2ef-f9db-411a-ba61-9b0c1d9e7e5f/x64-readmsr-api?forum=windowsgeneraldevelopmentissuesja
	//					 data = __readmsr(*(ULONG*)lpInBuffer); // MSR ReadAPI
	//				カーネルddk関数としてはあるらしい。


	//				https://learn.microsoft.com/ja-jp/cpp/intrinsics/readmsr?view=msvc-170
	//					__readmsr
	//						やっぱカーネルモードでしか設定できねぇわ。

	//					https://clang.llvm.org/doxygen/intrin_8h_source.html
	//						intrin.h
	//							の中に __readmsr が定義されておる。

	//					https://learn.microsoft.com/en-us/windows/win32/debug/debugging-a-running-process
	//						debug help libyrary
	//						の説明があるけど、trace 関係なんも載ってない。

	//					https://kashiwaba-yuki.com/windows-windbg-008-time-travel-debugging
	//						winDbg を使用した、タイムトラベルデバッギングの紹介
	//							数分程度の実行で数ギガバイトのデータになるそうな。
	//							そら使い物にならんわな。

	//							・・・CPUで実装してんじゃなくって、
	//							これ多分・・・オールステッピングでソフトで
	//							実装してんだろうなぁ。はぁ。。。

	//					https://www.elastic.co/de/security-labs/deep-dive-into-the-ttd-ecosystem
	//						Deep dive into the TTD ecosystem
	//							トレース一応できるけど、なんかダウンロード
	//							せんといかんらしい。いらねぇ・・・・。
	

	//			

	//			winipt は GitHub とかの実装・・・らしい？？？
	//				https://github.com/ionescu007/winipt/blob/master/libipt/win32.c
	//					winipt/libipt/win32.c
	//
	//
	//						CreateFile( "//??//PT", .... )
	//						....
	//						DeviceIoControl ( 構造体で動作決定 )
	//				
	//				https://github.com/ionescu007/winipt/blob/master/inc/ipt.h
	//					winipt/inc/ipt.h
	//								#define IOCTL_IPT_REQUEST \
	//									    CTL_CODE(FILE_DEVICE_UNKNOWN, 1, METHOD_BUFFERED, FILE_ANY_ACCESS)
	//								#define IOCTL_IPT_READ_TRACE \
	//										CTL_CODE(FILE_DEVICE_UNKNOWN, 1, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
	//
	//								このマクロの中身がわかりゃな～～～。
	//								https://learn.microsoft.com/ja-jp/windows-hardware/drivers/kernel/defining-i-o-control-codes
	//										I/O 制御コードの定義
	//								・・・で一応、分解出来なくもなさそう。
	//
	//				すっげーー怪しい。でも一応動くらしい？
	//
	//				ipt.sys 自体はほとんどのプログラムで使われる事は無い、はず。
	//				なのに、win10 から標準搭載ってなんかおかしく無いか？？？
	//
	//		Intel Processor Trace は今回のデバッガで使用可能か？
	//		結論：
	//			可能。
	//			ただし、Windows 10 Spring Update (Version 1803 / Redstone 4)
	//			(2018年 5月ぐらい) 以降で使用可能。
	//			このバージョンアップ以降で、ipt.sys という IPT 制御ドライバが供給される。
	//			本来ならばカーネルモードのドライバを用意すべきだが、カーネルモードのドライバの
	//			作り方が良く分からないし、デバッグする用のPC環境も無いので
	//			MS 供給の ipt.sys を利用すれば、一応実装出来る。
	//
	//			32bit XP でも動くように！！という目標があるので、追加機能みたいな扱いじゃね？
	//
	//			使い方は、
	//				https://github.com/ionescu007/winipt/blob/master/libipt/win32.c
	//					winipt/libipt/win32.c
	//			でやれば出来る気がする。
	//
	/************************************************************/
	/*                                                          */
	/*	Trace 機能調査、ここまで								  */
	/*                                                          */
	/************************************************************/
#endif

	//		file:///F:/Syumi/doc/etc/program/IntelCPUManual/%E6%96%B0%E3%81%97%E3%81%84%E3%83%95%E3%82%A9%E3%83%AB%E3%83%80%E3%83%BC/325462-sdm-vol-1-2abcd-3abcd.pdf
	//				331 ページ
	//				13.5.6 PT State
	//					MSR 内のビット数の位置=8 、XSAVE 内においてIntel Processor Trace 
	//					が構成する 各MSR が各 Xsave Area のそれぞれ８バイトに対応する、
	//					と書いてある。
	//
	//					comprise  :   構成する、の意で良いらしい
	//


}		// namespace CliDbger


