// csDbger_CleanUp.cs

//		アプリケーションで使用されるクリーンナップ
//		とその登録番号を全て明記する。
//		このファイルのコードは一切使われない。

//		 csDebger.cs に関するクリーンナップに関するコメント集

using System;



//#if AAA
//#endif





// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。



namespace CliDbger {



internal partial class clsCsDebugger {

// 
//	[CLEANUP:0001] : 
//		メモリ開放コード：
//			csGetDllName.cs
//			void clsGetDllNameFromHandle.Dispose()
//		処理内容：
//			dll の名前を取得する dll 関数を呼び込む際の
//			DLL の GetModuleHandle( "kernel32.dll ")
//			または LoadLibrary( "psapi.dll ")
//			のハンドルを保持したハンドルを開放する。
//		登録場所：
//			WaitForDebugObject win32 debug API 呼び出し時に
//			 LOAD_DLL_DEBUG_EVENT が始まって
//			csWApiManEevnt.cs : 	OnLoadDllDebugEvent メソッド内で
//			Add_CleanupWhenAlways() として登録される。 
//		実行タイミング：
//			親クラス clsWin32ManagerDatas がメモリ開放される時に
//			実行される。
//			cks
//		クリーンアップチェーン：
//			clsCligbgger.<clsWin32Manager>dat.
//				<mobjMultiDisposer >> clsWin32ManCleanUp>
//						mobjMultiDisposer
//				2番目または登録されない。( LOAD_DLL_INFO が
//					来る場合や順序が違う事がある？)
//		想定されるユーザー操作：
//			デバッガにアタッチしてエラーにより中断した時。
//			デバッガをデタッチした時。
//			デバッガをアタッチしたままデバッガを終了させた時。
//			
//	[CLEANUP:0002] : 
//		メモリ開放コード：
//			csWApiEevnt_CleanUp.cs
//				void clsWin32ManEventCleanUp.Dispose()
//		処理内容：
//			Win32 WaitForDebugObject で帰る構造体が持つ
//			ハンドルを閉じる。
//			CREATE_PROCESS/THREADDEBUG_INFO
//			LOAD_DLL_DEBUG_INFO
//			この３つのうちどれかを受け取った後に
//			ターゲットアプリケーションが落としたまたは
//			落ちている時のみ
//			hFile/hProcess/hThread ハンドルを CloseHandle する。
//		登録場所：
//			WaitForDebugObject win32 debug API 呼び出し時に
//			 LOAD_DLL_DEBUG_EVENT が始まって
//			oManEevnt.cs : 	OnLoadDllDebugEvent メソッド内で
//			Add_CleanupWhenAlways() として登録される。 
//		実行タイミング：
//			親クラス clsWin32ManagerDatas がメモリ開放される時に
//			実行される。
//		クリーンアップチェーン：
//			clsCligbgger.<clsWin32Manager>dat.
//				<mobjMultiDisposer >> clsWin32ManCleanUp>
//						mobjMultiDisposer
//				１番目または登録されない。( LOAD_DLL_INFO が
//					来る場合や順序が違う事がある？
//		想定されるユーザー操作：
//			デバッガにアタッチしてエラーにより中断した時。
//			デバッガをデタッチした時。
//			デバッガをアタッチしたままデバッガを終了させた時。
//	[CLEANUP:0003] : 
//		メモリ開放コード：
//			csWApiThreadContext.cs
//				void clsWin32ManEventCleanUp.Dispose()
//		処理内容：
//			GetThreadContext() 用の戻り値バッファの
//			メモリ開放を clsMySafeHGlobalHandle 経由で行う。
//		登録場所：
//			WaitForDebugObject win32 debug API 呼び出し時に
//			 CREATE_THREAD_DEBUG_EVENT が始まって
//			csWApiManEtc.cs : 	GetWin32RegsAndSetToRegUi メソッド内で
//			Add_CleanupWhenAlways() として登録される。 
//		実行タイミング：
//			親クラス clsWin32ManagerDatas がメモリ開放される時に
//			実行される。
//		クリーンアップチェーン：
//			clsCligbgger.<clsWin32Manager>dat.
//				<mobjMultiDisposer >> clsWin32ManCleanUp>
//						mobjMultiDisposer
//				１～３番目または登録されない。( LOAD_DLL_INFO が
//					来る場合や順序が違う事がある？
//		想定されるユーザー操作：
//			デバッガにアタッチしてエラーにより中断した時。
//			デバッガをデタッチした時。
//			デバッガをアタッチしたままデバッガを終了させた時。
//	[CLEANUP:0004] : 
//		clscsDebugger -> clsWin32Manager ->
//			clsWin32ManagerDatas.Dispose()
//	[CLEANUP:0005] : 
//		clscsDebugger -> NMANAGEDAPI.clsWin32Manager.Dispose()
//	[CLEANUP:0006] : 
//		clscsDebugger -> CLR.clsCLRManager.Dispose()
//
//	[CLEANUP:0007] : 
//		clscsDebugger.Dispose()
//
//	[CLEANUP:0008] : 
//		clscsDebugger ->  CLR.clsCLRManager mobjCLRManager -> 
//			clsCLRManager.CLRSetup() -> clsCLRManager.v4DIFSetup()
//			-> v4DIFSetup.Setupv4IF_GetpMetaHost
//		内 LoadLibrary( "mscoreee.dll" ) のハンドル(safeHandle)
//
//	[CLEANUP:0009] : 
//		clscsDebugger ->  CLR.clsCLRManager mobjCLRManager -> 
//			clsCLRManager.CLRSetup() -> clsCLRManager.v4DIFSetup()
//			にて clsComDisposer( CLR.ICLRDebugging )
//
//				ICLRDebugging インターフェイスオブジェクトのポインタを
//				モジュールレベル clsCLRManager::mobjClrv4Debugging に
//				保存。 clsCLRManager::Dispose() 内で RekaseComObject
//				するようにする
//
//	[CLEANUP:0010] : 
//			clscsDebugger.AattachExe() 処理の
//			エラー発生時に CLR/Win32 各マネージャに null をセットする
//			clscsDebugger 下 CLR/Win32 各モジュールクリーンナップも
//			削除する
//
//	[CLEANUP:0011] : 
//			欠番
//
//	[CLEANUP:0012] : 
//			欠番
//
//	[CLEANUP:0013] : 
//			欠番
//
//	clsMemoryCleanUpManager によるメモリクリーンツリー詳細
//
//		root : 
//		  Module:clscsDbger
//			|		[CLEANUP:007] clscsDebugger.Dispose()
//			|
//			+---- Module : mobjCLRManager  "clsCLRManager"
//			|		[CLEANUP:0005(finally)] CLR.clsCLRManager.Dispose()
//			|		[CLEANUP:0008(Finally)] CLR.clsCLRManager.clsMySafeFreeLibraryHandle
//			|									msfeHandleDllCorEE.Dipose()
//			|		[CLEANUP:0009(Finally)] clsComDisposer( 
//			|				ICLRDebugging mobjCLRManager.mobjClrv4Debugging  )
//			|
//			|
//			+---- Module : mobjWin32Manager  "clsWin32Manager"
//			|			|	[CLEANUP:0006(finally)]
//			|			|				MANAGEDAPI.clsWin32Manager.Dispose()
//			|			|
//			|			+---- Module : dat  "clsWin32ManagerDatas"
//			|							[CLEANUP:0004(finally)] 
//			|								MANAGEDAPI.clsWin32ManagerDatas.Dispose()
//			|								
//			|							[CLEANUP:0002(finally)] clsCallBackDisposer		mobjEventCleanUp
//			|										clsWin32Manager::Dispose_Events
//			|											"clsWin32Manager::Dispose_Events"
//			|					
//			|							[CLEANUP:0003(finally)] clsContentProvider cp
//			|											clsContentProvider::Dispose()
//			|											"clsContentProvider"
//			|					
//			|					---- Module :  "clsGetDllNameFromHandle"
//			|							[CLEANUP:0001(finally)] System.IDisposable mobjGetDllName
//			|											clsGetDllNameFromHandle::Dispose()
//			|											"clsGetDllNameFromHandle"
//			|
//			|
//			|
//			+---- Function : "AttachExe"
//					|	--- [CLEANUP:0008(firstToParent)] CLR.clsCLRManager.Dispose()
//					|			Success To Parent, finally to 
//					|			 Module : mobjCLRManager  "clsCLRManager" Dispose() . 
//					|			
//					|	--- [CLEANUP:0006(firstToParent)] MANAGEDAPI.clsWin32Manager.Dispose()
//					|			Success To Parent, finally to 
//					|			 Module : mobjWin32Manager  "clsWin32Manager"
//					|			
//					|		[CLEANUP:0004(firstToParent)] 
//					|			MANAGEDAPI.clsWin32ManagerDatas.Dispose()
//					|			Success To Parent, finally to 
//					|			 Module : mobjWin32ManagerDatas  "clsWin32ManagerDatas"
//					|			
//					|
//					+----- function :  "v4DIFSetup"
//					|			|			
//					|			+----- function : "v4DIFSetup_GetpMetaHost"
//					|						[CLEANUP:0008(firstToParent)] 
//					|							clsMySafeFreeLibraryHandle( 
//					|						 	clsCLRManager.msfeHandleDllCorEE  ).
//					|								.Dispose()
//					|						Success To Parent, finally to 
//					|						 Module : mobjWin32ManagerDatas  "clsWin32ManagerDatas"
//					|
//					|
//					|	--- [CLEANUP:0009(firstToParent)] clsComDisposer( 
//					|			ICLRDebugging mobjCLRManager.mobjClrv4Debugging  )
//					|			Success To Parent, finally to 
//					|					 Module : mobjCLRManager  "clsCLRManager"
//					|
//					+----- function :  "EnterDebufLoop"
//							|				[CLEANUP:0002(firstToParent)] objCallBackDisposer  
//							|								clsWin32Manager::Dispose_Events
//							|									"clsWin32Manager::Dispose_Events"
//							|				[CLEANUP:0001(firstToParent)] 
//							|								 clsGetDllNameFromHandle::Dispose()
//							|										"clsGetDllNameFromHandle"
//							|				
//							+----- function : "GetWin32RegsAndSetToRegUi"
//													[CLEANUP:0003(firstToParent)] 
//																	ContentProvider
//																			"clsContentProvider"
//






}		// clsCsDebugger






}		// namespace CliDbger


