// csCLRManager.cs

	// csDebger.cs の、mscoreee.dll 
	//  呼び出し部分

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。





//			https://csharpvbcomparer.blogspot.com/2013/05/cast-comparison-1.html
//					キャストの比較 #1 対比表
//						複雑だ。

//			! static_cast 
//			  reinterpret_cast
//				・・・というのは、c++/CLI 独特の文法らしい？
//			  const_cast
//			  dynamic_cast
//					・・・というのもC++にはあるらしい。




using BOOL = System.Int32;



namespace CliDbger {



internal class clsCsRet {

	protected			object		mobjErrCode;
	protected bool					mbError;

	protected internal enum colonyRET : uint
	{
		OK		= 0, 
		NG		, 
		UNSET	
	}

	protected internal enum colonySECCESS_ARG : uint
	{
		SUCCESS = 0, 
		ELSE
	}
	

	#region clsCsRet: constructor / Dispose()
		
		internal clsCsRet() {
			this.mobjErrCode = new object( this.colonyRET.UNSET );
			this.mbError = true;
		}

	#endregion

	#region clsCsRet:property / support mini function etc
		// 今んとこない
	#endregion


	#region clsCsRet:functions


		internal object SetSuccessCode( object objValue ) {
			this.SetCode( colonySECCESS_ARG.SUCCESS, objValue );
		}
		internal object SetErrorCode( object objValue ) {
			this.SetCode( colonySECCESS_ARG.ELSE, objValue );
		}


		private void SetErrorCode( colonySECCESS_ARG enmSuccess_arg, object objErrCode ) {
			
			//		https://www.web-dev-qa-db-ja.com/ja/c%23/%E5%BC%95%E6%95%B0%E4%BB%98%E3%81%8D%E3%81%AE%E3%82%B2%E3%83%83%E3%82%BF%E3%83%BC%E3%83%97%E3%83%AD%E3%83%91%E3%83%86%E3%82%A3/972836184/
			//				c sharp では引数付きプロパティは出来ないらしい。
			//				インデックサ( [...] 配列の添え字指定みたいな )のなら、似たようなのが実装出来るらしい。

			this.mobjErrCode = new object( objErrCode );
			if ( enmSuccess_arg = colonySECCESS_ARG.SUCCESS ) {
				this.mbError = false;
			} else { 
				this.mbError = true;
			}

		}


		protected internal void SetSuccess()
		{
			// とにかくサクセス
			this.mobjErrCode = new object( this.colonyRET.OK );
			this.this.mbError = false;
		}
		protected internal void SetSuccess( object objErrCode )
		{
			// メッセージ付きサクセス
			this.mobjErrCode = new object( objErrCode );
			this.this.mbError = false;
		}




		protected bool Error() {
			// 派生クラスでエラー状況を読めればいい。
			// friend protected としたい所だが、多分無理では。
			return this.mbError;
		}

		protected internal virtual bool IsThisCode( object objCode )
		{

			#if TEST_CODE_FOR_ISERROR
				// テスト２：enum の列挙型の親の名前を取得できるか？

				// test2 
				internal enum colonyVALUES : uint {
					UNSET		= 0,
					SUCCESS
				}


				colonyVALUES		enmValue =colonyVALUES.UNSET; 

				Console.WriteLine( " enmValue.ToString() = {0} ", enmValue.ToString() );

				// 以下は "UInt32" を返す
				//Console.WriteLine( " enmValue.GetTypeCode().ToString() = {0} ", enmValue.GetTypeCode().ToString() );

				// 以下は "CodeTest.csTestMain+colonyVALUES" を返す
				//Console.WriteLine( " enmValue.GetType().ToString() = {0} ", enmValue.GetType().ToString() );

				// 以下は "colonyVALUES" を返す
				Console.WriteLine( " enmValue.GetType().Name = {0} ", enmValue.GetType().Name );

				// 一度オブジェクト型にキャストした後でも取れるか試す
				//object objTest = (object)enmValue;
				// 以下は "colonyVALUES" を返す
				//Console.WriteLine( " objTest.GetType().Name = {0} ", objTest.GetType().Name );


				// 一度オブジェクト型にキャストした後に、enum メンバー値の文字列を取れるか試す
				//object objTest = (object)enmValue;
				// 以下は "" を返す
				//Console.WriteLine( " System.Enum.GetName( objTest.GetType(), objTest ) = {0} ", System.Enum.GetName( objTest.GetType(), objTest ) );


				// gettype した system.Type 型インスタンスは、２つの enum > object 型キャストした物から取得したものが
				// 同一インスタンスであるか確かめるｗこんなの分かるかっつーの！！！
				System.Type		typCode1, typCode2;
				colonyVALUES		enmValue2 =colonyVALUES.UNSET, enmValue3 =colonyVALUES.SUCCESS; 
				object objTest1 = (object)enmValue;
				object			objTest2 = (object)enmValue2, objTest3 = (object)enmValue3;

				typCode1 = objTest1.GetType();
				typCode2 = objTest2.GetType();
				// 以下は "true" を帰す
				Console.WriteLine( " typCode1 == typCode2 ?  = {0} ", (typCode1 == typCode2) );
				// 値が同一であるか確かめる

				// 以下は  を帰す
				// True
				Console.WriteLine( "  ((System.Enum)objTest1).Equals( objTest2 ) ?  = {0} ", ((System.Enum)objTest1).Equals( objTest2 ) );
				// False
				Console.WriteLine( "  ((System.Enum)objTest1).Equals( objTest3 ) ?  = {0} ", ((System.Enum)objTest1).Equals( objTest3 ) );
			#endif

			// 上記の実験から、「指定エラーコードであるか」を判定するコードは以下になる・・・はず。

			if ( this.mobjErrCode.GetType() != objCode.GetType() ) {
				return false;
			}
			System.Enum		objEnmErrCode = (System.Enum)this.mobjErrCode;
			if ( objEnmErrCode.Equals( objCode )  ) {
				return true;
			}
			
			return false;
		}

		protected internal virtual bool Success()
		{
			// 	継承先でオーバーライドして動かす。

			//	
			{		//		bool bUnsetError
				bool		bUnsetError = false;
				if ( this.mobjErrCode == null ) {
					bUnsetError = tue;
				} else if ( this.mobjErrCode is this.colonyRET ) {
					this.colonyRET		nRet;
					nRet = (this.colonyRET)this.mobjErrCode;
					if ( nRet == this.colonyRET.UNSET ) {
						bUnsetError = tue;
					}
				}

				if ( bUnsetError ) {
					return false;
				}
			}	//		bool bUnsetError

			/* ref 構造体渡しにすれば、ポインタ渡しと同じ動作になるかしらん？？ */
			if ( this.mobjErrCode is this.colonyRET) {
				this.colonyRET		nRet;
				nRet = (this.colonyRET)this.mobjErrCode;
				if ( nRet == colonyRET.OK ) {
					return true;
				}
				return false;

			}
			return false;
		}		//		bool Success

		protected internal virtual string GetMsg() {

			if ( this.mobjErrCode is stHResult ) {
				stHResult		stpRet;
				stpRet = (stHResult)this.mobjErrCode;
				return "COM error : " & stpRet.miHResult.ToString( "x8" );
			}


			//				GetType した後に ToString()  だと、" 名前空間 . enum 宣言所属クラス名 . enum グループ名 " になってしまう。

			// https://learn.microsoft.com/ja-jp/dotnet/api/system.type.tostring?view=net-8.0
			//			Type.ToString Method
			//				のサンプルの通り、GetType した後に Name プロパティを使えば、" enum グループ名" だけを取る事が出来る。
			//
			//	でも、それだけだと enum グループ名が取れるだけで、「メンバー宣言名だけ」が取れない。

			// そこで！
			//	https://learn.microsoft.com/ja-jp/dotnet/api/system.enum.getname?view=net-8.0
			//			Enum.GetName メソッド
			//				を使うと「メンバー宣言名だけ」が取れるようになる。

			// 名前空間は省略しても・・・多分平気だよな？多分？？？

			System.Type		typBelongs;
			string			sRet;

			typBelongs = this.mobjErrCode.GetType();
			sRet = typBelongs.Name & " : " & System.Enum.GetName( this.mobjErrCode.GetType(), this.mobjErrCode );

			return sRet;
		}


		public static implicit  operator clsCsRet(int  iValue ) {
			// expliict 、明示的なキャストが必要、でもまぁいいかもしれんけど・・・。
			// HResult を一応受けられるようにしておく。
			// csWin32.cs 参照
			clsCsRet		objRet = new clsCsRet();
			stHResult		stpResult;
			stpResult = iValue;
			if ( stpResult.success() ) {
				objRet.SetSuccess();
			} else {
				objRet.SetCode( stpResult );
			}


			return objRet;
		}		//		operator clsCsRet

	#endregion		//		clsCsRet:functions

}		//	class clsCsRet





}		// namespace CliDbger


