// csGetDllName.cs

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;



// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。




using BOOL = System.Int32;





namespace CliDbger {



namespace MANAGEDAPI {

internal class clsGetDllNameFromHandle	: System.IDisposable
{


	internal Microsoft.Win32.SafeHandles.SafeFileHandle						mKernel32Handle;
	internal clsMySafeFreeLibraryHandle										mPsApiHandle;
	internal clsWin32.dgltGetModuleFileNameExW								pGetModuleFileNameExW;


	internal clsGetDllNameFromHandle() 
	{
		this.mKernel32Handle = null;
		this.mPsApiHandle = null;
		this.pGetModuleFileNameExW = null;
	}




	internal string GetName( IntPtr hProcessHandle, IntPtr hdllHandle )
	{

		// https://learn.microsoft.com/ja-jp/windows/win32/fileio/maximum-file-path-limitation?tabs=registry
		//		パスの最大長の制限

		
		clsMySafeHGlobalHandle				hNameBuf;
		DWORD							dwSize;

		//			Windows 10バージョン 1607以降では長いファイル名を使えるようになった、とか、
		//			 GetVolumeInformation 関数をよんで長さを調べないと駄目だとか。
		//			面倒なので 255 文字(一般的な長さ) x 2にしとく。
		//			っていうか長さ足んなくね？
		dwSize = 255 * 2;


		string sModuleName = null;

		using ( hNameBuf = clsMySafeHGlobalHandle.AllocHGlobal(  (int)dwSize ) )
		{
			if ( hNameBuf == null || hNameBuf.IsInvalid ) {
				// hNameBuf.Dispose();
				return null;
			}

			if (this.pGetModuleFileNameExW == null) {
				this.GetProccAddress();
			}
			if (this.pGetModuleFileNameExW == null) {

				#if __DEBUG__
					//Console.WriteLine( "\"{0}\"{1}\" fail to make pGetModuleFileNameExW delegate. > ", 
					//					this.ToString(), 
					//					System.Reflection.MethodBase.GetCurrentMethod().Name );
					//Console.ReadKey();
				#endif
				// hNameBuf.Dispose();
				return null;
			}


			DWORD	dwRet;
			dwRet = (this.pGetModuleFileNameExW)( 
							hProcessHandle, 
							hdllHandle, 
							hNameBuf.DangerousGetHandle(), 
							dwSize
						);
			if ( dwRet == 0 ) {
				//ptrNameBuf.Dispose();

				//	#if __DEBUG__
				//	clscsPub.PErrMsg( " fail to call pGetModuleFileNameExW, dwRet == 0.  " );
				//	#endif

				return null;
			}
			//#if __DEBUG__
					// clscsPub.PErrMsg(( " dwRet={0}. > ", 
					//						dwRet );
			//#endif


			//sModuleName = ptrNameBuf.ToString();
			//sModuleName = new string( (char *)hNameBuf.DangerousGetHandle() );
			//		https://learn.microsoft.com/ja-jp/dotnet/api/system.runtime.interopservices.marshal.ptrtostringuni?view=net-8.0
			//				Marshal.PtrToStringUni Method
			sModuleName = System.Runtime.InteropServices.Marshal.PtrToStringUni( hNameBuf.DangerousGetHandle() );

			hNameBuf.Dispose();
		}

		return sModuleName;
	}


	private void GetProccAddress()
	{

		System.IntPtr hModule = clsWin32.GetModuleHandleW( "kernel32.dll" );
		if( hModule == System.IntPtr.Zero) {
			clscsPub.PErrMsg( " GetModuleHandleW failed. > " );
			return;
		}

		System.IntPtr functionAddress = clsWin32.GetProcAddress( hModule, "K32GetModuleFileNameExW" ) ;
		if( functionAddress != System.IntPtr.Zero) {

			this.pGetModuleFileNameExW = 
					(clsWin32.dgltGetModuleFileNameExW)
					System.Runtime.InteropServices.Marshal.GetDelegateForFunctionPointer( 
								functionAddress, 
								typeof (clsWin32.dgltGetModuleFileNameExW)
							) ;
			
			this.mKernel32Handle = 
						new Microsoft.Win32.SafeHandles.SafeFileHandle( hModule, true );

			//#if __DEBUG__
				//clscsPub.PErrMsg( " GetProcAddress succss. > " );
			//#endif

			return;
			
		}



		clsWin32.CloseHandle( hModule );
		hModule = IntPtr.Zero;


		hModule = clsWin32.LoadLibraryA( "psapi.dll" );
		if( hModule == System.IntPtr.Zero) {
			//clscsPub.PErrMsg( " LoadLibary failed. > " );
			return;
		}

		functionAddress = clsWin32.GetProcAddress( hModule, "K32GetModuleFileNameExW" ) ;
		if( functionAddress == System.IntPtr.Zero) {
			// clscsPub.PErrMsg( " LoadLibary failed. > " );
			return;
		}



		this.pGetModuleFileNameExW = 
				(clsWin32.dgltGetModuleFileNameExW)
				System.Runtime.InteropServices.Marshal.GetDelegateForFunctionPointer( 
							functionAddress, 
							typeof (clsWin32.dgltGetModuleFileNameExW)
						) ;
			
		this.mPsApiHandle = new clsMySafeFreeLibraryHandle( hModule );
		return;

	}	// GetProccAddress



	//	[CLEANUP:0001] : 
	//		process/dll ハンドルからファイル名を取得する際に呼び出す dll のハンドルを保存する。

	public void Dispose()
	{
		// GetModuleFileNameExW 呼び出し関係のハンドルクローズ 
		if (this.mKernel32Handle != null) {
			if ( !this.mKernel32Handle.IsInvalid ) {
				this.mKernel32Handle.Dispose();
			}
		}
		if ( this.mPsApiHandle != null ) { 
			if ( !this.mPsApiHandle.IsInvalid ) {
				this.mPsApiHandle.Dispose();
			}
		}
		this.pGetModuleFileNameExW = null;

	}	//		void Dispose()



}	//	class clsDllNameGetFromHandle



}		// namespace MANAGEDAPI


}		// cliDbger
