// csManagedDbgApis.cs

//		DEBUG_EVENT イベント関係の 32/64 bit 共通化
//		Debug API の 32/64 bit ラッパー共通化を試みる



using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;



namespace CliDbger {



internal class clsTAddr : clsNuint {
	public clsTAddr( int nDataSize ) : base( MANAGEDAPI.clsManagedDbgApis.TargetBitSize )
	{
	}
	public clsTAddr( uint uiValue ) : base( uiValue )
	{
	}

	public clsTAddr( ulong ulValue ) : base( ulValue )
	{
	}
}
internal class clsTPointer : clsTAddr {
	public clsTPointer( int nDataSize ) : base( MANAGEDAPI.clsManagedDbgApis.TargetBitSize )
	{
	}
	public clsTPointer( uint uiValue ) : base( uiValue )
	{
	}

	public clsTPointer( ulong ulValue ) : base( ulValue )
	{
	}

	// 本家 clsNuint は
	//		clsNuint a = System.IntPtr( 123 );
	// と設定出来ないが、ビットサイズを static グローバルで設定してしまう
	// 派生クラス clsTPointer はこの動作が出来てしまう！
	// 
	public static explicit  operator clsTPointer(System.IntPtr ptrValue ) {
		clsTPointer		objPointerRet;
		objPointerRet = new clsTPointer( MANAGEDAPI.clsManagedDbgApis.TargetBitSize );
		if ( objPointerRet.Size == 4) {

			// キャストエラー出てもしらんぷり・・・
			// なんつう適当なコードなんだ。
			objPointerRet.Value32Internal = 
				unchecked(
					(uint) ptrValue 
				);
		} else {
			objPointerRet.Value64Internal = 
				unchecked(
					(uint) ptrValue 
				);
		}
		return objPointerRet;
	}
}


internal class clsTSize : clsNuint {
	public clsTSize( int nDataSize ) : base( MANAGEDAPI.clsManagedDbgApis.TargetBitSize )
	{
	}
}


namespace MANAGEDAPI {


internal struct stEXCEPTION_RECORD {
	internal DWORD						ExceptionCode;				// 0
	internal DWORD						ExceptionFlags;			// 4
	
	// struct _EXCEPTION_RECORD *ExceptionRecord;
	//internal EXCEPTION_RECORD_x64*    ExceptionRecord;			// 8
	internal clsTPointer				ExceptionRecord;			// 8
	//PVOID                    ExceptionAddress;
	// c# では ulong は 64bit 。超ややこしいｗ
	internal clsTPointer				ExceptionAddress;			// 16
	internal DWORD						NumberParameters;			// 24
	//ULONG_PTR              ExceptionInformation[EXCEPTION_MAXIMUM_PARAMETERS];
	//  たしか・・・15 で合ってたようなｗ
	//  かなり、超怪しい。っていうか書き方分からんよこれｗ
	//internal fixed ulong              ExceptionInformation[ 15 ];	// 28

	internal ulong[]					ExceptionInformation;
} // 計 148 バイト

internal partial struct stEXCEPTION_DEBUG_INFO {
	// partial の理由：Win32 32bit/64bit 構造体から、c#上構造体にデータを
	//					コピーする関数を同じファイル内で宣言されているため。
	//					データ構造部分と、関数を別々に記述した方がコードが
	//					見やすいだろうと思ったため。
	internal stEXCEPTION_RECORD			ExceptionRecord;
	internal DWORD						dwFirstChance;
}

internal partial struct stCREATE_THREAD_DEBUG_INFO {
	internal IntPtr						hThread;
	// LPVOID                 lpThreadLocalBase
	internal clsTPointer				lpThreadLocalBase;
	// LPTHREAD_START_ROUTINE lpStartAddress
	internal clsTPointer				lpStartAddress;
}	// 計 32バイト




internal partial struct stCREATE_PROCESS_DEBUG_INFO {
	//HANDLE                 hFile;
	internal System.IntPtr			hFile;
	//HANDLE                 hProcess;
	internal System.IntPtr			hProcess;
	//HANDLE                 hThread;
	internal System.IntPtr			hThread;
	//LPVOID                 lpBaseOfImage;
	internal clsTPointer			lpBaseOfImage;


	//DWORD                  dwDebugInfoFileOffset;
	internal DWORD                  dwDebugInfoFileOffset;
	
	// DWORD                  nDebugInfoSize;
	internal DWORD                  nDebugInfoSize;
	//LPVOID                 lpThreadLocalBase;
	internal clsTPointer			lpThreadLocalBase;
	//LPTHREAD_START_ROUTINE lpStartAddress;
	internal clsTPointer			lpStartAddress;
	// なんか重要そう？DLL のイメージファイルをロード時に指定とか
	// ファイル名が入るとか何とか。でもいいやｗ
	//LPVOID                 lpImageName;
	internal clsTPointer			lpImageName;
	internal WORD					fUnicode;
}

internal partial struct stEXIT_THREAD_DEBUG_INFO {
	internal DWORD dwExitCode;
}

internal partial struct stEXIT_PROCESS_DEBUG_INFO {
	internal DWORD dwExitCode;
}

internal partial struct stLOAD_DLL_DEBUG_INFO
{
	//HANDLE hFile;
	internal IntPtr				hFile;
	//LPVOID lpBaseOfDll;
	internal clsTPointer		lpBaseOfDll;
	// DWORD  dwDebugInfoFileOffset;
	internal DWORD				dwDebugInfoFileOffset;
	// DWORD  nDebugInfoSize;
	internal DWORD				nDebugInfoSize;
	//LPVOID lpImageName;
	internal clsTPointer		lpImageName;
	internal WORD			   fUnicode;
}


internal partial struct stUNLOAD_DLL_DEBUG_INFO
{
	//LPVOID lpBaseOfDll;
	internal clsTPointer		lpBaseOfDll;
}

internal partial struct stOUTPUT_DEBUG_STRING_INFO
{
	internal clsTPointer		lpDebugStringData;
	internal WORD				fUnicode;
	internal WORD				nDebugStringLength;
}

internal partial struct stRIP_INFO {
	internal DWORD			dwError;
	internal DWORD			dwType;
}

internal partial struct stDEBUG_EVENT
{
	internal clsWin32.colonyDW_DEBUGEVENTCODE		dwDebugEventCode;
	internal DWORD							dwProcessId;
	internal DWORD							dwThreadId;
	internal object 						u;

	
	// u には以下の構造体のどれかが入る。
	//	[System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Explicit)]
	//	internal struct _Union
	//	{
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stEXCEPTION_DEBUG_INFO				Exception;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stCREATE_THREAD_DEBUG_INFO_x86		CreateThread;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stCREATE_PROCESS_DEBUG_INFO_x86		CreateProcessInfo;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stEXIT_THREAD_DEBUG_INFO				ExitThread;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stEXIT_PROCESS_DEBUG_INFO				ExitProcess;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stLOAD_DLL_DEBUG_INFO_x86				LoadDll;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stUNLOAD_DLL_DEBUG_INFO_x86			UnloadDll;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stOUTPUT_DEBUG_STRING_INFO_x86		DebugString;
	//		[System.Runtime.InteropServices.FieldOffset(0)]internal stRIP_INFO							RipInfo;
	//	}
}


//********************************************************/
/*	  構造体の追加関数                                   */
/*********************************************************/

internal partial struct stCREATE_PROCESS_DEBUG_INFO
{
	internal void SetWin32Struct_32( ref clsWin32.CREATE_PROCESS_DEBUG_INFO_x86 stpChild )
	{
		this.hFile 						= stpChild.hFile;
		this.hProcess 					= stpChild.hProcess;
		this.hThread 					= stpChild.hThread;
		this.lpBaseOfImage 				= new clsTPointer( stpChild.lpBaseOfImage );
		this.dwDebugInfoFileOffset		= stpChild.dwDebugInfoFileOffset;

		this.nDebugInfoSize				= stpChild.nDebugInfoSize;
		this.lpThreadLocalBase			= new clsTPointer( stpChild.lpThreadLocalBase );
		this.lpStartAddress				= new clsTPointer( stpChild.lpStartAddress );
		this.lpImageName				= new clsTPointer( stpChild.lpImageName );
		this.fUnicode					= stpChild.fUnicode;

	}

	internal void SetWin32Struct_64( ref clsWin32.CREATE_PROCESS_DEBUG_INFO_x64 stpChild )
	{
		this.hFile 						= stpChild.hFile;
		this.hProcess 					= stpChild.hProcess;
		this.hThread 					= stpChild.hThread;
		this.lpBaseOfImage 				= new clsTPointer( stpChild.lpBaseOfImage );
		this.dwDebugInfoFileOffset		= stpChild.dwDebugInfoFileOffset;

		this.nDebugInfoSize				= stpChild.nDebugInfoSize;
		this.lpThreadLocalBase			= new clsTPointer( stpChild.lpThreadLocalBase );
		this.lpStartAddress				= new clsTPointer( stpChild.lpStartAddress );
		this.lpImageName				= new clsTPointer( stpChild.lpImageName );
		this.fUnicode					= stpChild.fUnicode;

	}

}



internal partial struct stCREATE_THREAD_DEBUG_INFO
{
	internal void SetWin32Struct_32( ref clsWin32.CREATE_THREAD_DEBUG_INFO_x86 stpChild )
	{
		this.hThread 					= stpChild.hThread;
		this.lpThreadLocalBase 			= new clsTPointer( stpChild.lpThreadLocalBase );
		this.lpStartAddress 			= new clsTPointer( stpChild.lpStartAddress );
	}

	internal void SetWin32Struct_64( ref clsWin32.CREATE_THREAD_DEBUG_INFO_x64 stpChild )
	{
		this.hThread 					= stpChild.hThread;
		this.lpThreadLocalBase 			= new clsTPointer( stpChild.lpThreadLocalBase );
		this.lpStartAddress 			= new clsTPointer( stpChild.lpStartAddress );
	}

}



internal partial struct stEXCEPTION_DEBUG_INFO
{
	internal void SetWin32Struct_32( ref clsWin32.EXCEPTION_DEBUG_INFO_x86 stpChild )
	{
		stEXCEPTION_RECORD						stpSet;
		clsWin32.EXCEPTION_RECORD_x86			stpChildChild;
		stpSet = new stEXCEPTION_RECORD();
		stpChildChild = stpChild.ExceptionRecord;

		stpSet.ExceptionCode 			= stpChildChild.ExceptionCode;
		stpSet.ExceptionFlags 			= stpChildChild.ExceptionFlags;
		stpSet.ExceptionRecord 			= new clsTPointer( stpChildChild.ExceptionRecord );
		stpSet.ExceptionAddress			= new clsTPointer( stpChildChild.ExceptionAddress );
		stpSet.NumberParameters 		= stpChildChild.NumberParameters;

		stpSet.ExceptionInformation = new ulong[]{

			stpChildChild.ExceptionInformation0, 
			stpChildChild.ExceptionInformation1,
			stpChildChild.ExceptionInformation2,
			stpChildChild.ExceptionInformation3, 
			stpChildChild.ExceptionInformation4,
			stpChildChild.ExceptionInformation5,
			stpChildChild.ExceptionInformation6, 
			stpChildChild.ExceptionInformation7,
			stpChildChild.ExceptionInformation8,
			stpChildChild.ExceptionInformation9, 
			stpChildChild.ExceptionInformation10,
			stpChildChild.ExceptionInformation11,
			stpChildChild.ExceptionInformation12, 
			stpChildChild.ExceptionInformation13,
			stpChildChild.ExceptionInformation14,
			stpChildChild.ExceptionInformation15
			};
		this.ExceptionRecord			= stpSet;
		this.dwFirstChance				= stpChild.dwFirstChance;

	}

	internal void SetWin32Struct_64( ref clsWin32.EXCEPTION_DEBUG_INFO_x64 stpChild )
	{
		stEXCEPTION_RECORD						stpSet;
		clsWin32.EXCEPTION_RECORD_x64			stpChildChild;
		stpSet = new stEXCEPTION_RECORD();
		stpChildChild = stpChild.ExceptionRecord;

		stpSet.ExceptionCode 			= stpChildChild.ExceptionCode;
		stpSet.ExceptionFlags 			= stpChildChild.ExceptionFlags;
		stpSet.ExceptionRecord 			= new clsTPointer( stpChildChild.ExceptionRecord );
		stpSet.ExceptionAddress			= new clsTPointer( stpChildChild.ExceptionAddress );
		stpSet.NumberParameters 		= stpChildChild.NumberParameters;

		stpSet.ExceptionInformation = new ulong[  ]{

			stpChildChild.ExceptionInformation0, 
			stpChildChild.ExceptionInformation1,
			stpChildChild.ExceptionInformation2,
			stpChildChild.ExceptionInformation3, 
			stpChildChild.ExceptionInformation4,
			stpChildChild.ExceptionInformation5,
			stpChildChild.ExceptionInformation6, 
			stpChildChild.ExceptionInformation7,
			stpChildChild.ExceptionInformation8,
			stpChildChild.ExceptionInformation9, 
			stpChildChild.ExceptionInformation10,
			stpChildChild.ExceptionInformation11,
			stpChildChild.ExceptionInformation12, 
			stpChildChild.ExceptionInformation13,
			stpChildChild.ExceptionInformation14,
			stpChildChild.ExceptionInformation15
			};
		this.ExceptionRecord			= stpSet;
		this.dwFirstChance				= stpChild.dwFirstChance;
	}

}


internal partial struct stEXIT_PROCESS_DEBUG_INFO
{
	internal void SetWin32Struct( ref clsWin32.EXIT_PROCESS_DEBUG_INFO stpChild )
	{
		this.dwExitCode		= stpChild.dwExitCode;

	}
}

internal partial struct stEXIT_THREAD_DEBUG_INFO
{
	internal void SetWin32Struct( ref clsWin32.EXIT_THREAD_DEBUG_INFO stpChild )
	{
		this.dwExitCode		= stpChild.dwExitCode;

	}
}


internal partial struct stLOAD_DLL_DEBUG_INFO
{
	internal void SetWin32Struct_32( ref clsWin32.LOAD_DLL_DEBUG_INFO_x86 stpChild )
	{
		this.hFile						= stpChild.hFile;
		this.lpBaseOfDll				= new clsTPointer( stpChild.lpBaseOfDll );
		this.dwDebugInfoFileOffset		= stpChild.dwDebugInfoFileOffset;
		this.nDebugInfoSize				= stpChild.nDebugInfoSize;
		this.lpImageName				= new clsTPointer( stpChild.lpImageName );
		this.fUnicode					= stpChild.fUnicode;
	}

	internal void SetWin32Struct_64( ref clsWin32.LOAD_DLL_DEBUG_INFO_x64 stpChild )
	{
		this.hFile						= stpChild.hFile;
		this.lpBaseOfDll				=  new clsTPointer( stpChild.lpBaseOfDll );
		this.dwDebugInfoFileOffset		= stpChild.dwDebugInfoFileOffset;
		this.nDebugInfoSize				= stpChild.nDebugInfoSize;
		this.lpImageName				= new clsTPointer( stpChild.lpImageName );
		this.fUnicode					= stpChild.fUnicode;
	}

}


internal partial struct stOUTPUT_DEBUG_STRING_INFO
{
	internal void SetWin32Struct_32( ref clsWin32.OUTPUT_DEBUG_STRING_INFO_x86 stpChild )
	{
		this.lpDebugStringData			= new clsTPointer( stpChild.lpDebugStringData );
		this.fUnicode					= stpChild.fUnicode;
		this.nDebugStringLength			= stpChild.nDebugStringLength;
	}

	internal void SetWin32Struct_64( ref clsWin32.OUTPUT_DEBUG_STRING_INFO_x64 stpChild )
	{
		this.lpDebugStringData			= new clsTPointer( stpChild.lpDebugStringData );
		this.fUnicode					= stpChild.fUnicode;
		this.nDebugStringLength			= stpChild.nDebugStringLength;
	}

}



internal partial struct stRIP_INFO
{
	internal void SetWin32Struct( ref clsWin32.RIP_INFO stpChild )
	{
		this.dwError				= stpChild.dwError;
		this.dwType					= stpChild.dwType;
	}

}


internal partial struct stUNLOAD_DLL_DEBUG_INFO
{
	internal void SetWin32Struct_32( ref clsWin32.UNLOAD_DLL_DEBUG_INFO_x86 stpChild )
	{
		this.lpBaseOfDll			= new clsTPointer( stpChild.lpBaseOfDll );
	}

	internal void SetWin32Struct_64( ref clsWin32.UNLOAD_DLL_DEBUG_INFO_x64 stpChild )
	{
		this.lpBaseOfDll			= new clsTPointer( stpChild.lpBaseOfDll );
	}
}


internal partial struct stDEBUG_EVENT
{

}		//		struct stDEBUG_EVENT


	internal class clsManagedDbgApis
	{

		static private int miTargetBitSize;

		private clsWin32.DEBUG_EVENT_x86			mstpDebugEvent_x86;
		private clsWin32.DEBUG_EVENT_x64			mstpDebugEvent_x64;


		static internal int TargetBitSize {
			set { clsManagedDbgApis.miTargetBitSize = value; }
			get { return clsManagedDbgApis.miTargetBitSize; }
		}



		// コントラスタ
		internal clsManagedDbgApis( int nTargetBitSize )
		{
			clsManagedDbgApis.miTargetBitSize = nTargetBitSize;
			if ( nTargetBitSize == 4 ) {
				this.mstpDebugEvent_x86 = new clsWin32.DEBUG_EVENT_x86();
			} else {
				this.mstpDebugEvent_x64 = new clsWin32.DEBUG_EVENT_x64();
			}
		}




		internal void SetManaged( ref stDEBUG_EVENT stpDbg, ref clsWin32.DEBUG_EVENT_x86 stpBase ) {
			stpDbg.dwDebugEventCode = (clsWin32.colonyDW_DEBUGEVENTCODE)
						stpBase.dwDebugEventCode;
			stpDbg.dwProcessId				= stpBase.dwProcessId;
			stpDbg.dwThreadId				= stpBase.dwThreadId;


			switch ( stpDbg.dwDebugEventCode ) {
			case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_PROCESS_DEBUG_EVENT:
				{
					stCREATE_PROCESS_DEBUG_INFO		stCur;
					stCur = new stCREATE_PROCESS_DEBUG_INFO();
					stCur.SetWin32Struct_32( ref stpBase.u.CreateProcessInfo );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_THREAD_DEBUG_EVENT:
				{
					stCREATE_THREAD_DEBUG_INFO		stCur;
					stCur = new stCREATE_THREAD_DEBUG_INFO();
					stCur.SetWin32Struct_32( ref stpBase.u.CreateThread );
					stpDbg.u = stCur;
				}
				break;

			case clsWin32.colonyDW_DEBUGEVENTCODE.EXCEPTION_DEBUG_EVENT:
				{
					stEXCEPTION_DEBUG_INFO			stCur;
					stCur = new stEXCEPTION_DEBUG_INFO();
					stCur.SetWin32Struct_32( ref stpBase.u.Exception );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.EXIT_PROCESS_DEBUG_EVENT:
				{
					stEXIT_PROCESS_DEBUG_INFO		stCur;
					stCur = new stEXIT_PROCESS_DEBUG_INFO();
					stCur.SetWin32Struct( ref stpBase.u.ExitProcess );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.EXIT_THREAD_DEBUG_EVENT:
				{
					stEXIT_THREAD_DEBUG_INFO		stCur;
					stCur = new stEXIT_THREAD_DEBUG_INFO();
					stCur.SetWin32Struct( ref stpBase.u.ExitThread );
					stpDbg.u = stCur;
				}
				break;

			case clsWin32.colonyDW_DEBUGEVENTCODE.LOAD_DLL_DEBUG_EVENT:
				{
					stLOAD_DLL_DEBUG_INFO		stCur;
					stCur = new stLOAD_DLL_DEBUG_INFO();
					stCur.SetWin32Struct_32( ref stpBase.u.LoadDll );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.OUTPUT_DEBUG_STRING_EVENT:
				{
					stOUTPUT_DEBUG_STRING_INFO		stCur;
					stCur = new stOUTPUT_DEBUG_STRING_INFO();
					stCur.SetWin32Struct_32( ref stpBase.u.DebugString );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.RIP_EVENT:
				{
					stRIP_INFO						stCur;
					stCur = new stRIP_INFO();
					stCur.SetWin32Struct( ref stpBase.u.RipInfo );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.UNLOAD_DLL_DEBUG_EVENT:
				{
					stUNLOAD_DLL_DEBUG_INFO			stCur;
					stCur = new stUNLOAD_DLL_DEBUG_INFO();
					stCur.SetWin32Struct_32( ref stpBase.u.UnloadDll );
					stpDbg.u = stCur;
				}
				break;
			}
		}		// void SetManaged()


		internal void SetManaged( ref stDEBUG_EVENT stpDbg, ref clsWin32.DEBUG_EVENT_x64 stpBase ) {
			stpDbg.dwDebugEventCode = (clsWin32.colonyDW_DEBUGEVENTCODE)
						stpBase.dwDebugEventCode;
			stpDbg.dwProcessId				= stpBase.dwProcessId;
			stpDbg.dwThreadId				= stpBase.dwThreadId;


			switch ( stpDbg.dwDebugEventCode ) {
			case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_PROCESS_DEBUG_EVENT:
				{
						stCREATE_PROCESS_DEBUG_INFO		stCur;
					stCur = new stCREATE_PROCESS_DEBUG_INFO();
					stCur.SetWin32Struct_64( ref stpBase.u.CreateProcessInfo );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_THREAD_DEBUG_EVENT:
				{
					stCREATE_THREAD_DEBUG_INFO		stCur;
					stCur = new stCREATE_THREAD_DEBUG_INFO();
					stCur.SetWin32Struct_64( ref stpBase.u.CreateThread );
					stpDbg.u = stCur;
				}
				break;

			case clsWin32.colonyDW_DEBUGEVENTCODE.EXCEPTION_DEBUG_EVENT:
				{
					stEXCEPTION_DEBUG_INFO			stCur;
					stCur = new stEXCEPTION_DEBUG_INFO();
					stCur.SetWin32Struct_64( ref stpBase.u.Exception );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.EXIT_PROCESS_DEBUG_EVENT:
				{
					stEXIT_PROCESS_DEBUG_INFO		stCur;
					stCur = new stEXIT_PROCESS_DEBUG_INFO();
					stCur.SetWin32Struct( ref stpBase.u.ExitProcess );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.EXIT_THREAD_DEBUG_EVENT:
				{
					stEXIT_THREAD_DEBUG_INFO		stCur;
					stCur = new stEXIT_THREAD_DEBUG_INFO();
					stCur.SetWin32Struct( ref stpBase.u.ExitThread );
					stpDbg.u = stCur;
				}
				break;

			case clsWin32.colonyDW_DEBUGEVENTCODE.LOAD_DLL_DEBUG_EVENT:
				{
					stLOAD_DLL_DEBUG_INFO		stCur;
					stCur = new stLOAD_DLL_DEBUG_INFO();
					stCur.SetWin32Struct_64( ref stpBase.u.LoadDll );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.OUTPUT_DEBUG_STRING_EVENT:
				{
					stOUTPUT_DEBUG_STRING_INFO		stCur;
					stCur = new stOUTPUT_DEBUG_STRING_INFO();
					stCur.SetWin32Struct_64( ref stpBase.u.DebugString );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.RIP_EVENT:
				{
					stRIP_INFO						stCur;
					stCur = new stRIP_INFO();
					stCur.SetWin32Struct( ref stpBase.u.RipInfo );
					stpDbg.u = stCur;
				}
				break;
			case clsWin32.colonyDW_DEBUGEVENTCODE.UNLOAD_DLL_DEBUG_EVENT:
				{
					stUNLOAD_DLL_DEBUG_INFO			stCur;
					stCur = new stUNLOAD_DLL_DEBUG_INFO();
					stCur.SetWin32Struct_64( ref stpBase.u.UnloadDll );
					stpDbg.u = stCur;
				}
				break;
			}
		}		// void SetManaged()




		/*******************************************************/
		/*******************************************************/
		/*******************************************************/
		/* 														*/
		/* WaitForDebugEvent 32/64 bit 共通化 本体				*/
		/* 														*/
		/*******************************************************/
		/*******************************************************/
		/*******************************************************/
		internal bool WaitForDebugEvent( ref stDEBUG_EVENT stpDebugEvent,
												DWORD dwMilliseconds ) {
			bool		bRet;
			int			nRet;

			bRet = false;
			if ( clsManagedDbgApis.miTargetBitSize == 4) {

				nRet = clsWin32.WaitForDebugEvent_32( ref this.mstpDebugEvent_x86, dwMilliseconds );

				if ( nRet != 0 ) {
					this.SetManaged( 
							ref stpDebugEvent, 
							ref this.mstpDebugEvent_x86 );
					bRet = true;
				}
			} else {

				nRet = clsWin32.WaitForDebugEvent_64( ref this.mstpDebugEvent_x64, dwMilliseconds );

				if ( nRet != 0 ) {
					this.SetManaged( 
						ref stpDebugEvent, 
						ref this.mstpDebugEvent_x64 );
					bRet = true;
				}
			}

			
			return bRet;

		}		//		bool WaitForDebugEvent()


	}		// class clsManagedDbgApis




}		// namespace MANAGEDAPI


}		// namespace CliDbger


