// csNuint.cs

	// c sharp ninnt/nuint 型相当で、コードぁらにデータサイズを変更出来る
	// 「型」が欲しかったので追加。



using System;





// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。






namespace CliDbger {



internal class clsNuint : System.IComparable, System.IComparable<clsNuint>, System.IConvertible, System.IEquatable<clsNuint>, System.IFormattable
{

	private uint		mui32Value;
	private ulong		mul64Value;
	private int			mnSize;

	/*******************************************/
	/*   継承:                                 */
	/* Int32 型と同じインターフェイスを継承      */
	/*******************************************/

	/* System.IComparable 実装 */
	/* 名前空間フル記述だと、なんで public 宣言いらねーんだろ・・・謎過ぎる。 */
	//        https://learn.microsoft.com/ja-jp/dotnet/csharp/programming-guide/interfaces/explicit-interface-implementation   
	//					明示的なインターフェイスの実装 (C# プログラミング ガイド
	//						クラスインスタンス変数を、一度インターフェイスインスタンス変数にキャストしないと
	//						アクセス出来ないメソッドというのが、XXX.YYY(.... ) という記述らしい。ややこしいｗ
	public int CompareTo(object other) {
	//public int CompareTo(object other) {
		if (other == null) return 1;

		clsNuint otherclsNuint = other as clsNuint;
		if (otherclsNuint == null)
			//throw new ArgumentException("Object is not a Temperature");
			return 1;

		return this.CompareTo( otherclsNuint );

    }


	/* System.IComparable<T> 実装 */
	public int CompareTo(clsNuint other) {
		if (other == null) return 1;

		int nRet;
		if ( this.Size == 4 && other.Size == 4 ) {
			nRet = this.mui32Value.CompareTo( other.Value32Internal );
		} else {
			ulong ulThis, ulOther;

			if ( this.Size == 4)
				ulThis = unchecked( (ulong)this.Value32Internal );
			else
				ulThis = this.Value64Internal;
			
			if ( other.Size == 4)
				ulOther = unchecked( (ulong)other.Value32Internal );
			else
				ulOther = other.Value64Internal;

			nRet = ulThis.CompareTo( ulOther );
		} 
		return nRet;

    }




	/* System.IConvertible 実装 */
	//	https://learn.microsoft.com/ja-jp/dotnet/api/system.iconvertible?view=netframework-3.5
	//			IConvertible インターフェイス
	//					なんでメソッド名の頭に、IConvertible がいるんだろコレ・・・。
	//					フツーに関数呼べないのかしらん？？？
	public System.TypeCode GetTypeCode()
	{
		//return System.TypeCode.Object;
		if ( this.Size == 4 ) {
			return this.mui32Value.GetTypeCode();
		} else {
			return this.mul64Value.GetTypeCode();
		}
	}

	bool System.IConvertible.ToBoolean(System.IFormatProvider provider)
	{
		bool blRet;
		if ( this.Size == 4 ) {
			if ( this.mui32Value != 0)
				blRet = true;
			else
				blRet = false;
		} else {
			if ( this.mul64Value != 0)
				blRet = true;
			else
				blRet = false;
		}

		return blRet;
	}


	byte System.IConvertible.ToByte(System.IFormatProvider provider)
	{
		byte nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToByte( this.mui32Value );
		else
			nRet = System.Convert.ToByte( this.mul64Value );

		return nRet;
	}

	char System.IConvertible.ToChar( System.IFormatProvider provider)
	{
		System.Char nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToChar( this.mui32Value );
		else
			nRet = System.Convert.ToChar( this.mul64Value );

		return nRet;
	}

	DateTime System.IConvertible.ToDateTime( System.IFormatProvider provider)
	{
		System.DateTime nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToDateTime( this.mui32Value );
		else
			nRet = System.Convert.ToDateTime( this.mul64Value );

		return nRet;
	}

	decimal System.IConvertible.ToDecimal( System.IFormatProvider provider)
	{
		System.Decimal nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToDecimal( this.mui32Value );
		else
			nRet = System.Convert.ToDecimal( this.mul64Value );

		return nRet;
	}

	double System.IConvertible.ToDouble( System.IFormatProvider provider)
	{
		System.Double nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToDouble( this.mui32Value );
		else
			nRet = System.Convert.ToDouble( this.mul64Value );

		return nRet;
	}

	short System.IConvertible.ToInt16( System.IFormatProvider provider)
	{
		System.Int16 nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToInt16( this.mui32Value );
		else
			nRet = System.Convert.ToInt16( this.mul64Value );

		return nRet;
	}

	int System.IConvertible.ToInt32( System.IFormatProvider provider)
	{
		System.Int32 nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToInt32( this.mui32Value );
		else
			nRet = System.Convert.ToInt32( this.mul64Value );

		return nRet;
	}

	long System.IConvertible.ToInt64( System.IFormatProvider provider)
	{
		System.Int64 nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToInt64( this.mui32Value );
		else
			nRet = System.Convert.ToInt64( this.mul64Value );

		return nRet;
	}

	sbyte System.IConvertible.ToSByte( System.IFormatProvider provider)
	{
		System.SByte nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToSByte( this.mui32Value );
		else
			nRet = System.Convert.ToSByte( this.mul64Value );

		return nRet;
	}

	float System.IConvertible.ToSingle( System.IFormatProvider provider)
	{
		System.Single nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToSingle( this.mui32Value );
		else
			nRet = System.Convert.ToSingle( this.mul64Value );

		return nRet;
	}

	string System.IConvertible.ToString( System.IFormatProvider provider)
	{
		System.String nRet;
		if ( this.Size ==4 )
			nRet = String.Format("{0},{1:x8}", this.Size, this.mui32Value );
		else
			nRet = String.Format("{0},{1}:x16", this.Size, this.mul64Value );

		return nRet;
	}

	object System.IConvertible.ToType( System.Type conversionType, System.IFormatProvider provider)
	{
		System.Object nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ChangeType( this.mui32Value, conversionType );
		else
			nRet = System.Convert.ChangeType( this.mul64Value, conversionType );

		return nRet;
	}

	ushort System.IConvertible.ToUInt16( System.IFormatProvider provider)
	{
		System.UInt16 nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToUInt16( this.mui32Value );
		else
			nRet = System.Convert.ToUInt16( this.mul64Value );

		return nRet;
	}

	uint System.IConvertible.ToUInt32( System.IFormatProvider provider)
	{
		System.UInt32 nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToUInt32( this.mui32Value );
		else
			nRet = System.Convert.ToUInt32( this.mul64Value );

		return nRet;
	}

	ulong System.IConvertible.ToUInt64( System.IFormatProvider provider)
	{
		System.UInt64 nRet;
		if ( this.Size ==4 )
			nRet = System.Convert.ToUInt64( this.mui32Value );
		else
			nRet = System.Convert.ToUInt64( this.mul64Value );

		return nRet;
	}







	/* System.IEquatable<clsNuint> 実装 */
	public override int GetHashCode ()
 	{
		 if ( this.mnSize == 4 )
		 	return this.mui32Value.GetHashCode();
		else
			return this.mul64Value.GetHashCode();
	}


	public override bool Equals(System.Object other) {
		/* 元が vitural 宣言なので override がいる */
		if (other == null) return false;

		clsNuint otherclsNuint = other as clsNuint;
		if (otherclsNuint == null)
			//throw new ArgumentException("Object is not a Temperature");
			return false;

		return this.Equals( otherclsNuint );

	}
	public bool Equals(clsNuint other) {
		/* referenceEqual 別途実装でいいよな。 */
		if (other == null) return false;

		bool blRet;
		/* Size=4/8 で混合運用する事ないはずなので関係ないな。 */
		/* List<T>.binarysearch だとか2分探索用じゃないのこれ？ */
		if ( this.Size == 4 && other.Size == 4 ) {
			blRet = this.mui32Value.Equals( other.mui32Value );
		} else {
			ulong ulThis, ulOther;

			if ( this.Size == 4)
				ulThis = unchecked( (ulong)this.Value32Internal );
			else
				ulThis = this.Value64Internal;
			
			if ( other.Size == 4)
				ulOther = unchecked( (ulong)other.Value32Internal );
			else
				ulOther = other.Value64Internal;

			blRet = ulThis.Equals( ulOther );
		}


		return blRet;
	}


	/* System.IFormattable 実装 */
	public string ToString (string format, System.IFormatProvider formatProvider)
	{
		string sRet;

		if ( this.Size == 4)
			sRet = this.mui32Value.ToString( format, formatProvider );
		else
			sRet = this.mul64Value.ToString( format, formatProvider );

		return sRet;
	}


	/********************************/
	/* コントラスタ                  */
	/********************************/
	public clsNuint() {
		this.mnSize = 4;
		this.mui32Value = 0;
		this.mul64Value = 0;
	}
	public clsNuint( clsNuint objNuint ) 
	{
		this.mnSize = objNuint.Size;
		this.mui32Value = objNuint.Value32Internal;
		this.mul64Value = objNuint.Value64Internal;
	}
	public clsNuint( uint uiValue ) {
		this.Init_32( uiValue );
	}
	public clsNuint( ulong ulValue ) {
		this.Init_64( ulValue );
	}
	
	public clsNuint( int nDataSize ) {
		if ( nDataSize == 4) {
			this.Init_32( 0x0 );
		} else {
			this.Init_64( 0x0 );
		}
	}

	private void Init_32( uint uiValue )
	{
		this.mnSize = 4;
		this.mui32Value = uiValue;
		this.mul64Value = 0;
	}
	private void Init_64( ulong ulValue )
	{
		this.mnSize = 8;
		this.mui32Value = 0x0;
		this.mul64Value = ulValue;
	}


	/********************************/
	/* プロパティ                    */
	/********************************/
	internal uint Value32Internal
	{
		// C#6.0 以降は以下記述が可能。
		// 使ってるのは3.5 だからムリ。
		//get =>  this.mui32Value;
		get{		return this.mui32Value;		 }
		set {		this.mui32Value = value;	}
	}


	internal ulong Value64Internal {
		get  {		return this.mul64Value;		}
		set  {		this.mul64Value = value;	}
	}

	internal int Size {
		get { return this.mnSize; }
		set
		{
			if ( value != 4 && value != 8 )
				throw new System.Exception( "size error.");
			this.mnSize = value;
		}

	}

	internal bool Is32bit {
		get {
			return ( this.mnSize == 4);
		}
	}
	internal bool Is64bit {
		get {
			return ( this.mnSize == 8);
		}
	}


	internal clsNuint MaxValue {
		get {
			clsNuint		nuiRet;
			if ( this.Is32bit)
				nuiRet = new clsNuint( uint.MaxValue );
			else
				nuiRet = new clsNuint( ulong.MaxValue );

			return nuiRet;
		}
	}

	/********************************/
	/* 関数                         */
	/********************************/
	internal void CastSet( uint uiValue )
	{
		if ( this.Is32bit ) {
			this.mui32Value = uiValue;
		} else {
			unchecked {
				this.mul64Value =  (ulong)uiValue;
			}
		}
	}
	internal void CastSet( ulong ulValue )
	{
		if ( this.Is32bit ) {
			unchecked {
				this.mui32Value = (uint)ulValue;
			}
		} else {
			this.mul64Value = ulValue;
		}
	}

	internal ulong Get64Value()
	{
		ulong		ulRet;
		if ( this.Is32bit ) {
			unchecked {
				ulRet = (ulong)this.mui32Value;
			}
		} else {
			ulRet = this.mul64Value;
		}
		return ulRet;
	}

	internal int GetInt32Value()
	{
		int		siRet;
		unchecked {
			if ( this.Is32bit ) {
				siRet = (int)this.mui32Value;
			} else {
				siRet = (int)this.mul64Value;
			}
		}
		return siRet;
	}


	internal static string GetHexFromNuint( clsNuint objnuValue, string sWhenNull )
	{
		if ( objnuValue == null )
			return sWhenNull;
		
		string		strRet;
		if ( objnuValue.Size == 4 ) {
			uint		uiData;
			string		sHexed;
			uiData = objnuValue.Value32Internal;
			sHexed = uiData.ToString( "x8" );
			strRet = 	"0x" +
						sHexed.Substring( 0, 4) + " " + 
						sHexed.Substring( 4, 4);
		} else {
			ulong		ulData;
			string		sHexed;
			ulData = objnuValue.Value64Internal;
			sHexed = ulData.ToString( "x16" );
			strRet =	"0x" +
						sHexed.Substring( 0, 4) + " " + 
						sHexed.Substring( 4, 4) + "' " + 
						sHexed.Substring( 8, 4) + " " + 
						sHexed.Substring( 12, 4);

		}
		return strRet;
	}	//		string GetHexFromNuint()


	internal clsNuint GetSafePlus( clsNuint uniPlusValue ) {
		clsNuint	nuiRet;
		nuiRet = new clsNuint( this );

		if ( ~nuiRet < uniPlusValue) {
			nuiRet = nuiRet.MaxValue;
		} else {
			nuiRet += uniPlusValue;
		}
		return nuiRet;
	}

	internal clsNuint GetSafeMinus( clsNuint uniMinusValue ) {
		clsNuint	nuiRet;
		nuiRet = new clsNuint( this );

		if ( nuiRet < uniMinusValue) {
			nuiRet.CastSet( (ulong)0x0 );
		} else {
			nuiRet -= uniMinusValue;
		}
		return nuiRet;
	}



	#region "演算子 実装"
	/*******************************************/
	/*   演算子実装                             */
	/* Int32/64 のみ                            */
	/* +-/*, |&^, <<,>>                        */
	/* ==, !=                                  */
	/*******************************************/

	public static clsNuint operator +( clsNuint value1 , clsNuint value2 )
	{

		// https://learn.microsoft.com/ja-jp/dotnet/csharp/language-reference/language-specification/expressions#the-checked-and-unchecked-operators
		//			checked 演算子と unchecked 演算子
		//				checked   :  System.OverflowException  が発生
		//				unchecked :                            が発生しない。上位ビットが切られる。

		clsNuint		objRet;
		if (     value1.Size == 4 && value2.Size == 4 ) {
			objRet = new clsNuint( unchecked( value1.Value32Internal + value2.Value32Internal )  );
		} else if ( value1.Size == 8 && value2.Size == 4 ) {
			ulong ulValue;
			ulValue = unchecked( (ulong)value2.Value32Internal );
			ulValue = unchecked( ulValue + value1.Value64Internal );
			objRet = new clsNuint( ulValue );
		} else if ( value1.Size == 4 && value2.Size == 8 ) {
			ulong ulValue;
			ulValue = unchecked( (ulong)value1.Value32Internal );
			ulValue = unchecked( ulValue + value2.Value64Internal );
			objRet = new clsNuint( ulValue );
		} else {
			objRet = new clsNuint( unchecked( value1.Value64Internal + value2.Value64Internal ) );
		}
		return objRet;
	}


	/* A + B */
	public static clsNuint operator +( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 + objValue2;
	}

	public static clsNuint operator +( uint value1 , clsNuint value2 )
	{
		return value2 + value1;
	}


	public static clsNuint operator +( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 + objValue2;
	}

	public static clsNuint operator +( ulong value1 , clsNuint value2 )
	{
		return value2 + value1;
	}

	/* A - B */

	public static clsNuint operator -( clsNuint value1 , clsNuint value2 )
	{
		clsNuint		objValue2Minus;
		if ( value1.Size == 4 && value2.Size == 4 ) {
			uint		uiValue2;
			uiValue2 = value2.Value32Internal;
			uiValue2 = unchecked( ~uiValue2 );
			uiValue2 = unchecked( uiValue2 + 1 );

			objValue2Minus = new clsNuint( uiValue2 );
		} else {
			ulong		ulValue2;

			if ( value2.Size == 4 ) {
				ulValue2 = unchecked( (ulong)value2.Value32Internal );
			} else {
				ulValue2 = value2.Value64Internal;
			}
			ulValue2 = unchecked( ~ulValue2 );
			ulValue2 = unchecked( ulValue2 + 1 );

			objValue2Minus = new clsNuint( ulValue2 );

		}
		return  unchecked( value1 + objValue2Minus );
	}


	public static clsNuint operator -( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 - objValue2;
	}
	public static clsNuint operator -( uint value1 , clsNuint value2 )
	{
		clsNuint	objValue1, objValue2, objRet;

		if ( value2.Size == 4 ) {
			objValue1 = new clsNuint( value1 );
			objValue2 = new clsNuint( value2 );

			uint		uiValue2;
			uiValue2 = value2.Value32Internal;
			uiValue2 = unchecked( ~uiValue2 );
			uiValue2 = unchecked( uiValue2 + 1 );
			objValue2 = new clsNuint( uiValue2 );
			objRet    = objValue1 - objValue2;
			
		} else {
			objValue1 = new clsNuint( unchecked( (ulong)value1 ) );
			objValue2 = new clsNuint( value2 );
			ulong		ulValue2;
			ulValue2 = value2.Value64Internal;
			ulValue2 = unchecked( ~ulValue2 );
			ulValue2 = unchecked( ulValue2 + 1 );
			objValue2 = new clsNuint( ulValue2 );
			objRet    = objValue1 - objValue2;
		}

		return objRet;
	}


	public static clsNuint operator -( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 - objValue2;
	}

	public static clsNuint operator -( ulong value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 - value2;
	}

	/* A*B */
	public static clsNuint operator *( clsNuint value1 , clsNuint value2 )
	{
		clsNuint	objRet = null;
		if ( value1.Size == 4 && value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal * value2.Value32Internal );
			objRet = new clsNuint( uiResult );
		} else if ( value1.Size == 8 && value1.Size == 4 ){
			ulong		ulResult, ulValue2;
			ulValue2 = unchecked( (ulong)value2.Value32Internal );
			ulResult = unchecked( value1.Value64Internal * ulValue2 );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 4 && value1.Size == 8 ){
			ulong		ulResult, ulValue1;
			ulValue1 = unchecked( (ulong)value1.Value32Internal );
			ulResult = unchecked(  ulValue1 *  value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 8 && value1.Size == 8 ){
			ulong		ulResult;
			ulResult = unchecked(  value1.Value64Internal *  value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}

	public static clsNuint operator *( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 * objValue2;
	}

	public static clsNuint operator *( uint value1 , clsNuint value2 )
	{
		return value2 * value1;
	}


	public static clsNuint operator *( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 * objValue2;
	}

	public static clsNuint operator *( ulong value1 , clsNuint value2 )
	{
		return value2 * value1;
	}




	/* A / B */
	public static clsNuint operator /( clsNuint value1 , clsNuint value2 )
	{
		clsNuint	objRet = null;
		if ( value1.Size == 4 && value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal / value2.Value32Internal );
			objRet = new clsNuint( uiResult );
		} else if ( value1.Size == 8 && value1.Size == 4 ){
			ulong		ulResult, ulValue2;
			ulValue2 = unchecked( (ulong)value2.Value32Internal );
			ulResult = unchecked( value1.Value64Internal / ulValue2 );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 4 && value1.Size == 8 ){
			ulong		ulResult, ulValue1;
			ulValue1 = unchecked( (ulong)value1.Value32Internal );
			ulResult = unchecked(  ulValue1 /  value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 8 && value1.Size == 8 ){
			ulong		ulResult;
			ulResult = unchecked(  value1.Value64Internal /  value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}


	public static clsNuint operator /( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 / objValue2;
	}

	public static clsNuint operator /( uint value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 / value2;
	}


	public static clsNuint operator /( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 / objValue2;
	}

	public static clsNuint operator /( ulong value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 / value2;
	}




	/* A % B */
	public static clsNuint operator %( clsNuint value1 , clsNuint value2 )
	{
		clsNuint	objRet = null;
		if ( value1.Size == 4 && value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal % value2.Value32Internal );
			objRet = new clsNuint( uiResult );
		} else if ( value1.Size == 8 && value1.Size == 4 ){
			ulong		ulResult, ulValue2;
			ulValue2 = unchecked( (ulong)value2.Value32Internal );
			ulResult = unchecked( value1.Value64Internal % ulValue2 );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 4 && value1.Size == 8 ){
			ulong		ulResult, ulValue1;
			ulValue1 = unchecked( (ulong)value1.Value32Internal );
			ulResult = unchecked(  ulValue1 %  value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 8 && value1.Size == 8 ){
			ulong		ulResult;
			ulResult = unchecked(  value1.Value64Internal % value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}


	public static clsNuint operator %( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 % objValue2;
	}

	public static clsNuint operator %( uint value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 % value2;
	}


	public static clsNuint operator %( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 % objValue2;
	}

	public static clsNuint operator %( ulong value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 % value2;
	}





	/* A & B */
	public static clsNuint operator &( clsNuint value1 , clsNuint value2 )
	{
		clsNuint	objRet = null;
		if ( value1.Size == 4 && value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal & value2.Value32Internal );
			objRet = new clsNuint( uiResult );
		} else if ( value1.Size == 8 && value1.Size == 4 ){
			ulong		ulResult, ulValue2;
			ulValue2 = unchecked( (ulong)value2.Value32Internal );
			ulResult = unchecked( value1.Value64Internal & ulValue2 );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 4 && value1.Size == 8 ){
			ulong		ulResult, ulValue1;
			ulValue1 = unchecked( (ulong)value1.Value32Internal );
			ulResult = unchecked(  ulValue1 & value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 8 && value1.Size == 8 ){
			ulong		ulResult;
			ulResult = unchecked(  value1.Value64Internal & value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}

	public static clsNuint operator &( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 & objValue2;
	}

	public static clsNuint operator &( uint value1 , clsNuint value2 )
	{
		return value2 & value1;
	}


	public static clsNuint operator &( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 & objValue2;
	}

	public static clsNuint operator &( ulong value1 , clsNuint value2 )
	{
		return value2 & value1;
	}



	/* A | B */
	public static clsNuint operator |( clsNuint value1 , clsNuint value2 )
	{
		clsNuint	objRet;
		objRet = null;
		if ( value1.Size == 4 && value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal | value2.Value32Internal );
			objRet = new clsNuint( uiResult );
		} else if ( value1.Size == 8 && value1.Size == 4 ){
			ulong		ulResult, ulValue2;
			ulValue2 = unchecked( (ulong)value2.Value32Internal );
			ulResult = unchecked( value1.Value64Internal | ulValue2 );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 4 && value1.Size == 8 ){
			ulong		ulResult, ulValue1;
			ulValue1 = unchecked( (ulong)value1.Value32Internal );
			ulResult = unchecked(  ulValue1 | value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 8 && value1.Size == 8 ){
			ulong		ulResult;
			ulResult = unchecked(  value1.Value64Internal | value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}

	public static clsNuint operator |( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 | objValue2;
	}

	public static clsNuint operator |( uint value1 , clsNuint value2 )
	{
		return value2 | value1;
	}


	public static clsNuint operator |( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 | objValue2;
	}

	public static clsNuint operator |( ulong value1 , clsNuint value2 )
	{
		return value2 | value1;
	}



	/* A ^ B */
	public static clsNuint operator ^( clsNuint value1 , clsNuint value2 )
	{
		clsNuint	objRet;
		objRet = null;
		if ( value1.Size == 4 && value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal ^ value2.Value32Internal );
			objRet = new clsNuint( uiResult );
		} else if ( value1.Size == 8 && value1.Size == 4 ){
			ulong		ulResult, ulValue2;
			ulValue2 = unchecked( (ulong)value2.Value32Internal );
			ulResult = unchecked( value1.Value64Internal ^ ulValue2 );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 4 && value1.Size == 8 ){
			ulong		ulResult, ulValue1;
			ulValue1 = unchecked( (ulong)value1.Value32Internal );
			ulResult = unchecked(  ulValue1 ^ value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		} else if ( value1.Size == 8 && value1.Size == 8 ){
			ulong		ulResult;
			ulResult = unchecked(  value1.Value64Internal ^ value2.Value64Internal );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}

	public static clsNuint operator ^( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 ^ objValue2;
	}

	public static clsNuint operator ^( uint value1 , clsNuint value2 )
	{
		return value2 ^ value1;
	}


	public static clsNuint operator ^( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 ^ objValue2;
	}

	public static clsNuint operator ^( ulong value1 , clsNuint value2 )
	{
		return value2 ^ value1;
	}





	/* A ~ B */
	public static clsNuint operator ~( clsNuint value1  )
	{
		clsNuint	objRet;
		if ( value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( ~value1.Value32Internal  );
			objRet = new clsNuint( uiResult );
		} else {
			ulong		ulResult;
			ulResult = unchecked( ~value1.Value64Internal );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}





	/* A << B , A >> B */
	public static clsNuint operator <<( clsNuint value1 , int value2 )
	{
		clsNuint	objRet;
		if ( value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal << value2 );
			objRet = new clsNuint( uiResult );
		} else {
			ulong		ulResult;
			ulResult = unchecked( value1.Value32Internal << value2 );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}
	public static clsNuint operator >>( clsNuint value1 , int value2 )
	{
		clsNuint	objRet;
		if ( value1.Size == 4 ){
			uint		uiResult;
			uiResult = unchecked( value1.Value32Internal >> value2 );
			objRet = new clsNuint( uiResult );
		} else {
			ulong		ulResult;
			ulResult = unchecked( value1.Value32Internal >> value2 );
			objRet = new clsNuint( ulResult );
		}
		return objRet;
	}












	/* A == B ? */
	// null 参照出来ないぜ・・・・うはｗｗ
	#if DEBUG_NULL_ERROR
	public static bool operator ==( clsNuint value1 , System.Nullable value2 )
	{
		System.Nullable<clsNuint>	objNullable;
		objNullable = value1;

		if ( objNullable.HasValue == true )
			return true;
		
		return false;
	}
	#endif

	public static bool operator ==( clsNuint value1 , clsNuint value2 )
	{
		//Console.WriteLine( " Operator == : " );
		bool	blvalue1_IsNull, blvalue2_IsNull;
		blvalue1_IsNull = false;
		blvalue2_IsNull = false;
		System.Type		typValue1, typValue2;

	#pragma warning disable 219

		

		// CLiDebuger じゃ使わんけど、ここ
		// if ( value1 is null) {
		//	
		//}
		//		にすれば null 取れるかもしれんね。やってみないと分からないけど。
		
		// Nullable< .... > に書き戻せないものか・・・


		try {
			typValue1 = value1.GetType();
		} catch ( System.NullReferenceException err ) {
			blvalue1_IsNull = true;
			err = null;
		}

		try {
			typValue2 = value1.GetType();
		} catch ( System.NullReferenceException err ) {
			blvalue2_IsNull = true;
			err = null;
		}
	#pragma warning restore 219


		if ( blvalue1_IsNull == true && blvalue2_IsNull == true )
			return true;

		if ( blvalue1_IsNull == true && blvalue2_IsNull == false || 
			 blvalue1_IsNull == false && blvalue2_IsNull == true )
			return false;


		return value1.Equals( value2 );
	}

	public static bool operator ==( clsNuint value1 , uint value2 )
	{
		if ( value1.Is32bit) {
			return ( value1.Value32Internal == value2 );
		}

		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );

		return value1.Equals( objValue2 );
	}

	public static bool operator ==( uint value1 , clsNuint value2 )
	{
		if ( value2.Is32bit) {
			return ( value2.Value32Internal == value1 );
		}

		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 == value2;
	}


	public static bool operator ==( clsNuint value1 , ulong value2 )
	{
		if ( value1.Is64bit) {
			return ( value1.Value64Internal == value2 );
		}

		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 == objValue2;
	}

	public static bool operator ==( ulong value1 , clsNuint value2 )
	{
		if ( value2.Is64bit) {
			return ( value2.Value64Internal == value2 );
		}

		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 == value2;
	}





	/* A != B ? */
	#if DEBUG_NULL_ERROR
	public static bool operator !=( clsNuint value1 , System.Nullable value2 )
	{
		System.Nullable<clsNuint>	objNullable;
		objNullable = value1;

		if ( objNullable.HasValue == true )
			return false;
		
		return true;
	}
	#endif


	public static bool operator !=( clsNuint value1 , clsNuint value2 )
	{
		return !( value1 == value2 );
	}

	public static bool operator !=( clsNuint value1 , uint value2 )
	{
		return !( value1 == value2 );
	}

	public static bool operator !=( uint value1 , clsNuint value2 )
	{
		return !( value1 == value2 );
	}


	public static bool operator !=( clsNuint value1 , ulong value2 )
	{
		return !( value1 == value2 );
	}

	public static bool operator !=( ulong value1 , clsNuint value2 )
	{
		return !( value1 == value2 );
	}



	/* A > B ? */
	public static bool operator >( clsNuint value1 , clsNuint value2 )
	{
		return (   value1.CompareTo( value2 ) > 0   );
	}


	public static bool operator >( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 > objValue2;
	}

	public static bool operator >( uint value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 > value2;
	}


	public static bool operator >( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 > objValue2;
	}

	public static bool operator >( ulong value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 > value2;
	}




	/* A < B ? */
	public static bool operator <( clsNuint value1 , clsNuint value2 )
	{
		return (   value1.CompareTo( value2 ) < 0   );
	}


	public static bool operator <( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 < objValue2;
	}

	public static bool operator <( uint value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 < value2;
	}


	public static bool operator <( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 < objValue2;
	}

	public static bool operator <( ulong value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 < value2;
	}




	/* A >= B ? */
	public static bool operator >=( clsNuint value1 , clsNuint value2 )
	{
		return (   value1.CompareTo( value2 ) >= 0   );
	}


	public static bool operator >=( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 >= objValue2;
	}

	public static bool operator >=( uint value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 >= value2;
	}


	public static bool operator >=( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 >= objValue2;
	}

	public static bool operator >=( ulong value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 >= value2;
	}





	/* A <= B ? */
	public static bool operator <=( clsNuint value1 , clsNuint value2 )
	{
		return (   value1.CompareTo( value2 ) <= 0   );
	}


	public static bool operator <=( clsNuint value1 , uint value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 <= objValue2;
	}

	public static bool operator <=( uint value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 <= value2;
	}


	public static bool operator <=( clsNuint value1 , ulong value2 )
	{
		clsNuint	objValue2;
		objValue2 = new clsNuint( value2 );
		return value1 <= objValue2;
	}

	public static bool operator <=( ulong value1 , clsNuint value2 )
	{
		clsNuint	objValue1;
		objValue1 = new clsNuint( value1 );
		return objValue1 <= value2;
	}

#endregion		// 演算子の実装


	// nuint a = 123;
	// みたいな感じでセット出来るようにしたいが、ビット数の
	// 指定ができねぇ。
	// ビット数を static グローバルにすりゃ出来ない事もないが、
	// その都度データサイズを設定する方法じゃないとかなり危ない気がする。
	//
	// csManagedDbgApis.cs : 派生クラス clsTPointer : clsNuint
	//  ならそんなに危なくないから実装しても、まぁ良いだろう？？？
	//
	//public static implicit  operator Nuint(uint  uiValue ) {
	//	if ( this)
	//	return new stHResult( iValue );
	//}


}		// clsNuint


internal class clsNuiRange
{
	private clsNuint mnuiSta, mnuiEnd;

	internal clsNuint nuiSta {
		get { return this.mnuiSta; }
		set { this.mnuiSta = new clsNuint( value ); }
	}
	internal clsNuint nuiEnd {
		get { return this.mnuiEnd; }
		set { this.mnuiEnd = new clsNuint( value ); }
	}
	
	internal clsNuint nuiLength {
		get { 
			if ( this.mnuiSta > this.mnuiEnd  ) {
				Console.WriteLine( "\"{0}\".\"{1}\" this.mnuiSta > this.mnuiEnderror. this.mnuiSta=\"{2}\", this.mnuiEnd=\"{3}\". > ", 
				this.ToString(), 
				System.Reflection.MethodBase.GetCurrentMethod().Name,
				this.mnuiSta.ToString(), this.mnuiEnd.ToString() 
					);
				Console.ReadKey( false );
				return null;
			}
			return this.mnuiEnd - this.mnuiSta;
		}
	}
	
	internal bool IsValid {
		get {
			if ( this.mnuiSta == null || this.mnuiEnd == null )
				return false;

			if ( this.mnuiSta > this.mnuiEnd )
				return false;
			
			return true;
		}
	}

	internal clsNuiRange( int nDataSize )
	{
		this.mnuiSta = new clsNuint( nDataSize );
		this.mnuiEnd = new clsNuint( nDataSize );
	}
	
	internal clsNuiRange( clsNuint nuiValueSta, clsNuint nuiValueEnd )
	{
		if ( nuiValueSta != null && nuiValueEnd != null ) {
			if ( nuiValueSta.Size != nuiValueEnd.Size ) {
				this.mnuiSta = null;
				this.mnuiEnd = null;
				return;
			}
		}
		this.mnuiSta = new clsNuint( nuiValueSta );
		this.mnuiEnd = new clsNuint( nuiValueEnd );
	}

	

}		//		class clsNuiRange


}		// namespace CliDbger
