// csWApiData.cs

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;



// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。




using BOOL = System.Int32;





namespace CliDbger {



namespace MANAGEDAPI {


internal partial class clsWin32ManagerDatas : System.IDisposable
{

	#region CleanUp についての考え事メモ
		//　dbgmtfile から clidbger.clsWin32ManagerData に移行した。
		//  ~> 旧 clsDebuggerData の init 等が全部使えなくなった。

		// データどうしよう？
		// ？1 MultiDisposer () による データ消去方法に移行？
		// ？2 safeHandle 、Finilize() を用意してそこで開放？
		// ？3 using .... によるブロック式に変更する？？？

		//  ？2-？3  形式でないと、なぜかウィルスソフトが
		//    ソフトを停止させてしまう？謎だ。
		//			==> 原因をもっとよく調べないとなんとも・・・。

		// ！ CREATE_DEBUG_PROCESS_EVENT の hModule/hProcess
		//    取り扱いが面倒。

		//  どう弄っても綺麗なデータ消去構造が思い浮かばない・・・

		//  ・safeHandle / Finalize 式だと、別のモジュールに
		//    safeHandle ハンドルを渡した時に勝手に開放してしまう。
		//    IntPtr で渡してるのとなんも変わらん上に、
		//    開放時にリソースが既に開放されていたのかを知る方法がない。


		// 案：
		//	clsWin32ManagerDatas に Dispose(), Finalize() を実装。
		//    Finalize() に MutiDisposer().CleanUp を呼び出す？

		//   cleanup ３つ。
		//			・エラー時メモリクリア
		//			・正常終了時に継続運用用メモリクリア
		//			・終了時にぜんぶのメモリをクリアするメモリクリア

		//  当面は CLR + win32Dbug 双方でメモリウォッチ/ブレーク/ステップ/goが
		//  出来るかを検証するのが目的なので。
		//  小手先変更でその場しのぎのコードとする。

		//	×：　クラスごとに close()
		//				あっちこっちで変な処理していて分かりにくい
		//	×：　Data クラスで close()
		//				なんで駄目なんだっけ？？？
		//				なんか気に入らなかった気がするけれど覚えて無いな…
		//				CleanUp 構造に変更したくても出来ない。データを追加しずらい。
		//
		//					～＞ XXXXdef.cs でクラスが持つ変数名を分かりやすくしておく。
		
		//
		//		現行改修決定：
		//			Exception.cs でクラスの void func().... を
		//			CleanUp に登録できるようにする。
		//			CleanUp で「メモリ開放コード」を見なくてもよいようにする？
		//				これでも、コードの可読性が急激に落ちるんだよな。
		//
		//				クリーンナップのコードがずらっと見れればいいんだけど。
		//
		//			～＞メモリ確保・メモリ開放の関数を対に出来ないものか・・・。
		//				namespacefunc.alloc()
		//				func.release()
		//				わざわざクラス・構造体宣言はコードの可読性が落ちるしなぁ。
		//			
		//				LINQ/・・・ラムダ式が使えればなぁ。
		//				バージョン古いから諦めるか…。
		//								2023/11/24 AM09:51

		// 
		//		CleanUp の中身がどの順序でなんの処理をやっているか
		//		分からない：
		//				～＞
		//				MultiDisposer を派生して、クリーン手順をコード化する。
		//				コードとしては、
		//				 objXXDispoer.ClenupSuccessEnd();
		//				で、この中身は、

		//					#define CLEANUP_VISIBLE
		//					#if CLEANUP_VISIBLE
		//						internal new void ClenupSuccessEnd() {
		//							stCleanupInfo		stpClenUp;
		//							stpClenUp = (stCleanUp)( this.mStack.Pop());
		//							if ( this.mStack.COunt == 7 ) {
		//								// 処理をかく
		//							}

		//						}


		//				dotnet-csharp.pdf : 1843 ページ
		//					アクセシビリティ レベル
		//					・・・によると、派生クラスで継承元クラスの
		//					変数とかをアクセスするには、
		//					protect 宣言に変えないと駄目らしい？

		//					protected:
		//					private protected:
		//					　dll 経由でクラスを参照して、
		//					　そこで派生して、その参照先で参照出来るかどうか！
		//					　アセンブリ境界を超えて、アクセス禁止にするかどうか！！
		//					　ややこし過ぎるぜ～～～～。
		//					　レジストリに変な値をじゃんじゃん書き込まれても困るし、原則的に
		//					　protected は使われなくて、
		//					　protected internal  ： 現在のアセンブリ、
		//							またはよそのアセンブリの継承クラスから
		//							参照出来る、という意味らしい。
		//							dll 超えても継承元から読めるらしい。意味分からんｗ
		//					　private protected だろうな。

		//					・・・と思ったが、private protected は
		//					c sharp 7.2 以降かららしいｗ

		//					 以後、protected 宣言は使用禁止！
		//					public は internal に！！
		//					protected 宣言は  protected 宣言のみとする！！
		//					
		//					
	#endregion


	// コントラスタ
	public clsWin32ManagerDatas()
	{
		this.Init();
	}

	// デストラクタ
	//	・・・一応あるが、いつ呼ばれるかはガベージコレクタ次第。
	//  ・・・って、public も private もデストラクタにはつけちゃ
	//  いけないのかよ・・・知らんかった・・・謎が多過ぎるわｗ
	~clsWin32ManagerDatas()
	{
		this.Dispose();
	}

	public void Init()
	{


		this.mdwPidForDebugActiveProcess	= (DWORD)colonyDW_VALUE_STATE.UNSET;
		this.mdwProcessId            = (DWORD)colonyDW_VALUE_STATE.UNSET;
		this.mdwThreadId             = (DWORD)colonyDW_VALUE_STATE.UNSET;

		this.mbValid_pi     = false;
		this.mbValid_dll    = false;
		this.mbValid_thread = false;

		//this.mobjMultiDisposer = new clsMultiDisposer();
		clscsPub.Assert( this.mobjCLeanM != null );

		this.mobjEventCleanUp = null;

		this.marDllNames = 
			new System.Collections.Generic.List<string>();
		//mobjMultiDisposer.Add_CleanupWhenAlways();

		this.mobjRegs = new clsRegToUi();

		// GetThreadContext を完全に実装するには・・・。
		//  cpuid 命令から xsave/ xstore 命令がどんな内容を返すのか、
		// を調べないといけない。
		//
		// 完全新作の dll を用意するか、CreateFileObject か、virtualAlloc/CirtualProtect
		// でアセンブラを動かせる方法を確立しなきゃいけない。
		// ちょっと実装無理しょこれわとりあえずはｗ
		this.cp = null;

	}

	internal void Close()
	{
		// 開いてるデバッグセッションを閉じるがデバッガは終了させない
		this.Dispose();
	}

	internal void Exit()
	{
		// 終了してアプリケーション全体を終了する
		this.Dispose();
	}

	internal void Dispose()
	{
		// Dispose()         : 親オブジェクト開放直前に、必ず全てのメモリ開放をする。
		// CleanUpWhenErr    : エラー発生時に、途中で作った物をメモリ開放する。
		// CleanUpSuccessEnd : 正常終了処理時に、成果オブジェクトは開放せずに
		//						途中で作った中間生成インスタンスのみ開放する。
		// CleanUpFinalize  : Dispose() と同じ。

		// ??? DebugIvent == DLL/thread/process 開始時に、
		//          ターゲットプロセスが生存している場合のみ
		//          各種ハンドルを開放する。
		//
		//      ↑これは上の４つのうちどれに該当するのだ？
		//
		//
		//   Dispose() の条件を拡張して、条件付き開放に変更する事にしよう。

		if ( this.mobjRegs != null ) {
			this.mobjRegs.Close();
		}
		this.mobjRegs = null;


		// 親の multDisposer に登録されてる
		//  クリーンナップチェーンは呼び出さなくても
		//  いいか・・・？？別に？？？？

		// 本当だったら個別に親のクリーンナップチェーンから、
		// push されたクリーンナップを探し出して
		// 実行し、stack から間引きしないと駄目なんだよな。
		// でも簡単にはコード出来ないしなぁ・・・。

		// このコードは・・・上位の clsWin32Manager か
		// その上の、clscsDbger でやるべきだよなぁ・・・。

		// 上位側で、アプリケーション起動時か、
		// Connect > エラー発生時に mobjMultiDisposer.SuccessEndCleanUp();
		// としたい所なんだけどなぁ。。。

		// でもここで Dispose() として入れとかないと、
		// なんかマズイ気がする。
		// 上位側で clsWin32Manager インスタンスの Dispose() を
		// し忘れた時に、clsWin32Manager ファイナライザが起動して
		// この処理をやってくれるんだよな？？？
		// いやファイナライザは扱いが面倒そうだから、使わない方向に
		// したはず。
		//		'24.05.10 追記:
		// 		というのも、ファイナライザを実行するようにすると、
		// 		メモリ開放のタイミングがガベージコレクタ依存になってしまう、
		// 		というのと、なんか、クラスインスタンスをポインタ渡しした際に
		// 		ポインタ渡しをした元のクラスインスタンスと、
		// 		ポインタ渡しをした先のクラスインスタンス双方で、
		// 		ファイナライザが起動してしまうのでは？という疑惑をずっと
		// 		抱えていた。
		// 		この疑惑は、Bing に質問する事で解決したはずで、
		//		実際には一度しかファイナライザが起動しないはず。



		// 問題なのは、ここで、mobjMutiDisposer.SuccessEndCleanUp / 
		//	ErrorCleanUp を呼び出すと、上位側で必要なエラーチェーン
		// まで起動してしまう点。

		//		'24.05.10 追記:
		//		 なので、関数ごと、モジュールごとにクリーンナップ「階層フレーム」
		//			を設け、それを clsDispDir とした。

		// かといって、clsWin32Manager のためだけに
		// MultiDisposer インスタンスを保有するのもちょっと
		// MultiDisposer があっちにもこっちにも、ってのは
		// 処理的になんか分かりずらい気がするんだよなぁ。

		// むしろ以下のは、予想外の終了でファイナライザが起動した時用の
		// 扱いでいいのかしら？？よく分からん・・・
		// 根本的に設計不良、検討不足が多過ぎるような・・・。


		{		//		int nIndexDelete;
			int nIndexDelete;

			if ( this.mobjGetDllName != null ) {
				System.IDisposable		objDisposable;
				// これ書き直さないと駄目だなぁ。
				// 
				objDisposable = this.mobjClean_Datas.List_PopDisposerFromListName
								( "clsGetDllNameFromHandle" );
				
				if ( objDisposable != this.mobjGetDllName ) {
					objDisposable.Dipose();
					objDisposable = null;
				}
				// [CLEANUP:0001]
				this.mobjGetDllName.Dispose();
				this.mobjGetDllName = null;
			}

			if ( this.mobjEventCleanUp != null ) {
				System.IDisposable		objDisposable;
				objDisposable = this.mobjClean_Datas.List_PopDisposerFromListName
								( "clsWin32Manager::Dispose_Events" );
				
				if ( objDisposable != this.mobjGetDllName ) {
					objDisposable.Dipose();
					objDisposable = null;
				}


				// [CLEANUP:0002]
				this.mobjEventCleanUp.Dispose();
				this.mobjEventCleanUp = null;
			}

			if ( this.cp != null ) {
				System.IDisposable		objDisposable;
				objDisposable = this.mobjClean_Datas.List_PopDisposerFromListName
								( "clsContentProvider" );
				if ( objDisposable != this.cp ) {
					objDisposable.Dipose();
					objDisposable = null;
				}


				// [CLEANUP:0003]
				// .cp は半永久モジュールに変更したので、
				// 以下はここで必ず実行が必要。上のコードらとは
				// 状況が異なる。(要見直し)
				this.cp.Dispose();			//		Dispose した時に上位側も null に出来れば・・・。
											//		cp.pContent 周辺しか開放しないんだよなこれ。
											//		.cp 自体は消さない・・・。
											//		ref object で null を設定すればいい？？？

				// こんな感じかな・・・。
				//	でも、ローカルでない変数を ref 渡しなんか出来たっけ。
				//	
				//clsDispose.Dispose( ref (object)this.cp );
				
				this.cp = null;
			}
		}		//		int nIndexDelete;

		this.mobjClean_Datas.SuccessEndCleanUp();

	}		//		void Dispose()




	#region clsWin32ManagerDatas:property / support mini function etc

		internal clsCleanUpDirManager ParentCleanUpManager {
			set { this.mobjCLeanM = value };
			get { return this.mobjCLeanM; };
		}

		internal clsMfDisposer Clean_Win32Datas {
			set { this.mobjClean_Datas = value };
			get { return this.mobjClean_Datas; };
		}


		internal void Set4or8ByteMode( int nByteLength )
		{

			this.mobjRegs.SetRegMode_x86or64( nByteLength );
		}

		internal void SetNull_objGetDllName() {
			this.mobjGetDllName = null;
		}
		internal void SetNull_cp() {
			this.mobjGetDllName = null;
		}

	#endregion


} // Class clsWin32ManagerDatas


}		// namespace MANAGEDAPI


}		// namespace CliDbger


