// csWApiManCleanUp.cs

//		clsWApiManager.cs class clsWin32Manager: 
//		で使われる クラス用 Dispose に登録される中身の
//		説明ドキュメント。
//		デバッグ時のみコードは使われ、実際に稼働する事は無い。

// #define はファイルの先頭じゃないと使えないらしい。
// 変わってるなぁ。。。なんでだろ？？？？
#if __DEBUG__
#define CLEANUP_VISIBLE
#endif

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;




namespace CliDbger {


namespace MANAGEDAPI {


internal class clsWin32ManCleanUp : clsMultiDisposer {


	#if CLEANUP_VISIBLE
		// オーバーライドではなく、明示的に 元の関数を上書きするので
		//	new 演算子で宣言する。
		//  ・・・・あれ。new だと元の関数名が変わった場合用だから
		//  別にオーバーライドでもいいんじゃ・・・
		//  new とオーバーライド扱い、どっちがいいんだべｗ

		// 元の関数が virtual(C++) もとい、abstract 宣言じゃねーから、
		// オーバーライドできねーのか。う～～～ん、ややこしいｗ
		internal void ClenupSuccessEnd() {
			stCleanupInfo		stpClenUp;
			System.IDisposable		objDisposable;


			// LOAD_DLL_DEBUG_EVENT が先か、
			// LOAD_PROCESS/THREAD_DEBUG_EVENT が先か、
			// どっちが先に来るか分からない。
			// デバッグ時だけ動かない可能性あるよこれｗ


			for ( int nTry = 0; nTry < 3; nTry++ ) {

				stpClenUp = this.mStackList[ this.mStackList.Count - 1 ];
				objDisposable = stpClenUp.objDisposable;


				// is 演算子について：
				//		パターンマッチ
				//				C# 1.0 : パターン以前
				//			
				//			as 演算子は csharp ver 1.0 から使えた
				//			らしい。
				//			
				//			is 演算子は
				//			if ( xxx is int )
				//			みたいに、比較先型名を直接指定したものは
				//			#1.0 から使えたらしい。
				//			
				//			だけど、
				//			if ( xxx is null )
				//			if ( xxx is int n)		n はint じゃない別の型
				//			みたいにキャストした後の n と比較出来る
				//			ようになった、らしいのは c# 7.0 以降らしい。
				//			
				//			訳ワカメｗ

				if ( this.mStackList.Count == 1 - nTry ) {
				} else {
					clscsPub.Assert( objDisposable is clsGetDllNameFromHandle, 
							"stack rest error, nTry={0}, this.mStack.Count={1}. ",
								nTry, this.mStackList.Count - 1 );
				}		//		this.mStack.Count == 0 ) {


				// [CLEANUP:0001]
				if ( objDisposable is clsGetDllNameFromHandle ) {
					// 処理をかく
					clsGetDllNameFromHandle		objGetDllName;

					// is 演算子 で
					//	XXX is clsDllNameGetFromHandle で判断するのが妥当？
					// typeof xxx is clsDllNameGetFromHandle.GetType()
					//	とするのが妥当だろうか？
					//System.Diagnostics.Debug.Assert( objDisposable is clsDllNameGetFromHandle, 
					//		"stack 7 not clsDllNameGetFromHandle . "  )
					clscsPub.Assert( objDisposable is clsGetDllNameFromHandle, 
							"stack {0} not clsDllNameGetFromHandle . ", 
								this.mStackList.Count - 1 );
					objGetDllName = (clsGetDllNameFromHandle)objDisposable;

					objGetDllName.Dispose();

					this.mStackList.RemoveAt( this.mStackList.Count - 1 );
					continue;
				}


				// [CLEANUP:0002]
				if ( objDisposable is clsCallBackDisposer ) {

					clsCallBackDisposer		objCallBackDisposer;

					clscsPub.Assert( objDisposable is clsCallBackDisposer, 
							"stack {0} not clsCallBackDisposer . ", 
								this.mStackList.Count - 1  );
					objCallBackDisposer = (clsCallBackDisposer)objDisposable;

					clscsPub.Assert( objCallBackDisposer.FuncName ==  
										"clsWin32Manager::Dispose_Events", 
							"stack {0} not \"clsWin32Manager::Dispose_Events\" . ", 
								this.mStackList.Count - 1  );

					objCallBackDisposer.Dispose();
					this.mStackList.RemoveAt( this.mStackList.Count - 1 );

					continue;
				}

				// [CLEANUP:0003]
				if ( objDisposable is clsContentProvider ) {

					clsContentProvider		objContentProvider;

					clscsPub.Assert( objDisposable is clsContentProvider, 
							"stack {0} not clsContentProvider . ", 
								this.mStackList.Count - 1  );
					objContentProvider = (clsContentProvider)objDisposable;

					objContentProvider.Dispose();
					this.mStackList.RemoveAt( this.mStackList.Count - 1 );

					continue;
				}


				clscsPub.PErrMsg( 
							"stack {0} is unknown cleanUp . ", 
								this.mStackList.Count - 1  );


			}

			// こんな感じでずらずらクリーンナップの登録内容を
			//	描いていけば、見通しそんな悪くないよね？


			return;
	
		}	//	void ClenupSuccessEnd()
	


	internal void ErrorCleanUp() {
		// オーバーライド？出来ないよな・・・。
		// 元関数が virtual/abstract 宣言されてないんだから・・・。
		// じゃあなんで new いらんのだろう？？？

		// ぜんぶメモリ開放するんだから、正常終了時と
		// 処理内容は同じはず？
		this.ClenupSuccessEnd();

	}	//	void ErrorCleanUp()
	
	#endif		//		if CLEANUP_VISIBLE



}		//		class clsWin32Manager


}		// namespace MANAGEDAPI



}		// namespace CliDbger
