// csWApiManEevntCleanUp.cs

//		Win32 Debug API ラッパーを呼び出す
//		Debug メインループ、から呼び出される
//		各種 OnXXX イベント・・・
//		のクリーンナップ処理実行部分

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;



namespace CliDbger {


namespace MANAGEDAPI {


internal partial class clsWin32Manager {


	// [CLEANUP:0002]
	private void Dispose_Events()
	{

		int		nEventCase;

		switch( this.dat.dwLastDbgEventCode )
		{
		case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_THREAD_DEBUG_EVENT:
			nEventCase = 0;
			break;
		case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_PROCESS_DEBUG_EVENT:
			nEventCase = 1;
			break;
		case clsWin32.colonyDW_DEBUGEVENTCODE.LOAD_DLL_DEBUG_EVENT:
			nEventCase = 2;
			break;
		default:
			return;
		}

		bool bIsTagetDown;

		 bIsTagetDown = this.IsTargetProcessDown();
		 if ( !bIsTagetDown )
		 	return;


		if ( nEventCase == 0 ) {

			if ( !this.dat.mbValid_thread )
				return;

			if ( !this.IsValidHandle( this.dat.thread.hThread ) )
				return;
			
			clsWin32.CloseHandle( this.dat.thread.hThread );
			this.dat.thread.hThread = System.IntPtr.Zero;

			return;
		}
		
		if ( nEventCase == 1 ) {

			if ( !this.dat.mbValid_pi )
				return;

			System.IntPtr	ptrHandle;

			ptrHandle = this.dat.pi.hFile;
			if ( this.IsValidHandle( ptrHandle ) ) {
				clsWin32.CloseHandle( ptrHandle );
			}
			this.dat.pi.hFile = System.IntPtr.Zero;

			ptrHandle = this.dat.pi.hProcess;
			if ( this.IsValidHandle( ptrHandle ) ) {
				clsWin32.CloseHandle( ptrHandle );
			}
			this.dat.pi.hProcess = System.IntPtr.Zero;

			ptrHandle = this.dat.pi.hThread;
			if ( this.IsValidHandle( ptrHandle ) ) {
				clsWin32.CloseHandle( ptrHandle );
			}
			this.dat.pi.hThread = System.IntPtr.Zero;


			return;

		}


		if ( nEventCase == 2 ) {

			if ( !this.dat.mbValid_dll )
				return;

			System.IntPtr	ptrHandle;

			ptrHandle = this.dat.dll.hFile;
			if ( this.IsValidHandle( ptrHandle ) ) {
				clsWin32.CloseHandle( ptrHandle );
			}
			this.dat.dll.hFile = System.IntPtr.Zero;

			return;
		}

		return;
	}


	private bool IsValidHandle( System.IntPtr hHandle ) {

		System.IntPtr	ptrMinusOne;
		ptrMinusOne	= new System.IntPtr( -1 );

		if ( hHandle == System.IntPtr.Zero || 
				hHandle == ptrMinusOne )
			return true;
		else
			return false;
	}

	private bool IsTargetProcessDown() {
		int 		nRet;
		DWORD		dwExitCode;

		if ( this.dat.pi.hProcess == IntPtr.Zero || 
			this.dat.pi.hProcess == new IntPtr( -1 ) ) {

			//Console.WriteLine( "this.pi.mhProcess == IntPtr.Zero . ");
			return true;
		}

		dwExitCode = 0;
		nRet = clsWin32.GetExitCodeProcess( this.dat.pi.hProcess, ref dwExitCode );
		if ( nRet == 0) {
			//Console.WriteLine( "GetExitCodeProcess returns 0 . ");

			
			IntPtr		hProcessForQuary;
			hProcessForQuary = clsWin32.OpenProcess( 
					(uint)clsWin32.PROCESS_ACCESS_PERMISSION.PROCESS_QUERY_INFORMATION, 
					0,
					this.dat.mdwProcessId
						);
			if ( hProcessForQuary == IntPtr.Zero ) {
				//Console.WriteLine( "OpenProcess for GetExitCodeProcess returns failed . ");
				return true;
			}
			nRet = clsWin32.GetExitCodeProcess( hProcessForQuary, ref dwExitCode );
			if ( nRet == 0) {
				//Console.WriteLine( "GetExitCodeProcess with infomation authority returns 0 . ");
				return true;
			}
			clsWin32.CloseHandle( hProcessForQuary );


		}
		if ( dwExitCode != (DWORD)clsWin32.colonyGETEXITPROCESS_EXITCODE.STILL_ACTIVE) {
			//Console.WriteLine( "dwExitCode is not still active, downed . ");
			return true;
		}
		
		
		//	Console.WriteLine( "dwExitCode == STILL_ACTIVE . ");
		return false;
	} 


}		// clsWin32Manager



}		// namespace MANAGEDAPI



}		// namespace CliDbger


