// csWApiManEtc.cs

//		clsWin32ApiManager 、旧 csCDbger.cs
//		に入ってたその他関数
//		別ファイルに分割予定。



using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;



namespace CliDbger {


namespace MANAGEDAPI {


internal partial class clsWin32Manager {










	internal bool GetWin32RegsAndSetToRegUi()
	{

		// 見直し点？：
		//		・mobjClean_CurFunc をやめ、cleanupManager が持つ .Current に統合
		//		・最初にクリーンナップ登録削除をするよう変更
		//		・ContentProvider が既にある時は使い回す。
		//		　でも扱うレジスタ変更があった場合は COntentProvuder の
		//		  alloc 領域のみを作り直す。


		clsContentProvider		objCp;
		if ( this.dat.cp == null ) {
			objCp = new clsContentProvider();
			this.dat.cp = (System.IDisposable)objCp;
		}






		// このままだと、clsWin32Data .Dispose() 開放時に .cp が開放されない恐れがある？
		// this.dat.cp は、デバッガデタッチ時のみ開放だから、clsWin32Data 内でのみ
		// 開放する仕組みでいいのでは。
		// クリーンナップマネージャーはほぼ恒久的にあるリソースを管理
		// 出来ない事になるが・・・Alloc 使ってる以上、新作クリーンナップマネージャー
		// で管理させるべき。

		// 二重の保険の意味で、
		// this.dat.Dispose() 内で .cp.Dispose()、.cp= null  させるべきでは？
		// めんどくせ。 clsWin32Data.Dipose() でベタにやりゃいいか・・・。






		clsDispDir		objDispDir_GetWin32Regs;
		objDispDir_GetWin32Regs = this.mobjCleanM.Current.
									CreateOrGetFunc( "GetWin32RegsAndSetToRegUi" );


		objCp.SetRegisterListMode( this.dat.mblIsTarget_64 );
		objCp.SetDbgRegister( false );

		bool bRet;
		bRet = objCp.CreateContextBuffer();
		if ( !bRet ) {
			clscsPub.PErrMsg ( "memory alloc failed . " );
			objDispDir_GetWin32Regs.ErrorCleanUp();
			return false;
		}


		// ContentProvider をクリーンナップ登録


		

		// [CLEANUP:0003]
		this.objDispDir_GetWin32Regs.
				Add_CleanupForModuleVarEx( 
						this.dat.cp, 
						"clsContentProvider", 
							this.mobjCleanM.RootFunc, 
							this.objClean_Win32Datas, 
							this.dat.SetNull_cp
						);





		// まさか・・・キャスト・・・出来るよな？？？
		BOOL	bRet;
		bRet = clsWin32.GetThreadContext( t
							his.dat.thread.hThread, 
							objCp.pContent.DangerousGetHandle() );
		if ( bRet == 0 ) {
			this.dat.mobjRegs.SetInvalid();
			objDispDir_GetWin32Regs.ErrorCleanUp();
			return false;
		}


		unsafe
		{

			clsWin32.CONTEXT		stThreadContent;

			//	https://learn.microsoft.com/ja-jp/dotnet/api/system.runtime.interopservices.marshal.ptrtostructure?view=net-7.0
			//		Marshal.PtrToStructure メソッド
			stThreadContent = (clsWin32.CONTEXT)
								System.Runtime.InteropServices.Marshal.PtrToStructure( 
								this.dat.cp.pContent.DangerousGetHandle(), typeof( clsWin32.CONTEXT )
							);

			this.dat.mobjRegs.dwContntFlags = stThreadContent.ContextFlags;
			this.dat.mobjRegs.dwEflags = 
						stThreadContent.EFlags;



			clsRegToUi.colonyREGNO		enmIndex;

			/*****************************************/
			/*   segment                             */
			/*****************************************/
			enmIndex = clsRegToUi.colonyREGNO.CS;
			this.dat.mobjRegs.Segs[ (int)enmIndex ] = 
						stThreadContent.SegCs;		// code segment
			this.dat.mobjRegs.SegAddrs[ (int)enmIndex ] = this.GetSegAddr( enmIndex );



			enmIndex = clsRegToUi.colonyREGNO.DS;
			this.dat.mobjRegs.Segs[ (int)enmIndex ] = 
						stThreadContent.SegDs;		// data segment
			this.dat.mobjRegs.SegAddrs[ (int)enmIndex ] = this.GetSegAddr( enmIndex );

			enmIndex = clsRegToUi.colonyREGNO.ES;
			this.dat.mobjRegs.Segs[ (int)enmIndex ] = 
						stThreadContent.SegEs;		// code segment
			this.dat.mobjRegs.SegAddrs[ (int)enmIndex ] = this.GetSegAddr( enmIndex );

			enmIndex = clsRegToUi.colonyREGNO.FS;
			this.dat.mobjRegs.Segs[ (int)enmIndex ] = 
						stThreadContent.SegFs;		// data segment
			this.dat.mobjRegs.SegAddrs[ (int)enmIndex ] = this.GetSegAddr( enmIndex );

			enmIndex = clsRegToUi.colonyREGNO.GS;
			this.dat.mobjRegs.Segs[ (int)enmIndex ] = 
						stThreadContent.SegGs;		// data segment
			this.dat.mobjRegs.SegAddrs[ (int)enmIndex ] = this.GetSegAddr( enmIndex );

			enmIndex = clsRegToUi.colonyREGNO.SS;
			this.dat.mobjRegs.Segs[ (int)enmIndex ] = 
						stThreadContent.SegSs;		// stack segment
			this.dat.mobjRegs.SegAddrs[ (int)enmIndex ] = this.GetSegAddr( enmIndex );



			/*****************************************/
			/*   general/rip                         */
			/*****************************************/

			
			if (this.dat.mblIsTarget_64) {

				enmIndex = clsRegToUi.colonyREGNO.RAX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rax;
				enmIndex = clsRegToUi.colonyREGNO.RCX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rcx;
				enmIndex = clsRegToUi.colonyREGNO.RDX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rdx;
				enmIndex = clsRegToUi.colonyREGNO.RBX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rbx;


				enmIndex = clsRegToUi.colonyREGNO.RSP_RESEREVE;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rsp;
				enmIndex = clsRegToUi.colonyREGNO.RSP;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rsp;


				enmIndex = clsRegToUi.colonyREGNO.RBP_RESEREVE;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rbp;
				enmIndex = clsRegToUi.colonyREGNO.RBP;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rbp;

				enmIndex = clsRegToUi.colonyREGNO.RSI_RESEREVE;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rsi;
				enmIndex = clsRegToUi.colonyREGNO.RSI;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rsi;

				enmIndex = clsRegToUi.colonyREGNO.RDI_RESEREVE;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rdi;
				enmIndex = clsRegToUi.colonyREGNO.RDI;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value64Internal = 
							stThreadContent.Rdi;
			

				
				this.dat.mobjRegs.ip.Value64Internal = 
							stThreadContent.Rip;


			} else {

				/* 32bit xsave なんぞ、オフセット値が分からん。 */
				/* 多分使う事は・・・無い。 */
				/* 64bit 対応CPU上で、32bit OS を使う人ならいるだろうが、 */
				/* 恐らく 32bit CPU 自体、未だに稼働可能なパソコンは恐らく */
				/* 日本中どこ探しても無いだろう。 */
				/* 2007~2010 年ぐらいまでに発売された PC が該当するだろうが、 */
				/* 恐らくマザーボードを直す技術が廃れて無くなってるんじゃないか？ */
				/* x64 命令が無い CPU で、未だに動く PC なんて中古屋でも相当 */
				/* 探さないと見つからない、はず？？？ */

				/* それ以前に、 win32.CONTENT 構造体の構成が分からん。 */
				/* 古過ぎて cpuid 命令によるオフセット算出も恐らく対応していないだろう。 */

				enmIndex = clsRegToUi.colonyREGNO.RAX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rax;
				enmIndex = clsRegToUi.colonyREGNO.RCX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rcx;
				enmIndex = clsRegToUi.colonyREGNO.RDX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rdx;
				enmIndex = clsRegToUi.colonyREGNO.RBX;
				this.dat.mobjRegs.generals[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rbx;

				enmIndex = clsRegToUi.colonyREGNO.RSP;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rsp;
				enmIndex = clsRegToUi.colonyREGNO.RBP;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rbp;

				enmIndex = clsRegToUi.colonyREGNO.RSI;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rsi;

				enmIndex = clsRegToUi.colonyREGNO.RDI;
				this.dat.mobjRegs.sipi[ (int)enmIndex ].Value32Internal = 
							(uint)stThreadContent.Rdi;
			
				this.dat.mobjRegs.ip.Value32Internal = 
							(uint)stThreadContent.Rip;

			}


			//Console.WriteLine( "context is : " );
			//Console.WriteLine( "P1home : {0:x16}  P2home : {1:x16}  P3home : {2:x16}", 
			//			stThreadContent.P1Home, stThreadContent.P2Home, stThreadContent.P3Home );
			//Console.WriteLine( "P4home : {0:x16}  P5home : {1:x16}  P6home : {2:x16}", 
			//			stThreadContent.P4Home, stThreadContent.P5Home, stThreadContent.P6Home );
			//Console.WriteLine( "" ); 

			//Console.WriteLine( "ContextFlags : {0:x16}  ", stThreadContent.ContextFlags );

			//Console.WriteLine( "CS : {0:x16}  DS : {1:x16}  ES : {2:x16}", 
			//			stThreadContent.SegCs, stThreadContent.SegDs, stThreadContent.SegEs );
			//Console.WriteLine( "FS : {0:x16}  GS : {1:x16}  SS : {2:x16}", 
			//			stThreadContent.SegFs, stThreadContent.SegGs, stThreadContent.SegSs );

			//Console.WriteLine( "RAX : {0:x16}  RCX : {1:x16}  RDX : {2:x16}  RBX : {3:x16}", 
			//			stThreadContent.Rax, stThreadContent.Rcx, stThreadContent.Rdx,  stThreadContent.Rbx  );
			//Console.WriteLine( "RSP : {0:x16}  RBP : {1:x16}  RSI : {2:x16}  RDI : {3:x16}", 
			//			stThreadContent.Rsp, stThreadContent.Rbp, stThreadContent.Rsi, stThreadContent.Rdi );

			//Console.WriteLine( "R8-11  : {0:x16}   {1:x16}  {2:x16}  {3:x16}    ", 
			//				stThreadContent.R8,
			//				stThreadContent.R9,
			//				stThreadContent.R10,
			//				stThreadContent.R11 );

			//Console.WriteLine( "R12-15 : {0:x16}   {1:x16}  {2:x16}  {3:x16}    ", 
			//				stThreadContent.R12,
			//				stThreadContent.R13,
			//				stThreadContent.R14,
			//				stThreadContent.R15 );



			//Console.WriteLine( "EFLAGS : {0:x16}  RIP : {1:x16} ", 
			//			stThreadContent.EFlags, stThreadContent.Rip );

			//Console.WriteLine( "press any key.  > " );
			//this.WaitKey();
		
			/* こんな感じでレジスタが取れた。
			context is :
			P1home : 0000000000000000  P2home : 0000000000000000  P3home : 0000000000000000
			P4home : 0000000000000000  P5home : 0000000000000000  P6home : 0000000000000000

			ContextFlags : 000000000010000f
			CS : 0000000000000033  DS : 000000000000002b  ES : 000000000000002b
			FS : 0000000000000053  GS : 000000000000002b  SS : 000000000000002b
			RAX : 0000000000000006  RCX : 000000000000005c  RDX : 0000000000000000  RBX : 00000000012fe8f8
			RSP : 00000000012fe798  RBP : 00000000012fe860  RSI : 000000000000005c  RDI : 0000000000000000
			R8-11  : 00007ffbd25017a7   00000000012fe370  000000000000000a  00007ffbd2561829
			R12-15 : 0000000001366660   00000000035b8ef8  000000000000001d  0000000000000001
			EFLAGS : 0000000000000246  RIP : 00007ffc0882ed14


			RIP : 0000 7ffc 0882 ed14
				PC が取れてる風には見えないな～～～～。
			*/


		}		// unsafe

		// ファンクションクリーンナップディレクトリ、GetWin32RegsAndSetToRegUi
		// を削除し上位側管理下に移行させる
		objDispDir_GetWin32Regs.SuccessEndCleanUp();
		objDispDir_GetWin32Regs = null;

		return true;
	}		//		bool GetWin32RegsAndSetToRegUi()



	// バッファ生成機能付きの ProcessReadMemory ラッパー
	internal bool ReadMemory( clsNuint nuiAddr, clsNuint nuiSize, out byte[] arbytReadData )
	{
		
		clsMySafeHGlobalHandle		safeBuffer;
		int nRet;

		arbytReadData = null;
		if ( nuiAddr.Size != nuiSize.Size ) {
			Console.WriteLine( "\"{0}\".\"{1}\" nuint vars size different error nuiAddr=\"{2}\", nuiSize=\"{3}\". > ", 
							this.ToString(), 
							System.Reflection.MethodBase.GetCurrentMethod().Name,
							nuiAddr.ToString(), nuiSize.ToString() 
							 );
			Console.ReadKey();
			return false;
		}

		if ( this.dat.mblIsTarget_64 ) {
			if ( !nuiAddr.Is64bit || !nuiSize.Is64bit ) {
				clscsPub.PErrMsg( 
					" nuint vars 32 vs this.mblIsTarget_64=true mismatach nuiAddr=\"{0}\", nuiSize=\"{1}\". > ", 
							nuiAddr.ToString(), nuiSize.ToString() 
								);
				return false;
			}
		} else {
			if ( !nuiAddr.Is32bit || !nuiSize.Is32bit ) {
				clscsPub.PErrMsg( 
						" nuint vars 64 vs this.mblIsTarget_32=true mismatach nuiAddr=\"{0}\", nuiSize=\"{1}\". > ", 
							nuiAddr.ToString(), nuiSize.ToString() 
								);
				return false;
			}
		}



		clscsPub.Assert( this.dat.pi.hProcess != null, "Process Handle is set to null. " );



		arbytReadData = null;
		using ( safeBuffer = clsMySafeHGlobalHandle.AllocHGlobal( nuiSize.GetInt32Value() ) )
		{
			if ( this.dat.mblIsTarget_64 ) {

				//		https://context.reverso.net/%E7%BF%BB%E8%A8%B3/%E6%97%A5%E6%9C%AC%E8%AA%9E-%E8%8B%B1%E8%AA%9E/%E8%AA%AD%E3%81%BF%E8%BE%BC%E3%81%BE%E3%82%8C%E3%81%9F
				//				「読み込まれた」を英語に翻訳する
				//					Readed ... に最初しようと思ったがやっぱ不自然だな。
				//					loaded だとちょっと意味が違うけど・・・。
				ulong		ulByteSizeLoaded;

				ulByteSizeLoaded = 0;
					
				nRet = clsWin32.ReadProcessMemory_64( 
					this.dat.pi.hProcess,
					nuiAddr.Value64Internal, 
					safeBuffer.DangerousGetHandle(), 
					nuiSize.Value64Internal, 
					ref ulByteSizeLoaded );
				if ( nRet == 0 ) {
					return false;
				}
				if ( nuiSize != ulByteSizeLoaded )
					return false;

			} else {

				uint		uiByteSizeLoaded;

				uiByteSizeLoaded = 0;
					
				nRet = clsWin32.ReadProcessMemory_32( 
					this.dat.pi.hProcess,
					nuiAddr.Value32Internal, 
					safeBuffer.DangerousGetHandle(), 
					nuiSize.Value32Internal, 
					ref uiByteSizeLoaded );
				if ( nRet == 0 ) {
					return false;
				}
				if ( nuiSize != uiByteSizeLoaded )
					return false;


			}		// if (this.mblIsTarget_64 ) {


			arbytReadData = new byte[ (int)nuiSize.Get64Value() ];
			System.Runtime.InteropServices.Marshal.Copy( 
						safeBuffer.DangerousGetHandle(), 
						arbytReadData, 0, arbytReadData.Length );

			/* あまり動かんかったら以下つかおっと。 */
			//unsafe {
			//	byte *pData;


			//	pData = (byte *)safeBuffer.DangerousAddRef;
			//	for ( nIndex = 0 ; nIndex < arbytReadData.Length; nIndex++ )
			//	{
			//		arbytReadData[ nIndex ] = *pData;
			//		pData++;
			//	}

			//}	// unsafe


		}	//			using		safeBuffer

		return true;

	}		//			bool ReadMemory()











}		// class clsWin32Manager


}		// namespace MANAGEDAPI



}		// namespace CliDbger

