// csWApiManMap.cs

//		clsWin32ApiManager 、旧 csCDbger.cs
//		に入ってた Map 表示関係



using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;



namespace CliDbger {


namespace MANAGEDAPI {


internal partial class clsWin32Manager {












	internal bool CreateMapInf()
	{
		// ターゲットメモリ域全域の、ページング割り当て状況を
		// 調べて実験するために作った奴。残しておくけど、使う事ないんじゃん？？
		// 何のデータが置いてあるか、どうせ分からんし・・・。




		IntPtr		hProcessForQuary;
		hProcessForQuary = clsWin32.OpenProcess( 
				(uint)clsWin32.PROCESS_ACCESS_PERMISSION.PROCESS_QUERY_INFORMATION, 
				0,
				this.dat.mdwProcessId
					);
		if ( hProcessForQuary == IntPtr.Zero ) {
			return false;
		}



		clsMapToUi		objMapToUi;
		objMapToUi = new clsMapToUi();
		objMapToUi.InitMap();
		objMapToUi.IsTarget64bit = this.dat.mblIsTarget_64;


		// https://snoozy.hatenablog.com/entry/2020/01/15/123230
		//			VirtualQueryExによるRWX保護メモリの列挙をやってみる
		//			・・・を全面的に信じてやってみる。
		clsNuint		objAddr;
		if ( this.dat.mblIsTarget_64 ) {
			objAddr = new clsNuint( (uint)0 );
		} else {
			objAddr = new clsNuint( (ulong)0 );
		}


		
		int nCnt;

		nCnt = 0;

		while( true ) {
			
			clsMapToUi.clsMapInfo	objCrrentMapInf;

			objCrrentMapInf = this.GetWin32MapInf( hProcessForQuary, objAddr );
			if ( objCrrentMapInf == null )
				break;
			
			objMapToUi.marMapInf.Add( objCrrentMapInf );

			clsNuint		objNewAddr;

			objNewAddr = objCrrentMapInf.BaseAddress + objCrrentMapInf.RegionSize;
			if ( objAddr >= objNewAddr )
				break;
			objAddr = objNewAddr;
			nCnt++;
			if ( nCnt == 10000 ) {
				#if __DEBUG__
					Console.WriteLine( "memory info count over 10000." );
				#endif
				break;
			}
		}


		clsWin32.CloseHandle( hProcessForQuary  );

		this.dat.mobjMapToUi = objMapToUi;
		return true;

		#if TRYCODE_QUERYEX_MEMORY_INFOMATION

			//clsWin32.SYSTEM_INFO		sysinfo;
			//sysinfo = new clsWin32.SYSTEM_INFO();
			//clsWin32.GetSystemInfo( ref sysinfo );


			ulong		ulPc, ulRet, ulStMemSize;
			clsWin32.MEMORY_BASIC_INFORMATION64		stmeminf;
			//ulPc = stThreadContent.Rip;
			//IntPtr		ptrlpStartAddress;
			//ptrlpStartAddress = new IntPtr( 0xfffffffffffffff );
			ulPc = this.dat.pi.lpThreadLocalBase.Value64Internal;
			ulPc &= ~(sysinfo.dwPageSize);
			ulStMemSize = (ulong)sizeof( clsWin32.MEMORY_BASIC_INFORMATION64 );
			stmeminf = new clsWin32.MEMORY_BASIC_INFORMATION64();

			//
			//				this.dat.pi.mhProcess, 

			//ulRet = clsWin32.VirtualQueryEx_64( 
			//				hProcessForQuary, 
			//				ulPc, 
			//				ref stmeminf, 
			//				ulStMemSize );
			ulRet = clsWin32.VirtualQueryEx_64( 
							hProcessForQuary, 
							ulPc, 
							ref stmeminf, 
							ulStMemSize );

			if ( ulRet != ulStMemSize ) {
				Console.WriteLine( "\"{0}\".\"{1}\" : VirtualQuery failed. ulRet={2}. > ", 
						this.ToString(), 
						System.Reflection.MethodBase.GetCurrentMethod().Name, 
						ulRet );
				Console.ReadKey();
			}

			//Console.WriteLine( "VirtualQueryEx ret  : BaseAddress=\"{0:x16}\"  AllocationBase=\"{1:x16}\"  RegionSize=\"{2:x16}\", ulStMemSize=\"{3:x16}\" ", 
			//				stmeminf.BaseAddress, 
			//				stmeminf.AllocationBase, 
			//				stmeminf.RegionSize, 
			//				ulStMemSize );


			//Console.WriteLine( "VirtualQueryEx ret2  : State=\"{0:x16}\"  Protect=\"{1:x16}\"  Type=\"{2:x16}\" ", 
			//				stmeminf.State, 
			//				stmeminf.Protect, 
			//				stmeminf.Type );
			String		sBaseAddressInMemInf, sAllocationBaseInMemInf;
			if ( stmeminf.BaseAddress != null ) 
				sBaseAddressInMemInf = ((ulong)(stmeminf.BaseAddress)).ToString( "x16" );
			else
				sBaseAddressInMemInf = "null";
			if ( stmeminf.AllocationBase != null ) 
				// * でAllocationBaseをアクセスしたら強制終了デタ。こいつターゲットのポインタらしいｗんなバカな。
				sAllocationBaseInMemInf = ((ulong)(stmeminf.AllocationBase)).ToString( "x16" );
			else
				sAllocationBaseInMemInf = "null";
				
			if ( stmeminf.State == 0x1000 ) {
				Console.WriteLine( "VirtualQueryEx ret  : State=\"{0:x8}\"  hProcessForQuary=\"{1:x8}\"  ", 
												stmeminf.State, 
												hProcessForQuary );
				Console.WriteLine( "                    : BaseAddress=\"{0}\"  RegionSize=\"{1:x16}\"    ulPc=\"{2:x16}\"   lpThreadLocalBase=\"{3:x16}\" lpBaseOfImage=\"{4:x16}\" . ", 
											sBaseAddressInMemInf, stmeminf.RegionSize,  ulPc, (ulong)(DebugEv->u.CreateProcessInfo.lpThreadLocalBase), 
														DebugEv->u.CreateProcessInfo.lpBaseOfImage );

			} else {

				Console.WriteLine( "VirtualQueryEx ret  : State=\"{0:x8}\"  hProcessForQuary=\"{1:x8}\"  ", 
												stmeminf.State, 
												hProcessForQuary );
				Console.WriteLine( "                    : BaseAddress=\"{0}\"  RegionSize=\"{1:x16}\"  BaseAddress+RegionSize=\"{2:x16}\"   ulPc=\"{3:x16}\"   lpThreadLocalBase=\"{4:x16}\" lpBaseOfImage=\"{5:x16}\" . ", 
											sBaseAddressInMemInf, stmeminf.RegionSize, (ulong)(stmeminf.BaseAddress) + stmeminf.RegionSize,  ulPc, (ulong)(DebugEv->u.CreateProcessInfo.lpThreadLocalBase), 
														DebugEv->u.CreateProcessInfo.lpBaseOfImage );
				Console.WriteLine( "                    : AllocationBase=\"{0}\"   > . ", 
											sAllocationBaseInMemInf );

			}
			Console.WriteLine( "                    : sysinfo.dwPageSize=\"{0:x8}\" .", sysinfo.dwPageSize  );
			//Console.ReadKey();

			clsWin32.CloseHandle( hProcessForQuary  );

		#endif

	}


	private clsMapToUi.clsMapInfo GetWin32MapInf( IntPtr hProcessForInf, clsNuint objAddr )
	{

		clsMapToUi.clsMapInfo		objMapInf;
				
		if ( !this.dat.mblIsTarget_64 ) {
			unsafe {
				DWORD		dwPc, dwRet, dwStMemSize;
				clsWin32.MEMORY_BASIC_INFORMATION32		stmeminf;

				dwStMemSize = (DWORD)sizeof(
									clsWin32.MEMORY_BASIC_INFORMATION32 );
				dwPc = objAddr.Value32Internal;

				stmeminf = new clsWin32.MEMORY_BASIC_INFORMATION32();
				dwRet = clsWin32.VirtualQueryEx_32( 
						hProcessForInf, 
						dwPc, 
						ref stmeminf, 
						dwStMemSize );
				if ( dwRet != dwStMemSize ) {
					objMapInf = null;
				} else {
					objMapInf = clsMapToUi.ConvertWin32ToMangagedMemInf( ref stmeminf );
				}

			}	// unsafe


		} else {

			unsafe {
				ulong		ulPc, ulRet, ulStMemSize;
				clsWin32.MEMORY_BASIC_INFORMATION64		stmeminf;

				ulStMemSize = (ulong)sizeof( 
									clsWin32.MEMORY_BASIC_INFORMATION64 );
				ulPc = objAddr.Value64Internal;

				stmeminf = new clsWin32.MEMORY_BASIC_INFORMATION64();


				ulRet = clsWin32.VirtualQueryEx_64( 
						hProcessForInf, 
						ulPc, 
						ref stmeminf, 
						ulStMemSize );

				if ( ulRet != ulStMemSize ) {
					objMapInf = null;
				} else {
					objMapInf = clsMapToUi.ConvertWin32ToMangagedMemInf( ref stmeminf );
				}
					
			}  // unsafe


		}

		return objMapInf;

	}		// clsMapToUi.clsMapInfo		GetMapInf()




	internal bool CreateMapInf_nearRip()
	{
		// PC 付近のマップ状況を確認。逆アセンブル用
		
		clsMapToUi.clsMapInfo2	objRipMap;


		IntPtr			hProcessForQuary;
		hProcessForQuary = clsWin32.OpenProcess( 
				(uint)clsWin32.PROCESS_ACCESS_PERMISSION.PROCESS_QUERY_INFORMATION, 
				0,
				this.dat.mdwProcessId
					);
		if ( hProcessForQuary == IntPtr.Zero ) {
			return false;
		}

		Microsoft.Win32.SafeHandles.SafeFileHandle		sfhProcessForQuary;
		using ( sfhProcessForQuary = 
			new Microsoft.Win32.SafeHandles.SafeFileHandle( hProcessForQuary, false ) )
		{

			
			if ( this.dat.mobjMapToUi == null) {
				clsMapToUi		objMapToUi;
				objMapToUi = new clsMapToUi();
				objMapToUi.InitMap();
				this.dat.mobjMapToUi = objMapToUi;
				objMapToUi.IsTarget64bit = this.dat.mblIsTarget_64;
			}


			// https://snoozy.hatenablog.com/entry/2020/01/15/123230
			//			VirtualQueryExによるRWX保護メモリの列挙をやってみる
			//			・・・をかなり改造してやってみる。
			clsNuint		objAddr, objPageSize, objPageMask;
			objAddr = new clsNuint( this.dat.mobjRegs.ip );

			//#if __DEBUG__
			//	
			//	Console.WriteLine( "\"{0}\".\"{1}\" : rip=\"0x{2:x16}\"  > . ", 
			//			this.ToString(), 
			//			System.Reflection.MethodBase.GetCurrentMethod().Name, 
			//			objAddr );
			//
			//	Console.ReadKey( false );
			//#endif


			// https://learn.microsoft.com/ja-jp/dotnet/csharp/programming-guide/classes-and-structs/named-and-optional-arguments
			//			名前付き引数と省略可能な引数 (C# プログラミング ガイド)
			//				・・・・は。C# 4.0 以降らしい。駄目じゃん。
			//objPageSize = new clsNuint( nDataSize: objAddr.Size );
			objPageSize = new clsNuint(  objAddr.Size );
			objPageMask = new clsNuint(  objAddr.Size );

			{

				clsWin32.SYSTEM_INFO		sysinfo;
				sysinfo = new clsWin32.SYSTEM_INFO();
				clsWin32.GetSystemInfo( ref sysinfo );

				objPageSize.CastSet( sysinfo.dwPageSize );

				// 最上位ビットを判定
				for ( int nBit = 0; nBit < 32; nBit++ )
				{
					ulong		ulBit;
					ulBit = ((ulong)0x8000000) >> nBit;
					if ( ( sysinfo.dwPageSize & ulBit ) != 0 )
						objPageMask.CastSet( ~(ulBit - 1) );
				}
			}

			objAddr &= objPageMask;

			clsMapToUi.clsMapInfo		objMapFirst;
			objMapFirst = this.GetWin32MapInf( 
				sfhProcessForQuary.DangerousGetHandle(), objAddr );
			if ( objMapFirst == null ) {
				//clsWin32.CloseHandle( hProcessForQuary  );
				//sfhProcessForQuary.Dispose();
				return false;
			}


			clsNuint		nuiNewTopAddr;
			if ( objMapFirst.AllocationBase < objPageSize ) {
				// 先頭は取れたので０方向に検索しなくて良くなった
				nuiNewTopAddr = new clsNuint( objMapFirst.AllocationBase );
				objRipMap = new clsMapToUi.clsMapInfo2( objMapFirst );
			} else {

				objAddr = objMapFirst.AllocationBase - objPageSize;
				objAddr &= objPageMask;
				int nCnt;

				nCnt = 0;


				// アドレス 上(0)方向に取得して先頭virtualAlloc 先頭アドレスを特定
				clsMapToUi.clsMapInfo	objCrrentMapInf;

				// null 避けるために適当に入れとく。
				nuiNewTopAddr = new clsNuint( objMapFirst.AllocationBase );
				while( true ) {
					
					objCrrentMapInf = this.GetWin32MapInf( 
						sfhProcessForQuary.DangerousGetHandle(), objAddr );
					if ( objCrrentMapInf == null )
						break;
					
					// アドレス連続かつ属性連続だったら同じセクション扱いにする。
					if ( objMapFirst.AllocationBase != objCrrentMapInf.AllocationBase ) {
						if ( objCrrentMapInf.nuiBaseAddrEnd != objMapFirst.AllocationBase || 
								objCrrentMapInf.Type != objMapFirst.Type || 
								objCrrentMapInf.AllocationProtect != objMapFirst.AllocationProtect )
						{
							if ( objCrrentMapInf.State == clsWin32.colonyMEMORY_BASIC_INFO_STATE.MEM_FREE  ) {
								nuiNewTopAddr = objCrrentMapInf.nuiBaseAddrEnd;
							} else {
								nuiNewTopAddr = objCrrentMapInf.nuiAllocationAddrEnd;
							}
							break;

						}
					
					}
					
					// 同属性、連続配置が上にあった。
					// もっと上にあるか検索をかける

					if ( objCrrentMapInf.AllocationBase < objPageSize ) {
						nuiNewTopAddr = new clsNuint( objCrrentMapInf.AllocationBase );
						break;
					}
					clsNuint		objNewAddr;

					objNewAddr = objCrrentMapInf.AllocationBase - objPageSize;
					objNewAddr &= objPageMask;

					if ( objAddr <= objNewAddr ) {
						// 無限ループにならんための保険ｗ
						nuiNewTopAddr = new clsNuint( objCrrentMapInf.AllocationBase );
						break;
					}
					objAddr = new clsNuint( objNewAddr );
					nCnt++;
					if ( nCnt == 10000 ) {
						#if __DEBUG__
							Console.WriteLine( "memory info count over 10000." );
						#endif
						break;
					}
				}		// while ( true ) {


				objCrrentMapInf = this.GetWin32MapInf( 
					sfhProcessForQuary.DangerousGetHandle(), nuiNewTopAddr );

				if ( objCrrentMapInf == null ) {
					// ・・・・どんなケースなんだろこれ。
					//#if __DEBUG__
					//	
					//	Console.WriteLine( "\"{0}\".\"{1}\" : lower, failed to get previous map.  > . ", 
					//			this.ToString(), 
					//			System.Reflection.MethodBase.GetCurrentMethod().Name );
					//			Console.ReadKey( false );
					//#endif
					return false;
				}		// objCrrentMapInf

				// 先頭検索位置が確定。
				objRipMap = new clsMapToUi.clsMapInfo2( objCrrentMapInf );

			}		//		if ( objMapFirst.AllocationBase < objPageSize ) {




			objRipMap.nuiTargetRip = new clsNuint( this.dat.mobjRegs.ip );

			
			// アドレス 下(0xffffffff)方向に取得してマップ範囲確定
			objAddr = objRipMap.LastPiece.nuiBaseAddrEnd;
			objAddr &= objPageMask;

			{
				int nCnt;
				nCnt = 0;

				while( true ) {
					
					clsMapToUi.clsMapInfo	objCrrentMapInf;

					objCrrentMapInf = this.GetWin32MapInf( 
						sfhProcessForQuary.DangerousGetHandle(), objAddr );
					if ( objCrrentMapInf == null )
						break;
					

					//#if __DEBUG__
					//	{
					//	string strDisp;
					//	if ( this.mblIsTarget_64 )
					//		strDisp = objCrrentMapInf.BaseAddress.Value64Internal.ToString( "x16" );
					//	else 
					//		strDisp = objCrrentMapInf.BaseAddress.Value32Internal.ToString( "x8" );
					//	
					//	Console.WriteLine( "\"{0}\".\"{1}\" : curMap BaseAddress ={2}.  ", 
					//			this.ToString(), 
					//			System.Reflection.MethodBase.GetCurrentMethod().Name, 
					//			strDisp
					//			);
					//	}
					//#endif

					if ( objCrrentMapInf.State == clsWin32.colonyMEMORY_BASIC_INFO_STATE.MEM_FREE )
						break;

					clsMapToUi.clsMapInfo2Piece		objPieceLast;

					objPieceLast = objRipMap.LastPiece;

					// アドレス連続かつ属性連続だったら同じセクション扱いにする。
					if ( objCrrentMapInf.AllocationBase != objPieceLast.AllocationBase ) {
						if ( objCrrentMapInf.AllocationBase != objPieceLast.nuiBaseAddrEnd || 
								objCrrentMapInf.Type != objRipMap.Type || 
								objCrrentMapInf.AllocationProtect != objRipMap.AllocationProtect )
						{
							break;
						}
					
					}
					
					clsMapToUi.clsMapInfo2Piece		objMPiece;
					objMPiece = new clsMapToUi.clsMapInfo2Piece( objCrrentMapInf );
					if ( objRipMap.IsExistPiece( objMPiece ) ) {

						// ・・・・前のマップ情報はどうも取れない気がする。
						//#if __DEBUG__
						//	
						//	Console.WriteLine( "\"{0}\".\"{1}\" : upper, failed to get next map.  > . ", 
						//			this.ToString(), 
						//			System.Reflection.MethodBase.GetCurrentMethod().Name );
						//			Console.ReadKey( false );
						//#endif
						break;
					}
					
					//#if __DEBUG__
					//	
					//		Console.WriteLine( "\"{0}\".\"{1}\" : piece \"0x{2:x16}\" add last.  > . ", 
					//				this.ToString(), 
					//				System.Reflection.MethodBase.GetCurrentMethod().Name, 
					//				objMPiece.BaseAddress );
					//		
					//#endif
					objRipMap.marPiece.Add( objMPiece );
					objRipMap.objnuRegionSize += objMPiece.RegionSize;


					clsNuint		objNewAddr;

					objNewAddr = objMPiece.nuiBaseAddrEnd;
					objNewAddr &= objPageMask;

					if ( objNewAddr <= objAddr )
						break;
					objAddr = objNewAddr;
					nCnt++;
					if ( nCnt == 10000 ) {
						#if __DEBUG__
							Console.WriteLine( "memory info count over 10000." );
						#endif
						break;
					}
				}		// while ( true ) {

			}	// 				int nCnt;

			//clsWin32.CloseHandle( hProcessForQuary  );
			//sfhProcessForQuary.Dispose();
		}		//using 


		if ( this.dat.mobjMapToUi == null) {
			this.dat.mobjMapToUi = new clsMapToUi();
			this.dat.mobjMapToUi.InitMap();

		}
		this.dat.mobjMapToUi.mobjMapNearRip = objRipMap;
		return true;

	}	//		bool CreateMapInf_nearRip()


	internal clsNearRipInfo GetCodeByteNearRip( uint nCodeByteSizeNeerRip )
	{
		clsNearRipInfo				objRet;
		objRet = new clsNearRipInfo();

		if ( this.dat.mobjRegs == null)
			return null;
		if ( this.dat.mobjMapToUi == null)
			return null;
		if ( this.dat.mobjMapToUi.mobjMapNearRip == null)
			return null;

		objRet.nuiRip = new clsNuint( this.dat.mobjRegs.ip );

		//		https://csharp.programmer-reference.com/operator-list/
		//			[C#] 演算子一覧
		//				使用例：　　int x = (a==null)?0:1;
		//							nuiValue = new clsNuint( this.mblIsTarget_64 ? 8:4 );
		//				まぁ結局使わなかったけど。
		
		objRet.rngnuiCode = 
				this.dat.mobjMapToUi.mobjMapNearRip.GetNearCommitRange( 
						objRet.nuiRip, 
						(int)nCodeByteSizeNeerRip );

		if ( objRet.rngnuiCode == null )
			return null;

 

		byte[]		arBytesOfCode;

		bool	 bRet;
		bRet = this.ReadMemory( objRet.rngnuiCode.nuiSta, objRet.rngnuiCode.nuiLength, out arBytesOfCode );
		if ( !bRet ) {
			return null;
		}

		objRet.arbytData = arBytesOfCode;

		return objRet;
		// rip(pc)行から２０命令文、逆アセンブルする。
		// その後、上方向に２０命令、逆アセンブルする。

	}










}		// class clsWin32Manager


}		// namespace MANAGEDAPI



}		// namespace CliDbger

