// csWApiManReg.cs

//		clsWin32Manager クラス、レジストリ
//		読み込み関係のうち
//		clsWin32Manager と切り離せない部分



using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;



namespace CliDbger {


namespace MANAGEDAPI {


internal partial class clsWin32Manager {


	internal void GetRegister( out clsRegToUi objRet)
	{
		objRet = this.dat.mobjRegs.Clone();
		return;
		
	}		//		void	GetRegister()






	internal int ForClrGetThreadContext(
									uint dwThreadID,
									uint contextFlags,
									uint uiContextSize,
									out byte [] pContext)
	{

		stHResult		ret;

		IntPtr		hThread;

		DWORD		dwThreadPermission;

		dwThreadPermission = (DWORD)(
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.DELETE | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.READ_CONTROL | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_GET_CONTEXT | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_QUERY_INFORMATION | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_QUERY_LIMITED_INFORMATION | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_CONTEXT | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_INFORMATION | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_LIMITED_INFORMATION | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_LIMITED_INFORMATION | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SET_THREAD_TOKEN | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_SUSPEND_RESUME | 
			clsWin32.colonyTHREAD_ACCESS_PERMISSION.THREAD_TERMINATE 
			);
		//hThread = clsWin32.OpenThread( (DWORD)clsWin32.colonyTHREAD_ACCESS_PERMISSION.ALL   ,1 , dwPid );
		hThread = clsWin32.OpenThread( dwThreadPermission
									,1 , dwThreadID );
		if ( hThread == null || hThread == System.IntPtr.Zero ) { 

			clscsPub.PErrMsg( " no thread found. thread ID {0}  > . ", dwThreadID.ToString() );
			// ながっ・・・・エラーコード取るだけでこの長さかよｗ
			ret.SetErrorCode( clsWin32.stHResult.colonyFACILITY_CODE.FACILITY_WIN32 );
			pContext = null;
			return ret;
		}


		clsMySafeCloseHandle		sfeHandle_Thread;
		using ( sfeHandle_Thread = new clsMySafeCloseHandle( hThread ) )
		{



			clsContentProvider		objContentProvier;
			if ( this.dat.cp == null ) {
				clscsPub.PErrMsg( " this.dat.cp not initialized. > " );
				ret.SetErrorCode( clsWin32.stHResult.colonyFACILITY_CODE.FACILITY_WIN32 );
				pContext = null;
				return ret;
			}
			objContentProvier = (clsContentProvider)this.dat.cp;
		
			{
				bool bRetMakeBuf = objContentProvier.CreateContextBuffer( uiContextSize );
				if ( !bRetMakeBuf ) {
						clscsPub.Warn( " ForClrGetThreadContext ::Memory alloc failed. > " );
					ret.SetErrorCode( clsWin32.stHResult.colonyFACILITY_CODE.FACILITY_WIN32 );
					pContext = null;
					return ret;
				}
			}

			objContentProvier.UpdateContentFlags( contextFlags );



			BOOL	bRet;
			bRet = clsWin32.GetThreadContext( 
							sfeHandle_Thread.DangerousGetHandle(), 
							objCp.pContent.DangerousGetHandle() );
			if ( bRet == 0 ) {
					clscsPub.Warn( " ForClrGetThreadContext ::GetThreadContext failed. > " );
				ret.SetErrorCode( clsWin32.stHResult.colonyFACILITY_CODE.FACILITY_WIN32 );
				pContext = null;
				return ret;
			}


			byte arbContents = new byte [ contextSize ];

			// https://learn.microsoft.com/ja-jp/dotnet/api/system.runtime.interopservices.marshal.copy?view=net-8.0#system-runtime-interopservices-marshal-copy(system-intptr-system-byte()-system-int32-system-int32)
			//		Marshal.Copy メソッド
			//				Copy(IntPtr, Byte[], Int32, Int32)
			//
			//					public static void Copy 
			//							(IntPtr source, byte[] destination,
			//							 int startIndex, int length);

			// 最初探した時、このメソッドが見つからなかったけどなんで？？？
			System.Marshal.Copy( objCp.pContent.DangerousGetHandle(), 
									arbContents, 0, contextSize );

			pContext = arbContents;
		}

		ret.SetSuccess();

		return ret;

	}		//		int ForClrGetThreadContext()






	internal void GetProcesssAdressInf( out clsPeFormat objPeFormat )
	{
		#if RESERCH_ABOUT_GDT_LDT
			// 本来なら、
			//		プロセスの開始～終了アドレス、スタートアドレス、
			//		モジュールごとのアドレス範囲、
			//		データブロックの位置などの情報が欲しいところ。

			//		CREATE_PROCESS_DEBUG_INFO_x64 構造体の hFile ハンドルがあるから、
			//		ここからプロセスの情報を読むしか無い？
			//		
			//		プロセスハンドルからなんで情報とれねーの？

			//		つまり、coff ファイル内の virtualAddress が実効アドレスで
			//		これ向けにコンパイルされていて、
			//		OS はこのアドレス周辺を勝手にメモリマッピングするって事らしい。

			//		だから、ReadProcessMemory で読むべきアドレスは、
			//			coff ファイルの virtualベースアドレス + どっかｗ
			//			このオフセットの、「どっか」というのが、実は実行中の
			//			exe の中の、CLI ランタイム系の情報しか知り得ない。


			//		https://learn.microsoft.com/ja-jp/windows/win32/api/winbase/nf-winbase-getthreadselectorentry
			//			GetThreadSelectorEntry 関数
			//				x86 系のみ。これ以外では false を返す。
			//				ここで得たセグメント情報を元に、線形仮想アドレスに
			//				変換する。
			//				Write/ReadProcessMemory 関数は線形仮想アドレスを使わないと
			//				いけないそうな。

			//		IntelCPUManual/325462-sdm-vol-1-2abcd-3abcd.pdf
			//				3091 ページ
			//				Figure 3-6. Segment Selector
			//					Table indicator Flag の事じゃね？
			//						0 : GPT, 1:LPT
			//					こんなんどう見てもローカル指定でいいんじゃないの？
			//			
			//			GPT は恐らく OS 予約、LPT はたぶんドライバ/ユーザープログラムに
			//			割り振られている？
			//			つまり、実効アドレス/線形仮想アドレスでアクセスする分には
			//			何もせんで良い、という事らしい。
			//			
			//				https://kashiwaba-yuki.com/linux-memory-protect-gdt-ldt
			//					x86CPUのメモリ保護機構に関するメモ書き(とLDT)
			//				
			//						GPT とは、LDT 先頭アドレスの集まり、配列、らしい？
			//						で、ユーザーモードでは GPT という配列のどれか一個の値を
			//						LDT レジスタにセットし、LDT レジスタにセットされた
			//						アドレスから、セグメント対応表を実際に CPU が使う、
			//						という流れ、らしい。
			//
			//						+------+								+------+
			//						|      | 8192こ?						|      |8192 個目?
			//						+------+								+------+
			//						....									....
			//						+------+								+------+
			//						|      | 2		→---------+				|      | 2		<= セグメント 2 番目使うよ！
			//						+------+				  |				+------+
			//						|      | 1				  |				|      | 1		<= セグメント 1 番目使うよ！
			//						+------+				  |				+------+
			//						|      | 0				  |				|      | 0		<= セグメント 0 番目使うよ！
			//						+------+				  |				+------+
			//						GPTにはこのテーブル		  |	
			//						先頭アドレスが入る		  +	----------------+
			//																	↓	
			//						+------+								+------+
			//						|      | GDT register					|		|  LDT register 
			//						+------+								+------+	 GPT のどれか一個の値が
			//																			コピーされる？？？
			//
			//			実際に segment レジスタに入る値っつーのは、右側の
			//			LDT のテーブルのうちのどれか１つ、らしい？？？
			//			CPU マニュアル 3-5-1 辺りを見ればビット詳細が書いてある。
			//			まぁ実際に使う事は無いから直接は関係ないな。


			//		・・・・という事が分かっていないと、
			//		x86 機では Write/ReadProcessMemory を使えないらしいｗ
			//		実際には、セグメントによるアドレス変換に加えてさらにアドレス変換機構が
			//		ある、らしいんだけど、詳細よく分からん。

			//			LDT_ENTRY構造体は、 Segment Descriptor ( メモリ上に置かれる)
			//			にほぼ一致する。
			//
			//			logical address ( 論理アドレス) : 
			//				セグメント値を足す前のオフセットアドレス。
			//				rip とかはコレ。
			//			lenar address (線形仮想アドレス) : 
			//				セグメントオフセットを足した後のアドレス。
			//				通常 VC などのユーザー空間はこのアドレスでの実行を前提にコンパイルされる。
			//			physical adress ( 物理アドレス) : 
			//				実際のメモリデバイス上のアドレス。
			//				paging 機能により、lear address がコレに変換される。

			//
			//			アドレス : 					32bit のベース address
			//			セグメント空間のサイズ：	1～1M バイトのバイト単位による指定
			//									または 4K～4G バイトの4Kバイト単位による指定
			//				
			//			IA32 mode( AMD/athlon の事じゃね?) では、
			//			system discriopor は通常は８バイトなのが、１６バイト
			//			48/80 bit まで拡張される、らしい。
			//			こいつを疑似deescriptor、と言うらしい。
			//			  Call/IDT/ gate, LDT/TSS descriptor がこれに
			//			該当するらしい。
			//
			//			あくまでも、オフセットだから足すだけでいいらしい？？？
			//			64 bit モードでは、セグメントレジスタが無効で0 扱いになるって書いてあるけど、
			//			それは memory model : Flat のみの話なのかな？

			//			

		#endif

		//		PC 現在値
		//objRet = this.clone();
		if ( !this.dat.mbValid_pi ) {
			clscsPub.PErrMsg( "  no process_debug_infomation . " );
			objPeFormat = null;
			return;
		}

		clsPeFormat.colonyRet_CheckPeFormat		nRet_pe;
		objPeFormat = new clsPeFormat();
		
		nRet_pe = objPeFormat.GetPeformat( this.dat.pi.hFile );
		if ( nRet_pe != clsPeFormat.colonyRet_CheckPeFormat.SUCCESS_DEBUG_STILL_UNCODED )
		{
			clscsPub.PErrMsg( " returns {2} > . ", nRet_pe.ToString() );
			return;
		}


		//if ( objPeFormat.IsWarn() ) {
			//Console.WriteLine( "\"{0}\".\"{1}\" warns {2} :  ", 
			//					this.ToString(), 
			//					System.Reflection.MethodBase.GetCurrentMethod().Name, 
			//					objPeFormat.ToString() );
			//foreach ( clsPeFormat.colonyRet_CheckPeFormat nWarn in objPeFormat.GetWarns() )
			//{
			//		Console.WriteLine( "      {0} :  ", 
			//					nWarn.ToString() );
			//}

		//}


		return;
		
	}		//		void	GetRegister()


}		// class clsWin32Manager


}		// namespace MANAGEDAPI



}		// namespace CliDbger

