// csWApiManager.cs

//		Win32 Debug API ラッパーを呼び出す
//		Debug メインループ



using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;




// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。


using BOOL = System.Int32;



namespace CliDbger {


namespace MANAGEDAPI {


internal partial class clsWin32Manager {


	internal enum colonyDW_MTDBG_CONTINUE_STATUS : uint 
	{
		TO_UIFLOW_WAITCOMMAND		= 0xF0000001U,
		QUIT_DEBUGGER_ONLY			= 0xF0000002U
	}



	private clsCleanUpDirManager				mobjCleanM;
	private clsMfDisposer						mobjDispDir_CurModule;
	private clsMfDisposer						mobjDispDir_Datas;

	internal clsWin32ManagerDatas				dat;
	// debug_info_32/64 構造体を常時保持するためと、最後に実行したイベントコードを
	//	保存するために static じゃなくインスタンス化してある！
	private	clsManagedDbgApis					mobjApis;

	#region clsWin32Manager:property / support mini function etc

		internal clsCleanUpDirManager ParentCleanUpManager {
			set { this.mobjCleanM = value };
			get { return this.mobjCleanM; };
		}

		internal void SetNull_dat() {
			this.dat = null;
		}


	#endregion

	internal void init( int nTargetBitSize ) {

		//this.mobjMultiDisposer = new clsWin32ManCleanUp();
		clscsPub.Assert( this.mobjCleanM != null );

		this.dat = new clsWin32ManagerDatas();
		// clsWin32ManagerDatas の disposer は親の物を間借りする。
		//this.dat.Disposer = this.mobjMultiDisposer;
		this.dat.mobjCleanM = this.mobjCleanM;


		this.dat.mblIsTarget_64 = ( nTargetBitSize == 8 );
		this.dat.mn4or8ByteMode = nTargetBitSize;
		this.dat.Init();
		this.dat.Set4or8ByteMode( nTargetBitSize );



		// イチイチディレクト指定が面倒なので変数として持っておく
		this.mobjDispDir_CurModule = 
			this.mobjCleanM.Root.GetChild_FromClassInstance( this );


		// clsWin32ManagerDatas の引っ越し
		// AttachExe チェーンが成功したらその 正常終了 Dispose 内で
		// モジュール cleanup として登録し直す(引っ越し)
		// Attach チェーンでエラーが出たら消去する



		{	// 	objModule_Win32ManagerDatas
			
			clsDispDir		objModule_Win32ManagerDatas;
			objModule_Win32ManagerDatas = mobjDispDir_CurModule.CreateChildModule(
												this.dat, 
												"clsWin32ManagerDatas", 
												typeof( MANAGEDAPI.clsWin32ManagerDatas )
										);


			clsDispDir			objModule_AttachExe;

			objModule_AttachExe = this.mobjCleanM.RootFunc;
			// [CLEANUP:0004]
			objCleanup_AtattchExe.
				Add_CleanupForModuleVariable(
							this.dat, 
							objCleanup_AtattchExe, 
							objModule_Win32ManagerDatas, 
							this.SetNull_dat );
			
			this.mobjDispDir_Datas = objModule_Win32ManagerDatas;
			this.dat.Clean_Win32Datas = objModule_Win32ManagerDatas;
		}	// 	objModule_Win32ManagerDatas



		// 4 か 8 をセット
		this.mobjApis = new clsManagedDbgApis( nTargetBitSize );

	}

	internal void Dispose() {
		// [CLEANUP:0006]

		// メモリ開放は上のマルチディスポーザーを呼んで
		// 終わっているが念のため呼び出す。
		if ( this.dat != null ) {
			this.dat.Dispose();
			this.dat = null;
		}
	}



	private bool WaitForDebugEvent_WithRegsterCleanUp( ref stDEBUG_EVENT stpDebugEvent,
												DWORD dwMilliseconds )
	{
		bool		bRet;	
		bRet = this.mobjApis.WaitForDebugEvent( ref stpDebugEvent, dwMilliseconds ); 

		if ( !bRet )
			return bRet;

		this.dat.dwLastDbgEventCode = stpDebugEvent.dwDebugEventCode;

		// 一度でも clsWin32.WaitForDebugEvent を呼び出したら、
		// Event クリーンナップを登録する

		// この登録処理は、WaitForDebugEvent() を呼び出す前に
		// やった方がいいかも？
		// LOAD_DLL_EVENT が CREATE_PROCESS/THRED_DEBUG_EVENT よりも先に
		// 来る可能性は多大にある。
		// clsWin32ManCleanUp でどっちでも取れるようにしとけばよいか。
		if ( this.dat.mobjEventCleanUp == null )
		{

			// dat の Dipose() にとりあえずつけてみる。
			clsMfDisposer	objClean_Win32Datas;
			objClean_Win32Datas = this.mobjDispDir_CurModule.GetChild_FromFuncName( "clsWin32ManagerDatas" );

			// [CLEANUP:0002]
			clsCallBackDisposer		objCallBackDisposer;
			objCallBackDisposer = new clsCallBackDisposer( "clsWin32Manager::Dispose_Events", 
									this.Dispose_Events );

			this.dat.mobjEventCleanUp = objCallBackDisposer;


			this.mobjCleanM.Current.
					Add_CleanupForModuleVariable( 
							objCallBackDisposer, 
							"clsWin32Manager::Dispose_Events", 
								this.mobjCleanM.RootFunc, 
								objClean_Win32Datas, 
								null
							);


		}
		return bRet;
	}

	internal DWORD EnterDebugLoop( ref stDEBUG_EVENT stpDebugEv )
	{
		// objCleanParentDir は csDbugger -> mobjLCRManager -> "AttachExe" または同列呼び出し箇所
		// である事を前提とする。
		// かつ clennupmanager.RootFunc が "AttachExe" または同列呼び出し箇所である事を前提とする。


		clsDispDir	objCleanCurrent;

		objCleanCurrent = this.mobjCleanM.Current;
		

		objCleanCurrent = this.objCleanParentDir.CreateFunc( "EnterDebugLoop" );



		DWORD dwContinueStatus = (DWORD)clsWin32.colonyDW_CONTINUE_STATUS.DBG_CONTINUE; // exception continuation 
	



		for(;;) 
		{ 
			// Wait for a debugging event to occur. The second parameter indicates
			// that the function does not return until a debugging event occurs. 
		
			//clsWin32.WaitForDebugEvent( DebugEv, clsWin32.INFINITE ); 
			//this.mobjApis.WaitForDebugEvent( stpDebugEv, clsWin32.INFINITE ); 
			this.WaitForDebugEvent_WithRegsterCleanUp( ref stpDebugEv, clsWin32.INFINITE );

			// Process the debugging event code. 
			clsWin32.colonyDW_DEBUGEVENTCODE	enmDbgZEventCode;

			enmDbgZEventCode = (clsWin32.colonyDW_DEBUGEVENTCODE)stpDebugEv.dwDebugEventCode;
			Console.WriteLine( "stpDebugEv.dwDebugEventCode : {0} . ", enmDbgZEventCode );
			//bool bRet;
			//bRet = this.WaitKey();
			//if ( bRet) { 
			//	dwContinueStatus = 
			//		(DWORD)colonyDW_MTDBG_CONTINUE_STATUS.TO_UIFLOW_WAITCOMMAND;
			//	break;
			//}

			// 構造体引数の HandleClose 用に、イベント情報保存
			//this.dat.mdwLastDbgEventCode = stpDebugEv.dwDebugEventCode;

			// 上記処理は this.mobjApis.WaitForDebugEvent 内の SetManaged 
			//  でイベントクリーンナップに保存されるため不要になった。


			switch ( stpDebugEv.dwDebugEventCode ) 
			{ 
				case clsWin32.colonyDW_DEBUGEVENTCODE.EXCEPTION_DEBUG_EVENT: 
				// Process the exception code. When handling 
				// exceptions, remember to set the continuation 
				// status parameter (dwContinueStatus). This value 
				// is used by the ContinueDebugEvent function. 

					stEXCEPTION_DEBUG_INFO	stpExceptionDebugInf;
					stpExceptionDebugInf = 
						(stEXCEPTION_DEBUG_INFO)(stpDebugEv.u);
		
					stEXCEPTION_RECORD		stpExcetoionRecord;
					stpExcetoionRecord = stpExceptionDebugInf.ExceptionRecord;

					//switch(DebugEv->u.Exception.ExceptionRecord.ExceptionCode)
					switch(stpExcetoionRecord.ExceptionCode)
					{ 
					case (DWORD)clsWin32.colonyDW_EXCEPTION_CODE.EXCEPTION_ACCESS_VIOLATION: 
					// First chance: Pass this on to the system. 
					// Last chance: Display an appropriate error. 
						break;
		
					case (DWORD)clsWin32.colonyDW_EXCEPTION_CODE.EXCEPTION_BREAKPOINT: 
					// First chance: Display the current 
					// instruction and register values. 
						break;
		
					case (DWORD)clsWin32.colonyDW_EXCEPTION_CODE.EXCEPTION_DATATYPE_MISALIGNMENT: 
					// First chance: Pass this on to the system. 
					// Last chance: Display an appropriate error. 
						break;
		
					case (DWORD)clsWin32.colonyDW_EXCEPTION_CODE.EXCEPTION_SINGLE_STEP: 
					// First chance: Update the display of the 
					// current instruction and register values. 
						break;
		
					//case clsWin32.colonyDW_EXCEPTION_CODE_GENERAL_WINDOWS.DBG_CONTROL_C: 
					case (DWORD)clsWin32.colonyDW_EXCEPTION_CODE_GENERAL_WINDOWS.CONTROL_C_EXIT: 
					
					// First chance: Pass this on to the system. 
					// Last chance: Display an appropriate error. 
						break;
		
					default:
					// Handle other exceptions. 
						break;
					} 

					break;
		
				case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_THREAD_DEBUG_EVENT: 
				// As needed, examine or change the thread's registers 
				// with the GetThreadContext and SetThreadContext functions; 
				// and suspend and resume thread execution with the 
				// SuspendThread and ResumeThread functions. 

					dwContinueStatus = this.OnCreateThreadDebugEvent( ref stpDebugEv );
					break;

				case clsWin32.colonyDW_DEBUGEVENTCODE.CREATE_PROCESS_DEBUG_EVENT: 
				// As needed, examine or change the registers of the
				// process's initial thread with the GetThreadContext and
				// SetThreadContext functions; read from and write to the
				// process's virtual memory with the ReadProcessMemory and
				// WriteProcessMemory functions; and suspend and resume
				// thread execution with the SuspendThread and ResumeThread
				// functions. Be sure to close the handle to the process image
				// file with CloseHandle.

					dwContinueStatus =this. OnCreateProcessDebugEvent( ref stpDebugEv );
					break;
		
				case clsWin32.colonyDW_DEBUGEVENTCODE.EXIT_THREAD_DEBUG_EVENT: 
				// Display the thread's exit code. 

					dwContinueStatus = this.OnExitThreadDebugEvent( ref stpDebugEv );
					break;
		
				case clsWin32.colonyDW_DEBUGEVENTCODE.EXIT_PROCESS_DEBUG_EVENT: 
				// Display the process's exit code. 

					dwContinueStatus = this.OnExitProcessDebugEvent( ref stpDebugEv );
					break;
		
				case clsWin32.colonyDW_DEBUGEVENTCODE.LOAD_DLL_DEBUG_EVENT: 
				// Read the debugging information included in the newly 
				// loaded DLL. Be sure to close the handle to the loaded DLL 
				// with CloseHandle.

					dwContinueStatus = this.OnLoadDllDebugEvent( ref stpDebugEv );
					break;
		
				case clsWin32.colonyDW_DEBUGEVENTCODE.UNLOAD_DLL_DEBUG_EVENT: 
				// Display a message that the DLL has been unloaded. 

					dwContinueStatus = this.OnUnloadDllDebugEvent( ref stpDebugEv );
					break;
		
				case clsWin32.colonyDW_DEBUGEVENTCODE.OUTPUT_DEBUG_STRING_EVENT: 
				// Display the output debugging string. 

					dwContinueStatus = this.OnOutputDebugStringEvent( ref stpDebugEv );
					break;

				case clsWin32.colonyDW_DEBUGEVENTCODE.RIP_EVENT:
					dwContinueStatus = this.OnRipEvent( ref stpDebugEv );
					break;

			} // switch (DebugEv->dwDebugEventCode) 
		

			if ( dwContinueStatus == 
				(DWORD)colonyDW_MTDBG_CONTINUE_STATUS.TO_UIFLOW_WAITCOMMAND || 
				dwContinueStatus == 
				(DWORD)colonyDW_MTDBG_CONTINUE_STATUS.QUIT_DEBUGGER_ONLY )
			{
				break;
			}

			// Resume executing the thread that reported the debugging event. 
			
			clsWin32.ContinueDebugEvent(stpDebugEv.dwProcessId, 
								stpDebugEv.dwThreadId, 
								dwContinueStatus);


		}		// for ( ;; )

		// モジュールレベルに移行するクリーンナップをつけかえる
		objCleanCurrent.SuccessEndCleanUp();
		objCleanCurrent = null;

		return dwContinueStatus;








	}		//	DWORD EnterDebugLoop()


}		// class clsWin32Manager


}		// namespace MANAGEDAPI



}		// namespace CliDbger


