// csWApiMapReg.cs


using System;






// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;


// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。




using BOOL = System.Int32;



namespace CliDbger {


namespace MANAGEDAPI {





internal class clsRegToUi {


	internal enum colonyREGNO : int
	{
		CS		= 0, 
		DS		= 1, 
		ES		= 2, 
		FS		= 3, 
		GS		= 4, 
		SS		= 5, 
		SEGCOUNT  = 6, 

		RAX		= 0, 
		RCX		= 1, 
		RDX		= 2, 
		RBX		= 3, 

		RSP_RESEREVE		= 4, 
		RBP_RESEREVE		= 5, 
		RSI_RESEREVE		= 6, 
		RDI_RESEREVE		= 7,
		R8					= 8,
		R9					= 9,
		R10					= 10,
		R11					= 11,
		R12					= 12,
		R13					= 13,
		R14					= 14,
		R15					= 15,


		RSP		= 0, 
		RBP		= 1, 
		RSI		= 2, 
		RDI		= 3
	}

	#if __NOT_CODE_SEGMENT_DEAIL_GET
		internal struct stSegmentInfo {
			internal uint			dwAddressFrom;
			internal uint			dwAddressTo;
			internal bool			bExceptionWhenUsed;
			internal byte			bytLevel;
			internal int			nType;
			internal int			nTypeDetail;
			

			internal void SetDescriptor( ref in clsWin32.LDT_ENTRY stLdt )
			{
				DWORD	dwAddrBase, dwAddrLimit;

				//internal struct LDT_ENTRY {
				//	WORD	LimitLow;
				//	WORD	BaseLow;
				//	byte	BaseMid;
				//	byte	Flags1;
				//	byte	Flags2;
				//	byte	BaseHi;
				//}
				dwAddrBase  = (DWORD)stLdt.BaseLow;
				dwAddrBase += ( (DWORD)stLdt.Flags1 ) << 15;
				dwAddrBase += ( (DWORD)stLdt.BaseHi ) << 24;

				dwAddrLimit  = (DWORD)stLdt.LimitLow;
				dwAddrLimit += ( ( (DWORD)stLdt.Flags1 ) & 0x0f ) << 15;

				

			}
		}	//
	#endif

	internal uint			dwContntFlags;
	internal uint			dwEflags;
	internal ushort[]		Segs;
	internal uint[]			SegAddrs;
	internal clsNuint[]		generals, sipi;
	internal clsNuint		ip, ip_linear;

	private bool			mbIs64bitMode;

	internal bool Is64bitMode {
		set {
			this.mbIs64bitMode = value;
		}
		get {
			return this.mbIs64bitMode;
		}
	}

	public clsRegToUi() 
	{
		this.dwContntFlags = 0x0;
		this.dwEflags = 0x0;
		this.Segs = new ushort[ (int)colonyREGNO.SEGCOUNT ];
		this.SegAddrs = new uint[ (int)colonyREGNO.SEGCOUNT ];
		this.generals = new clsNuint[16];
		this.sipi = new clsNuint[4];

		this.mbIs64bitMode = false;

		for ( int nIndex = 0 ; nIndex < this.generals.Length ; nIndex++ ){
			this.generals[ nIndex ] = new clsNuint();
		}
		for ( int nIndex = 0 ; nIndex < this.sipi.Length ; nIndex++ ){
			this.sipi[ nIndex ] = new clsNuint();;
		}

		this.ip = new clsNuint();
		this.ip_linear = new clsNuint();
	}

	internal void SetRegMode_x86or64 ( int nDataSize )
	{
		for ( int nIndex = 0 ; nIndex < this.generals.Length ; nIndex++ ){
			this.generals[ nIndex ].Size = nDataSize;
		}
		for ( int nIndex = 0 ; nIndex < this.sipi.Length ; nIndex++ ){
			this.sipi[ nIndex ].Size = nDataSize;
		}
		this.ip.Size = nDataSize;
		this.ip_linear.Size = nDataSize;

		if ( nDataSize == 8)
			this.mbIs64bitMode = true;
		else
			this.mbIs64bitMode = false;
	}


	internal void SetInvalid () 
	{
		this.dwContntFlags = uint.MaxValue;
		this.dwEflags = uint.MaxValue;

		int nIndex;
		for ( nIndex = 0 ; nIndex < this.Segs.Length ; nIndex++ ){
			this.Segs[ nIndex ] = ushort.MaxValue;
			this.SegAddrs[ nIndex ] = uint.MaxValue;
		}

		for ( nIndex = 0 ; nIndex < this.generals.Length ; nIndex++ ){
			this.generals[ nIndex ] = null;
		}
		for ( nIndex = 0 ; nIndex < this.sipi.Length ; nIndex++ ){
			this.sipi[ nIndex ] = null;
		}

		this.ip = null;
		this.ip_linear = null;
	}

	internal clsRegToUi Clone()
	{
		clsRegToUi		objClone;

		objClone = new clsRegToUi();

		objClone.dwContntFlags = this.dwContntFlags;
		objClone.dwEflags = this.dwEflags;

		objClone.Segs = new ushort[6];
		objClone.SegAddrs = new DWORD[6];
		objClone.generals = new clsNuint[16];
		objClone.sipi = new clsNuint[4];


		for ( int nIndex = 0 ; nIndex < this.Segs.Length ; nIndex++ ){
			objClone.Segs[ nIndex ] = this.Segs[ nIndex ];
			objClone.SegAddrs[ nIndex ] = this.SegAddrs[ nIndex ];
		}
		for ( int nIndex = 0 ; nIndex < this.generals.Length ; nIndex++ ){
			objClone.generals[ nIndex ] = new clsNuint( this.generals[ nIndex ] );
		}
		for ( int nIndex = 0 ; nIndex < this.sipi.Length ; nIndex++ ){
			objClone.sipi[ nIndex ] = new clsNuint( this.sipi[ nIndex ] );
		}

		objClone.ip = new clsNuint( this.ip );
		objClone.ip_linear = new clsNuint( this.ip_linear );

		objClone.Is64bitMode = this.Is64bitMode;

		return objClone;
	}


	internal void Close()
	{
		this.Segs = null;
		this.generals = null;
		this.sipi = null;
		this.ip = null;
	}		//	void close()

}		// class clsRegToUi



internal class clsMapToUi {

	internal class clsMapInfo {
		internal clsNuint									BaseAddress;		// 細分化された先頭
		internal clsNuint									AllocationBase;		// virtualAlloc でアロケーションされた単位? (COMMIT/RESERVE ごっちゃ)
		internal clsWin32.colonyCONST_MEMORY_GARD			AllocationProtect;
		internal clsNuint									RegionSize;
		internal clsWin32.colonyMEMORY_BASIC_INFO_STATE		State;				// CONNIT/RESERVE?FREE
		internal clsWin32.colonyCONST_MEMORY_GARD			Protect;
		internal clsWin32.colonyMEMORY_BASIC_INFO_TYPE		Type;				// IMAGE/MAPPED/PRIVATE



		internal clsNuint nuiBaseAddrEnd {
			get { return this.BaseAddress + this.RegionSize; }
		}
		internal clsNuint nuiAllocationAddrEnd {
			get { return this.AllocationBase + this.RegionSize; }
		}
		
	}


	internal class clsMapInfo2 {
		internal clsNuint									nuiTargetRip;

		internal clsNuint									objnuRegionSize;
		internal clsWin32.colonyCONST_MEMORY_GARD			AllocationProtect;
		internal clsWin32.colonyMEMORY_BASIC_INFO_TYPE		Type;				// IMAGE/MAPPED/PRIVATE

		internal System.Collections.Generic.List<clsMapInfo2Piece>	marPiece;

		internal clsMapInfo2( clsMapInfo objMapInf )
		{
			this.objnuRegionSize 		= new clsNuint( objMapInf.RegionSize );
			this.AllocationProtect	 	= objMapInf.AllocationProtect;
			this.Type 					= objMapInf.Type;
			this.marPiece = new System.Collections.Generic.List<clsMapInfo2Piece>();

			clsMapToUi.clsMapInfo2Piece		objMPiece;
			objMPiece = new clsMapToUi.clsMapInfo2Piece( objMapInf );
			this.marPiece.Add( objMPiece );
		}

		internal bool IsExistPiece( clsMapInfo2Piece mobjNewPiece )
		{
			if ( this.marPiece == null)
				return false;
			if ( this.marPiece.Count == 0 )
				return false;
			for ( int nIndex = 0 ; nIndex < this.marPiece.Count; nIndex++ )
			{
				if ( this.marPiece[ nIndex ].BaseAddress == mobjNewPiece.BaseAddress ) {
					return true;
				}
			}
			return false;
		}

		internal clsMapInfo2Piece LastPiece {
			get {
				
				int nLastIndex;
				nLastIndex = this.PieceLastIndex;
				
				if ( nLastIndex < 0 ) {
					// 実行時エラーはいやずら。
					#if __DEBUG__
						Console.WriteLine( "\"{0}\".\"{1}\" : failed to get last marPiece Index.  > . ", 
								this.ToString(), 
								System.Reflection.MethodBase.GetCurrentMethod().Name );
								Console.ReadKey( false );
					#endif

					return null;
				}
				return this.marPiece[ nLastIndex ];
			}
		}
		
		internal int PieceLastIndex {
		get {
			if ( this.marPiece == null)
				return -1;

			int nLastIndex;
			nLastIndex = this.marPiece.Count -1;
			if ( nLastIndex < 0 )
				return -1;
			return nLastIndex;
			}
		}
		
		internal clsNuint nuiBaseAddrEnd {
			get { 

				int nLastIndex;
				nLastIndex = this.PieceLastIndex;
				if ( nLastIndex <= 0 ) {
					// 実行時エラーはいやずら。
					#if __DEBUG__
						Console.WriteLine( "\"{0}\".\"{1}\" : failed to get last marPiece Index.  > . ", 
								this.ToString(), 
								System.Reflection.MethodBase.GetCurrentMethod().Name );
								Console.ReadKey( false );
					#endif

					return new clsNuint( this.objnuRegionSize.Size );
				}
				
				clsNuint	objRet;
				clsMapInfo2Piece	objMPieceLast;
				objMPieceLast = this.LastPiece;
				objRet = objMPieceLast.BaseAddress + 
							objMPieceLast.RegionSize;

				return objRet;
			 }
		}

		internal bool GetTopCommitRange( out clsMapInfo2Piece objMPRet_Sta, out clsMapInfo2Piece objMPRet_End )
		{

			objMPRet_Sta = null;
			objMPRet_End = null;
			if ( this.marPiece == null )
				return false;
			if ( this.marPiece.Count == 0 )
				return false;


			clsMapInfo2Piece	objMPieceCommitTop, objMPieceCommitEnd;
			objMPieceCommitTop = null;
			objMPieceCommitEnd = null;
			for( int nMapIndex = 0 ; nMapIndex < this.marPiece.Count; nMapIndex++ )
			{

				if ( this.marPiece[ nMapIndex ].State == 
					clsWin32.colonyMEMORY_BASIC_INFO_STATE.MEM_COMMIT )
				{
					if ( objMPieceCommitTop == null ) {
						objMPieceCommitTop = this.marPiece[ nMapIndex ];
					} else {
						// なんで item プロパティを使えないんだろ・・・[] インデクサ以外では
						// 実装されてないらしい。なんで？？？
						// 配列がネスト配列されてたら認識出来なくね？？？
						//objMPieceCommitEnd = this.marPiece.Item[ nMapIndex ];
						objMPieceCommitEnd = this.marPiece[ nMapIndex ];
					}
				}
			}

			if (objMPieceCommitTop == null) {
				// Commit されたメモリエリアが無い。
				return true;
			}
			if (objMPieceCommitEnd == null )
				objMPieceCommitEnd = objMPieceCommitTop;


			objMPRet_Sta = objMPieceCommitTop;
			objMPRet_End = objMPieceCommitEnd;
			return true;
		}

		internal clsNuiRange GetNearCommitRange( clsNuint nuiTargetAddr, int nSizeFromAddrToLower )
		{
			clsNuint	nuiTopAddr, nuiEndAddr, nuiSize;
			clsNuint	nuiToTop, nuiToEnd;

			nuiSize = new clsNuint( nuiTargetAddr.Size );
			nuiSize.CastSet( (ulong)nSizeFromAddrToLower );

			nuiToTop = new clsNuint( nuiSize / (ulong)2 );

			nuiTopAddr = new clsNuint( nuiTargetAddr );
			nuiTopAddr = nuiTopAddr.GetSafeMinus( nuiToTop );
			
			nuiToEnd = new clsNuint( nuiSize );
			nuiToEnd -= nuiToTop;


			nuiEndAddr = nuiTopAddr.GetSafePlus( nuiSize );



			bool bRet;
			clsMapInfo2Piece		objMPieceCommitTop, objMPieceCommitEnd;
			bRet = this.GetTopCommitRange( out objMPieceCommitTop, out objMPieceCommitEnd );
			if ( !bRet )
				return null;
			if ( objMPieceCommitTop == null && objMPieceCommitEnd == null )
				return null;
			
			
			
			/* Commit 属性の先頭を開始アドレスにする */
			if ( nuiTopAddr < objMPieceCommitTop.BaseAddress) {
				nuiTopAddr = new clsNuint( objMPieceCommitTop.BaseAddress );
				nuiToEnd   = nuiTopAddr.GetSafePlus( nuiSize );

				clsNuint		nuiComitAddrEnd;
				nuiComitAddrEnd = objMPieceCommitEnd.nuiBaseAddrEnd;
				if ( nuiToEnd > nuiComitAddrEnd ) {
					nuiToEnd   = nuiComitAddrEnd;
				}
			} else if ( nuiTopAddr > objMPieceCommitEnd.nuiBaseAddrEnd ) {
				nuiTopAddr = objMPieceCommitEnd.nuiBaseAddrEnd.GetSafeMinus( nuiToEnd );

				if ( nuiTopAddr < objMPieceCommitTop.BaseAddress ) {
					nuiTopAddr = new clsNuint( objMPieceCommitTop.BaseAddress );
				}

				nuiToEnd = nuiTopAddr.GetSafePlus( nuiSize );
				
				clsNuint		nuiComitAddrEnd;
				nuiComitAddrEnd = objMPieceCommitEnd.nuiBaseAddrEnd;
				if ( nuiToEnd > nuiComitAddrEnd ) {
					nuiToEnd = nuiComitAddrEnd;
				}

			} else {
				nuiToEnd = nuiTopAddr.GetSafePlus( nuiSize );
				
				clsNuint		nuiComitAddrEnd;
				nuiComitAddrEnd = objMPieceCommitEnd.nuiBaseAddrEnd;
				if ( nuiToEnd > nuiComitAddrEnd ) {
					nuiToEnd = nuiComitAddrEnd;
				}

			}

			clsNuiRange		rngRip;
			rngRip = new clsNuiRange( nuiTopAddr, nuiEndAddr );
			if ( !rngRip.IsValid )
				return null;

			return rngRip;

		}		//		clsNuiRange GetNearRipRange()

	}		//		class clsMapInfo2

	internal class clsMapInfo2Piece {
		internal clsNuint									AllocationBase;		// virtualAlloc でアロケーションされた単位? (COMMIT/RESERVE ごっちゃ)
		internal clsNuint									BaseAddress;		// 細分化された先頭
		internal clsWin32.colonyMEMORY_BASIC_INFO_STATE		State;				// CONNIT/RESERVE?FREE
		internal clsWin32.colonycolonyCONST_MEMORY_GARD		Protect;
		internal clsNuint									RegionSize;

		internal clsMapInfo2Piece( clsMapInfo objMapInf )
		{
			this.AllocationBase 	= objMapInf.AllocationBase;
			this.BaseAddress		= objMapInf.BaseAddress;
			this.State				= objMapInf.State;
			this.Protect			= objMapInf.Protect;
			this.RegionSize		= objMapInf.RegionSize;
		}

		internal clsNuint nuiBaseAddrEnd {
			get { return this.BaseAddress + this.RegionSize; }
		}


		internal clsNuint nuiAllocationAddrEnd {
			get { return this.BaseAddress + this.RegionSize; }
		}
	}
	


	internal System.Collections.Generic.List<clsMapInfo>		marMapInf;

	internal clsMapInfo2										mobjMapNearRip;

	private bool mblIsTarget64bit;


	internal bool IsTarget64bit
	{
		set {	this.mblIsTarget64bit = value; }
		get {	return this.mblIsTarget64bit; }
	}

	internal void InitMap()
	{
		if ( this.marMapInf != null ) {
			this.marMapInf.Clear();
			this.marMapInf = null;
		}
		this.marMapInf = new System.Collections.Generic.List<clsMapInfo>();
	}
	

	internal int GetCountOfAllMap() {
		if ( this.marMapInf == null )
			return 0;
		return this.marMapInf.Count;
	}


	internal static clsMapInfo ConvertWin32ToMangagedMemInf( ref clsWin32.MEMORY_BASIC_INFORMATION32 refstMemInf32 )
	{
		clsMapInfo		objNewMap;
		objNewMap = new clsMapInfo();
		if ( refstMemInf32.State == (DWORD)clsWin32.colonyMEMORY_BASIC_INFO_STATE.MEM_FREE  ) {

			objNewMap.BaseAddress			= new clsNuint( refstMemInf32.BaseAddress );
			objNewMap.AllocationBase		= null;
			objNewMap.AllocationProtect		= 0;
			objNewMap.RegionSize			= new clsNuint( refstMemInf32.RegionSize );
			objNewMap.State					= (clsWin32.colonyMEMORY_BASIC_INFO_STATE)refstMemInf32.State;
			objNewMap.Protect				= 0;
			objNewMap.Type					= 0;
		} else if ( refstMemInf32.State == (DWORD)clsWin32.colonyMEMORY_BASIC_INFO_STATE.MEM_RESERVE ) {

			objNewMap.BaseAddress			= new clsNuint( refstMemInf32.BaseAddress );
			objNewMap.AllocationBase		= new clsNuint( refstMemInf32.AllocationBase );
			objNewMap.AllocationProtect		= (clsWin32.colonyCONST_MEMORY_GARD)refstMemInf32.AllocationProtect;

			objNewMap.RegionSize			= new clsNuint( refstMemInf32.RegionSize );
			objNewMap.State					= (clsWin32.colonyMEMORY_BASIC_INFO_STATE)refstMemInf32.State;
			objNewMap.Protect				= 0;
			objNewMap.Type					= (clsWin32.colonyMEMORY_BASIC_INFO_TYPE)refstMemInf32.Type;
		} else {
			objNewMap.BaseAddress			= new clsNuint( refstMemInf32.BaseAddress );
			objNewMap.AllocationBase		= new clsNuint( refstMemInf32.AllocationBase );
			objNewMap.AllocationProtect		= (clsWin32.colonyCONST_MEMORY_GARD)refstMemInf32.AllocationProtect;

			objNewMap.RegionSize			= new clsNuint( refstMemInf32.RegionSize );
			objNewMap.State					= (clsWin32.colonyMEMORY_BASIC_INFO_STATE)refstMemInf32.State;
			objNewMap.Protect				= (clsWin32.colonyCONST_MEMORY_GARD)refstMemInf32.Protect;
			objNewMap.Type					= (clsWin32.colonyMEMORY_BASIC_INFO_TYPE)refstMemInf32.Type;
		}

		//foreach( clsMapInfo	objMapIndex in this.marMapInf ) {
		//	if ( objMapIndex.BaseAddress ==  objNewMap.BaseAddress )
		//		// baseaddress が被ってる時は登録しない。
		//		return;
		//}
		return objNewMap;
	} // 		void AddMemInf()



	internal static clsMapInfo ConvertWin32ToMangagedMemInf( ref clsWin32.MEMORY_BASIC_INFORMATION64 refstMemInf64 )
	{
		clsMapInfo		objNewMap;
		objNewMap = new clsMapInfo();
		if ( refstMemInf64.State == (DWORD)clsWin32.colonyMEMORY_BASIC_INFO_STATE.MEM_FREE  ) {

			objNewMap.BaseAddress			= new clsNuint( refstMemInf64.BaseAddress );
			objNewMap.AllocationBase		= null;
			objNewMap.AllocationProtect		= (clsWin32.colonyCONST_MEMORY_GARD)0;
			objNewMap.RegionSize			= new clsNuint( refstMemInf64.RegionSize );
			objNewMap.State					= (clsWin32.colonyMEMORY_BASIC_INFO_STATE)refstMemInf64.State;
			objNewMap.Protect				= 0;
			objNewMap.Type					= 0;
		} else if ( refstMemInf64.State == (DWORD)clsWin32.colonyMEMORY_BASIC_INFO_STATE.MEM_RESERVE ) {

			objNewMap.BaseAddress			= new clsNuint( refstMemInf64.BaseAddress );
			objNewMap.AllocationBase		= new clsNuint( refstMemInf64.AllocationBase );
			objNewMap.AllocationProtect		= (clsWin32.colonyCONST_MEMORY_GARD)refstMemInf64.AllocationProtect;

			objNewMap.RegionSize			= new clsNuint( refstMemInf64.RegionSize );
			objNewMap.State					= (clsWin32.colonyMEMORY_BASIC_INFO_STATE)refstMemInf64.State;
			objNewMap.Protect				= (clsWin32.colonyCONST_MEMORY_GARD)0;
			objNewMap.Type					= (clsWin32.colonyMEMORY_BASIC_INFO_TYPE)refstMemInf64.Type;
		} else {
			objNewMap.BaseAddress			= new clsNuint( refstMemInf64.BaseAddress );
			objNewMap.AllocationBase		= new clsNuint( refstMemInf64.AllocationBase );
			objNewMap.AllocationProtect		= (clsWin32.colonyCONST_MEMORY_GARD)refstMemInf64.AllocationProtect;

			objNewMap.RegionSize			= new clsNuint( refstMemInf64.RegionSize );
			objNewMap.State					= (clsWin32.colonyMEMORY_BASIC_INFO_STATE)refstMemInf64.State;
			objNewMap.Protect				= (clsWin32.colonyCONST_MEMORY_GARD)refstMemInf64.Protect;
			objNewMap.Type					= (clsWin32.colonyMEMORY_BASIC_INFO_TYPE)refstMemInf64.Type;
		}

		return objNewMap;
	} // 		void AddMemInf()





}		// class clsMapToUi


internal class clsNearRipInfo {
	internal clsNuint		nuiRip;
	internal uint			nuiDemandSize;
	internal clsNuiRange	rngnuiCode;
	internal byte[]			arbytData;

}



}		// namespace MANAGEDAPI

}		// namespace CliDbger

