// csWApiThreadContext.cs

	// clsWin32.GetThreadContext 関係

using System;



//#if AAA
//#endif



// VC では    DWORD   4byte らしい。0
using DWORD = System.UInt32;
using DWORD64 = System.UInt64;

using WORD = System.UInt16;


// csharp/vb/win32 vc/vc compiler
//  各種データ型のサイズ詳細メモは csWin32.cs を参照。

using BOOL = System.Int32;




namespace CliDbger {


namespace MANAGEDAPI {



internal partial class clsContentProvider : System.IDisposable
{

	internal int ContentBufferSize {
		set { this.mdwContentSize = value; }
		get { return this.mdwContentSize; }
	}

	internal void SetRegisterListMode( bool bTarget64 ) {
		ushort			enmOrder;
		enmOrder = this.menmOrderedRegStyle;
		if ( bTarget64 ) {
		 	enmOrder |= colonyREG_STYLE.GENERAL_64;	
		} else {
		 	enmOrder &= colonyREG_STYLE.GENERAL_64;	
		}
		this.menmOrderedRegStyle = enmOrder;

	}

	internal void SetDbgRegister( bool bShow ) {

		ushort			enmOrder;
		enmOrder = this.menmOrderedRegStyle;
		if ( bTarget64 ) {
		 	enmOrder |= colonyREG_STYLE.WITH_DBG_REG;	
		} else {
		 	enmOrder &= colonyREG_STYLE.WITH_DBG_REG;	
		}
		this.menmOrderedRegStyle = enmOrder;
	
	}

	internal clsContentProvider() 
	{
		this.hKernel32Dll = null;
		this.bXStatevalid = stContentProvider.colonyXSTATE_OS_COMPATIBLE.NO_CHECKED;
		this.pGetEnabledXStateFeatures = null;
		this.pInitializeContext = null;
		this.pGetXStateFeaturesMask = null;
		this.pLocateXStateFeature = null;
		this.pSetXStateFeaturesMask = null;
		this.pContent = null;
		this.mdwContentSize = this.dwCONTENTSIZE_NOINITIALIZED;

		this.menmCurrentRegStyle = colonyREG_STYLE.NOT_LOADED;
		this.menmOrderedRegStyle = colonyREG_STYLE.NOT_LOADED;

	}




	public clsMySafeHGlobalHandle GetContextBuffer() {
		return pContent;
	}


	private bool CreateContextBuffer( uint dwContentSize ) {
		// CONTEXT 構造体のバッファサイズを確定、用意する

		if ( this.menmCurrentRegStyle == this.menmOrderedRegStyle && 
			this.menmCurrentRegStyle != colonyREG_STYLE.NOT_LOADED )
			return true;

		if ( this.mdwContentSize == dwContentSize )
			return true;

		bool	bRet;

		// デバッグ系とかSSE 系とか　AVX512 とかは、cpuid 命令呼び出す DLL 生成
		// アセンブラ exe 出力プログラムが出来るまでおあずけｗ
		// CreateFileMappingObject() で code 領域作ってもまぁ、別に
		// いいけど・・・。
		// スタック管理とか引数戻り値とかめんどいしなぁ。
		// だいたい、.net ってプラットフォーム呼び出しで簡単に出来るとも
		// 思えないしなぁ。
		bRet = this.CreateContextBuffer_noExtend( dwContentSize );
		if ( bRet)
			this.this.menmCurrentRegStyle = this.menmOrderedRegStyle;

		return bRet;


		#if __NOT_CODE_YET_

			if ( this.bXStatevalid == clsWin32ManagerDatas.clsContentProvider.colonyXSTATE_OS_COMPATIBLE.NO_CHECKED ) {

				this.pGetEnabledXStateFeatures = 
						(clsWin32.dgltGetEnabledXStateFeatures) 
							this.LoadKernel32Function<clsWin32.dgltGetEnabledXStateFeatures>(
									"GetEnabledXStateFeatures" );
				if ( this.pGetEnabledXStateFeatures == null ) {
					bContentExtend = false;
					this.CreateContextBuffer_extendDisable();
					return this.CreateContextBuffer_noExtend();
				}


				this.pInitializeContext = 
						(clsWin32.dgltInitializeContext) 
							this.LoadKernel32Function<clsWin32.dgltInitializeContext>(
									"InitializeContext" );
				if ( this.pInitializeContext == null ) {
					bContentExtend = false;
					this.CreateContextBuffer_extendDisable();
					return this.CreateContextBuffer_noExtend();
				}

				this.pGetXStateFeaturesMask = 
						(clsWin32.dgltGetXStateFeaturesMask) 
							this.LoadKernel32Function<clsWin32.dgltGetXStateFeaturesMask>(
									"GetXStateFeaturesMask" );
				if ( this.pGetXStateFeaturesMask == null ) {
					bContentExtend = false;
					this.CreateContextBuffer_extendDisable();
					return this.CreateContextBuffer_noExtend();
				}

				this.pLocateXStateFeature = 
						(clsWin32.dgltLocateXStateFeature) 
							this.LoadKernel32Function<clsWin32.dgltLocateXStateFeature>(
									"LocateXStateFeature" );
				if ( this.pLocateXStateFeature == null ) {
					bContentExtend = false;
					this.CreateContextBuffer_extendDisable();
					return this.CreateContextBuffer_noExtend();
				}

				this.pSetXStateFeaturesMask = 
						(clsWin32.dgltSetXStateFeaturesMask) 
							this.LoadKernel32Function<clsWin32.dgltSetXStateFeaturesMask>(
									"SetXStateFeaturesMask" );
				if ( this.pSetXStateFeaturesMask == null ) {
					bContentExtend = false;
					this.CreateContextBuffer_extendDisable();
					return this.CreateContextBuffer_noExtend();
				}

				this.bXStatevalid =  colonyXSTATE_OS_COMPATIBLE.VALID;
			}





			//Marshal.AllocHGlobal でヒープ割り当て
			clsWin32.dgltInitializeContext pInitilizeContentPointer;

			pInitilizeContentPointer = (clsWin32.dgltInitializeContext) 
										clsWin32.LoadFunction<clsWin32.dgltInitializeContext>(
											"kernel32.dll", "InitializeContext") ;

			if ( pInitilizeContentPointer == null  ) { 
				Console.WriteLine( "LoadLibrary of InitializeContext  : failed" );
				return false;
			}


			Console.WriteLine( "LoadLibrary of InitializeContext  : success!!" );
			return true;






			#if NOT_CODED_OLD_CODE


				BOOL		bRet;
				bRet = (this.dat.cp.pInitializeContext)( null, dwContentFlags, this.dat.cp.pContent, this.mdwContentSize  );
				if ( bRet == 0 ) {
					//Console.WriteLine( """{0}"".""{1}"" : InitializeContext 2nd call failed. ", 
					//						this.ToString(), 
					//						System.Reflection.MethodBase.GetCurrentMethod().Name );
					Console.WriteLine( "\"{0}\".\"{1}\" : InitializeContext 2nd call failed. " , 
											this.ToString(), 
											System.Reflection.MethodBase.GetCurrentMethod().Name );

					System.Runtime.InteropServices.Marshal.FreeHGlobal( this.dat.cp.pContent );
					this.dat.cp.pContent = null;
					return false;
				}
				if ( this.mdwContentSize == 0 ) {
					Console.WriteLine( "\"{0}\".\"{1}\" : InitializeContext returns size 0. ", 
											this.ToString(), 
											System.Reflection.MethodBase.GetCurrentMethod().Name );
					System.Runtime.InteropServices.Marshal.FreeHGlobal( this.dat.cp.pContent );
					this.dat.cp.pContent = null;
					return false;
				}
				if ( this.mdwContentSize > 10000 ) {
					Console.WriteLine( "\"{0}\".\"{1}\" : InitializeContext returns big size. ", 
											this.ToString(), 
											System.Reflection.MethodBase.GetCurrentMethod().Name );
					System.Runtime.InteropServices.Marshal.FreeHGlobal( this.dat.cp.pContent );
					this.dat.cp.pContent = null;
					return false;
				}

				// メモリサイズが確定したので再度サイズ設定
				System.Runtime.InteropServices.Marshal.FreeHGlobal( this.dat.cp.pContent );
				this.dat.cp.pContent = null;

				try {
					pContent = System.Runtime.InteropServices.AllocHGlobal( 
								this.mdwContentSize
									);
				}
				catch( System.OutOfMemoryException e)
				{

					Console.WriteLine( "\"{0}\".\"{1}\" : AllocHGlobal failed. not enough memory. ", 
											this.ToString(), 
											System.Reflection.MethodBase.GetCurrentMethod().Name );

					// 例外をスローした方が良い気もするけど、まぁいいやｗ
					// 例外ってなんか動き、昔から怪しいしｗ
					return false;
				}
				this.dat.cp.pContent = pContent;


				return false;




			#endif		// NOT_CODED_OLD_CODE


		#endif		// __NOT_CODED_YET

	}		//		bool CreateContextBuffer()


	//private void CreateContextBuffer_extendDisable() {
	//	this.pGetEnabledXStateFeatures = null;
	//	this.pInitializeContext = null;
	//	this.pGetXStateFeaturesMask = null;
	//	this.pLocateXStateFeature = null;
	//	this.pSetXStateFeaturesMask = null;
	//	this.bXStatevalid = colonyXSTATE_OS_COMPATIBLE.INVALID;
	//}		// void CreateContextBuffer_extendDisable()







	private bool CreateContextBuffer_noExtend( uint dwContentSize ) {

		// API ないなら InitializeContent から再開???


		// 最初に buffer パラメータをnullにして呼び出し、サイズを確定させる。
		DWORD			dwContentFlags;
		dwContentFlags = (DWORD)
					(	 clsWin32.colonyDW_CONTEXT_FLAGS.CONTEXT_FULL | 
						clsWin32.colonyDW_CONTEXT_FLAGS.CONTEXT_SEGMENTS );
		if ( this.dat.mbShowDebugRegs ) {
			dwContentFlags |= (DWORD)
					(	 clsWin32.colonyDW_CONTEXT_FLAGS.CONTEXT_DEBUG_REGISTERS );
		}

		// マネージドな構造体を API に渡しても意味ない(というか渡せない)ので、
		// 構造体用のメモリを動的に確保する。
		DWORD		dwSize;

		if ( this.mdwContentSize == this.dwCONTENTSIZE_NOINITIALIZED || 
				dwContentSize == this.dwCONTENTSIZE_NOINITIALIZED ) {
			dwSize = (DWORD)
					System.Runtime.InteropServices.Marshal.SizeOf( 
							typeof( clsWin32.CONTEXT )
					);
		} else {
			dwSize = dwContentSize;
		}



		// 以前使ってるメモリが入ってたら念のため開放
		if ( this.pContent != null ) {
			//		https://learn.microsoft.com/ja-jp/dotnet/api/system.runtime.interopservices.marshal.destroystructure?view=net-8.0
			//			Marshal.DestroyStructure メソッド
			//
			//				構造体メンバーに文字列があって、
			//				Marshal.StructureToPtr メソッドで構造体データをコピー
			//				する場合はこのメソッドを呼び出す事で、構造哀メンバーの
			//				アンマネージドエリアへの参照文字列エリアをメモリ開放できるらしい。
			//				メンバには無いけど一応呼んでおこう。
			//	
			System.Runtime.InteropServices.Marshal.DestroyStructure<clsWin32.CONTEXT>(
							this.pContent.DangerousGetHandle()
						);

			this.pContent.Dispose();
			this.pContent = null;
		}


		// InitilizeContnt の最初の呼び出しに、いちおーは念のため第三引数に適当に
		//	メモリを設定しておくｗ
		//	フツーどう考えても null 設定するべこんなの・・・。

		System.IntPtr		pContent;
		// try 文の使い方：
		// 		https://learn.microsoft.com/ja-jp/dotnet/csharp/language-reference/statements/exception-handling-statements
		//			Exception-handling statements - throw, try-catch, try-finally, and try-catch-finally
		// 		/MSDN_pdf/dotnet-csharp.pdf
		//			Exception-handling statements - throw ,try-catch , try-finally , and try-catchfinally
		//				1929 ページ
		try {
			pContent = (IntPtr)System.Runtime.InteropServices.Marshal.AllocHGlobal( 
						(int)dwSize
							);
		}
		catch( System.OutOfMemoryException e)
		{
			// https://qiita.com/jTakasuRyuji/items/8c1b393e3b5c23691956
			//		実行中のクラス名とメソッド名を取得する
			//				これ見つけた奴天才だろ・・・
			clscsPub.PErrMsg( " AllocHGlobal failed. not enough memory.   {0} ", 
									e.Message );

			// 例外をスローした方が良い気もするけど、まぁいいやｗ
			// 例外ってなんか動き、昔から怪しいしｗ
			//System.Runtime.InteropServices.Marshal.FreeHGlobal( this.dat.cp.pContent );
			this.pContent = null;
			return false;
		}
		this.pContent = new clsMySafeHGlobalHandle( pContent );
		this.mdwContentSize = dwSize;

		unsafe
		{
			clsWin32.CONTEXT		stThreadContext;
			stThreadContext = new clsWin32.CONTEXT();
			stThreadContext.ContextFlags = dwContentFlags;

			// https://learn.microsoft.com/ja-jp/dotnet/api/system.runtime.interopservices.marshal.structuretoptr?view=net-7.0
			//		Marshal.StructureToPtr メソッド
			//				※ AllocHGlobal などでコピー先バッファを事前に確保しとく必要がある。

			// 何だろこのコード？？？？？意味わかんねぇ。

			System.Runtime.InteropServices.Marshal.StructureToPtr( 
										stThreadContext, this.pContent.DangerousGetHandle(), false );
		}


		return true;
	}		//		bool CreateContextBuffer_noExtend()


	internal void UpdateContentFlags( uint dwContentFlags )
	{
		
		clsWin32.CONTEXT		stThreadContext;
		stThreadContext = new clsWin32.CONTEXT();
		stThreadContext.ContextFlags = dwContentFlags;


		// 最後の引数を true にする事で、最後にコピーしたマネージド
		// 構造体インスタンスへの参照カウントをデクリメントする！
		// なんつぅめんどくさいんだ。
		System.Runtime.InteropServices.Marshal.StructureToPtr( 
										stThreadContext, this.pContent.DangerousGetHandle(), true );

	}		//		UpdateContentFlag()


	internal void Dispose() {
		// [CLEANUP:0003]
		if ( this.pContent != null ) {
			System.Runtime.InteropServices.Marshal.DestroyStructure<clsWin32.CONTEXT>(
							this.pContent.DangerousGetHandle()
						);
			this.pContent.Dispose();
			this.pContent = null;
		}
	}



	private System.Delegate LoadKernel32Function<T>( string functionName ) {

		if ( this.hKernel32Dll == null || this.hKernel32Dll.IsInvalid ) {
			IntPtr			hKernel32Dll;

			hKernel32Dll =  clsWin32.GetModuleHandleW( "kernel32.dll" );

			if ( hKernel32Dll == IntPtr.Zero ) { 
				clscsPub.PErrMsg( " : GetModuleHandleW(\"kernel32.d\") failed . " );
				return null;
			}
			//	https://learn.microsoft.com/en-us/dotnet/api/system.runtime.interopservices.safehandle.-ctor?view=net-6.0
			//			SafeHandle Constructors
			//				ownsHandle は true でいいらしい？？？
			//this.dat.cp.hKernel32Dll.SetHandle( hKernel32Dll );
			this.hKernel32Dll = new Microsoft.Win32.SafeHandles.SafeFileHandle( hKernel32Dll, true );
		}

		// this.dat.cp.hKernel32Dll 、 HandleRef? DengorousGetHandle?
		IntPtr		hKernel32;
		bool		bSucess = false;
		this.hKernel32Dll.DangerousAddRef( ref bSucess );

		hKernel32 = this.dat.cp.hKernel32Dll.DangerousGetHandle();
		System.IntPtr functionAddress = clsWin32.GetProcAddress( hKernel32, functionName) ;
		this.hKernel32Dll.DangerousRelease();
		if( functionAddress == System.IntPtr.Zero) {
			#if __DEBUG__
				//Console.WriteLine( "\"{0}\".\"{1}\" : GetProcAddress failed. > ", 
				//						this.ToString(), 
				//						System.Reflection.MethodBase.GetCurrentMethod().Name );
				//Console.ReadKey( false );
			#endif
			return null;
		}
		return System.Runtime.InteropServices.Marshal.GetDelegateForFunctionPointer( functionAddress, typeof (T)) ;

	}		//	System.Delegate LoadKernel32Function()




}		//	class clsContentProvider

}		// namespace MANAGEDAPI



}		// namespace CliDbger
