Option Explicit On


NameSpace MtCalc

' エプソンlk33風の多重参照ハッシュテーブルを真似して実装する。
' https://jyuch.hatenablog.com/entry/2015/07/27/220551
' こんなんで合ってるんかね…。

'Friend Class clsArrayHash(Of TKey, TValue)
Friend Class clsArrayHash(OF TKey, TValue)



	Friend Class clsKeyValuePair
		'Implements System.IEquatable(Of clsKeyValuePair)


		Friend Key			As TKey
		Friend Value		As TValue

		Public Sub New( ByVal key As TKey, ByVal value As TValue)
			Me.Key = key
			Me.Value = value
		End Sub

		Friend Class clsKeyValuePairComparer
			Implements System.Collections.Generic.IComparer(Of clsKeyValuePair)

			Private mFullKeyComparer As System.Collections.Generic.IComparer(Of TKey)

			Public Sub New( pFullKeyComparer As System.Collections.Generic.IComparer(Of TKey) )
				Me.mFullKeyComparer = pFullKeyComparer
			End Sub

			Public Shadows Function Compare( ByVal other1 As clsKeyValuePair, ByVal other2 As clsKeyValuePair ) As Integer Implements System.Collections.Generic.IComparer(Of clsKeyValuePair).Compare
				Return Me.mFullKeyComparer.Compare( other1.Key, other2.Key )
			End Function
		
		End Class

	End Class


	Friend Interface IEqualityComparerPlusHashMaker
		Inherits System.Collections.Generic.IEqualityComparer(Of TKey)
		Function GetDicKey( ByVal objSourceKey As TKey) As TKey
	End Interface

	Private mobjDicComparer 			  	 	  As IEqualityComparerPlusHashMaker
	

	Private mobjListFullKeyComparer    			  As System.Collections.Generic.IComparer(Of TKey)
	Private mobjKeyValuePairFullKeyComparer    	  As System.Collections.Generic.IComparer(Of clsKeyValuePair)
	

	' キーで呼び出して、参照した複数のオブジェクトを参照する。
	' 確かシンボル名でハッシュしてたような
	' 呼び出しが高速だからインデックス参照代わりに使ってたんだよな。

	' DelfGen からの転用だけど中身書き換えまくったので完全に別クラス。
	' List全体を返すコードだったのをListの各Itemのset/get する形に変更した。

	
	' https://learn.microsoft.com/ja-jp/dotnet/api/system.collections.generic.dictionary-2?view=net-6.0
	private mDictionary As System.Collections.Generic.Dictionary(Of TKey, System.Collections.Generic.List(Of clsKeyValuePair ) )
	
	Public Sub New( ByVal nItemCount As Integer, _ 
				ByVal pDicKeyComparer As IEqualityComparerPlusHashMaker, _ 
				ByVal pFullKeyComparer As System.Collections.Generic.IComparer(Of TKey) _ 
				 )
		'mobjDicComparer = new clsDicKeyComparer()
		'mobjDicComparer.SetEqualKeyGeratorPointer( pEqualKeyGeneratorPointer )
		'Me.mEqualKeyGeneratorFuncPointer = pEqualKeyGeneratorPointer

		'mobjDicComparer.SetHashCodePointer( pHashCodePointer )
		'Me.mHashCodeFuncPointer = pHashCodePointer

		'Me.mFullKeyMatchFuncPointer	= pFullKeyMatchPointer

		Me.mobjDicComparer = pDicKeyComparer

		Me.mobjListFullKeyComparer = pFullKeyComparer
		Me.mobjKeyValuePairFullKeyComparer = new clsKeyValuePair.clsKeyValuePairComparer( pFullKeyComparer )

		mDictionary = new System.Collections.Generic.Dictionary(Of TKey, System.Collections.Generic.List(Of clsKeyValuePair ) )( nItemCount, mobjDicComparer )

	End Sub
	


	Friend Sub Add(ByVal key As TKey, ByVal value As TValue )
	
		' http://programmers.high-way.info/vb/list-remove.html
		' うわList型の条件検索すっげー便利だわこのHPによると…。
		Dim lstValueList As System.Collections.Generic.List(Of clsKeyValuePair)


		Dim objKeyForDic		As TKey
		objKeyForDic = Me.mobjDicComparer.GetDicKey( key )


		If mDictionary.ContainsKey( key ) = false Then
			lstValueList = new System.Collections.Generic.List(Of clsKeyValuePair )()

			mDictionary.Add( objKeyForDic, lstValueList )

		Else
			lstValueList = mDictionary( objKeyForDic )
		End If

		Dim objKeyValuePair		As clsKeyValuePair
		objKeyValuePair = new clsKeyValuePair( key, value )


		Dim nAddIndex		As Integer
		' 確か、CompareTo を呼び出したような・・・
		' どこ呼び出すんだろｗわすれたｗ
		nAddIndex = lstValueList.BinarySearch( objKeyValuePair, _ 
							Me.mobjKeyValuePairFullKeyComparer )
		If nAddIndex >= 0 Then
			' キーが完全一致したら上書き
			lstValueList( nAddIndex ) = objKeyValuePair
		Else
			lstValueList.Insert( Not nAddIndex, objKeyValuePair )
		End If


	End Sub

	Friend Sub Remove(ByVal key As TKey )


		' http://programmers.high-way.info/vb/list-remove.html
		' うわList型の条件検索すっげー便利だわこのHPによると…。
		Dim lstValueList As System.Collections.Generic.List(Of clsKeyValuePair)
	
		Dim objKeyForDic				As TKey
		objKeyForDic = Me.mobjDicComparer.GetDicKey( key )

		If mDictionary.ContainsKey( objKeyForDic ) = false Then
			' 何もしない・・・で良いのかね？？？エラーの方が良くね？
			'Console.WriteLine( "claArrayHash : Remove : mDictionary.ContainsKey( key ) = false :  key={0}, key.ToString()=""{1}"" ", key, key.ToString() )
			Return
		End If
			

		lstValueList = mDictionary( objKeyForDic )
		If lstValueList Is Nothing Then
			Return
		End If

		Dim objKeyValuePair		As clsKeyValuePair
		objKeyValuePair = new clsKeyValuePair( key, Nothing )

		Dim nIndex		As Integer
		nIndex = lstValueList.BinarySearch( objKeyValuePair, _ 
							Me.mobjKeyValuePairFullKeyComparer )
		If nIndex < 0 Then
			' 削除しようとして無かったら何もしない
			Return
		End If
		lstValueList.RemoveAt( nIndex )

		If lstValueList.Count = 0 Then
			mDictionary.Remove( objKeyForDic )
			lstValueList.Clear()
			lstValueList = Nothing
		End If

	End Sub

	Default Friend Property Item( key As TKey ) As TValue
	Get
		Dim objKeyForDic				As TKey
		objKeyForDic = Me.mobjDicComparer.GetDicKey( key )


		If mDictionary.ContainsKey( objKeyForDic ) = false Then
			'#If __DEBUG__
			'Console.WriteLine( "clsArrayHash : Item(Get) : mDictionary.ContainsKey returns False . key=""{0}"" ", _ 
			'		key.ToString() )
			'Console.WriteLine( "arrayHash Get_Item : mDictionary.ContainsKey( key ) = false " )
			'#End If
			Return Nothing
		End If

		Dim lstValueList As System.Collections.Generic.List(Of clsKeyValuePair)



		lstValueList = Me.mDictionary.Item( objKeyForDic )
		If lstValueList Is Nothing Then
			'#If __DEBUG__
			'Console.WriteLine( "arrayHash Get_Item : lstValueList Is Nothing " )
			'#End If
			Return Nothing
		End If

		Dim objKeyValuePair		As clsKeyValuePair
		objKeyValuePair = new clsKeyValuePair( key, Nothing )

		Dim nIndex		As Integer
		nIndex = lstValueList.BinarySearch( objKeyValuePair, _ 
							Me.mobjKeyValuePairFullKeyComparer )
		If nIndex < 0 Then
			'#If __DEBUG__
			'Console.WriteLine( "arrayHash Get_Item : BinarySearch ret={0} ", _ 
			'			nIndex )
			'#End If
			Return Nothing
		End If

		' #If __DEBUG__
		'Console.WriteLine( "arrayHash Get_Item : BinarySearch hit:nIndex={0} ", _ 
		'	nIndex )
		'#End If

		objKeyValuePair = lstValueList.Item( nIndex )
		If objKeyValuePair Is Nothing Then
			Return Nothing
		End If

		Return objKeyValuePair.Value

	End Get
	Set( ByVal value As TValue )
		
		Dim objKeyForDic				As TKey
		objKeyForDic = Me.mobjDicComparer.GetDicKey( key )

		If mDictionary.ContainsKey( objKeyForDic ) = false Then
			Exit Property
		End If

		Dim lstValueList As System.Collections.Generic.List(Of clsKeyValuePair)

		lstValueList = Me.mDictionary.Item( objKeyForDic )

		Dim objKeyValuePair		As clsKeyValuePair
		objKeyValuePair = new clsKeyValuePair( key, Nothing )


		Dim nIndex		As Integer
		nIndex = lstValueList.BinarySearch( objKeyValuePair, _ 
							Me.mobjKeyValuePairFullKeyComparer )
		If nIndex < 0 Then
			Return
		End If

		If lstValueList.Item( nIndex ) Is Nothing Then
			objKeyValuePair.Value = value
			lstValueList.Item( nIndex ) = objKeyValuePair
			Return
		End If

		lstValueList.Item( nIndex ).Value = value
		Return

		Exit Property
	End Set

	end Property


	Friend Sub Clear()
		Me.mDictionary.Clear()
	End Sub
	

	Friend Function GetAllKeysAndValues( ByRef objRetKeys As  System.Collections.Generic.List(Of TKey), _ 
						ByRef objRetValues As System.Collections.Generic.List(Of TValue) ) As Boolean
	

		For Each objKey As TKey In Me.mDictionary.Keys
			If objRetKeys Is Nothing Then
				objRetKeys = new System.Collections.Generic.List(Of TKey)
			End If
			If objRetValues Is Nothing Then
				objRetValues = new System.Collections.Generic.List(Of TValue)
			End If
			Dim lstValueList As System.Collections.Generic.List(Of clsKeyValuePair)

			'Console.WriteLine( "clsArrayHash :  GetAllKeysAndValues : For : objKey={0}, objKey.ToString()=""{1}"" ", _ 
			'	objKey, objKey.ToString()  )
			If Me.mDictionary.ContainsKey( objKey ) = False Then
				'Console.WriteLine( "clsArrayHash :  GetAllKeysAndValues : For NOT FOUND: objKey={0}, ", objKey   )
				Continue For
			End If
			'Dim objHashedKey    As TKey  
			'objHashedKey = Me.mEqualKeyGeneratorFuncPointer( objKey )


			lstValueList = Me.mDictionary.Item( objKey )

			For Each lstValueListItem As clsKeyValuePair In lstValueList

				Dim nAddIndex		As Integer

				nAddIndex = objRetKeys.BinarySearch( lstValueListItem.Key, Me.mobjListFullKeyComparer )
				If nAddIndex >= 0 Then
					Continue For
				Else
					objRetKeys.Insert( Not nAddIndex, lstValueListItem.Key )
					objRetValues.Insert( Not nAddIndex, lstValueListItem.Value )
				End If

			Next
		Next

		Return True
	End Function
	



	Friend Function ContainedKey( key As TKey ) As TKey

	
		Dim objKeyForDic				As TKey
		objKeyForDic = Me.mobjDicComparer.GetDicKey( key )

		If mDictionary.ContainsKey( objKeyForDic ) = false Then
			Return Nothing
		End If

		Dim lstValueList As System.Collections.Generic.List(Of clsKeyValuePair)

		lstValueList = Me.mDictionary.Item( objKeyForDic )
		If lstValueList Is Nothing Then
			Return Nothing
		End If


		Dim objKeyValuePair		As clsKeyValuePair
		objKeyValuePair = new clsKeyValuePair( key, Nothing )


		Dim nIndex		As Integer
		nIndex = lstValueList.BinarySearch( objKeyValuePair, _ 
							Me.mobjKeyValuePairFullKeyComparer )
		If nIndex < 0 Then
			Return Nothing
		End If
		Return lstValueList.Item( nIndex ).Key


	End Function


	Friend Function ContainsKey( key As TKey ) As boolean


		Dim objKeyForDic				As TKey
		objKeyForDic = Me.mobjDicComparer.GetDicKey( key )

		If mDictionary.ContainsKey( objKeyForDic ) = false Then
			Return False
		End If

		Dim lstValueList As System.Collections.Generic.List(Of clsKeyValuePair)

		lstValueList = Me.mDictionary.Item( objKeyForDic )
		If lstValueList Is Nothing Then
			Return False
		End If


		Dim objKeyValuePair		As clsKeyValuePair
		objKeyValuePair = new clsKeyValuePair( key, Nothing )


		Dim nIndex		As Integer
		nIndex = lstValueList.BinarySearch( objKeyValuePair, _ 
							Me.mobjKeyValuePairFullKeyComparer )
		If nIndex < 0 Then
			Return False
		End If
		Return True


	End Function


	Friend Sub SetListFullKeyComparer( ByVal pFunc As System.Collections.Generic.IComparer(Of TKey) )
		Me.mobjListFullKeyComparer = pFunc
	End Sub


	Protected Overrides Sub Finalize()


		Me.mobjDicComparer = Nothing
	

		Me.mobjListFullKeyComparer = Nothing
		Me.mobjKeyValuePairFullKeyComparer = Nothing
	

		' 念のため傘下のList<T>を全部クリアしておく
		For Each value As System.Collections.Generic.List(Of clsKeyValuePair ) In mDictionary.Values
			value.Clear()
		Next
	End Sub



End Class








End NameSpace
