
Option Explicit On


NameSpace MtCalc


Friend Partial Class clsIniRW

    Friend Class clsSaveSection

		Friend Class clsSectionData
			
			Friend Class clsSaveSectionDataListComparer
				Implements System.Collections.Generic.IComparer(Of clsSectionData)


				Public Shadows Function Compare( ByVal other1 As clsSectionData, ByVal other2 As clsSectionData ) As Integer Implements System.Collections.Generic.IComparer(Of clsSectionData).Compare

					Dim nIndex1		As Integer
					Dim nIndex2		As Integer

					nIndex1 = other1.SecIndex
					nIndex2 = other2.SecIndex
					If nIndex1 < 0 Then
						If nIndex2 >= 0 Then
							' 未登録セクション名は後ろへ
							Return 1
						End If
						Return System.String.Compare( other1.SecNameRaw, other2.SecNameRaw )
					End If
					
					If nIndex2 >= 0 Then
						Return other1.SecIndex - other2.SecIndex
					End If
					Return -1

				End Function

			End Class

			Private msSectionWithBracket	As String
			Private msSectionRaw			As String
			Private mnSectionIndex			As Integer
			Private mbPreserve				As Boolean

			Private mlstKeys				As System.Collections.Generic.List(Of String)
			Private mlstValues				As System.Collections.Generic.List(Of String)
			Private mlstValuesRaw			As System.Collections.Generic.List(Of String)

			Friend ReadOnly Property SecNameWithB() As String
			Get
				Return Me.msSectionWithBracket
			End Get
			End Property

			Friend Property SecNameRaw() As String
			Get
				Return Me.msSectionRaw
			End Get
			Set( ByVal value As String)
				Me.msSectionRaw = value
				Me.msSectionWithBracket = "[ " & value & " ]"
			End Set
			End Property


			Friend Property SecIndex() As Integer
			Get
				Return Me.mnSectionIndex
			End Get
			Set( ByVal value As Integer)
				Me.mnSectionIndex = value
			End Set
			End Property


			Friend Property Keys() As System.Collections.Generic.List(Of String)
			Get
				Return Me.mlstKeys
			End Get
			Set( ByVal value As System.Collections.Generic.List(Of String) )
				Me.mlstKeys = value
			End Set
			End Property




			Friend Property Values() As System.Collections.Generic.List(Of String)
			Get
				Return Me.mlstValues
			End Get
			Set( ByVal value As System.Collections.Generic.List(Of String) )
				Me.mlstValues = value
			End Set
			End Property


			Friend Property ValuesRaw() As System.Collections.Generic.List(Of String)
			Get
				Return Me.mlstValuesRaw
			End Get
			Set( ByVal value As System.Collections.Generic.List(Of String) )
				Me.mlstValuesRaw = value
			End Set
			End Property


			Friend Property Preserve() As Boolean
			Get
				Return Me.mbPreserve
			End Get
			Set( ByVal value As Boolean )
				Me.mbPreserve = value
			End Set
			End Property

			Friend Function SortByKeys() As Boolean

				' データ不整合チェックをなぜかここでやる
				If Me.mlstKeys Is Nothing Then
					Me.mlstKeys = new System.Collections.Generic.List(Of String)( 0 )
				End If
				If Me.mlstValues Is Nothing Then
					Me.mlstValues = new System.Collections.Generic.List(Of String)( 0 )
				End If


				If Me.mlstKeys.Count = 0 Then
					If Me.mlstValues.Count = 0 Then
						Return True
					End If
				End If

				If Me.mlstKeys.Count <> Me.mlstValues.Count Then
					Return False
				End If


				If Me.mlstKeys.Count = 1 Then
					Return True
				End If

				Dim bNotSorted			As Boolean

				bNotSorted = False
				For nIndex As Integer = 1 To Me.mlstKeys.Count - 1
					Dim nCompare		As Integer
					nCompare =  System.String.Compare( Me.mlstKeys.Item( nIndex - 1 ), _ 
											Me.mlstKeys.Item( nIndex )  ) 
					If nCompare = 0 Then
						Return False
					End If
					If nCompare  > 0 Then
						bNotSorted = True
						Exit For
					End If
				Next

				If Not bNotSorted Then
					Return True
				End If

				' ソートし直す
				Dim lstNewKeys		As  System.Collections.Generic.List(Of String)
				Dim lstNewValues	As  System.Collections.Generic.List(Of String)

				lstNewKeys = new  System.Collections.Generic.List(Of String)( Me.mlstKeys.Count )
				lstNewValues = new  System.Collections.Generic.List(Of String)( Me.mlstKeys.Count )

				For nIndex As Integer = 0 To Me.mlstKeys.Count - 1
					Dim nAddIndex			As Integer

					nAddIndex = lstNewKeys.BinarySearch( Me.mlstKeys.Item( nIndex ) )
					If nAddIndex >= 0 Then
						' こりゃプログラムエラーだな・・・
						Console.WriteLine( "Program Error! clsSaveSection : clsSectionData : SortByKeys : new sorted keys has same key already. " )
						Return False
					End If
					lstNewKeys.Insert( Not nAddIndex, Me.mlstKeys.Item( nIndex ) )
					lstNewValues.Insert( Not nAddIndex, Me.mlstValues.Item( nIndex ) )
				Next

				Me.mlstKeys = lstNewKeys
				Me.mlstValues = lstNewValues
				Return True

			End Function

		End Class



		Private mlstSecDatas			As System.Collections.Generic.List(Of clsSectionData )
		Private mnCurrentSecIndex		As Integer

		
		Protected msr					As System.IO.StreamReader
		Protected msw					As System.IO.StreamWriter

		Protected msLine				As System.String
		Private msLineTrim				As System.String
		Private mnBlankCount			As Integer

		Private mnCurrentKeyNo			As Integer


		Protected marSecOrder()			As String

		Private mobjSecDataComparer		As clsSectionData.clsSaveSectionDataListComparer

		Friend Sub New()
			Me.msr = Nothing
			Me.msw = Nothing
			
			Me.mlstSecDatas = Nothing
			Me.mnCurrentKeyNo = -1
			Me.marSecOrder = Nothing

			Call Me.SetSectionOrderArray( clsIniRW.SectionOrder )

		End Sub

		Friend Sub SetSectionOrderArray( ByVal arSecName() As String )
			Me.marSecOrder = arSecName

			If arSecName Is Nothing Then
				Me.mlstSecDatas = Nothing
				Return
			End If

			If arSecName.Length <= 0 Then
				Me.mlstSecDatas = Nothing
				Return
			End If
			Me.mlstSecDatas = new System.Collections.Generic.List(Of clsSectionData )()

			For nIndex As Integer = 0 To arSecName.Length - 1
			Dim objSecData		As clsSectionData
				objSecData = new clsSectionData()

				objSecData.SecNameRaw = arSecName(nIndex )
				objSecData.SecIndex = nIndex
				objSecData.Keys = Nothing
				objSecData.Values = Nothing
				objSecData.Preserve = True

				Me.mlstSecDatas.Add( objSecData )
			Next

		End Sub

		Friend Function AddSectionData( ByVal sSecName As String, _ 
					ByVal lstKeys                    As System.Collections.Generic.List(Of String), _ 
					ByVal lstMutilinedValues         As System.Collections.Generic.List(Of String), _
					Optional ByVal bPreserve         As Boolean = False _ 
					 ) As Boolean

			Dim bRet		As Boolean

			Dim objSecData		As clsSectionData
			objSecData = new clsSectionData()

			objSecData.SecNameRaw = sSecName
			objSecData.SecIndex = Me.GetSecOrder( objSecData.SecNameRaw )
			objSecData.Keys = lstKeys
			objSecData.Values = lstMutilinedValues
			objSecData.ValuesRaw = Nothing
			objSecData.Preserve = bPreserve

			If objSecData.Values IsNot Nothing Then

				If objSecData.Values.Count > 0 Then

					DIm nIndex			As Integer
					Dim nIndexEnd        As Integer
					nIndexEnd = objSecData.Values.Count	- 1
					For nIndex = 0 To nIndexEnd
						Dim sKey		As String
						Dim sValue		As String
						sKey   = objSecData.Keys.Item( nIndex )
						sValue = objSecData.Values.Item( nIndex )
						If Me.IsMultiLinedValue( sKey, sValue ) = False Then
							sValue = Me.ToMultiLinedValue( sKey, sValue )
							
							' コピーしないで、上位で与えられたList直接いじっちゃってるけど・・・。
							' まぁいいか。
							objSecData.Values.Item( nIndex ) = sValue
						End If
					Next
				
				End If
			End If


			bRet = objSecData.SortByKeys()
			If Not bRet Then
				Return False
			End If


			'#If __DEBUG__
			'If objSecData.Keys IsNot Nothing Then
			'	Console.WriteLine( "{0}.AddSectionData.AddSectionData :  objSecData.SecNameRaw=""{1}"",  objSecData.Keys.Count={2} ", _ 
			'				Me.ToString(), objSecData.SecNameRaw, objSecData.Keys.Count )
			'End If
			'#End If


			If Me.mobjSecDataComparer Is Nothing Then
				Me.mobjSecDataComparer = new clsSectionData.clsSaveSectionDataListComparer()
			End If

			Dim nAddIndex			As Integer
			nAddIndex = Me.mlstSecDatas.BinarySearch( objSecData, _ 
					 			Me.mobjSecDataComparer )
			If nAddIndex >= 0 Then
				Me.mlstSecDatas.Item( nAddIndex ) = objSecData
			Else
				Me.mlstSecDatas.Insert( Not nAddIndex, objSecData )
			End If
			
			Return True

		End Function

		
		''' <summary>
		''' ini ファイルのの読み書き全体
		'''    派生しまくり。メインルーチン
		''' </summary>
		''' <param name="filePath">ない</param>
		''' <param name="sectionName">ない</param>
		''' <param name="keyName">引数ない</param>
		''' <param name="value">引数ない</param>
		''' <returns>true : 正常 / false : 異常</returns>
		Friend Function SaveSection() As Boolean

			Dim bRet			As Boolean

			' ライン抜き出し

			If Not clsIniRW.mblWriteExecute Then
				Return False
			End If

		


			If System.IO.File.Exists( mstrIniFileName ) = False Then
				' 新規で作る
				bRet = Me.CreateNewIni()
				Return bRet
			End If




			If Me.mlstSecDatas Is Nothing Then
				Console.WriteLine( "Program Error!  {0}.clsSaveSection : SaveSection : Me.mlstSecDatas is Nothing. ", _ 
									Me.ToString() )
				Return False
			End If
			If Me.mlstSecDatas.Count = 0 Then
				Console.WriteLine( "Program Error!  {0}.clsSaveSection : SaveSection : Me.mlstSecDatas.Count is 0. ", _ 
									Me.ToString() )
				Return False
			End If



			' 入力/出力のファイルポハンドルを用意
			bRet = Me.SetupRW()
			If Not bRet Then
				Call Me.EndsRW( True )
				Return False
			End If

			

			'#If __DEBUG__
			'	Console.WriteLine(  "SaveSection : Opened."  )
			'	Console.ReadKey( False )
			'#End If

			Dim bLastWriteIsBlank		As Boolean
			bLastWriteIsBlank = False


			'#If __DEBUG__
			'For Each objSecData As clsSectionData In Me.mlstSecDatas
			'	Console.WriteLine(  "{0}.SaveSection : Me.mlstSecDatas sec name=""{1}""   .", _ 
			'						Me.ToString() , objSecData.SecNameRaw  )
			'Next
			'Console.ReadKey( False )
			'#End If


			Me.mnCurrentSecIndex = 0
			Dim objCurrentSecData		As clsSectionData
			objCurrentSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )

			' 書き込むセクションを探す
			Call Me.ReadLine()
			Me.mnBlankCount = 0
			Do While Me.msLine IsNot Nothing

				'#If __DEBUG__
				'Console.WriteLine(  "{0}.SaveSection : Section loop top : Me.msLine=""{1}"", objCurrentSecData.SecIndex={2}, objCurrentSecData.SecNameWithB=""{3}"" .", _ 
				'					Me.ToString(),  Me.msLine, objCurrentSecData.SecIndex, objCurrentSecData.SecNameWithB  )
				'Console.ReadKey( False )
				'#End If

				If Me.msLine.Length = 0 Then
					Me.mnBlankCount += 1
					Call Me.ReadLine()
					Continue Do
				End If

				If Me.msLineTrim.Length = 0 Then
					Call Me.WriteBlankLines()
					Me.WriteLine( Me.msLine )
					Call Me.ReadLine()
					Continue Do
				End If

				'#If __DEBUG__
				'Console.WriteLine(  "SaveSection : Read Me.msLine=""{0}"".", Me.msLine  )
				'Console.ReadKey( False )
				'#End If

				If Me.msLineTrim ( 0 ) <> "["C Or Me.msLineTrim.EndsWith( "]" ) = False Then

					Call Me.WriteBlankLines()
					Me.WriteLine( Me.msLine )
					Call Me.ReadLine()
				End If

				Dim sReadSecName		As String
				'012345
				'[ABCD]
				sReadSecName = Me.msLineTrim.Substring( 1, Me.msLineTrim.Length - 2 ).Trim( " " & vbTab )


				If sReadSecName = objCurrentSecData.SecNameRaw Then

					'#If __DEBUG__
					'Console.WriteLine(  "{0}.SaveSection : Section found :  sReadSecName=""{1}"" Me.mnCurrentSecIndex={2} Me.mnCurrentKeyNo={3}.", _ 
					'		Me.ToString(), 	sReadSecName, Me.mnCurrentSecIndex, Me.mnCurrentKeyNo )
					'Console.ReadKey( False )
					'#End If


					Dim nRet			As RET_SaveSection_UpdateKeys
					' キー突き合わせ処理に移行
					Me.WriteLine( Me.msLine )

					'#If __DEBUG__
					'Console.WriteLine(  "{0}.SaveSection : If sReadSecName = objCurrentSecData.SecNameRaw   2:  . ", _ 
					'		Me.ToString()  )
					'Console.ReadKey( False )
					'#End If

					nRet = Me.SaveSection_UpdateKeys()
					'#If __DEBUG__
					'Console.WriteLine(  "{0}.SaveSection : SaveSection_UpdateKeys returns {1} . ", _ 
					'		Me.ToString(), nRet.ToString()  )
					'#End If

					If nRet = RET_SaveSection_UpdateKeys.PRESERVE_AND_FILEEOF_ALLSECCOPIED Then
						' 1
						' 読み込みファイルがEOFになった
						bRet = Me.EndsRW()
						Return bRet
					ElseIf nRet = RET_SaveSection_UpdateKeys.PRESERVE_SECINC_EXIT_ALLINPUT_COPIED Then
						' 2
						' セクション更新分は終わった
						bRet = Me.EndsRW()
						Return bRet
					ElseIf nRet = RET_SaveSection_UpdateKeys.PRESERVE_FIND_NEXTSEC Then
						' 3
						' 1つだけセクションpresereコピーが出来た
						objCurrentSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )
						Continue Do
					ElseIf nRet = RET_SaveSection_UpdateKeys.FOUND_NEXTSEC_AND_SAVED_CURRENT_RESTKEYS_AND_ALLSEC_WROUTE Then
						' 4
						' １つのセクション更新に成功したら最後のセクションだった。
						bRet = Me.EndsRW()
						Return bRet
					ElseIf nRet = RET_SaveSection_UpdateKeys.FOUND_NEXTSEC_AND_SAVED_CURRENT_RESTKEYS Then
						' 5
						objCurrentSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )
						Continue Do
					ElseIf nRet = RET_SaveSection_UpdateKeys.READLINE_IS_EOF_ALLKEYS_AND_SECS_WROUTE Then
						' 6
						bRet = Me.EndsRW()
						Return bRet
					End If
					
					Me.mnCurrentSecIndex += 1
					If Me.mnCurrentSecIndex >= Me.mlstSecDatas.Count Then
						Call Me.WriteBufferAndInputRests()
						bRet = Me.EndsRW()
						Return bRet
					End If
					objCurrentSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )
					Continue Do
					
				End If


				Dim nReadSecOder		As Integer
				
				nReadSecOder = Me.GetSecOrder( sReadSecName )

				Dim nCompare			As Integer

				
				If nReadSecOder >= 0 Then
					If objCurrentSecData.SecIndex >= 0 Then
						nCompare = nReadSecOder - objCurrentSecData.SecIndex
					Else
						' 最後のセクション扱い
						nCompare = -1
					End If
				Else
					If objCurrentSecData.SecIndex < 0 Then
						nCompare = String.Compare( sReadSecName, objCurrentSecData.SecNameRaw )
					Else
						nCompare = 1
					End If
				End If



				'#If __DEBUG__
				'Console.WriteLine(  "{0}.SaveSection : Secname diff nCompare={1},  sReadSecName=""{2}"", objCurrentSecData.SecNameRaw=""{3}"", nReadSecOder={4}, objCurrentSecData.SecIndex={5} . ", _ 
				'			Me.ToString(), 	nCompare, sReadSecName, objCurrentSecData.SecNameRaw, nReadSecOder, objCurrentSecData.SecIndex  )
				'Console.ReadKey( False )
				'#End If


				If nCompare > 0  Then
					' セクションが無いのでまるごと追加する
					'Dim sLineSave		As String

					Call Me.WriteBlankLines()
					Me.WriteSection( Me.mnCurrentSecIndex )
					Me.WriteLine( "" )

					Me.mnCurrentSecIndex += 1
					If Me.mnCurrentSecIndex >= Me.mlstSecDatas.Count Then
						' 全部のセクション足した
							' 残りの入力は・・・セクション及びデータは破棄？
							' よく分からんなｗ

							' キーのみ破棄するコードにしなければ
							' ならない
							' セクションはいくらでも残ってて良いはず
						Call Me.WriteBufferAndInputRests()
						bRet = Me.EndsRW()
						Return bRet
					End If
					objCurrentSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )


					Continue Do

				End If


				Call Me.WriteBlankLines()
				Me.WriteLine( Me.msLine )

				Call Me.ReadLine()
			Loop



			#If __DEBUG__
			Console.WriteLine(  "{0}.SaveSection : first Loop Exit Me.msLine=""{1}"" . ", _
							Me.ToString(), Me.msLine  )
			'Console.ReadKey( False )
			#End If

			If Me.msLine Is Nothing Then
				' 終端まで追加するセクションが入力ファイル内に見つからなかった

				Call Me.WriteRestSections()

				bRet = Me.EndsRW()
				Return bRet
			End If

			' ここには誰も来ないはず・・・
			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					" Program Error! " & Me.ToString() & ".clsSaveSection: SaveSection() :  unknown execution path, function last return false . " )
			Console.ReadKey( False )

			Return False
			
		End Function



		Private Enum RET_SaveSection_UpdateKeys
			PRESERVE_AND_FILEEOF_ALLSECCOPIED								' 1
			PRESERVE_SECINC_EXIT_ALLINPUT_COPIED							' 2
			PRESERVE_FIND_NEXTSEC											' 3

			FOUND_NEXTSEC_AND_SAVED_CURRENT_RESTKEYS_AND_ALLSEC_WROUTE		' 4
			FOUND_NEXTSEC_AND_SAVED_CURRENT_RESTKEYS						' 5

			READLINE_IS_EOF_ALLKEYS_AND_SECS_WROUTE							' 6

		End Enum

		Private Function SaveSection_UpdateKeys() As RET_SaveSection_UpdateKeys
			' ret    1:    読み込みがEOFで、残りのセクションを全部書いた
			'        2:    セクションpreserveコピー後、変更すべきセクションが残りゼロになったので
			'              入力データを全部コピーした
			'        3:    入力ファイルがあり、Preserveなのでセクションコピーし、別セクションになった


			'#If __DEBUG__
			'Console.WriteLine(  "{0}.SaveSection_UpdateKeys : top Me.msLine=""{1}"", Me.mnCurrentSecIndex=""{2}"", Me.mnBlankCount={3}. ", _ 
			'					Me.ToString(), Me.msLine, Me.mnCurrentSecIndex,  Me.mnBlankCount  )
			'Console.ReadKey( False )
			'#End If

			Dim objCurSecData			As clsSectionData

			objCurSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )

			Call Me.SetLoadSecIndex( objCurSecData.SecNameRaw )


			If objCurSecData.Preserve Then
				' 次のセクションまでコピー
				Me.ReadLine()
				Do While Me.msLine IsNot Nothing

					If Me.msLine.Length = 0 Then
						Me.ReadLine()
						Me.mnBlankCount += 1
						Continue Do
					End If

					If Me.msLineTrim.Length = 0 Then
						Call Me.WriteBlankLines()
						Me.WriteLine( Me.msLine )
						Me.ReadLine()
						Continue Do
					End If

					If Me.msLineTrim( 0 ) = "["C Then
						' 次のセクションが見つかった
						Exit Do
					End If


					Call Me.WriteBlankLines()
					Me.WriteLine( Me.msLine )
					Me.ReadLine()


				Loop
				If Me.msLine Is Nothing Then

					' 最終セクションじゃなきゃ空行入る・・・よな？
					If Me.mnBlankCount >= 1 Then
						Call Me.WriteBlankLines()
					End If

					
					Me.mnCurrentSecIndex += 1
					If Me.mnCurrentSecIndex < Me.mlstSecDatas.Count Then
						' 残りのセクションデータを全部書く
						Call Me.WriteRestSections()
					End If

					Return RET_SaveSection_UpdateKeys.PRESERVE_AND_FILEEOF_ALLSECCOPIED
					'Return 1
				End If

				If Me.mnBlankCount <= 1 Then
					Me.WriteLine( "" )
					Me.mnBlankCount = 0
				ElseIf Me.mnBlankCount > 2 Then
					Call Me.WriteBlankLines()
				End If


				Me.mnCurrentSecIndex += 1
				If Me.mnCurrentSecIndex >= Me.mlstSecDatas.Count Then
					' 残りの入力を全部コピー
					Call Me.WriteBufferAndInputRests()
					Return RET_SaveSection_UpdateKeys.PRESERVE_SECINC_EXIT_ALLINPUT_COPIED
					'Return 2
				End If

				Return RET_SaveSection_UpdateKeys.PRESERVE_FIND_NEXTSEC
				'Return 3
			End If


			Dim bAllKeys_Consumed		As Boolean


				
			bAllKeys_Consumed = False
			If objCurSecData.Keys.Count = 0 Then
				bAllKeys_Consumed = True
			End If					
				

			'****************************************
			' セクションのキー同士の突き合わせ処理
			'****************************************


			Me.mnCurrentKeyNo = 0

			Call Me.ReadLine()
			Do While Me.msLine IsNot Nothing



				'#If __DEBUG__
				'Console.WriteLine(  "{0}.SaveSection_UpdateKeys : first Loop Top,  Me.msLine=""{1}"", objCurSecData.SecNameRaw=""{2}"", objCurSecData.keys.Count={3}. ", _ 
				'					Me.ToString(), Me.msLine, objCurSecData.SecNameRaw,  objCurSecData.keys.Count  )
				'Console.ReadKey( False )
				'#End If

				If Me.msLine.Length = 0 Then
					Me.ReadLine()
					Me.mnBlankCount += 1
					Continue Do
				End If

				If Me.msLineTrim.Length = 0 Then
					Call Me.WriteBlankLines()
					Me.WriteLine( Me.msLine )
					Call Me.ReadLine()
					Continue Do
				End If

				If Me.msLineTrim( 0 ) = "["C Then

					' 別のセクションに入った
					If objCurSecData.Keys.Count = 0 Then
						If Me.mnBlankCount >= 1 Then
							Call Me.WriteBlankLines()
						Else
							Me.WriteLine( "" )
						End If
					Else
						If Me.mnCurrentKeyNo < objCurSecData.Keys.Count Then
							If Me.mnBlankCount > 1 Then
								Call Me.WriteBlankLines()
								Call Me.WriteQuedAllKeys()
								Me.WriteLine( "" )
							Else
								Call Me.WriteQuedAllKeys()
								Me.WriteLine( "" )
								Me.mnBlankCount = 0
							End If
						Else
							If Me.mnBlankCount = 0 Then
								Me.WriteLine( "" )
							Else
								Call Me.WriteBlankLines()
							End If
						End If

					End If

					Me.mnCurrentSecIndex += 1
					If Me.mnCurrentSecIndex >= Me.mlstSecDatas.Count Then
						
						' 残りの入力を全部コピー
						Call Me.WriteBufferAndInputRests()

						Return RET_SaveSection_UpdateKeys.FOUND_NEXTSEC_AND_SAVED_CURRENT_RESTKEYS_AND_ALLSEC_WROUTE
						'Return 4
					End If

					Me.mnCurrentKeyNo = 0
					Return RET_SaveSection_UpdateKeys.FOUND_NEXTSEC_AND_SAVED_CURRENT_RESTKEYS
					'Return 5
				End If

				' コメント行の処理
				With Nothing
					Dim nRet				As RET_SaveSection_UpdateKeys_CommentLineSkip

					nRet = Me.SaveSection_UpdateKeys_CommentLineSkip()

					If nRet = RET_SaveSection_UpdateKeys_CommentLineSkip.INPUTLINE_ISNOT_COMMENT Then
						' 1
						' 何もせずキー読み取り処理に移行
					ElseIf nRet = RET_SaveSection_UpdateKeys_CommentLineSkip.WROUTE_SINGLE_LINE_COMMENT_AND_READLINE_DONE Then
						' 2
						' シングル行のコメント。出力してReadLineしてループ再開
						Continue Do
					ElseIf nRet = RET_SaveSection_UpdateKeys_CommentLineSkip.FINDEOF_DURING_MUTILINE_READING Then
						' 3
						Exit Do
						'Return 12
					ElseIf nRet = RET_SaveSection_UpdateKeys_CommentLineSkip.WROUTE_MULTI_LINE_COMMENT_AND_READLINE_DONE Then
						' 4
						Continue Do
					End If

				End With


				Dim sReadKey		As String
				Dim sReadData		As String
				Dim sReadComment	As String
				Dim nPosComment		As Integer
				Dim bMutiLine		As Boolean

				sReadKey = Nothing
				sReadData = Nothing
				sReadComment = Nothing

				Dim bRet			As Boolean
				bRet = Me.GetKeyAndData( sReadKey, sReadData, _ 
								sReadComment, nPosComment, bMutiLine )
				If Not bRet Then
					' コメントか何か？そのまま出力
					Me.WriteLine( Me.msLine )
					Call Me.ReadLine()
					Continue Do
				End If

				Dim sKeyCurrent		As String
				Dim nCompare		As Integer

				sKeyCurrent = Nothing

				If Not bAllKeys_Consumed Then
					sKeyCurrent = objCurSecData.Keys.Item( Me.mnCurrentKeyNo )
					nCompare = sReadKey.CompareTo( sKeyCurrent )
				Else
					nCompare = -1
				End If


				'#If __DEBUG__
				'Console.WriteLine(  "{0}.SaveSection_UpdateKeys : after GetKeyAndData, " & _ 
				'	" Me.msLine=""{1}"", objCurSecData.keys.Count={2}, " & _
				'	"nCompare={3}, Me.mnCurrentKeyNo={4}, sKeyCurrent=""{5}"",", _ 
				'		Me.ToString(), _ 
				'		Me.msLine, objCurSecData.keys.Count, _ 
				'		nCompare, Me.mnCurrentKeyNo, sKeyCurrent )
				'Console.ReadKey( False )
				'#End If


				If nCompare < 0 Then

					With Nothing
						Dim nRet			As RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad

						nRet = Me.SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad( _ 
									sReadKey, sReadData, bMutiLine )
						If nRet = RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.NOT_INHERIT Then
							' 何もしない
						ElseIf nRet = RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.VALUE_PARSED_AND_READLINE_DONE Then
							Continue Do
						ElseIf nRet = RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.FINDEOF_DURING_VALUE_MUTILINE_READING Then
							Exit Do
						ElseIf nRet = RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.REQUESTS_MODULE_NATIVE_READKEYSMALL Then
							' 何もしない
						End If
					End With

					'#If __DEBUG__
					'Console.WriteLine( "{0}.UpdateKeys Compare < 0 : nPosComment={0} sReadKey=""{1}"". ", _ 
					'				nPosComment, sReadKey )
					'#End If

					With Nothing
						Dim nRet		As RET_SaveSection_UpdateKeys_Compare_ReadKeySmall
						nRet = _
							Me.SaveSection_UpdateKeys_Compare_ReadKeySmall( _ 
								nPosComment, sReadComment )


						'#If __DEBUG__
						'Console.WriteLine( "{0}.UpdateKeys Compare < 0, after Compare_ReadKeySmall nRet={1}. ", _ 
						'				Me.ToString(), nRet )
						'#End If

						If nRet = RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.IN_MULTILINE_READLINE_IS_SUDDENLY_EOF Then
							' 1
							Exit Do
						ElseIf nRet = RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.READKEY_MULTILINE_SKIPPED Then
							' 2
							Continue Do
						ElseIf nRet = RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.READKEY_SINGLELINE_SKIPPED Then
							' 3
							Continue Do
						End If
					End With

				End If


				If nCompare = 0 Then
					
					Dim nRet			As RET_SaveSection_UpdateKeys_Compare0

					nRet = Me.SaveSection_UpdateKeys_Compare0( nPosComment, sReadComment, bMutiLine )
					If nRet = RET_SaveSection_UpdateKeys_Compare0.SAVESECSKEYS_ARE_ALL_CONSUMED_SO_INPUT_LKYS_SHOULDBE_DELETED Then
						bAllKeys_Consumed = True
						Continue Do
					ElseIf nRet = RET_SaveSection_UpdateKeys_Compare0.SUCCESS_KEYUPDATED_READLINE_DONE Then
						Continue Do
					End If

					Me.ReadLine()
					Continue Do
				End If

				' nCompare > 0
				' sReadKey > sKeyCurrent
				Dim bAllKeysWroute_InThisLoop		As Boolean
				Dim sWriteData						As String

				bAllKeysWroute_InThisLoop = False
				Me.mnBlankCount = 0
				Do


					sWriteData = System.String.Format( "{0}=""{1}""", _ 
							sKeyCurrent, objCurSecData.Values.Item( Me.mnCurrentKeyNo ) )
					Me.WriteLine( sWriteData )

					Me.mnCurrentKeyNo += 1
					If Me.mnCurrentKeyNo >= objCurSecData.Keys.Count Then

						' 現在書き込み中のセクションのキーは書き終わった
						' 後は残りの入力ファイルのセクションのを読み飛ばす

						bAllKeysWroute_InThisLoop = True
						Exit Do
					End If

					sKeyCurrent = objCurSecData.Keys.Item( Me.mnCurrentKeyNo )
					nCompare = sReadKey.CompareTo( sKeyCurrent )
					If nCompare <= 0 Then
						Exit Do
					End If

				Loop

				If nCompare <= 0 Then
					Continue Do
				End If

				If bAllKeysWroute_InThisLoop Then
					bAllKeys_Consumed = True
					Continue Do
				End If


			Loop

			If Me.msLine Is Nothing Then

				
				'#If __DEBUG__
				'Console.WriteLine(  "{0}.SaveSection_UpdateKeys : readline EOF,  Me.msLine=""{1}"", Me.mnCurrentSecIndex=""{2}"", " & _ 
				'					" objCurSecData.SecNameRaw=""{3}"", Me.mnCurrentKeyNo={3}, objCurSecData.Keys.Count={4}, " & _ 
				'					" Me.mnBlankCount={5} . ", _ 
				'					Me.ToString(), Me.msLine, Me.mnCurrentSecIndex, _ 
				'					objCurSecData.SecNameRaw,  Me.mnCurrentKeyNo, objCurSecData.Keys.Count, _ 
				'					Me.mnBlankCount  )
				'Console.ReadKey( False )
				'#End If

				If Me.mnCurrentKeyNo < objCurSecData.Keys.Count Then
					Call Me.WriteQuedAllKeys()
					Me.WriteLine( "" )
				End If
				Me.mnCurrentSecIndex += 1
				Call Me.WriteRestSections()

				Return RET_SaveSection_UpdateKeys.READLINE_IS_EOF_ALLKEYS_AND_SECS_WROUTE
				'Return 6
			End If


			' ここには誰も来ないはず・・・
			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					" Program Error! " & Me.ToString() & ".clsSaveSection: SaveSection() :  unknown execution path, function last return false . " )
			Console.ReadKey


		End Function
				


		Protected Enum RET_SaveSection_UpdateKeys_Compare_ReadKeySmall


			IN_MULTILINE_READLINE_IS_SUDDENLY_EOF				' 1
			READKEY_MULTILINE_SKIPPED							' 2
			READKEY_SINGLELINE_SKIPPED							' 3
		End Enum

		Protected Overridable Function SaveSection_UpdateKeys_Compare_ReadKeySmall( _ 
							ByVal nPosComment As Integer, _ 
							ByRef sReadComment As String ) As RET_SaveSection_UpdateKeys_Compare_ReadKeySmall



			If Me.IsMultiLine() Then
				Dim nRet			As RET_SaveSection_UpdateKeys_SkipMutiLineEnd
				' "～" まで行を読み飛ばす
				Dim nPosComment_LastLine		As Integer
				nRet = Me.SaveSection_UpdateKeys_SkipMutiLineEnd( bWrite:=False, bWriteComment:=True, nPosComment:= nPosComment_LastLine  )

				#If __DEBUG__
				Console.WriteLine( "Compare_ReadKeySmall : nPosComment_LastLine={0}, nRet={1} . ", _ 
									nPosComment_LastLine, nRet.ToString() )
				#End If


				If nRet = RET_SaveSection_UpdateKeys_SkipMutiLineEnd.FINDEOF_DURING_MUTILINE_READING Then
					Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.IN_MULTILINE_READLINE_IS_SUDDENLY_EOF
					'Return 1
				ELseIf nRet = RET_SaveSection_UpdateKeys_SkipMutiLineEnd.SKIPPED_MUTILINE Then
					Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.READKEY_MULTILINE_SKIPPED
					'Return 2
				End If


				#If __DEBUG__
				Console.WriteLine( "Compare_ReadKeySmall : out EndIF!!! nRet={0} . ", _ 
									nRet.ToString() )
				Console.ReadKey( False )
				#End If

			End If

			If nPosComment <> -1 Then
				Dim sSpace		As String
				sSpace = new String( " "C, nPosComment )
				Dim sWriteData	As String
				sWriteData = sSpace & sReadComment
				Me.WriteLine( sWriteData )
			End If

			Me.ReadLine()
			Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.READKEY_SINGLELINE_SKIPPED
			'Return 3

		End Function



		Protected Enum RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad
			VALUE_PARSED_AND_READLINE_DONE					' 1
			FINDEOF_DURING_VALUE_MUTILINE_READING			' 2
			NOT_INHERIT										' 3
			REQUESTS_MODULE_NATIVE_READKEYSMALL				' 4
		End Enum

		Protected Overridable Function SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad( _ 
							ByRef sReadKey As String, _ 
							ByRef sReadValues As String, _ 
							ByVal bMutiLine As Boolean ) As RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad
			Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.NOT_INHERIT
		End Function


		Private Enum RET_SaveSection_UpdateKeys_CommentLineSkip
			INPUTLINE_ISNOT_COMMENT									' 1
			WROUTE_SINGLE_LINE_COMMENT_AND_READLINE_DONE			' 2
			FINDEOF_DURING_MUTILINE_READING							' 3
			WROUTE_MULTI_LINE_COMMENT_AND_READLINE_DONE				' 4
		End Enum

		Private Function SaveSection_UpdateKeys_CommentLineSkip() As RET_SaveSection_UpdateKeys_CommentLineSkip

			Dim nPosComentContents		As Integer

			nPosComentContents = -1
			' コメント行扱い
			If Me.msLineTrim.ToLower().StartsWith( "rem " ) Then
				nPosComentContents = Me.msLine.ToLower().IndexOf( "rem " )
			ElseIf Me.msLineTrim( 0 )= "#"C Then
				nPosComentContents = Me.msLine.IndexOf( "#"C )
			ElseIf Me.msLineTrim( 0 )= "'"C Then
				nPosComentContents = Me.msLine.IndexOf( "'"C )
			End If

			If nPosComentContents < 0 Then
				' コメント行じゃなかったらしい
				Return RET_SaveSection_UpdateKeys_CommentLineSkip.INPUTLINE_ISNOT_COMMENT
				'Return 1
			End If


			If Me.IsMultiLine( nPosComentContents ) = False Then

				' シングル行のコメント行だった
				Call Me.WriteBlankLines()
				Me.WriteLine( Me.msLine )
				Me.ReadLine()
				Return RET_SaveSection_UpdateKeys_CommentLineSkip.WROUTE_SINGLE_LINE_COMMENT_AND_READLINE_DONE
				'Return 2
			End If



			Dim nRet				As RET_SaveSection_UpdateKeys_SkipMutiLineEnd
			Dim nPosComment			As Integer
			nRet = Me.SaveSection_UpdateKeys_SkipMutiLineEnd( bWrite:=False, bWriteComment:=True, nPosComment:= nPosComment  )

			If nRet = RET_SaveSection_UpdateKeys_SkipMutiLineEnd.FINDEOF_DURING_MUTILINE_READING Then
				Return RET_SaveSection_UpdateKeys_CommentLineSkip.FINDEOF_DURING_MUTILINE_READING
				'Return 3
			ELseIf nRet = RET_SaveSection_UpdateKeys_SkipMutiLineEnd.SKIPPED_MUTILINE Then
				Return RET_SaveSection_UpdateKeys_CommentLineSkip.WROUTE_MULTI_LINE_COMMENT_AND_READLINE_DONE
				'Return 4
			End If

		End Function



		' 、マルチラインのコメント行のスキップ            、コメント書き出し
		'   マルチラインキーの compare_Small < のスキップ、コメント書き出し
		'  マルチラインキーの、compare_> のスキップ    　、コメント書き出し
		'  マルチラインキーの、compare_= のスキップとコメント行の場所をリターン
		'     それぞれ ReadLine やるかどうかで動きがビミョーに違ってゴッチャコードは
		'     よろしくないけど・・・コード共通化と、関数分離をするの無理だなｗ
		'     機能とコードがゴッチャだけどほっとくしかないか。
		Protected Enum RET_SaveSection_UpdateKeys_SkipMutiLineEnd
			SKIPPED_MUTILINE
			SKIPPED_MUTILINE_NOT_READ_NEW_LINE_BUFFER_PRESERVED			' bEriteComment=True の時だけ返される
			FINDEOF_DURING_MUTILINE_READING
		End Enum

		Protected Function SaveSection_UpdateKeys_SkipMutiLineEnd( _
									ByVal bWrite As Boolean, _ 
									ByVal bWriteComment As Boolean, _ 
									ByRef nPosComment As Integer ) As RET_SaveSection_UpdateKeys_SkipMutiLineEnd

			Dim bMultiLineEndDquatateFind	As Boolean


			bMultiLineEndDquatateFind = False
			Do 
				If bWrite Then
					' マルチライン行の開始部分をまず書き込むｗ
					' ついでにループで書き込む時にもこのコード使い回すｗ
					Call Me.WriteBlankLines()
					Me.WriteLine( Me.msLine )
				End If
				Me.ReadLine()

				If Me.msLine Is Nothing Then
					Exit Do
				End If

				If Me.IsMultiLineEnd( nPosComment ) Then


					'#If __DEBUG__
					'Console.WriteLine( "slkipmulti : Me.msLine=""{0}"",nPosComment={1} . " , _ 
					'		Me.msLine, nPosComment	 )
					'#End If

					bMultiLineEndDquatateFind = True
					 
					If bWrite Then
						Me.WriteLine( Me.msLine )
					Else
						If nPosComment >= 1 Then


							If bWriteComment Then
								Dim sTabSpace		As String
								Dim sWriteData		As String

								sTabSpace = Me.GetTabSpaceStr( nPosComment )

								sWriteData = sTabSpace & Me.msLine.Substring( nPosComment )
								Me.WriteLine( sWriteData )
							End If

						End If 
					End If
					Exit Do
				End If
			Loop


			If Me.msLine Is Nothing Then

				' 勝手に終了の " を足す
				If bWrite Then
					Me.WriteLine( "    "" " )
				End If
				
				Return RET_SaveSection_UpdateKeys_SkipMutiLineEnd.FINDEOF_DURING_MUTILINE_READING
			End If


			If bWriteComment = False Then
				' compare_0 用動作
				Return RET_SaveSection_UpdateKeys_SkipMutiLineEnd.SKIPPED_MUTILINE_NOT_READ_NEW_LINE_BUFFER_PRESERVED
			End If

			If bMultiLineEndDquatateFind = True Then
				Me.ReadLine()
				Return RET_SaveSection_UpdateKeys_SkipMutiLineEnd.SKIPPED_MUTILINE
			End If


		End Function



		Private Enum RET_SaveSection_UpdateKeys_Compare0
			SAVESECSKEYS_ARE_ALL_CONSUMED_SO_INPUT_LKYS_SHOULDBE_DELETED		' 1
			SUCCESS_KEYUPDATED_READLINE_DONE									' 2
			FOUNDEOF_WHILE_READING_MULTI_LINE									' 3
		End Enum

		Private Function SaveSection_UpdateKeys_Compare0( _ 
							ByVal nPosComment As Integer, _ 
							ByRef sReadComment As String, _ 
							ByVal bMutiLine As Boolean ) As RET_SaveSection_UpdateKeys_Compare0
			Dim sKey			As String
			Dim sOut			As String

			Dim nSpaceCnt		As Integer

			Dim objCurSecData		As clsSectionData
			objCurSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )

			sKey = objCurSecData.Keys.Item( Me.mnCurrentKeyNo )
			sOut =  sKey & "=""" & _
					objCurSecData.Values.Item( Me.mnCurrentKeyNo ) & """"


			#If __DEBUG__
			Console.WriteLine( "Compare0 : Me.msLine=""{0}"", sOut=""{1}"" . ", _ 
						Me.msLine, sOut )
			#End If

			If bMutiLine Then
				Dim nRet				As RET_SaveSection_UpdateKeys_SkipMutiLineEnd
				Dim nPosComment_EndPos	As Integer
				nRet = Me.SaveSection_UpdateKeys_SkipMutiLineEnd( _ 
						bWrite:=False, bWriteComment:=False, nPosComment:= nPosComment_EndPos )
				
				If nRet = RET_SaveSection_UpdateKeys_SkipMutiLineEnd.FINDEOF_DURING_MUTILINE_READING Then
					Return RET_SaveSection_UpdateKeys_Compare0.FOUNDEOF_WHILE_READING_MULTI_LINE
				End If
				
				If nPosComment_EndPos >= 0 Then
					Dim nPosBlankLast			As Integer
					Dim sTopBlank				As String
					sTopBlank = Me.GetMultiLinedTopBlank( sKey )


					Dim nSOutLastLineLength		As Integer

					nPosBlankLast = Me.msLine.LastIndexOf( sTopBlank )
					If nPosBlankLast < 0 Then
						nSOutLastLineLength = sOut.Length
					Else

						' 4  5   6789 10
						' 0  1   2345  
						' \t \t  xxx"        nSoutLastLineLength:6
						'             10  11
						'             " " cooemnt
						nSOutLastLineLength = sOut.Length - nPosBlankLast
					End If

					Dim nSpaceCount				As Integer
					Dim sTabSpace				As String
					If nSOutLastLineLength >= nPosComment_EndPos Then
						' テキトーに1タブでいいんじゃねぇの。
						nSpaceCount = clsIniRW.TabtringCount
					Else

						nSpaceCount = nPosComment_EndPos - nSOutLastLineLength + 1

					End If
					sTabSpace = Me.GetTabSpaceStr( nSpaceCount )

					

					sOut = sOut & sTabSpace & Me.msLine.SubString( nPosComment_EndPos )

				End If


			Else


				If nPosComment <> -1 Then

					Dim nSpaceCount				As Integer
					Dim sTabSpace				As String

					nSpaceCnt = nPosComment - sOut.Length
					If nSpaceCnt < 0 Then
						nPosComment = clsIniRW.TabtringCount
					End If

					If nSpaceCnt > 0 Then
						sTabSpace = Me.GetTabSpaceStr( nSpaceCount )

					Else
						sTabSpace = ""
					End If
					sOut = sOut & sTabSpace & sReadComment
				End If

			End If


			
			' なんで WriteBlankLines 読んでるんだ？わからんｗｗｗｗ
			Call Me.WriteBlankLines()
			Me.WriteLine( sOut )
			Me.mnCurrentKeyNo += 1

			If Me.mnCurrentKeyNo >= objCurSecData.Keys.Count Then
				Me.ReadLine()
				Return RET_SaveSection_UpdateKeys_Compare0.SAVESECSKEYS_ARE_ALL_CONSUMED_SO_INPUT_LKYS_SHOULDBE_DELETED
				' Return 1

			End If

			Me.ReadLine()
			Return RET_SaveSection_UpdateKeys_Compare0.SUCCESS_KEYUPDATED_READLINE_DONE

		End Function

		Private Function IsMultiLinedValue(  ByRef sKey As String, ByRef sValue As String ) As Boolean

			Dim sTopBlank			As String
			sTopBlank = vbCrlf & Me.GetMultiLinedTopBlank( sKey )

			If sValue.IndexOf( sTopBlank ) >= 0 Then
				' たぶん、マルチライン化されてるんだろう。。。
				Return True
			End If

			Return False

		End Function

		Private Function GetTabSpaceStr(  ByVal nSpaceCount As Integer ) As String
			Dim sTabSpace			As String
			If nSpaceCount < clsIniRW.TabtringCount Then
				sTabSpace = new String( " "C, nSpaceCount ) 
			Else
				sTabSpace = new String( " "C, nSpaceCount \ clsIniRW.TabtringCount ) & _ 
							new String( " "C, nSpaceCount Mod clsIniRW.TabtringCount ) 
			End If

			Return sTabSpace
		End Function


		Private Function ToMultiLinedValue(  ByRef sKey As String, ByRef sValue As String ) As String

			If Me.IsMultiLinedValue( sKey, sValue ) Then
				' たぶん、マルチライン化されてるんだろう。。。
				Return sValue.Clone()
			End If


			Dim sTopBlank			As String
			sTopBlank = Me.GetMultiLinedTopBlank( sKey )

			If sValue.IndexOf( vbCrlf ) >= 0 Then
				sValue = sValue.Replace( vbCrLf , vbCrLf & sTopBlank )

				'#If __DEBUG__
				'Console.WriteLine( "ToMultiLinedValue : sValue=""{0}"" . ", _ 
				'		sValue	 )
				'#End If

				Return sValue
			End If

			If sKey.Length + 4 + sValue.Length < clsIniRW.mn1LineStringCount Then
				Return sValue.Clone()
			End If

			Dim sNewValue		As String
			Dim nPosValue		As Integer
			Dim n1LineCount		As Integer


			n1LineCount = clsIniRW.mn1LineStringCount - sTopBlank.Length

			If sValue.Length < n1LineCount Then
				sNewValue = sValue.Clone()
				Return sNewValue
			End If
			sNewValue = sValue.Substring( 0, n1LineCount )
			nPosValue = n1LineCount



			Do While nPosValue < sValue.Length
				Dim nLength			As Integer
				' n1LineCount=4 として・・・。
				'              11 1111  
				' 0123　4567 8901 2345
				' ABCD　EFab cdef BCDE 
				'    
				'   n1LineCount= 4 > 8  > 12
				nLength = sValue.Length - nPosValue
				If nLength > n1LineCount Then
					nLength = n1LineCount
				End If
				sNewValue = sNewValue & vbCrlf & sTopBlank & _ 
						sValue.Substring( nPosValue, nLength )
				nPosValue += nLength
			Loop

			Return sNewValue 

		End Function

		Protected Function GetMultiLinedTopBlank(  ByRef sKey As String ) As String
			Dim sTopBlank			As String
			'sTopBlank = ( new String( vbTab , ( sKey.Length + 4 ) \       clsIniRW.mnTabtringCount  )) & _ 
			'				( new String( " ",    ( sKey.Length + 4 ) Mod clsIniRW.mnTabtringCount  ))

			sTopBlank = new String( vbTab ,  2 )
			Return sTopBlank
		End Function

		Protected Function IsMultiLine(  Optional ByVal nPosStart As Integer = 0 ) As Boolean
			Dim nPosDQuotate		As Integer
			
			nPosDQuotate = Me.msLine.IndexOf( """"C, nPosStart )
			If nPosDQuotate < 0 Then
				Return False
			End If
			Dim nPosLastStr		As Integer

			nPosLastStr = clsPub.GetLastStr( Me.msLine )
			If nPosDQuotate = nPosLastStr Then
				Return True
			End If
			' 「閉じ " 」 がある
			nPosDQuotate = Me.msLine.IndexOf( """"C, nPosDQuotate + 1 )
			If nPosDQuotate < 0 Then
				Return True
			End If
			Return False

		End Function

		Private Function IsMultiLineEnd( ByRef nPosComment As Integer ) As Boolean

			Dim nPosDQuatate		As Integer
			nPosDQuatate = Me.msLine.IndexOf( """"C )
			If nPosDQuatate >= 0 Then
			
				nPosComment = -1
				If nPosDQuatate < Me.msLine.Length - 1 Then

					For nPos As Integer = nPosDQuatate + 1 To Me.msLine.Length - 1
						Dim c			As System.Char
						c = Me.msLine( nPos )
						If c <> " "C And c <> vbTab Then
							nPosComment = nPos
							Exit For
						End If

					Next
				End If

				Return True
			End If

			Return False

		End Function

		Private Sub WriteCommentAfterMultiLineEnd()
			Dim nPosDQuotate		As Integer
			nPosDQuotate = Me.msLine.IndexOf( """"C )
			If nPosDQuotate < 0 Then
				Return
			End If
			
			If nPosDQuotate = Me.msLine.Length -1 Then
				Return
			End If
			Dim sComment		As String
			sComment = Me.msLine( nPosDQuotate + 1 )
			
			If sComment.Trim( " " & vbTab ).Length = 0 Then
				Return
			End If

			Dim sSpace		As String
			If nPosDQuotate > 0 Then
				sSpace = new String( " "C, nPosDQuotate )
			Else
				sSpace = ""
			End If

			Dim sWriteData		As String
			sWriteData = sSpace & sComment
			Me.WriteLine( sWriteData )

			

		End Sub


		Private Function GetKeyAndData( ByRef sKey As String, _ 
								ByRef sData As String, _
								ByRef sComment As String, _
								ByRef nPosComment As Integer, _
								ByRef IsMultiLineData As Boolean ) As Boolean

			Dim nEqualIndex		As Integer

			nEqualIndex = Me.msLine.IndexOfAny( "=""" )
			If nEqualIndex < 0 Then
				
				If Me.msLine.Trim( " " & vbTab ).Length <> 0 Then
					sComment = Nothing
					nPosComment = -1
					
				End If
				Return False
			End If
			If Me.msLine( nEqualIndex ) <> "="C Then
				Return False
			End If
			' 01234
			'  abc=
			sKey = Me.msLine.Substring( 0,nEqualIndex ).Trim( " " & vbTab )

			Dim nDQuateIndexSta		As Integer
			Dim nDQuateIndexEnd		As Integer

			nDQuateIndexSta = Me.msLine.IndexOf( """"C, nEqualIndex + 1  )
			If nDQuateIndexSta < 0 Then
				Return False
			End If
			If nDQuateIndexSta = Me.msLine.Length - 1 Then
				IsMultiLineData = True
				sData = ""
				Return True
			End If

			IsMultiLineData = False
			nDQuateIndexEnd = Me.msLine.IndexOf( """"C, nDQuateIndexSta + 1  )
			If nDQuateIndexEnd < 0 Then
				IsMultiLineData = True
				nDQuateIndexEnd = Me.msLine.Length
			End If

			' 0123456789012
			'  abc= "aaa"
			sData = Me.msLine.Substring( nDQuateIndexSta + 1, nDQuateIndexEnd -1 - nDQuateIndexSta - 1 + 1)
			If IsMultiLineData = True THen
				nPosComment = -1
				Return True
			End If

			sComment = Nothing
			nPosComment = -1
			If nDQuateIndexEnd < Me.msLine.Length - 1 Then
				sComment = Me.msLine.Substring( nDQuateIndexEnd + 1 ).Trim( " " & vbTab )
				nPosComment = nDQuateIndexEnd + 1
				If sComment.Length = 0 Then
					sComment = Nothing
					nPosComment = -1
				End If
			End If

			Return True


		End Function

		Protected Sub ReadLine()
			Me.msLine = Me.msr.ReadLine()
			If Me.msLine IsNot Nothing Then
				Me.msLineTrim = Me.msLine.Trim( " " & vbTab )
			Else
				Me.msLineTrim = Nothing
			End If
		End Sub

		Protected Overridable Sub WriteLine( ByRef sWriteData As String )
			Me.msw.WriteLine( sWriteData )
		End Sub


		Private Sub WriteBlankLines()
			Do While Me.mnBlankCount > 0
				Me.WriteLine( "" )
				Me.mnBlankCount -= 1
			Loop
		End Sub


		Private Sub WriteQuedAllKeys()

			Dim objCurSecData		As clsSectionData
			objCurSecData = Me.mlstSecDatas( Me.mnCurrentSecIndex )

			If objCurSecData.Keys Is Nothing Then
				Exit Sub
			End If

			If objCurSecData.Keys.Count = 0 Then
				Exit Sub
			End If
			If Me.mnCurrentKeyNo >= objCurSecData.Keys.Count Then
				Exit Sub
			End If

			For nCnt As Integer = Me.mnCurrentKeyNo To objCurSecData.Keys.Count - 1
				Dim sWriteData		As String
				sWriteData = System.String.Format( "{0}=""{1}""", _ 
						objCurSecData.Keys.Item( nCnt ) , objCurSecData.Values.Item( nCnt)  )
				Me.WriteLine( sWriteData )
			Next

		End Sub


		Private Sub WriteBufferAndInputRests()
		
			' 残り全部コピーしとく
			Do While Me.msLine IsNot Nothing


				'#If __DEBUG__
				'Console.WriteLine(  "WriteBufferAndInputRests : Me.msLine=""{0}"".", Me.msLine  )
				'Console.ReadKey( False )
				'#End If


				Me.WriteLine( Me.msLine )
				Call Me.ReadLine()
			Loop


			'#If __DEBUG__
			'Console.WriteLine(  "WriteBufferAndInputRests : End. Me.msLine=""{0}"".", Me.msLine  )
			'Console.ReadKey( False )
			'#End If

		End Sub


		Private Sub WriteRestSections()

			If Me.mnCurrentSecIndex >= Me.mlstSecDatas.Count Then
				Return
			End If
			For nSecIndex As Integer = Me.mnCurrentSecIndex To Me.mlstSecDatas.Count - 1
				Call Me.WriteSection( nSecIndex )
			Next

		End Sub

		Private Sub WriteSection( ByVal nSecIndex As Integer)

			Dim objSecData		As clsSectionData
			Dim bKeyZero		As Boolean

			bKeyZero = True

			objSecData = Me.mlstSecDatas( nSecIndex )
			Me.WriteLine( objSecData.SecNameWithB )

			If objSecData.Keys IsNot Nothing Then
				If objSecData.Keys.Count > 0 Then

					bKeyZero = False
					For nCnt As Integer = 0 To objSecData.Keys.Count - 1
						Dim sWriteData			As String
						sWriteData = System.String.Format( "{0}=""{1}""", _ 
								objSecData.Keys.Item( nCnt ), objSecData.Values.Item( nCnt ) )
						Me.WriteLine( sWriteData )
					Next
				End If
			End If


			If Me.mlstSecDatas.Count - 1 <> nSecIndex Or bKeyZero = False Then
				' 新規作成時になぜか最終セクションに改行が２つ出てしまうためif文で避ける
				Me.WriteLine( "" )
			End If

		End Sub


		Protected Overridable Sub SetLoadSecIndex( ByRef sSecName As String)
			Return
		End Sub

		Protected Overridable Function CreateNewIni() As Boolean
			Try
			
				Me.msw = new System.IO.StreamWriter( clsIniRW.mstrIniFileName )
			catch e as System.Exception
				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" cannot open file to save! file name = """ & clsIniRW.mstrIniFileName & """" )
				Return False
			End Try


			If Me.mlstSecDatas IsNot Nothing Then
				For nSecIndex As Integer = 0 To  Me.mlstSecDatas.Count - 1
					Me.WriteSection( nSecIndex )
				Next
			End If

			Me.msw.Close()
			Me.msw.Dispose()
			Me.msw = Nothing
			Return True

		End Function



        Protected Overridable Function SetupRW() As Boolean
			Try
				Me.msr = new System.IO.StreamReader( clsIniRW.mstrIniFileName )
			Catch e As System.Exception
				' TypeOf
				' GetType

				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" can't read file. file name is """ & clsIniRW.mstrIniFileName & """. " )
				Return False
			End Try

			Try
				System.IO.File.Delete( clsIniRW.mstrIniFileNameTemp )
			catch e as System.Exception
			End Try

			Try
				Me.msw = new System.IO.StreamWriter( clsIniRW.mstrIniFileNameTemp )
			catch e as System.UnauthorizedAccessException
				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" No access authority to """ & clsIniRW.mstrIniFileNameTemp & """. " )
				Return False

			catch e as System.Exception
				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" can't open file """ & clsIniRW.mstrIniFileNameTemp & """. " & vbCrlf & _ 
						e.Message )
				Return False
			End Try

			Return True

		End Function

		Protected Overridable Function EndsRW( Optional ByVal bCancel As Boolean = False ) As Boolean

			If Me.msr IsNot Nothing Then
				Me.msr.Close()
				Me.msr.Dispose()
			End If
			If Me.msw IsNot Nothing Then
				Me.msw.Close()
				Me.msw.Dispose()
			End If
			Me.msr = Nothing
			Me.msw = Nothing



			'#If __DEBUG__
			'Console.WriteLine(  "EndsRW : handle closed. "  )
			'Console.ReadKey( False )
			'#End If


			If bCancel Then
				Try
					System.IO.File.Delete( clsIniRW.mstrIniFileNameTemp )
				catch e as System.Exception
				End Try
				Return False
			End If

			Try


				'#If __DEBUG__
				'Console.WriteLine(  "EndsRW : before delete file=""{0}"". ", clsIniRW.mstrIniFileName  )
				'Console.ReadKey( False )
				'#End If

				' https://docs.microsoft.com/ja-jp/dotnet/api/system.io.file.move?view=net-6.0#system-io-file-move(system-string-system-string-system-boolean)
				System.IO.File.Delete( clsIniRW.mstrIniFileName )

				'#If __DEBUG__
				'Console.WriteLine(  "EndsRW : before Move clsIniRW.mstrIniFileNameTemp=""{0}"". clsIniRW.mstrIniFileName=""{1}"" . ", _ 
				'			 clsIniRW.mstrIniFileNameTemp, clsIniRW.mstrIniFileName )
				'Console.ReadKey( False )
				'#End If


				System.IO.File.Move( clsIniRW.mstrIniFileNameTemp, clsIniRW.mstrIniFileName )


				'#If __DEBUG__
				'Console.WriteLine(  "EndsRW : after Move clsIniRW.mstrIniFileNameTemp=""{0}"". clsIniRW.mstrIniFileName=""{1}"" . ", _ 
				'			 clsIniRW.mstrIniFileNameTemp, clsIniRW.mstrIniFileName )
				'Console.ReadKey( False )
				'#End If

			catch e as System.Exception
				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" 削除or上書きできない！ 移動元ファイル名 = " & clsIniRW.mstrIniFileNameTemp, _ 
						" 移動先ファイル名 = " & clsIniRW.mstrIniFileName & vbCrlf & _ 
							e.Message )
				
				#If __DEBUG__
				Console.ReadKey( False )
				#End If

				Return False
			End Try


			'#If __DEBUG__
			'Call clsPub.ErrMsg( _
			'		new System.Diagnostics.StackTrace( true ) , _ 
			'		" 以下が動いてました。" )
			'Console.ReadKey( False )
			'#End If



			Return True		
		End Function

		Private Function GetSecOrder( ByVal sSecCurrent As String ) As Integer
			
			Dim nIndexCurrent		As Integer
			
			nIndexCurrent = -1
			If Me.marSecOrder.Length > 0 Then
				For nIndex As Integer = 0 To Me.marSecOrder.Length - 1
					If sSecCurrent = Me.marSecOrder( nIndex ) Then
						Return nIndex
					End If
				Next
			End If

			Return nIndexCurrent
		End Function

		

		Public Overrides Function ToString() As String
			Return "clsSaveSection"
		End Function


    End Class

End Class



End NameSpace
