
Option Explicit On


NameSpace MtCalc


Friend Partial Class clsIniRW


	' 単独でキー更新
	'    >>>    あり得ない。現状必要ない。
	'           アプリケーションで常時持つ設定のいくつかを同時に保存する事はある。
	'           
	'           データの保存タイミング：
	'                     ・アプリケーション終了時
	'                     ・ユーザーが保存コマンドを行った時、
	'                     ・なんらかの処理を行い、常時保存が必要なデータが発生した時
	'           従来のような、「ちょこっとだけ保存」を行うのと、このコードは相性が悪い。
	'                      従来の保存方式：
	'                           １．メモリに ini ファイル全体を保存しまるごとファイルに保存する方式
	'                           ２．window の配置位置が変更されるたびに毎回ファイルに書き込む形式
	'                                  ・強制終了がいつ発生するか分からない。
	'                                  ・アプリケーション終了時に保存処理が成功するか分からない)
	'                               2式はバグ対応が不完全なので、バグ対応出来れば問題なくなる。無視ｗ
	'                           ３．Win32 WritePrivateProfile を利用する形式
	'                        いずれもコメント化に対応出来ない、メモリ食い過ぎだろ、等。
	'
	'     今回のは、けっこうデカイデータを保存する事に「なりそう」。
	'     mtCalc と DotConv では保存するデータの種類が本質的に全く異なる。
	'      mtCalc には、
	'                 アプリケーション内の設定   データ量少ない
	'                 計算キャッシュ            データ量膨大
	'      という2種類のデータが保存されるので、「２種類のデータを保存する」機能が必要になる。
	'      今回は、アプリケーション終了時に自動保存する形式と、ユーザーが指定した時に保存する形式の
	'             ２系統用意するとして・・・
	'
	'          膨大なデータとは？
	'              掛け算、割り算キャッシュ
	'              チェビシェフ多項式のキャッシュ
	'              階乗、pow のキャッシュ
	'          Index が必要になる・・・はず？？？
	
	'   StreamReader.BaseStream  で FileStream を受け取り、そいつにSeekをすれば
	'   読み込みポインタを移動出来る・・・はず。
	'   テキストの自動エンコード機能が果たして必要なのかどうか・・・。

	'   デフォルトのStreamReader ：UTF-8  UTF8 unicode エンコーディング( Win2000 と同じ？)
   


    Friend Class clsSaveSection_UpdateKey
	    Inherits clsIniRW.clsSaveSection


		' clsSaveSection の、単キー/複数キー更新用。
		'  保存時に指定していないキーやセクションは消さずにそのままにしておく




		#If 0
		Public Function SetIniKey( _ 
					ByVal strSection As System.String, _ 
					ByVal strKey As System.String, _ 
					ByVal strValue As String, _ 
					Optional ByVal blWithReturn As Boolean = False ) As Boolean

			' ライン抜き出し

			If Not clsIniRW.mblWriteExecute Then
				Return False
			End If


			Dim sr		As System.IO.StreamReader
			Dim srout	As System.IO.StreamWriter

			If System.IO.File.Exists(mstrIniFileName ) = False Then
				' 新規で作る
				
				Try
					srout = new System.IO.StreamWriter( mstrIniFileName )
				catch e as System.Exception
					Call clsPub.ErrMsg( _
							new System.Diagnostics.StackTrace( true ) , _ 
							" 書き込むファイルが開けない！ ファイル名 = " & mstrIniFileName )
					Return False
				End Try
				
				strSection = "[" & strSection & "]"
				srout.WriteLine( strSection )
				srout.WriteLine( strKey & "=" & strValue )
				srout.WriteLine( "" )

				srout.Close()
				srout.Dispose()
				srout = Nothing
				Return True

			End If

			Try
				sr    = new System.IO.StreamReader( mstrIniFileName )
			Catch e As System.Exception
				' TypeOf
				' GetType

				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" can't read file. file name is """ & mstrIniFileName & """. " )
				Return False
			End Try

			Try
				System.IO.File.Delete( mstrIniFileNameTemp )
			catch e as System.Exception
			End Try

			Try
				srout = new System.IO.StreamWriter( mstrIniFileNameTemp )
			catch e as System.Exception
				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" can't open file """ & mstrIniFileNameTemp & """. " )
				Return False
			End Try

			Dim strLine				As String
			Dim blSectionAddMode	As Boolean
			Dim sAfterSection_Add	As String
			Dim blAdded				As Boolean




			sAfterSection_Add = ""
			Me.ReadLine()
			Do While Me.msLine IsNot Nothing



				If Me.msLineTrim( 0 ) = "["C And Me.msLineTrim.EndsWith( "]" ) Then

					Dim sReadSection		As String

					sReadSection = Me.msLineTrim.SubString( 1, Me.msLineTrim.Length - 2  ).Trim( " " & vbTab )
					If strSection = sReadSection Then
						srout.WriteLine( strLine )
						Exit Do
					ElseIf String.Compare( Me.msLine, strSection ) > 0  Then
						blSectionAddMode = True
						sAfterSection_Add = Me.msLine

						srout.WriteLine( "[ " & strSection & " ]" )
						Exit Do
					End If

				End If

				srout.WriteLine( Me.msLine )
				Me.ReadLine()
			Loop

			If Me.msLine Is Nothing Then
				' ini ファイルの中身がからっぽ
				' ファイルがあって中身がからっぽってどんなケースだよｗ
				srout.WriteLine( "[ " & strSection & " ]" )
				srout.WriteLine( strKey & "=""" & strValue & """" )
				srout.WriteLine( "" )
			ElseIf blSectionAddMode = True Then

				srout.WriteLine( "[ " & strSection & " ]" )
				srout.WriteLine( strKey & "=" & strValue )
				srout.WriteLine( "" )
				srout.WriteLine( sAfterSection_Add )


				Me.ReadLine()
				Call Me.WriteBufferAndInputRests()

			Else
				' 追加するキーのセクションは既にある場合
				Me.ReadLine()
				Do While Me.msLine IsNot Nothing


					If Me.msLineTrim( 0 ) = "["C Then
						' 別のセクションに入った
						srout.WriteLine( _ 
								strKey & "=""" & strValue & """" )
						' 空行とりあえず足しとく
						srout.WriteLine( "" )
						
						' 残り全部コピーしとく
						Call Me.WriteBufferAndInputRests()
						Exit Do
					End If

					
					
					If Me.msLineTrim.StartsWith( strKey ) Then

						Dim sEqual		As String
						sEqual = msLineTrim.Substring( strKey.Length ).LTrim( " " & vbTab )
						If sEqual( 0 ) = "=" Then
							srout.WriteLine( _ 
									strKey & "=""" & strValue & """" )
							blAdded = True
							Continue Do
						End If
					End If

					
					srout.WriteLine( Me.msLine )

					Me.ReadLine()
				Loop
				If blAdded = false Then
					srout.WriteLine( strKey & "=" & strValue )
				End If


			End If



			

			sr.Close()
			srout.Close()
			sr.Dispose()
			srout.Dispose()
			sr = Nothing
			srout = Nothing

			Try
				' https://docs.microsoft.com/ja-jp/dotnet/api/system.io.file.move?view=net-6.0#system-io-file-move(system-string-system-string-system-boolean)
				System.IO.File.Delete( mstrIniFileName )
				System.IO.File.Move( mstrIniFileNameTemp, mstrIniFileName )
			catch e as System.Exception
				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" 削除or上書きできない！ 移動元ファイル名 = " & mstrIniFileNameTemp, _ 
						" 移動先ファイル名 = " & mstrIniFileName )
			End Try
			
			Return True
		End Function
		#End If

		Friend Function UpdateIniKey( ByVal sSectionName As String, ByVal sKey As String, ByVal sValue As String ) As Boolean

			Dim lstKeys			As System.Collections.Generic.List(Of String)
			Dim lstValues		As System.Collections.Generic.List(Of String)

			lstKeys = new System.Collections.Generic.List(Of String)()
			lstValues = new System.Collections.Generic.List(Of String)()

			lstKeys.Add( sKey )
			lstValues.Add( sValue )

			Return Me.UpdateIniKeys( sSectionName, lstKeys, lstValues )

		End Function


		Friend Function UpdateIniKeys( ByVal sSectionName As String, _ 
										ByVal lstKeys As System.Collections.Generic.List(Of String), _ 
										ByVal lstValues As System.Collections.Generic.List(Of String) _ 
						) As Boolean

			Dim bRet			As Boolean

			Call Me.AddSectionData( sSectionName, lstKeys, lstValues )
			bRet = Me.SaveSection()

			Return bRet
		End Function


		Protected Overrides Function SaveSection_UpdateKeys_Compare_ReadKeySmall( _ 
							ByVal nPosComment As Integer, _ 
							ByRef sReadComment As String ) As RET_SaveSection_UpdateKeys_Compare_ReadKeySmall


			'#If __DEBUG__
			'	Console.WriteLine(  "clsSaveSection_UpdateKey : SaveSection_UpdateKeys_Compare_ReadKeySmall."  )
			'	Console.ReadKey( False )
			'#End If

			If Me.IsMultiLine() Then
				Dim nRet			As RET_SaveSection_UpdateKeys_SkipMutiLineEnd
				' "～" まで行を読み飛ばす
				Dim nPosComment_LastLine			As Integer
				nRet = Me.SaveSection_UpdateKeys_SkipMutiLineEnd( bWrite:=True, bWriteComment:=True, nPosComment:= nPosComment_LastLine )
				If nRet = RET_SaveSection_UpdateKeys_SkipMutiLineEnd.FINDEOF_DURING_MUTILINE_READING Then
					Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.IN_MULTILINE_READLINE_IS_SUDDENLY_EOF
					'Return 1
				ELseIf RET_SaveSection_UpdateKeys_SkipMutiLineEnd.SKIPPED_MUTILINE Then
					Me.ReadLine()
					REturn RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.READKEY_MULTILINE_SKIPPED
					'Return 2
				End If
			End If

			
			Me.msw.WriteLine( Me.msLine )

			Me.ReadLine()
			Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall.READKEY_SINGLELINE_SKIPPED
			'Return 3

			
		End Function



		Public Overrides Function ToString() As String
			Return "clsSaveSection_UpdateKey"
		End Function

    End Class

End Class



End NameSpace
