
Option Explicit On


NameSpace MtCalc


Friend Partial Class clsIniRW



    Friend Class clsSaveSection_LoadSection
	    Inherits clsIniRW.clsSaveSection


		Protected marLoadedSec				As System.Collections.Generic.List(Of clsSaveSection.clsSectionData)
		Protected mnCurrentLoadSecIndex		As Integer

		Public Sub New()
			Me.marLoadedSec = Nothing
			Me.mnCurrentLoadSecIndex = -1
		End Sub

		Friend Sub AddLoadSectionNameToLoad( ByRef sSecName As String )

			Dim lstKeys			As System.Collections.Generic.List(Of String)
			Dim lstValues		As System.Collections.Generic.List(Of String)

			' SeveSection に、全権読み出しするようダミーの保存データを与える
			lstKeys = new System.Collections.Generic.List(Of String)( 0 )
			lstValues = new System.Collections.Generic.List(Of String)( 0 )

			Call Me.AddSectionData( sSecName, lstKeys, lstValues )

			Dim objSecData		As clsSectionData
			objSecData = new clsSectionData()

			objSecData.SecNameRaw = sSecName
			objSecData.SecIndex = -1
			objSecData.Keys = new System.Collections.Generic.List(Of String)()
			objSecData.Values = new System.Collections.Generic.List(Of String)()
			objSecData.ValuesRaw = new System.Collections.Generic.List(Of String)()
			objSecData.Preserve = False

			If Me.marLoadedSec Is Nothing Then
				Me.marLoadedSec = new System.Collections.Generic.List(Of clsSectionData)(  marSecOrder.Count )
			End If
			Me.marLoadedSec.Add( objSecData )

		End Sub

		Friend Overridable Function LoadSections( ByRef lstSecDatas As System.Collections.Generic.List(Of clsSectionData) _ 
										) As Boolean

			Dim bRet			As Boolean


			'Call Me.AddSectionData( sSectionName, lstKeys, lstValues )
			' 読みだしたいセクション情報は事前に指定してもらう。（どうやって？)
			If Me.marLoadedSec Is Nothing Then
				Return False
			End If
			If Me.marLoadedSec.Count = 0 Then
				Return False
			End If


			bRet = Me.SaveSection()
			If bRet Then
				lstSecDatas = Me.marLoadedSec
			End If


			Return bRet
		End Function

		Friend Overridable Function LoadSection( ByVal sSectionName             As String, _ 
										ByRef lstLoadedKeys         As System.Collections.Generic.List(Of String), _ 
										ByRef lstLoadedValues       As System.Collections.Generic.List(Of String), _ 
										ByRef lstLoadedValuesRaw    As System.Collections.Generic.List(Of String) _ 
						) As Boolean

			Dim bRet			As Boolean
			Dim lstKeys			As System.Collections.Generic.List(Of String)
			Dim lstValues		As System.Collections.Generic.List(Of String)

			' SeveSection に、全権読み出しするようダミーの保存データを与える
			lstKeys = new System.Collections.Generic.List(Of String)( 0 )
			lstValues = new System.Collections.Generic.List(Of String)( 0 )


			Call Me.AddSectionData( sSectionName, lstKeys, lstValues )

			Dim objSecData		As clsSectionData
			objSecData = new clsSectionData()

			objSecData.SecNameRaw = sSectionName
			objSecData.SecIndex = -1
			objSecData.Keys = new System.Collections.Generic.List(Of String)()
			objSecData.Values = new System.Collections.Generic.List(Of String)()
			objSecData.ValuesRaw = new System.Collections.Generic.List(Of String)()
			objSecData.Preserve = False


			If Me.marLoadedSec Is Nothing Then
				Me.marLoadedSec = new System.Collections.Generic.List(Of clsSectionData)(  marSecOrder.Count )
			End If

			Me.marLoadedSec.Add( objSecData )

			bRet = Me.SaveSection()
			If bRet Then
				lstLoadedKeys = objSecData.Keys
				lstLoadedValues = objSecData.Values
				lstLoadedValuesRaw = objSecData.ValuesRaw
			End If


			Return bRet
		End Function



		Protected Overrides Sub SetLoadSecIndex( ByRef sSecName As String)
			Me.mnCurrentLoadSecIndex = -1
			If marLoadedSec IsNot Nothing Then
				If marLoadedSec.Count > 0 Then
					For nIndex As Integer = 0 To marLoadedSec.Count - 1
						If marLoadedSec.Item( nIndex ).SecNameRaw = sSecName Then
							Me.mnCurrentLoadSecIndex = nIndex
							Exit For
						End If
					Next
				End If
			End If

		End Sub



		Protected Overrides Function SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad( _ 
							ByRef sReadKey As String, _ 
							ByRef sReadValues As String, _ 
							ByVal bMutiLine As Boolean ) As RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad


			If Me.mnCurrentLoadSecIndex < 0 Then
				Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.REQUESTS_MODULE_NATIVE_READKEYSMALL
			End If
			If Me.SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad__IsTargetKey( sReadKey ) = False Then
				Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.REQUESTS_MODULE_NATIVE_READKEYSMALL
			End If


			Dim sReadValueRaw		As String

			sReadValueRaw = Nothing
			If bMutiLine Then


				Dim sTopBlank			As String

				sTopBlank = Me.GetMultiLinedTopBlank( sReadKey )

				sReadValueRaw = sReadValues.Clone()
				Do

					Me.ReadLine()

					If Me.msLine Is Nothing Then
						Exit Do
					End If

					Dim nPosDQuatate		As Integer
					Dim nPosValueEnd		As Integer
					nPosDQuatate = Me.msLine.IndexOf( """"C )

					If nPosDQuatate >= 0  Then
						nPosValueEnd = nPosDQuatate
					Else
						nPosValueEnd = Me.msLine.Length
					End If

					Dim sReadValusAdd		As String
					If Me.msLine.StartsWith( sTopBlank ) Then
						sReadValusAdd = Me.msLine.Substring( sTopBlank.Length, nPosValueEnd - sTopBlank.Length )
					Else
						sReadValusAdd = Me.msLine.Substring( 0, nPosValueEnd )
					End If

					sReadValues = sReadValues & sReadValusAdd
					sReadValueRaw = sReadValueRaw & vbCrlf & Me.msLine.Substring( 0, nPosValueEnd )

					If nPosDQuatate >= 0 Then
						Exit Do
					End If

				Loop

				
				If Me.msLine Is Nothing Then
					Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.FINDEOF_DURING_VALUE_MUTILINE_READING
				End If

			End If

			Call Me.SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad__AddLoadData( _ 
					sReadKey, sReadValues, sReadValueRaw )


			Me.ReadLine()
			Return RET_SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad.VALUE_PARSED_AND_READLINE_DONE

		End Function

		Protected Overridable Function SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad__IsTargetKey( _ 
						ByRef sKey As String ) As Boolean
			Return True
		End Function


		Protected Overridable Sub SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad__AddLoadData( _ 
						ByVal sReadKey			As String, _ 
						ByVal sReadValue		As String, _ 
						ByVal sReadValueRaw		As String )
			Dim objSecData		As clsSectionData

			objSecData = Me.marLoadedSec.Item( Me.mnCurrentLoadSecIndex )
			objSecData.Keys.Add( sReadKey )
			objSecData.Values.Add( sReadValue )
			objSecData.ValuesRaw.Add( sReadValueRaw )
			
		End Sub



		Protected Overrides Sub WriteLine( ByRef sWriteData As String )
			Exit Sub
		End Sub



		Protected Overrides Function CreateNewIni() As Boolean

			Return True

		End Function



        Protected Overrides Function SetupRW() As Boolean
			Try
				Me.msr = new System.IO.StreamReader( clsIniRW.mstrIniFileName )
			Catch e As System.Exception
				' TypeOf
				' GetType

				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
						" can't read file. file name is """ & clsIniRW.mstrIniFileName & """. " )
				Return False
			End Try


			Me.msw = Nothing

			Return True

		End Function

		Protected Overrides Function EndsRW( Optional ByVal bCancel As Boolean = False ) As Boolean

			If Me.msr IsNot Nothing Then
				Me.msr.Close()
				Me.msr.Dispose()
			End If

			Me.msr = Nothing

			If bCancel Then
				Return False
			End If

			'#If __DEBUG__
			'Call clsPub.ErrMsg( _
			'		new System.Diagnostics.StackTrace( true ) , _ 
			'		" ・・・が動いてました。" )
			'Console.ReadKey( False )
			'#End If



			Return True		
		End Function




    End Class





    Friend Class clsLoadKey
	    Inherits clsIniRW.clsSaveSection_LoadSection

		Private msLoadKey			As String
		Private msLoadedValue		As String
		Private msLoadedValueRaw	As String

		Friend Function LoadKey( _ 
										ByVal sSectionName        As String, _ 
										ByVal sLoadedKey          As String, _ 
										ByRef sLoadedValue        As String, _ 
										ByRef sLoadedValueRaw     As String _ 
						) As Boolean

			Dim bRet			As Boolean
			Dim lstKeys			As System.Collections.Generic.List(Of String)
			Dim lstValues		As System.Collections.Generic.List(Of String)

			' SeveSection に、全権読み出しするようダミーの保存データを与える
			lstKeys = new System.Collections.Generic.List(Of String)( 0 )
			lstValues = new System.Collections.Generic.List(Of String)( 0 )


			Call Me.AddSectionData( sSectionName, lstKeys, lstValues )

			Me.msLoadKey = sLoadedKey

			bRet = Me.SaveSection()
			If bRet Then
				sLoadedValue = Me.msLoadedValue
				sLoadedValueRaw = Me.msLoadedValueRaw
			End If



			Return bRet
		End Function


		Friend Shadows Function LoadSection( ByVal sSectionName             As String, _ 
								ByRef lstLoadedKeys         As System.Collections.Generic.List(Of String), _ 
								ByRef lstLoadedValues       As System.Collections.Generic.List(Of String), _ 
								ByRef lstLoadedValuesRaw    As System.Collections.Generic.List(Of String) _ 
						) As Boolean
			Return False
		End Function

		Friend Shadows Function LoadSections( ByRef lstSecDatas As System.Collections.Generic.List(Of clsSectionData) _ 
										) As Boolean
			Return False
		End Function

		


		Protected Overrides Function SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad__IsTargetKey( _ 
						ByRef sKey As String ) As Boolean
			If Me.msLoadKey = sKey Then
				Return True
			End If
			Return False
		End Function



		Protected Overrides Sub SaveSection_UpdateKeys_Compare_ReadKeySmall_WhenLoad__AddLoadData( _ 
						ByVal sReadKey			As String, _ 
						ByVal sReadValue		As String, _ 
						ByVal sReadValueRaw		As String )
			
			Me.msLoadedValue = sReadValue
			Me.msLoadedValueRaw = sReadValueRaw
			
		End Sub

	End Class

End Class



End NameSpace
