Option Explicit On

'#If 0
'#End If

NameSpace DbgMtFiles

'#const __DEBUG__ = 1

'  各種データ型のサイズ詳細メモは csWin32.cs を参照。




' 関係ないけど：
'		https://qiita.com/ohisama@github/items/3b3bac49ca8be5aa1b36
'			x64 アセンブリ　命令一覧
'
'				x64 アセンブラ命令一覧。便利だー。



Friend Class clsDisasm86Base
	Friend Enum REG As Byte
		ax = 0
		cx
		dx
		bx
		sp
		bp
		si
		di
	End Enum

	Friend Enum REG32 As Byte
		eax = 0
		ecx
		edx
		ebx
		esp
		ebp
		esi
		edi
	End Enum


	private Enum Bit As Byte
		D0		= &h1
		D1		= &h2
		D2		= &h4
		D3		= &h8
		D4		= &h10
		D5		= &h20
		D6		= &h40
		D7		= &h80 
	End Enum

	[System.Flags]
	Friend Enum PERFIES
		NONE			= &h0UL
		LOCK			= &h1UL
		REPENE			= &h2UL
		REPE			= &h4UL
		BND				= &h8UL
		SEGMENT			= &h10UL
		BRANCH_HINT		= &h20UL
		OPERAND			= &h40UL
		ADDRESS			= &h80UL
	End Enum


	Friend Enum IMMTYPE
		IMM8
		IMM_8TO64
		DISPLACEMENT
	End Enum

	Friend Class clsImmOrDisp64Range
		Friend nSta			As Integer
		Friend nEnd			As Integer

		Friend Sub New()
			Me.nSta = -1
			Me.nEnd = -1
		End Sub
	End Class

	Friend mX64ASM_MAX_INST_SIZE		As Integer = 11

	Friend bytPRIFEX_LOCK				As Byte = &hf0
	Friend bytPRIFEX_REPENE				As Byte = &hf2
	Friend bytPRIFEX_REPE				As Byte = &hf3
	Friend bytPRIFEX_BND				As Byte = &hf2

	Friend bytPRIFEX_SEGMENTS()			As Byte = new byte(6) { &he2, &h36, &h3e, &h26, &h64, &h65 }
	Friend bytPRIFEX_BRANCH_HINTS()		As Byte = new byte(2) { &h2e, &h3e }

	Friend bytPRIFEX_OPERAND			As Byte = &h66
	Friend bytPRIFEX_ADDRESS			As Byte = &h67

	Friend bytREX						As Byte = &h40
	Friend bytREX_MASK					As Byte = &hf0

	Friend Sub New()
	End Sub


End Class



Friend Class clsDisasm86
	Inherits clsDisasm86Base


	' おっかしいな、new class() の添え字数、0 でなんで１個配列扱いなんだ？？？？
	Protected marInst() 		As clsInstDef = new clsInstDef(0) _ 
		{ _
			new clsInstDef With { .DocName = "MOV - Move Data ", .DocNameSub = "register1 to register2 ", _ 
								  .AssembleName = "mov", .AssembleOperands = "reg2,reg1", _ 
								  .InstSize = 2, _ 
								  .Prefixes = PREFIXES.NONE, .HasRex=False, .OPCode= new byte(1) { &h88, &hc0 }, .OPCodeMask= new byte(1) { ~&h1, &hc0 }, _ 
								  .WordBit = Bit.D0, _ 
								  .OperandConv = new clsOperandConvDef(1) { _
										new clsOperandConvDef With { .TargetOperand = "reg1", .CodeOffset = 1, .CodeOMask = &h38, .RShift = 3, _ 
																		.EnumTypeB = GetType(REG), .EnumTypeW = GetType(REG32) }, _ 
										new clsOperandConvDef With { .TargetOperand = "reg2", .CodeOffset = 1, .CodeOMask = &h07, .RShift = 0, _ 
																		.EnumTypeB = GetType(REG), .EnumTypeW = GetType(REG32) } _ 
											   }
								}  _
		}



#If 0
	Friend Structure stDisasmInputInfo
		Dim		arbytCode()			As Byte
		Dim		nOffSet				As Integer
		Dim		bToLower			As Boolean
		' まだまだ色々あるぞ～～～。
		' 64bit モードか？とか、汎用設定？の情報とか

		Friend ReadOnly Property IsValid As Boolean
			Get
				If Me.arbytCode Is Nothing Then
					Return False
				End If
				If Me.nOffSet >= Me.arbytCode.Length Or _ 
					Me.nOffSet < 0 Then
					Return False
				End If
				
			End Get
		End Property
		
		Friend Sub New()
			Me.arbytCode = Nothing
			Me.nOffSet = 0
			Me.bToLower = False
		End Sub

		Friend Sub New( ByRef stSrc As stDisasmInputInfo )

			Me.arbytCode = stSrc.arbytCode
			Me.nOffSet = stSrc.nOffSet
			Me.bToLower = stSrc.bToLower
		End Sub
	End Structure

	Friend Structure stDisasmOutputInfo
		Dim		arbytCode()			As Byte
		Dim		nOffSet				As Integer
		Dim		nInstSize			As Integer

		Dim		sOpecode			As String
		Dim		sOperand1			As String
		Dim		sOperand2			As String
		Dim		sOperand3			As String

		Dim		enmOperand1			As ARGTYPE

		Dim		sDescription		As String
	End Structure

	Private mnMAX_INSTSIZE			As Integer = 23


	Friend Enum RET_GetDisasms
		ARG_ARRAW_ISNOTHING
		OFFSET_IS_OVER_ARRAW_LENGTH

		ERR_INPUT_ENV_IS_NOTHING
		ERR_INPUT_ENV_IS_INVALID
		ERR_OFFSET_IS_ZEORO_AND_LOLOWER_IS_TRUE
		OK_DISASM_1INSUTRUCTION_DISASSEMBLED
	End Enum
	Friend Function GetDisasms( ByRef stInputEnv As stDisasmInputInfo, _ 
							ByRef lstOuts As System.Collections.Generic.List(Of stDisasmOutputInfo ) ) _
							As RET_GetDisasms

		If stInputEnv Is Nothing Then
			Return RET_GetDisasms.ERR_INPUT_ENV_IS_NOTHING
		End If

		If !stInputEnv.IsValid Then
			Return 	RET_GetDisasms.ERR_INPUT_ENV_IS_INVALID
		End If
		
		Dim lstRetOuts					As System.Collections.Generic.List(Of stDisasmOutputInfo )
		Dim stRetDisasmOutput			As stDisasmOutputInfo
		Dim bRet						As Boolean

		lstRetOuts = new System.Collections.Generic.List(Of stDisasmOutputInfo )

		stRetDisasmOutput = Nothing
		If bToLower Then


			' 一つ上に行き、
			' 1バイト命令か？
			' imidiate/displacekment?
			'    もっとさかのぼってみる
			' 
			' 現在の PC 行より０方向に逆アセンブルするのは、かなり無謀らしい。
			' ・・・・出来なくはないだろうけど・・・。
			'
			' スタックから戻りアドレスを見て、そこのジャンプ命令で飛んだ先から
			' 逆アセンブルすればいいｗ
			' ・・・というのはかなり甘い。レジスタ間接ジャンプだと面倒臭過ぎる。

			' 現在の PC 行が、何らかの関数シンボル+offset である事は間違いないので、
			' その「一番近い」シンボル名の先頭から逆アセンブルすればいい。
			' ・・・って、そのシンボル名、どっから取って来るんだよ・・・。

			' .Net の出力コードは、アドレスがどう決まるんだろうか？？？
			' 多分、モジュール単位で、そのまんま、IL>x86/x64 コード生成時に
			' 決まるんだよな。
			' そのアドレス情報がどこに格納されているのか、今んとこ検討もつかんし。

			' .net の実行バイナリの、実行時ネイティブアドレス情報は・・・。
			' 

			' 面倒臭いし、シンボルの実行時アドレスをどうにか取って来る案でいくかｗ
			' 変数名とアドレスの対になる情報は、絶対にどっか入ってるはずｗ


			' Prefix と opecode が被らなければ、
			' prefix で命令先頭かどうかをほぼ確定出来るのでは？
			' 仮に prefix と RIB/SM/displacement/imm とゴッチャになってたとしたら・・・。

			' prefix は、opecode に絶対含まれない？？？
			'
			' RIB/SM/displacement/imm の前は必ず対応する opecode1-3 が来るはずだ。
			' 
			' だから、prefix で前方検索して、ヒットしたら、それが
			' **************     失敗品?     ********************
			' prefix を前方検索()
			' if ( prefix あった )
			'	//   典型的なケースだと、
			'	//	 この prefix は imm,R/M,SIB,displacement である可能性がある。
			'    if ( prefix の前が  )

			' } else { // Prefix なかった
			'}
			'
			' **************     失敗品?     ********************



			' imm : 最大で 8 バイト？
			' ?imm が２つ入る命令はない？
			' SIB という形式、base+index は Pentium ぐらいの時にはあったけど、
			' 消えたようだ？？？黒歴史扱い？

			
			' とりあえず、バグ覚悟で、標準/標準 64 bit 命令のみターゲットにしよう。
			' AVX とかその他の拡張命令は無視しよう。

			'  (1バイト単独命令) (1バイト単独命令)              (1バイト単独命令) (rip)
			'				※ 1バイト単独命令が延々続く
			'  (1バイト単独命令) (2バイト,1オペ1オペランド命令) ( 1バイト単独命令) (rip)
			'  (1バイト単独命令) (2バイト,1オペ1オペランド命令) (not 1バイト単独命令) (rip)


			' **************     失敗品?     ********************
			' if ( -1 バイト目が 1 バイト単独命令？)
			'   if ( -2 バイト目が単独命令? )
			'      ......
			'     if ( -24 バイト目が単独命令? )
			'
			' ....キリないから、ループで「単独命令？」( 100命令ぐらい)をやる
			' else {
			'	// -1 バイト目はオペランドで確定
			'	// オペランドが何バイトあるか推定する
			'   if ( -2,3,4,5,... バイト目が単独命令? )
			'}
			' **************     失敗品?     ********************





			' 最低でも 8 バイト以上は前を見なくては opecode が確定しない？
			' mov/add/adc とか 
			'  (imm0-7) (imm8-15) (imm16-23) (imm24-31) (imm32-39) (imm40-47) (imm48-55) (imm56-63) (rip)

			' call 最長：
			'	(Segment prefix) REX.W FF /3 imm64			CALL m16:64		12バイト
			


			'  (call/jmp/jcc) (64bit?)
			' (REX) (OP1-3)   (modR/M)/(OP2+reg)   (imm0-7) (imm8-15) (imm16-23) (imm24-31) (imm32-39) (imm40-47) (imm48-55) (imm56-63) (rip)

			' 		ここで、REX. OP1-3 が一致したからOKという訳ではなくて、
			'			REX~modR/M が前の命令の (mod/R/M)/imm だったという可能性を考えなくてはいけない。
			'			「 immに opecode があるケース」と命名する。

			'   結果的には？一番最初に最長の命令に合わせて、先頭フィールドを確認した方が良い、くさいｗ
			'   読み取ったコード領域の先頭を超えいる場合は、この付近の逆アセンブルは諦める？

			' --    --    --    --    --    --    --    --    --    --    
			' 「 immに opecode があるケース」 ：

			'	 if 文で検出で以下のように検出したとする。
			'		if ( Code[rip-8] is any-inst's op1 AND Code[rip-9] is REX   ) {
			'
			'		}
			'
			'	この場合、まだ Code[rip-8], Code[rip-9] はさらにその前の命令の rex/... の imm/displacement/modR/M 
			'	の一部である可能性が多分に残っている。
			'	
			'		・rip-9=anyInst op1 / rip-9=REX がより前の operand である事が真実の場合、
			'				Code[rip-7]  ～ Code[rip-m] は operand である可能性がある。
			'				Code[rip-7]  ～ Code[rip-1] に まるまる１命令以上入っているはずである。
			'				Code[rip-10] 、より上に opecode  が必ずあるはずである。
			'	
			'
			'		
			' --    --    --    --    --    --    --    --    --    --    

			' ざっと見た感じだと、		
			'				(REX)	(op1)	(ModR/M)	imm64
			'				(REX)	(op1)	(op2+reg)	imm64
			'				(REX)	(op1)				imm64
			' という命令フォーマットしか imm64 には無いようだ。
			' これを突破口に、上方向に逆アセンブルを試みる。
			'			ほとんどは op1 は 1バイトで、BT/BCC/BTR/BTS 命令だけ op1      は 2バイト   ただし imm は imm8
			'										SHLD/SHRD			imm8 	op1 も 2バイト        同上
			'										cmppsというか
			'										  vcmpps も imm8 ある
			'												 C4: rxb0_1: w xmmreg2 000:C2:11 xmmreg1 xmmreg3: imm
			'												 計 6 バイト
			'									

			' -1 バイト目を含む逆アセンブルをする時、
			' いきなり 8 バイト以上さかのぼり、 rex prefix があるか調べる。

			
			
			' かなり複雑になるので、超短文記述出来るコード体系にしないと駄目なようだ。



			Dim nCurrentCodeIndex		As Integer
			If stInputEnv.nOffset = 0 Then
				Return RET_GetDisasms.ERR_OFFSET_IS_ZEORO_AND_LOLOWER_IS_TRUE
			End If
			nCurrentCodeIndex = stInputEnv.nOffset - 1
			Do While nCurrentCodeIndex >= 0
				Dim stInputCurrent		As stDisasmInputInfo
				Dim stDisasm			As stDisasmOutputInfo

				stInputCurrent = new stDisasmInputInfo( stInputEnv )
				stInputEnv.nOffSet = nCurrentCodeIndex
				bRet = Me.GetInstInf( stInputEnv, stDisasm )
				If bRet = False Then 
					'Return False
					nCurrentCodeIndex -= 1
					If nCurrentCodeIndex < 0 Then

						If lstRetOuts.Count > 0 Then
							lstOuts = lstRetOuts
							Return True
						End If
						Return False

					End If
					Continue Do
				End If

				Dim nDisAsmTopOffset			As Integer
				If lstRetOuts.Count > 0 Then
					nDisAsmTopOffset = lstRetOuts.nOffSet
				Else
					snDisAsmTopOffset = tInputEnv.nOffset
				End If

				If stDisasm.nOffset + stDisasm.nInstSize > snDisAsmTopOffset Then

					nCurrentCodeIndex -= 1
					If nCurrentCodeIndex < 0 Then
						
						If lstRetOuts.Count > 0 Then
							lstOuts = lstRetOuts
							Return True
						End If
					ElseIf snDisAsmTopOffset - nCurrentCodeIndex > Me.mnMAX_INSTSIZE Then
						If lstRetOuts.Count > 0 Then
							lstOuts = lstRetOuts
							Return True
						End If
						Return False
					End If

					lstRetOuts.Insert( 0, stDisasm )
					nCurrentCodeIndex = stDisasm.nOffSet - 1
					

					Continue Do
				End If
			Loop
		End If


	End Function


	Friend Function GetInstInf(  ByRef stDisasmInputs As stDisasmInputInfo, _ 
							 ByRef stDisasmOutput As stDisasmOutputInfo ) As Boolean

		
	End Function
#End If

	'		334569-sdm-vol-2d.pdf
	'			APPENDIX B INSTRUCTION FORMATS AND ENCODINGS
	'				Figure B-1. General Machine Instruction Format

	'		334569-sdm-vol-2a.pdf

	' 	+-----------+-----------+---------+---------+---------+--------+-
	'	| legacy 	| REX 		| 1,2or3					  | ModR/M | 
	'	| Prefixes	| Prefixes	| Opcodes					  |		   |
	' 	+-----------+-----------+---------+---------+---------+--------+-

	'									+-----+---------------+-----------+
	'									|SIB  | address		  | immediate |
	'									|	  | displacement  |			  |
	'									+-----+---------------+-----------+

	' legacy Prefiexes : optional
	'			GRP1-4
	'			GRP1	: F0	LOCK prefix
	'					  F2	REPNE/REPNZ prefix
	'					  F3	REP/REPE/REPZ prefix
	'					  F2 	BND prefix
	'						if : CPUID.(EAX=07H, ECX=0):EBX.MPX[bit 14] is set.
	'							 BNDCFGU.EN and/or IA32_BNDCFGS.EN is set.
	'							 When the F2 prefix precedes a near CALL, a near RET, 
	'								a near JMP, a short Jcc, or a near Jcc instruction 
	'								
	'			GRP2	: segment overrirde
	'					2E		CS segment override
	'					36		SS segment override
	'					3E		DS segment override
	'					26		ES segment override
	'					64		FS segment override
	'					65		GS segment override
	'					  Branch hints1
	'					2E		Branch not taken (used only with Jcc instructions)
	'					3E		Branch taken (used only with Jcc instructions)
	'					
	'			GRP3	: Operand-size override prefix( 16or 32)
	'					66

	'			GRP4	: Address-size override prefix(16 or 32)
	'					67

	'		さーて、逆アセンブルとアセンブル、共通で使える
	'		アセンブラ命令テーブルのデータフォーマットはどんなかな～～～。
	'		C ではなく VB と .netframework ならではの高速変換、低メモリでの変換が出来る
	'		データ形式っつーと・・・・。

	'			ハッシュなんかは結構早いけど、メモリ若干食うんだよな～。
	'			256バイトぐらいはハッシュ使った方がいいか・・・。
	'			・・・というか、「なんでもハッシュ」の方が良いのかも知れないｗ
	'			
	'			・・・でも、x64 命令なんかフツー滅多にみねーだろ・・・ｗ
	'			アセンブラの時は、いるんじゃないの。
	
	' 		.net の利点っちゃ・・・「どの CPU でも使えて新しい CPU 向けのコードを
	'		吐く」ってのと、メモリ管理が超楽で、短文でライブラリが充実してて・・・

	'	？１バイト命令あるの？

	'	・テキトーに実装でいいんじゃん？ブレークポイント見れば別にいいだろ。
	'	・ハンド逆アセンブルが超大変。半日ぐらいかかった。
	'	・


	' 32bit
	'				ADC – ADD with Carry
	'				register1 to register2 						0001 000w : 11 reg1 reg2
	'				register2 to register1 						0001 001w : 11 reg1 reg2

	' 64bit
	'				ADC – ADD with Carry
	'				register1 to register2 			0100 0R0B : 0001 000w : 11 reg1 reg2
	'				qwordregister1 to qwordregister2 0100 1R0B : 0001 0001 : 11 qwordreg1 qwordreg

	' と、見た感じだと、REX Prefix の有無だけらしい。どうやら。

	' とりあえず：
	'		334569-sdm-vol-2d.pdf
	'				121 ページ、  B.2 GENERAL-PURPOSE INSTRUCTION FORMATS AND ENCODINGS FOR NON 64-BIT MODE
	' 		をだいたい実装すりゃいいかな？
	


	' 		253666-sdm-vol-2a.pdf
	'			43 ページ
	'				Table 2-1. 16-Bit Addressing Forms with the ModR/M Byte
	'				Table 2-2. 32-Bit Addressing Forms with the ModR/M Byte
	'				Table 2-3. 32-Bit Addressing Forms with the SIB Byte



	'	https://qiita.com/12345/items/64f4372fbca041e949d0
	'			VS Code の便利なショートカットキー
	'				Ctrl + Shift + Alt + ↑/↓/←/→　現在のカーソル位置を起点に矩形選択






	' REX.W mov reg, imm32/64
	' なぜ REX と mov の１倍とめ両方に W と w があるｗｗｗｗ


End Class


	' 256*8= 1024

Friend Class clsDisasm86Lower
	Inherits clsDisasm86Base

	'	https://learn.microsoft.com/ja-jp/dotnet/visual-basic/programming-guide/language-features/objects-and-classes/object-initializers-named-and-anonymous-types
	'			オブジェクト初期化子:名前付きの型と匿名型
	'	dotnet-visual-basic.pdf
	'			953 ページ
	'				初期値の指定
	'
	'
	'



	Friend FUnction DiasmByteDatas( ByVal objDisasmRowData As clsDisasmData) As Boolean
		Dim objCurrentData		As clsDisasmData

		Dim nNewOffSet, nNewLength		As Integer
		If objDisasmRowData.Offset < mX64ASM_MAX_INST_SIZE Then
			nNewOffSet = 0
			nNewLength = objDisasmRowData.Size
		Else
			nNewOffSet = objDisasmRowData.Offset - mX64ASM_MAX_INST_SIZE
			nNewLength = mX64ASM_MAX_INST_SIZE
		End If
		objCurrentData = new clsDisasmData( objDisasmRowData.Data, nNewOffSet, nNewLength )

		' objCurrentData に一致する命令はあるか？


	End Function


End Class

Friend Class clsInstDisassem

End Class		' 


Friend Class clsOperandConvDef

	Friend Delegate Function dlgt_GetOperandStr( ByVal objDisasmData As clsDisasmData ) As String

	Private msOperandOrigin			As String
	Private mnOffset				As Integer
	Private mbytBits				As Byte
	Private mnBitShift				As Integer
	Private mobjTypeByte			As System.Type
	Private mobjTypeWord			As System.Type

	Private mdlgtGetOperandStr		As dlgt_GetOperandStr


	Friend Property TargetOperand() As String
		Set( value As String )
			Me.msOperandOrigin = value
		End Set
		Get
			return Me.msOperandOrigin
		End Get
	End Property

	Friend Property CodeOffset() As Integer
		Set( value As Integer )
			Me.mnOffset = value
		End Set
		Get
			return Me.mnOffset
		End Get
	End Property

	Friend Property CodeOMask() As Byte
		Set( value As Integer )
			Me.mbytBits = value
		End Set
		Get
			return Me.mbytBits
		End Get
	End Property

	Friend Property RShift() As Integer
		Set( value As Integer )
			Me.mnBitShift = value
		End Set
		Get
			return Me.mnBitShift
		End Get
	End Property


	Friend Property EnumTypeB() As System.Type
		Set( value As System.Type )
			Me.mobjTypeByte = value
		End Set
		Get
			return Me.mobjTypeByte
		End Get
	End Property


	Friend Property EnumTypeW() As System.Type
		Set( value As System.Type )
			Me.mobjTypeWord = value
		End Set
		Get
			return Me.mobjTypeWord
		End Get
	End Property

	Friend Property ConvertCallBack() As dlgt_GetOperandStr
		Set( value As dlgt_GetOperandStr )
			Me.mdlgtGetOperandStr = value
		End Set
		Get
			return Me.mdlgtGetOperandStr
		End Get
	End Property

	Private Sub New()
		Me.mdlgtGetOperandStr = AddressOf Me.GetOperandStr_Default
	End Sub

	Private Function GetOperandStr_Default( ByVal objDisasmData As clsDisasmData ) As String
		Dim bytCode		As Byte

		bytCode = objDisasmData.Data( objDisasmData.OffSet + Me.mnOffset )
		bytCode &= Me.mbytBits
		If Me.mnBitShift > 0 Then
			bytCode >>= Me.mnBitShift
		End If


		Dim objEnumType			As System.Type
		If objInstDef.IsWBitActive( objInstDef.Data ) Then
			objEnumType = Me.mobjTypeWord
		Else
			objEnumType = Me.mobjTypeByte
		End If

		If objEnumType.IsEnum = False Then
			' 作り込み甘いような・・・。
			Return bytCode.ToString( "x2" )
		End If

		Return System.Enum.GetName( objEnumType, bytCode )

	End Function





End Class

Friend Class clsInstDef
	Inherits clsDisasm86Base

	Private		msDiscriptionName1		As String
	Private		msDiscriptionName2		As String

	Private		msAsm					As String
	Private		msOperands_Origin		As String



	Private		menmPrefix				As PREFIXES
	Private		mbRex					As Boolean


	Private		mbytCode()				As Byte
	Private		mbytCodeMask()			As Byte

	Private		mnWordMaskOffset		As Integer
	Private		mbytWordMask			As Byte

	Private 	mnOffset_ModRM			As Integer
	'Private 	mnOffset_SIB			As Integer				' 使わないんじゃね？
	Private 	msModRM_originStr		As String



	Private		marOperandConv()		As clsOperandConvDef


	Private 	mnOffset_ImmOrDisp64		As Integer
	Private 	mnImmOrDisp64Type			As IMMTYPE
	Private 	msImmOrDisp64_originStr		As String


	Friend Property DocName() As String
		Set( value As String )
			Me.msDiscriptionName1 = value
		End Set
		Get
			return Me.msDiscriptionName1
		End Get
	End Property

	Friend Property DocNameSub() As String
		Set( value As String )
			Me.msDiscriptionName2 = value
		End Set
		Get
			return Me.msDiscriptionName2
		End Get
	End Property



	Friend Property AssembleName() As String
		Set( value As String )
			Me.msAsm = value
		End Set
		Get
			return Me.msAsm
		End Get
	End Property


	Friend Property AssembleOperands() As String
		Set( value As String )
			Me.msOperands_Origin = value
		End Set
		Get
			return Me.msOperands_Origin
		End Get
	End Property



	Friend Property Prefixes() As PERFIES
		Set( value As PERFIES)
			Me.menmPrefix = value
		End Set
		Get
			return Me.menmPrefix
		End Get
	End Property

	Friend Property HasRex() As Boolean
		Set( value As Boolean)
			Me.mbRex = value
		End Set
		Get
			return Me.mbRex
		End Get
	End Property


	Friend Property OPCode() As Byte()
		Set( value As Byte())
			Me.mbytCode = value
		End Set
		Get
			return Me.mbytCode
		End Get
	End Property


	Friend Property OPCodeMask() As Byte()
		Set( value As Byte())
			Me.mbytCodeMask = value
		End Set
		Get
			return Me.mbytCodeMask
		End Get
	End Property


	Friend Property WordBitOffset() As Integer
		Set( value As Integer )
			Me.mnWordMaskOffset = value
		End Set
		Get
			return Me.mnWordMaskOffset
		End Get
	End Property

	Friend Property WordBit() As Byte
		Set( value As Byte )
			Me.mbytWordMask = value
		End Set
		Get
			return Me.mbytWordMask
		End Get
	End Property

	Friend Property OffsetModRM() As Integer
		Set( value As Integer )
			Me.mnOffset_ModRM = value
		End Set
		Get
			return Me.mnOffset_ModRM
		End Get
	End Property


	Friend Property OffsetImmOrDisp64() As Integer
		Set( value As Integer )
			Me.mnOffset_ImmOrDisp64 = value
		End Set
		Get
			return Me.mnOffset_ImmOrDisp64
		End Get
	End Property

	Friend Property ImmOrDisp64Type() As IMMTYPE
		Set( value As IMMTYPE )
			Me.mnImmOrDisp64Type = value
		End Set
		Get
			return Me.mnImmOrDisp64Type
		End Get
	End Property


	Friend Property OperandConv() As clsOperandConvDef()
		Set( value As clsOperandConvDef())
			Me.marOperandConv = value
		End Set
		Get
			return Me.marOperandConv
		End Get
	End Property

	' --------  コントラスタ     --------
	Friend Sub New()
		Me.msDiscriptionName1 = Nothing
		Me.msDiscriptionName2 = Nothing
		Me.msAsm = Nothing
		Me.msOperands_Origin = Nothing

		Me.mnInstSize = -1
		Me.menmPrefix = -1
		Me.mbRex = False
		Me.mbytCode = Nothing
		Me.mbytCodeMask = Nothing

		Me.mnWordMaskOffset = -1
		Me.mbytWordMask = -1


		Me.mnOffset_ModRM = -1
		Me.mnOffset_SIB = -1
		Me.msModRM_originStr = Nothing


		Me.marOperandConv = Nothing

		Me.mnOffset_ImmOrDisp64 = -1
		Me.mnImmOrDisp64Type = -1
		Me.msImmOrDisp64_originStr = Nothing
	End Sub


	' --------  メンバー設定以外のプロパティ     --------
	Private ReadOnly Property IsDefined() As Boolean
		Get

			If Me.mbytCode Is Nothing Then
				Throw new System.Exception( "IsDefined : OPCode Nothing." )
				Return False
			End If
			
			If Me.mbytCodeMask Is Nothing Then
				Throw new System.Exception( "IsDefined : OPCodeMask Nothing." )
				Return False
			End If


			If Me.mbytCode.Length <> Me.mbytCodeMask.Length Then
				Throw new System.Exception( "IsDefined : OPCode, Mask length mismatch." )
				Return False
			End If
			
			
			If Me.mnWordMaskOffset >= Me.mbytCode.Length Then
				Throw new System.Exception( "IsDefined : Me.mnWordMaskOffset bigger than code." )
				Return False
			End If


			If Me.mnOffset_ModRM >= 0 Then
				' 合ってんじゃね？違う命令とかありそうな感じもまぁするけどｗ
				If Me.mnOffset_ModRM <> Me.mbytCode.Length Then
					Throw new System.Exception( "IsDefined : Me.mnOffset_ModRM Not match code Size." )
					Return False
				End If

				If Me.mnOffset_ImmOrDisp64 <> Me.mbytCode.Length + 1 Then
					Throw new System.Exception( "IsDefined : Me.mnOffset_ImmOrDisp64 Not match code Size + 1." )
					Return False
				End If
			Else
				If Me.mnOffset_ImmOrDisp64 <> Me.mbytCode.Length Then
					Throw new System.Exception( "IsDefined : Me.mnOffset_ImmOrDisp64 Not match code Size." )
					Return False
				End If

			End If

			If Me.mnOffset_ImmOrDisp64 >= 0 Then
				' 合ってんじゃね？違う命令とかありそうな感じもまぁするけどｗ
				Dim nIsModMemValid		As Integer

				If Me.mnOffset_ImmOrDisp64 <> Me.mbytCode.Length Then
					Throw new System.Exception( "IsDefined : Me.Me.mnOffset_ModRM Not match code Size." )
					Return False
				End If
			End If

			return True
		End Get
	End Property

	Friend Function IsWBitActive(ByRef arDisasmData() As Byte ) As Boolean

		' "まだPrefix 考慮した w ビット読み取りコードになってない。"

		If arDisasmData Is Nothing Then
			' エラー
			Throw new System.Exception( "IsWBit : Code not set." )
			Return False
		End If

		If Me.mbytWordMask = 0 Then
			Return False
		End If

		If Me.WordBitOffset >= Me.mbytCode.Length Then
			Throw new System.Exception( "IsWBit : WordBitOffset bigger than code." )
			Return False
		End If
		
		Dim bytCode			As Byte
		bytCode = Me.mbytCode( Me.WordBitOffset )
		bytCode &= Me.WordBitOffset

		If bytCode <> 0 Then
			Return True
		End If
		Return False

	End Function

	Friend Function HasPrefix( enmAPrefix As PREFIXES) As Boolean
		If (Me.menmPrefix And enmAPrefix) = enmAPrefix Then
			Return True
		Else
			Return False
		End If
	End Function

	Friend Function PrefixCount() As Integer
		Dim nRet			As Integer

		nRet = 0
		If ( Me.menmPrefix And PERFIES.LOCK ) Or _ 
			 Me.menmPrefix And PERFIES.REPENE ) Or _ 
			 Me.menmPrefix And PERFIES.BND ) Then
			nRet += 1
		End If
		If Me.menmPrefix And PERFIES.SEGMENT Then
			nRet += 1
		End If
		If Me.menmPrefix And PERFIES.OPERAND Then
			nRet += 1
		End If
		If Me.menmPrefix And PERFIES.ADDRESS Then
			nRet += 1
		End If	
		Return nRet
	End Function


	Friend ReadOnly Property InstMinimumSize() As Integer
		Get
			Dim nRet			As Integer

			If Not Me.IsDefined Then

				Return False
			End If

			nRet = Me.mbytCode.Length
			If Me.mnOffset_ModRM >= 0 Then
				nRet += 1
			End If

			If Me.mnOffset_ImmOrDisp64 >= 0 And _ 
				Me.mnImmOrDisp64Type >= 0 	Then
				nRet += 1
			End If

			return nRet
		End Get
	End Property


	Friend ReadOnly Property InstMaxSize() As Integer
		Get
			Dim nRet			As Integer

			nRet = Me.PrefixCount

			If Me.mbRex Then
				nRet += 1
			End If

			nRet += Me.mbytCode.Length
			If Me.mnOffset_ModRM >= 0 Then

				If Not Me.HasPrefix( PREFIXES.ADDRESS ) Then
					' ModR/B byte + 2-byte(16bit-displacement)
					nRet += 3 
				Else
					' 最大は ModR/B byte + 4-byte(32bit-displacement)
					nRet += 5
				End If

			End If


			If Me.mnOffset_ImmOrDisp64 >= 0	Then
				If Me.mbRex Then
					If Me.mnImmOrDisp64Type = IMMTYPE.IMM_8TO64 Then
						nRet += 8
					ElseIf Me.HasPrefix( PREFIXES.OPERAND) Or Me.HasPrefix( PREFIXES.ADDRESS) Then
						nRet += 4
					Else
						nRet += 2
					End If
				Else
					nRet += 1
				End If
			End If
			' x64 では 64 bit call/Jxx/JMP 命令というのは廃止されたらしい。


			return nRet
		End Get
	End Property

	Friend Function IsNoOperand() As Boolean
		If Me.mnOffset_ModRM < 0 And _ 
			Me.mnOffset_ImmOrDisp64 < 0 Then
			Return True
		End If
		Return False

	End Function


	Friend Function IsNoImmOrDisp64() As Boolean
		If Me.mnOffset_ImmOrDisp64 < 0 Then
			Return True
		End If
		Return False
	End Function
End Class


Friend Class clsDisasmData
	Private marbytDisasmData()		As Byte
	Private mnOffsetSta				As Integer
	Private mnSize					As Integer

	Friend Sub New( ByRef bytRawData() As Byte, ByVal nOffset As Integer, Optional ByVal nDisasmLength As Integer = -1 )
		Me.marbytDisasmData = bytRawData
		Me.mnOffsetSta = nOffset
		Me.mnSize = nDisasmLength
	End Sub

	
	Friend Property Data() As Byte()
		Set( value As Byte())
			Me.marbytDisasmData = value
		End Set
		Get
			return Me.marbytDisasmData
		End Get
	End Property

	Friend Property OffsetData(ByVal nbyteIndex As Integer ) As Byte
		Set( value As Byte)
			Me.marbytDisasmData( Me.mnOffset + nbyteIndex) = value
		End Set
		Get
			return Me.marbytDisasmData( Me.mnOffset + nbyteIndex)
		End Get
	End Property



	Friend Property OffSet() As Integer
		Set( value As Integer )
			Me.mnOffsetSta = value
		End Set
		Get
			return Me.mnOffsetSta
		End Get
	End Property

	Friend Property Size() As Integer
		Set( value As Integer )
			Me.mnSize = value
		End Set
		Get
			return Me.mnSize
		End Get
	End Property



	Friend Sub New()
	End Sub

	Friend ReadOnly Property EffectiveLength() As Integer
		Get
			Dim nRet		As Ingeger
			If Me.mnSize >= 0 Then
				nRet = Me.mnSize
			Else
				nRet = Me.Data.Length - Me.Offset
			End If
			return nRet
		End Get
	End Property

	Friend Function IsSet() As Boolean

		If Me.mnOffsetSta < 0 Then
				Throw new System.Exception( "clsDisasmData.IsSet : Offset error, offset is minus. " )
				Return False
		End If

		If Me.marbytDisasmData Is Nothing Then
			Throw new System.Exception( "clsDisasmData.IsSet : Data error, Data  is null. " )
			Return False
		End If
		
		If Me.mnOffsetSta  >= Me.marbytDisasmData.Length Then
			Throw new System.Exception( "clsDisasmData.IsSet : Offset error, Offset overs Data size. " )
			Return False
		End If

		If Me.mnSize >= 0 Then
			If ( Me.Offset + Me.Size ) >= Me.marbytDisasmData.Length Then
				Throw new System.Exception( "clsDisasmData.IsSet : Offset+Size error, Offset+Size overs Data size. " )
				Return False
			End If
		End If

		Return True

	End Function


	Friend Function IsIdexFromOffSetOver( ByVal nIndexFromOffset As Integer ) As Boolean
		
		If Me.mnOffsetSta + nIndexFromOffset >= Me.marbytDisasmData.Length Then
			Return True
		End If
		Return False

	End Function
End Class


Friend Class clsDisasmedBlock

	Private msDisassmedStr			As String
	Private mobjAsmDef				As clsInstDef
	Private mnSearchedLoopCnt		As Integer

	Private mnParsedPrefix			As PERFIES
	Private mnPrefixSubIndex		As Integer

	Private mnOffset_Rex			As Integer

	Private mnOffset_OpeCode		As Integer
	Private mnOffset_ModRM			As Integer
	Private mnOffset_SIB			As Integer

	Private mrng_ImmOrDisp64		As clsImmOrDisp64Range


	Private mnParsedByteCnt			As Integer


	Friend ReadOnly Property ParsedByteCnt() As Integer
	Get
		Return Me.mnParsedByteCnt
	End Get
	End Property

	Friend Sub New()
		Call Me.ResetParsedInf()
	End Sub

	Friend Function IsCode( ByVal objDisasmData As clsDisasmData, ByVal objAsmDef As clsInstDef ) As Boolean


		' 読み取りサイズが -1 と未定の場合考えてなかった・・・・。

		Call Me.ResetParsedInf()

		If objAsmDef Is Nothing Then
			Return False
		End If

		
		If Not objAsmDef.IsDefined Then
			Return False
		End If

		Dim nPosParsingNow			As Integer
		Dim enmReadPrefix			As PREFIXES
		Dim nReadPrefixSubIndex		As Integer

		' objAsmDef データ整合性チェック
		If Not objDisasmData.IsSet() Then
			Return False
		End If

		With Nothing
			Dim nValidLength		As Integer
			nValidLength = objDisasmData.EffectiveLength
			If objDisasmData.Size >= 0 Then
				If nValidLength < objAsmDef.InstMinimumSize Or _ 
					nValidLength > objAsmDef.InstMaxSize Then
					Return False
				End If
			Else
				If nValidLength < objAsmDef.InstMinimumSize Then
					Return False
				End If
			End If
		End With

		nPosParsingNow = 0
		Me.mnParsedPrefix = PREFIXES.NONE
		Me.mnPrefixSubIndex = -1
		If objAsmDef.mbytPrefixies <> PREFIXES.NONE Then


			nDataOffsetSta = objDisasmData.OffSet
			
			Dim nPrefixDefCnt				As Integer
			Dim nSearchPrefixMaxSize		As Integer
			nPrefixDefCnt = objAsmDef.PrefixCount
			
			With Nothing
				DIm nSize		As Integer

				nSize = objDisasmData.Size
				If nSize >= 0 Then
					' 逆アセンブルするバイト数が指定されている場合
					nSearchPrefixMaxSize = objDisasmData.Size
				Else
					' 指定されてない場合、元データの最後まで
					nSearchPrefixSize = objDisasmData.Data.Length - _
											objDisasmData.OffSet
				End If
				If nSearchPrefixMaxSize > nPrefixDefCnt Then
					nSearchPrefixMaxSize =  nPrefixDefCnt
				End If
			End With

			Dim		nIndex				As Integer

			For nIndex = 0 To nSearchPrefixSize - 1
				Dim bytCurrent		As Byte
				bytCurrent = objDisasmData.OffsetData( nIndex )

				If objAsmDef.HasPrefix( PREFIXES.LOCK ) Then
					If bytCurrent = bytPRIFEX_LOCK Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.LOCK
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If
				If objAsmDef.HasPrefix( PREFIXES.REPENE ) Then
					If bytCurrent = bytPRIFEX_REPENE Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.REPENE
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If
				If objAsmDef.HasPrefix( PREFIXES.REPE ) Then
					If bytCurrent = bytPRIFEX_REPE Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.REPE
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If
				


				If objAsmDef.HasPrefix( PREFIXES.BND ) Then
					If bytCurrent = bytPRIFEX_BND Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.BND
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If

				If objAsmDef.HasPrefix( PREFIXES.SEGMENT ) Then
					Dim nSegIndex		As Integer
					nSegIndex = System.array.IndexOf( bytPRIFEX_SEGMENTS, bytCurrent ) 
					If nSegIndex >= 0 Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.SEGMENT
						Me.mnPrefixSubIndex = nSegIndex
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If
				
				If objAsmDef.HasPrefix( PREFIXES.BRANCH_HINT ) Then
					Dim nBranchIndex		As Integer
					nBranchIndex = System.array.IndexOf( bytPRIFEX_BRANCH_HINTS, bytCurrent ) 
					If nBranchIndex >= 0 Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.BRANCH_HINT
						Me.mnPrefixSubIndex = nBranchIndex
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If

				If objAsmDef.HasPrefix( PREFIXES.OPERAND ) Then
					If bytCurrent = bytPRIFEX_OPERAND Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.OPERAND
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If

				If objAsmDef.HasPrefix( PREFIXES.ADDRESS ) Then
					If bytCurrent = bytPRIFEX_ADDRESS Then
						Me.mnParsedPrefix = Me.mnParsedPrefix Or PREFIXES.ADDRESS
						nPosParsingNow += nIndex + 1
						Continue For
					End If
				End If

				' Prefix は見つからなかった
				Exit For
			Next
			
		End If

		If objAsmDef.HasRex Then
			Dim bytCurrent		As Byte
			bytCurrent = objDisasmData.OffsetData( nPosParsingNow )
			bytCurrent &= bytREX_NASK
			If bytCurrent = bytREX Then
				Me.mnOffset_Rex = nPosParsingNow
				nPosParsingNow += 1
			End If

		End If


		If objDisasmData.IsIdexFromOffSetOver(nPosParsingNow) Then
			Call Me.ResetParsedInf()
			Return False
		End If

		Me.mnOffset_OpeCode = nPosParsingNow


		' opecode は一致するか？
		With Nothing
			Dim arbytOpeCodeDef		As Byte()
			Dim nOffsetEnd			As Integer
			arbytOpeCodeDef = objAsmDef.OPCode
			nOffsetEnd = arbytOpeCodeDef.Length - 1

			If objDisasmData.Size > 0 Then
				' サイズ指定がある場合
				If arbytOpeCodeDef.Size <> _ 
					nPosParsingNow + 
			End If

			For nOpeCodeCurrentOffset As Integer = 0 To nOffsetEnd
				
				Dim bytCurrent		As Byte
				bytCurrent = objDisasmData.OffsetData( Me.mnOpeCodeOffset + nOpeCodeCurrentOffset )
				bytCurrent &= objAsmDef.OPCodeMask( nOpeCodeCurrentOffset )
				If bytCurrent <> arbytOpeCodeDef( nOpeCodeCurrentOffset ) Then
					Call Me.ResetParsedInf()
					Return False
				End If


			Next
		End With
		nPosParsingNow += objAsmDef.OPCode.Length

		If objAsmDef.IsNoOperand() Then
			If objDisasmData.Size >= 0 Then
				If nPosParsingNow = objDisasmData.Size Then
					Me.mnParsedByteCnt = nPosParsingNow
					Return True
				End If
				Call Me.ResetParsedInf()
				Return False
			End If
			Me.mnParsedByteCnt = nPosParsingNow
			Return True
		End If

		If objDisasmData.IsIdexFromOffSetOver(nPosParsingNow) Then
			Call Me.ResetParsedInf()
			Return False
		End If

		If objAsmDef.OffsetModRM >= 0 Then
			Me.mnOffset_ModRM = nPosParsingNow
			nPosParsingNow += 1

			' SIB が出る条件：
			' 32bit アドレスプリフィックス、
			'		mod(bit7-6) <> 11
			'		RM(bit2-0) = 100
			' の時に初めて SIB が続く。
			If ( (Me.mnParsedPrefix & PREFIXES.ADDRESS ) <> 0 ) Then

				Dim bytCurrent		As Byte
				bytCurrent = objDisasmData.OffsetData( _
						Me.mnOffset_ModRM )
				bytCurrent &= BITS.D7 & BITS.D6 & _ 
								BITS.D2 & BITS.D1 & BITS.D0
				If bytCurrent = &hc4 Then
					Me.mnOffset_SIB = nPosParsingNow
					nPosParsingNow += 1
				End If
			End If
		End If


		If objAsmDef.IsNoImmOrDisp64() Then
			If objDisasmData.Size >= 0 Then
				If nPosParsingNow = objDisasmData.Size Then
					Me.mnParsedByteCnt = nPosParsingNow
					Return True
				End If
				Call Me.ResetParsedInf()
				Return False
			End If
			Me.mnParsedByteCnt = nPosParsingNow
			Return True
		End If

		If objAsmDef.ImmOrDisp64Type = IMMTYPE.IMM8 Then
			Me.mrng_ImmOrDisp64 = new clsImmOrDisp64Range()
			Me.nSta = nPosParsingNow
			Me.nEnd = nPosParsingNow
			nPosParsingNow += 1
		ElseIf objAsmDef.ImmOrDisp64Type = IMMTYPE.IMM_8TO64 Then
			' w bit : 8/full
			' OPERAND : 16/32
			' REX : 32/64

			'  「IA-32e mode だと」
			' さらに、Code-Segment Selector が刺す
			' Code Segment の LDT 内の bit21 : L フラグが
			' 1 だと 64bit モードになって、64bit だと、
			' 
			' 253665-sdm-vol-1.pdf
			' 3.6.1 Operand Size and Address Size in 64-Bit Mode
			' に、オペランドサイズプリフィックス/アドレスプリフィックスつきで
			' REX.W プリフィックスつきの場合の動きが
			' なんとなく書いてある。
			


			' さっぱ分からん。呪われておるなここｗ

		End If

		Return True


	End Function

	Friend Sub ResetParsedInf()
		Me.msDisassmedStr = Nothing
		Me.mnParsedPrefix = -1
		Me.mnPrefixSubIndex = -1
		Me.mnOffset_Rex = -1
		Me.mnOffset_OpeCode = -1
		Me.mnOffset_ModRM = -1
		Me.mnOffset_SIB = -1
		Me.mrng_ImmOrDisp64 = Nothing

		Me.mnParsedByteCnt = -1

		Me.mobjAsmDef = Nothing
	End Sub

End Class

End NameSpace
